(function () {

    this.Ball = function () {
    };


    Ball.prototype = {
        newtonsCradle:null,
        init: function (number, width, height, textList, container, multiSelect) {
            var Body = Matter.Body,
                Engine = Matter.Engine,
                World = Matter.World,
                Bodies = Matter.Bodies,
                Composite = Matter.Composite,
                Bounds = Matter.Bounds,
                circles = [],
                isTouchMove = false,
                touchStartPoint = {x: 0, y: 0},
                Render = Matter.Render,
                Constraint = Matter.Constraint,
                intVal = null;
                //color = ["#1c70c6", "#f28f2c", "#e54322", "#e33238", "#5c5099", "#4ccfdb"];
            var engine = Engine.create({
                positionIterations: 6,
                velocityIterations: 4,
                enableSleeping: false,
                metrics: {extended: true}
            });
            var runner = Engine.run(engine);
            var render = Render.create({
                element: container,
                engine: engine,
                options: {
                    width: width * 2,
                    height: height * 2
                }
            });
            Render.run(render);
            var $canvas = $(container).find("canvas");
            $canvas.height(height).width(width).css("background", "white");
            var center = {
                x: width,
                y: height
            };
            this.newtonsCradle = Composite.create({label: 'Newtons Cradle'});
            var size = window.innerWidth>320?90:64;
            var bigSize=window.innerWidth>320?136:97;
            var ballx, bally, pX, pY;
            for (var i = 0; i < number; i++) {
                var random = Math.random();
                random = random > 0.5 ? random : random * (-1);
                var angle = random * 360;
                ballx = Math.random() * 1.5 * width;
                bally = Math.random() * 1.5 * height;

                pX = center.x + 2 * size * Math.cos(angle);
                pY = center.y + 2 * size * Math.sin(angle);
                var circle = Bodies.circle(ballx, bally, size,
                    {
                        inertia: Infinity,
                        restitution: 0.4,
                        friction: 0,
                        frictionAir: 0.0008,
                        slop: 1,
                        boundXY: {x: pX, y: pY},
                        oBoundXY: {x: pX, y: pY},
                        color: textList[i].color,
                        isSelect: false,
                        oriId: i,
                        text: textList[i].desc
                    });
                Composite.addBody(this.newtonsCradle, circle);
                //var len=Math.sqrt((pX-ballx)*(pX-ballx)+(pY-bally)*(pY-bally))-50;
                //console.log(len)
                var constraint = Constraint.create({
                    bodyA: circle,
                    pointB: {x: pX, y: pY},
                    length: 100,
                    stiffness: 0.00003,
                    render: {visible: false}

                });
                Composite.addConstraint(this.newtonsCradle, constraint);

            }


            var _world = engine.world;

            engine.enabled = true;
            engine.enableSleeping = false;
            engine.world.gravity.x = 0;
            engine.world.gravity.y = 0;
            var renderOptions = render.options;
            renderOptions.wireframes = false;
            renderOptions.showAxes = false;
            renderOptions.showPositions = false;
            renderOptions.showConvexHulls = false;
            World.add(_world, [
                Bodies.rectangle(0, 0, 4 * width, 5, {isStatic: true, restitution: 0.2, render: {visible: false}}),
                Bodies.rectangle(0, 0, 5, 4 * height, {isStatic: true, restitution: 0.2, render: {visible: false}}),
                Bodies.rectangle(0, 2 * height, 4 * width, 5, {
                    isStatic: true,
                    restitution: 0.2,
                    render: {visible: false}
                }),
                Bodies.rectangle(2 * width, 0, 5, 4 * height, {
                    isStatic: true,
                    restitution: 0.2,
                    render: {visible: false}
                }),

            ]);
            World.add(_world, this.newtonsCradle);
            var self=this;
            $canvas[0].addEventListener("touchstart", function (e) {
                touchStartPoint = translatePoint($canvas[0], e.touches[0].clientX, e.touches[0].clientY);
                window.setTimeout(function () {
                    if (isTouchMove)
                        return;
                    for (var i = 0; i < self.newtonsCradle.bodies.length; i++) {
                        if (Bounds.contains(self.newtonsCradle.bodies[i].bounds, translatePoint($canvas[0], e.touches[0].clientX, e.touches[0].clientY))) {
                            var circle = $.extend({}, self.newtonsCradle.bodies[i]);
                            circle.isSelect = !circle.isSelect;
                            //Composite.removeBodyAt(newtonsCradle, i);
                            if (circle.isSelect) {
                                circle = Bodies.circle(circle.position.x, circle.position.y, bigSize,
                                    {
                                        inertia: Infinity,
                                        restitution: 1,
                                        friction: 0,
                                        frictionAir: 0.0008,
                                        slop: 1,
                                        boundXY: {x: circle.boundXY.x, y: circle.boundXY.y},
                                        color: circle.color,
                                        isSelect: circle.isSelect,
                                        text: circle.text,
                                        oriId: circle.oriId
                                    });
                            } else {
                                circle = Bodies.circle(circle.position.x, circle.position.y, size,
                                    {
                                        inertia: Infinity,
                                        restitution: 1,
                                        friction: 0,
                                        frictionAir: 0.0008,
                                        slop: 1,
                                        boundXY: {x: circle.boundXY.x, y: circle.boundXY.y},
                                        color: circle.color,
                                        isSelect: circle.isSelect,
                                        text: circle.text,
                                        oriId: circle.oriId
                                    });
                            }
                            self.newtonsCradle.bodies[i] = circle;
                            // Composite.addBody(newtonsCradle, circle);
                            var constraint = Constraint.create({
                                bodyA: circle,
                                pointB: {x: circle.boundXY.x, y: circle.boundXY.y},
                                length: 100,
                                stiffness: 0.00003,
                                render: {visible: false}

                            });
                            Composite.addConstraint(self.newtonsCradle, constraint);

                            continue;
                        }
                        if (!multiSelect) {
                            var circle = $.extend({}, self.newtonsCradle.bodies[i]);
                            circle.isSelect = false;
                            //Composite.removeBodyAt(newtonsCradle, i);
                            circle = Bodies.circle(circle.position.x, circle.position.y, size,
                                {
                                    inertia: Infinity,
                                    restitution: 1,
                                    friction: 0,
                                    frictionAir: 0.0008,
                                    slop: 1,
                                    boundXY: {x: circle.boundXY.x, y: circle.boundXY.y},
                                    color: circle.color,
                                    isSelect: circle.isSelect,
                                    text: circle.text,
                                    oriId: circle.oriId
                                });
                            self.newtonsCradle.bodies[i] = circle;
                            // Composite.addBody(newtonsCradle, circle);
                            var constraint = Constraint.create({
                                bodyA: circle,
                                pointB: {x: circle.boundXY.x, y: circle.boundXY.y},
                                length: 100,
                                stiffness: 0.00003,
                                render: {visible: false}

                            });
                            Composite.addConstraint(self.newtonsCradle, constraint);
                        }

                    }
                }, 150);


                //console.log(translatePoint(this, e.touches[0].clientX, e.touches[0].clientY));
            });
            $canvas[0].addEventListener("touchmove", function (e) {
                //console.log(e.touches[0].clientX + "," + e.touches[0].clientY);
                isTouchMove = true;
            });
            $canvas[0].addEventListener("touchend", function (e) {
                if (isTouchMove) {
                    isTouchMove = false;
                    startDrag(touchStartPoint, translatePoint($canvas[0], e.changedTouches[0].clientX, e.changedTouches[0].clientY));
                }
            });
            var startDrag = function (point1, point2) {
                if (!intVal)
                    window.clearTimeout(intVal);
                var dy = (point2.y - point1.y);
                var dx = (point2.x - point1.x);
                console.log(dy + "," + dy);
                engine.world.gravity.x = dx * 0.0002;
                engine.world.gravity.y = dy * 0.0002;
                intVal = window.setTimeout(function () {
                    endDrag();
                }, 4000)
            };
            var endDrag = function () {
                console.log("endDrag");
                engine.world.gravity.x = 0;
                engine.world.gravity.y = 0;
                intVal = null;

            };
            var translatePoint = function getPointOnCanvas(canvas, x, y) {

                var bbox = canvas.getBoundingClientRect();

                return {
                    x: (x - bbox.left) * 2,

                    y: (y - bbox.top) * 2

                };

            }
        },
        getSelectBall: function () {
            var idxs = [];
            if (this.newtonsCradle && this.newtonsCradle.bodies)
                for (var i = 0; i < this.newtonsCradle.bodies.length; i++) {
                    if (this.newtonsCradle.bodies[i].isSelect)
                        idxs.push(this.newtonsCradle.bodies[i].oriId);
                }
            return idxs;
        }

    };


})();