window.amGloble = {
    page: {},
    slideBar: {},
    popup: {},
    // cardServer: "https://tlogin.kfc.com.cn/kfcgiftcard/",
    cardServer: "https://card.kfc.com.cn/",
    msg: function (msg, duration) {
        smartMobile.nativeUIWidget.showInstantMessage({
            content: msg,
            duration: duration || 3000
        });
    },
    hash: {
        get: function (isSearch) {
            var str = isSearch ? location.search : location.hash;
            var kvs = str.substring(1).split("&");
            var ret = {};
            for (var i = 0; i < kvs.length; i++) {
                var item = kvs[i].split("=");
                if (item[1] == null) {
                    continue;
                }
                ret[item[0]] = item[1];
            }
            ;
            return ret;
        },
        set: function (data, isSearch) {
            location.href = "#" + $.param(data);
        },

        add: function (data) {
            this.set($.extend(this.get(), data));
        },
        remove: function (keys) {
            var data = this.get();
            for (var i = 0; i < keys.length; i++) {
                delete data[keys[i]];
            }
            ;
            this.set(data);
        }
    },
    getPicture: function (size, success, failed) {
        try {
            navigator.camera.getPicture(function (imageURI) {
                $.am.debug.log(imageURI);
                if (imageURI) {
                    try {
                        $.am.debug.log(JSON.stringify({
                            "path": imageURI.split("?")[0],
                            "height": size.height,
                            "width": size.width
                        }));
                        smartmobile.media.resizeImage({
                            "path": imageURI.split("?")[0],
                            "height": size.height,
                            "width": size.width
                        }, function (ret) {
                            $.am.debug.log(JSON.stringify(ret));
                            if (ret.result == 0) {
                                success(ret);
                            } else {
                                amGloble.msg("照片裁剪失败!");
                                failed(ret);
                            }
                        }, function (ret) {
                            failed(ret);
                        });
                    } catch (e) {
                        $.am.debug.log("error:" + e);
                        success(imageURI);
                    }
                } else {
                    failed();
                }
            }, failed, {
                quality: 100,
                destinationType: Camera.DestinationType.FILE_URI,
                allowEdit: true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 300,
                targetHeight: 300,
                sourceType: size.type == 1 ? Camera.PictureSourceType.PHOTOLIBRARY : Camera.PictureSourceType.CAMERA
            });
        } catch (e) {
            success({
                result: 0,
                content: {
                    sourceRoot: "",
                    relativePath: "res/photo.png"
                }
            });
        }
        /*
         { quality : 75,
         destinationType : Camera.DestinationType.DATA_URL,
         sourceType : Camera.PictureSourceType.CAMERA,
         allowEdit : true,
         encodingType: Camera.EncodingType.JPEG,
         targetWidth: 100,
         targetHeight: 100,
         popoverOptions: CameraPopoverOptions,
         saveToPhotoAlbum: false
         };
         */
    },
    //服务器错误码 提示处理
    showErrMsg: function (code, opt) {
        var msg = opt && opt.msg || '访问服务器失败!';
        var errData = opt && opt.errData || '';
        var show = true;
        if (code == 400001) {
            msg = '';
            show = false;
            amGloble.userInfo.token = null;
            amGloble.userInfo.pwd = null;
            amGloble.util.storage.set("BRANDKFC_/login", amGloble.userInfo);
            navigator.notification.confirm("登录失效,是否立即登录?", function (button) {
                $.am.debug.log(JSON.stringify(button));
                if (button == 1) {
                    if (opt && opt.cb && typeof(opt.cb) == 'function') {
                        opt.cb();
                    } else {
                        amGloble.page.login.changeToMe("slideleft");
                    }
                } else {
                }
            }, "请先登录", ["确定", "取消"]);
        } else if (code == 400003) {
            show = false;
            msg = '登录失败多次请输入验证码';
        } else if (code == 400004) {
            show = false;
            var types = opt.types && opt.types.toLowerCase() || '';
            if (types == 'share') {
                msg = '分享太频繁';
            } else if (types == 'like') {
                msg = '点赞太频繁';
            } else if (types == 'sign') {
                msg = '您已签到了';
            }
        } else if (code == 400005) {
            show = false;
            msg = '刚签到过哦，休息一下再来吧!';
        } else if (code == 400006) {
            msg = '该手机号码已使用';
        } else if (code == 400007) {
            msg = '用户名或密码错误';
        } else if (code == 400008) {
            show = false;
            msg = '更换登录设备请输入验证码';
        } else if (code == 400009) {
            show = false;
            msg = '手机号未注册';
        } else if (code == 400010) {
            msg = '手机号已经注册过';
        } else if (code == 400011) {
            show = false;
            msg = 'email格式不对';
        } else if (code == 400012) {
            show = false;
            msg = 'sns token 无效';
        } else if (code == 400013) {
            show = false;
            msg = 'sns token 与登录账号不匹配';
        } else if (code == 400014) {
            show = false;
            msg = '你离该餐厅太远啦!';
        } else if (code == 400015) {
            show = false;
            msg = '昵称已被注册';
        } else if (code == 400016) {
            show = false;
            msg = '未验证手机号,昵称不能用于登录!';
        } else if (code == 400017) {
            show = false;
            msg = '请输入图片验证码,辅助登录!';
        } else if (code == 400018) {
            show = false;
            msg = '更换登录设备请输入图片验证码';
        } else if (code == 400019) {
            show = false;
            msg = '用户名未注册';
        } else if (code == 400020) {
            show = false;
            msg = '验证码输入次数太多请重新获取验证码';
        } else if (code == 400021) {
            show = false;
            msg = '验证码输入错误';
        } else if (code == 400028) {
            show = false;
            msg = '验证码失效';
        } else if (code == 500340) {
            msg = '您扫描的二维码已过期';
        } else if (code == 400030) {
            msg = '不能重复扫描同一个二维码';
        } else if (code == 500470) {
            msg = '本券已使用过';
        } else if (code == 500362) {
            msg = '根据肯德基会员规则，单天单账户扫码积分次数已达到上限，请保留小票次日再进行操作';
        } else if (code == 500351) {
            msg = '您的账号已被冻结。如有疑问，请拨打电话4009200715询问';
        }

        if (code >= 500000) {
            if (code >= 530000 && (msg == null || msg.trim() == "")) msg = "支付宝系统出错";
            else if (code >= 520000 && (msg == null || msg.trim() == "")) msg = "SSO系统出错";
            else if (code >= 510000 && (msg == null || msg.trim() == "")) msg = "积分系统出错";
            else msg = msg == null ? "" : msg.trim();
            msg = msg + "(" + code + " " + errData.substr(0, 20) + ")";
            msg && amGloble.page.oops.changeToMe("slideleft", msg);
        } else {
            msg = msg + "(" + code + " " + errData.substr(0, 20) + ")";
            msg && amGloble.msg(msg);
        }

    },
    loading: {
        show: function (e) {
            //smartMobile.nativeUIWidget.startBusy(e ? {
            //    caption: e
            //} : undefined);
            $("#anim_part").addClass("anim")
            $("#loading_new").show();

        },
        hide: function () {
            $("#anim_part").removeClass("anim");
            $("#loading_new").hide();
        },
        startSplash: function () {
            smartMobile.nativeUIWidget.startSplash();
        },
        stopSplash: function () {
            smartMobile.nativeUIWidget.stopSplash();
        }
    },


    //amGloble.popupMenu("请选择客户级别", [{name:"普通用户"}, {name:"高级用户"}], function (ret) {_this.$level.find("p.text").text(ret.name);})
    popupMenu: function (title, items, cb, keyName) {
        var temps = [];
        this.popupMenuCbs = [];
        for (var i = 0; i < items.length; i++) {
            temps.push({
                "caption": items[i][keyName || "name"],
                "action": "amGloble.popupMenuCbs[" + i + "].cb()"
            });
            this.popupMenuCbs.push({
                item: items[i],
                cb: function () {
                    cb(this.item);
                }
            });
        }
        smartMobile.nativeUIWidget.showPopupMenu({
            title: title,
            items: temps
        });
    },
    reMail: /^(?:[a-z\d]+[_\-\+\.]?)*[a-z\d]+@(?:([a-z\d]+\-?)*[a-z\d]+\.)+([a-z]{2,})+$/i,
    //手机，座机
    rePhone: /((\d{11})|^((\d{7,8})|(\d{4}|\d{3})-(\d{7,8})|(\d{4}|\d{3})-(\d{7,8})-(\d{4}|\d{3}|\d{2}|\d{1})|(\d{7,8})-(\d{4}|\d{3}|\d{2}|\d{1}))$)/,
    reCellphone: /^0?(1[0-9])[0-9]{9}$/, ///^0?(13[0-9]|15[012356789]|17[0-9]|18[0-9]|14[57])[0-9]{8}$/,
    //密码,由大小写字母加数字组成
    rePassword: /^[A-Za-z0-9]+$/,
    ms2str: function (time) {
        var r = {};

        var ms = time % 1000;
        time = Math.floor(time / 1000);
        var s = time % 60;
        s = s < 10 ? "0" + s : "" + s;
        time = Math.floor(time / 60);
        var m = time % 60;
        m = m < 10 ? "0" + m : "" + m;
        var h = Math.floor(time / 60);
        h = h < 10 ? "0" + h : "" + h;

        return h + ":" + m;
    },

    userInfo: null,
    strWidth: function (str) {
        var text = str.replace(/[^\x00-\xff]/g, "**");
        return text.length;
    },
    ajaxGetJson: function (url, data, scb, fcb) {
        var self = this;
        var data1 = $.extend({}, data);
        var cookie = localStorage.getItem("cookie");
        var takeaction = function () {

            yum.sys.get({
                "params": {
                    url: amGloble.cardServer + url + "?" + $.param(data) + "&" + amGloble.getMD5Code(data), //接口url
                    data: {},
                    header: {
                        "Cookie": cookie
                    },
                    dataType: "json",
                    contentType: "application/json",
                    timeout: 40000
                }
            }, function (ret) {
                var result = ret.content.responseData;
                if (typeof result == "string") {
                    result = JSON.parse(result);
                }
                scb && scb(result);
            }, function (ret) {
                var content = ret.content;
                var status = content.responseStatusCode;
                if (status == 409)
                    fcb && fcb(ret);
                else {
                    var errMsg = null;
                    var retData = content.responseData;
                    if (retData) {
                        if (typeof retData == "string")
                            retData = JSON.parse(retData);
                        var rstText = retData.responseText;
                        if (rstText) {
                            if (typeof rstText == "string")
                                rstText = JSON.parse(rstText);
                            errMsg = rstText.errorMessage;
                        }

                    }
                    amGloble.showGiftCardErrmsg(errMsg);
                }
            });

        };


        if (this.alreadyLogin) {
            takeaction();
        } else {
            amGloble.giftCardLogin(function () {
                self.alreadyLogin = true;
                takeaction();
            }, function () {
                amGloble.showGiftCardErrmsg();
                //fcb && fcb();
            });
        }
    },
    objectToString: function (jsonObject) {
        if (!(jsonObject instanceof Object)) {
            return ""
        }

        var array = new Array();
        $.each(jsonObject, function (name, value) {
            if (value instanceof Array) {
                array.push(name + "=" + this.arrayToString(value))
            } else if (value instanceof Object) {
                array.push(name + "=" + this.objectToString(value))
            } else {
                array.push(name + "=" + value)
            }
        });
        return "{" + array.join("_") + "}"
    },
    arrayToString: function (jsonArray) {
        if (!(jsonArray instanceof Array)) {
            return ""
        }
        ;
        var array = new Array();
        $.each(jsonArray, function (index, data) {
            if (data instanceof Array) {
                array.push(this.arrayToString(data))
            } else if (data instanceof Object) {
                array.push(this.objectToString(data))
            } else {
                array.push(data)
            }
        });
        return "[" + array.join(", ") + "]"
    },
    getSortedJson: function (jsonPojo) {
        var nameArray = new Array();
        if (jsonPojo instanceof Array) {
            var tempArray = new Array();
            $.each(jsonPojo, function (name, value) {
                if (value instanceof Object) {
                    tempArray.push(this.getSortedJson(value));
                } else {
                    tempArray.push(value);
                }
            });
            return tempArray;
        } else {
            $.each(jsonPojo, function (name, value) {
                nameArray.push(name);
            })
        }
        var sortedArray = nameArray.sort();
        var result = new Object();
        $.each(sortedArray, function (index, value) {
            var temp = jsonPojo[value];
            if (temp instanceof Object) {
                temp = this.getSortedJson(jsonPojo[value]);
            }
            result[value] = temp;
        });
        return result;
    },
    getJsonStr: function (jsonPojo) {
        var sortedData = this.getSortedJson(jsonPojo);
        var result;
        if (jsonPojo instanceof Array) {
            result = this.arrayToString(sortedData);
        } else {
            result = this.objectToString(sortedData);
        }
        return result;
    },
    ajaxPost: function (url, optKey, data, scb, fcb, getJsonStr) {
        var opt = {};
        if (optKey) {
            if (getJsonStr) {
                opt[optKey] = amGloble.getJsonStr(data);
            } else {
                opt[optKey] = data;
            }
        } else {
            opt = data;
        }
        var cookie = localStorage.getItem("cookie");
        var params = {
            url: amGloble.cardServer + url + "?" + amGloble.getMD5Code(opt),
            data: data,
            header: {
                "Cookie": cookie
            },
            dataType: "json",
            contentType: "application/json",
            timeout: 40000
        };
        yum.sys.post({
            "params": params
        }, function (ret) {
            var result = ret.content.responseData;
            if (typeof result == "string") {
                result = JSON.parse(result);
            }
            scb && scb(result);
        }, function (ret) {
            amGloble.loading.hide();
            var content = ret.content;
            //var status = content.responseStatusCode;
            //if (status == 406)
            //    amGloble.giftCardSSOBind(scb, fcb);
            //else if (status == 401) {
            //    amGloble.giftCardUpdatePhone(scb, fcb);
            //} else {
            //    var result = ret.content.responseData.responseText;
            //    if (typeof result == "string") {
            //        result = JSON.parse(result);
            //    }
            //    fcb && fcb(result);
            //}
            var errMsg = null;
            var retData = content.responseData;
            if (retData) {
                if (typeof retData == "string")
                    retData = JSON.parse(retData);
                var rstText = retData.responseText;
                if (rstText) {
                    if (typeof rstText == "string")
                        rstText = JSON.parse(rstText);
                    errMsg = rstText.errorMessage;
                }

            }
            amGloble.showGiftCardErrmsg(errMsg);
            if (url.indexOf("egc/ws/realcard/info") != -1 || url.indexOf("egc/ws/realcard/bind") != -1)
                fcb && fcb();
            // amGloble.showGiftCardErrmsg();
        });
    },
    giftCardUpdatePhone: function (scb, fcb) {
        yum.sys.get({
            "params": {
                url: amGloble.cardServer + "egc/ws/password/updatemobile?" + amGloble.getMD5Code({}), //接口url
                data: {},
                header: {},
                dataType: "json",
                contentType: "application/json",
                timeout: 40000
            }
        }, function (ret) {
            var result = ret.content.responseData;
            if (typeof result == "string") {
                result = JSON.parse(result);
            }
            if (result && result.url)
                window.open(result.url, "_blank")
        }, function (ret) {
            fcb && fcb();
        });
        //var url = amGloble.cardServer + "egc/ws/password/updatemobile?" + amGloble.getMD5Code({});
        //console.log(url);
        //$.ajax({
        //    url: url, //接口url
        //    type: "GET",
        //    dataType: "text",
        //    contentType: "application/json",
        //    timeout: 10000,
        //    success: function (ret) {
        //        if (typeof ret == "string")
        //            ret = JSON.parse(ret);
        //        if (ret && ret.url)
        //            window.open(ret.url, "_blank")
        //    },
        //    error: function (ret) {
        //        fcb && fcb();
        //    }
        //});
    },
    giftCardSSOBind: function (scb, fcb) {
        var opt = {
            "brand": "210010002",
            "mobile": amGloble.userInfo.phone,
            "sso": amGloble.userInfo.phone,
            "ssoId": "KFC_BRAND"
        };
        amGloble.ajaxPost("egc/ws/sso/bind", "ssoPojo", opt, function () {
            amGloble.giftCardLogin(scb, fcb);
        }, function () {
            amGloble.showGiftCardErrmsg();
        });
        //var url = amGloble.cardServer + "egc/ws/sso/bind?" + amGloble.getMD5Code({
        //    "ssoPojo": opt
        //});
        //console.log(url);
        //$.ajax({
        //    url: url, //接口url
        //    type: "POST",
        //    data: JSON.stringify(opt),
        //    dataType: "json",
        //    contentType: "application/json",
        //    timeout: 10000,
        //    success: function(ret) {
        //        amGloble.giftCardLogin(scb, fcb);
        //    },
        //    error: function(ret) {
        //        fcb && fcb();
        //    }
        //});
    },
    giftCardLogin: function (scb, fcb) {
        var opt = {
            ssoUserName: amGloble.userInfo.phone,
            ssoToken: amGloble.userInfo.token,
            brand: "210010002",
            ssoId: "KFC_BRAND"
        }
        var url = amGloble.cardServer + "egc/ws/sso/login?" + amGloble.getMD5Code({
                "ssoLoginPojo": opt
            });
        console.log(url);
        var params = {
            url: url,
            data: opt,
            header: {},
            dataType: "json",
            contentType: "application/json",
            timeout: 40000
        };
        yum.sys.post({
            "params": params
        }, function (ret) {
            var content = ret.content;
            var cookie = content.responseHeaders["Set-Cookie"];
            localStorage.setItem("cookie", cookie);
            scb && scb();
        }, function (ret) {
            amGloble.loading.hide();
            var content = ret.content;
            var status = content.responseStatusCode;
            if (status == 406)
                amGloble.giftCardSSOBind(scb, fcb);
            else if (status == 401) {
                amGloble.giftCardUpdatePhone(scb, fcb);
            } else {
                //fcb && fcb();
                var errMsg = null;
                var retData = content.responseData;
                if (retData) {
                    if (typeof retData == "string")
                        retData = JSON.parse(retData);
                    var rstText = retData.responseText;
                    if (rstText) {
                        if (typeof rstText == "string")
                            rstText = JSON.parse(rstText);
                        errMsg = rstText.errorMessage;
                    }

                }
                amGloble.showGiftCardErrmsg(errMsg);
            }

        });
        //$.ajax({
        //    url: url, //接口url
        //    type: "POST",
        //    data: JSON.stringify(opt),
        //    dataType: "json",
        //    contentType: "application/json",
        //    timeout: 10000,
        //    success: function (ret) {
        //        scb && scb();
        //    },
        //    error: function (ret) {
        //        if (ret.status == 406)
        //            amGloble.giftCardSSOBind(scb, fcb);
        //        else if (ret.status == 401) {
        //            amGloble.giftCardUpdatePhone(scb, fcb);
        //        } else {
        //            fcb && fcb();
        //        }
        //    }
        //});
    },
    getGiftCardImgSrc: function (cardId) {
        var opt = {
            cardTypeId: cardId,
            imageType: "PRIMITIVE"
        }
        return amGloble.cardServer + "egc/ws/product/stream/PRIMITIVE/" + cardId + "?" + amGloble.getMD5Code(opt);
    },
    getGiftOrderList: function (scb, fcb) {
        var opt = {
            maxResults: 30,
            firstResult: 0

        }
        var url = amGloble.cardServer + "egc/ws/order/orderlist?firstResult=0&maxResults=30&" + amGloble.getMD5Code(opt);
        console.log(url);
        var cookie = localStorage.getItem("cookie");
        var params = {
            url: url,
            data: {},
            header: {
                "Cookie": cookie
            },
            dataType: "text",
            contentType: "application/json",
            timeout: 40000
        };
        yum.sys.get({
            "params": params
        }, function (ret) {
            var content = ret.content;
            ret = content.responseData;
            if (typeof ret == "string")
                ret = JSON.parse(ret);
            scb && scb(ret);
        }, function (ret) {
            fcb && fcb();
        });
        //$.ajax({
        //    url: url, //接口url
        //    type: "GET",
        //    dataType: "text",
        //    contentType: "application/json",
        //    timeout: 10000,
        //    success: function (ret) {
        //        if (typeof ret == "string")
        //            ret = JSON.parse(ret);
        //        scb && scb(ret);
        //    },
        //    error: function (ret) {
        //        fcb && fcb();
        //    }
        //});
    },
    getMD5Code: function (opt) {

        return $.am.getAuthorizationCode(opt);

    },
    getQueryParameter: function (name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        var r = window.location.search.substr(1).match(reg);
        if (r != null)
            return unescape(r[2]);
        return null;
    },
    showGiftCardErrmsg: function (errMsg) {


        amGloble.loading.hide();
        if ($("#giftCardEntry_popUpBox").is(":hidden")) {
            $("#giftCardEntry_popUpBox .button-red").unbind("vclick").vclick(function () {
                $("#giftCardEntry_popUpBox").hide();
                //smartmobile.appmanager.stopTopApp();
            });
            $("#giftCardEntry_popUpBox .icon_close").unbind("vclick").vclick(function () {
                $("#giftCardEntry_popUpBox").hide();
                //smartmobile.appmanager.stopTopApp();
            });
            var msg = "您好，您的肯德基礼品卡暂无法使用，有疑问请拨打电话4009-123-823进行咨询。";
            if (errMsg)
                msg = msg + "<br/>(" + errMsg + ")";
            $("#giftCardEntry_popUpBox").find(".notes").html(msg)
            $("#giftCardEntry_popUpBox").show();
        }
    },
    validationString: function (str) {
        var valid = true;
        $.each(amGloble.specialChar, function (index, word) {
            if (str.toLowerCase().indexOf(word.toLowerCase()) != -1) {
                valid = false;
                return false;
            }
        });
        if (!valid) {
            amGloble.msg('请勿输入特殊字符');
            return false;
        }
        return true;
    },
    specialChar: ["|", '<', '>', '%', '+', 'script', 'src', 'select', 'update', 'delete', 'insert'],
    city: {},
    preOrderUrl: null,//自助点餐url
    orderUrl: null,  //外送url
    addrManageUrl: null
    //sns login auth


};

$(function () {

});

$.am.init = function () {
    smartmobile.storage.readProperty({
        "key": "KEY_USER"
    }, function (ret) {
        if (typeof ret !== "object")
            ret = JSON.parse(ret);
        amGloble.userInfo = ret.content;
        $.am.changePage(amGloble.page.feedback, "slideleft");
    }, function (ret) {
        // alert("用户未登录,请先获取登录信息");
        // smartmobile.appmanager.stopTopApp();
        location.replace("https://tlogin.kfc.com.cn/superapp_wechat/login.html?campUri="+location.href);
    });

};
