/**
 * Created by cheguoli on 10/19/2015.
 */
(function(window, $){
  var guid = function () {
    var guid = "";
    for (var i = 1; i <= 32; i++){
      var n = Math.floor(Math.random()*16.0).toString(16);
      guid +=n;
    }
    guid += new Date().getTime();
    return guid.toUpperCase();
  };
  var DatePicker = function (opt) {
    //config  e.g 2015-10-19 09:06:27
    this.id = "_datepicker_"+guid();
    console.log(this.id);
    this.gridHeight = 0;
    this.maxGrid = 3;
    this.increament = (this.maxGrid - 1)/2;

    //input object
    this.inputObject = opt.inputObject || null;
    this.datePattern = opt.datePattern || 'yyyy-MM-dd';
    this.timePattern = opt.timePattern || 'hh:ii:ss';
    this.dateDelimiter = opt.dateDelimiter || "-";
    this.timeDelimiter = opt.timeDelimiter || ":";

    this.showTimeControl = opt.showTimeControl || false;
    this.ignoreSecondPanel = opt.ignoreSecondPanel || false;//custom requirement;
    this.minuteInterval = opt.minuteInterval || 1;//custom requirement
    this.maxShowDate =  opt.maxShowDate || false; //custom requirement e.g maxShowDate: new Date()
    this.maxYear = this.maxMonth = this.maxDate = null;
    this.initFinished = false;

    //date
    this.startYear = opt.startYear || 1920;
    this.endYear = opt.endYear || 2030;

    if (this.maxShowDate !== false) {
      this.maxYear = parseInt(this.maxShowDate.getFullYear());  //2015
      this.maxMonth = parseInt(this.maxShowDate.getMonth()) + 1 ; //1-12
      this.maxDate = parseInt(this.maxShowDate.getDate()) ;//1-31
      //var d = this.maxShowDate.split('-');
      //this.maxYear = d[0] * 1, this.maxMonth = d[1]* 1, this.maxDate = d[2]*1;
      if (this.maxYear <= this.startYear) {
        this.startYear = this.maxYear;
      }
      this.endYear = this.maxYear + 1;
    }
    console.log('endY='+this.endYear);

    this.$ = null;
    this.$yearPanel = this.$yearPanelWrap = this.$yearPanelInner = null;
    this.$monthPanel = this.$monthPanelWrap = this.$monthPanelInner = null;
    this.$datePanel = this.$datePanelWrap = this.$datePanelInner = null;
    this.$yearScroll = this.$monthScroll = this.$dateScroll = null;
    //time
    this.$hourPanel = this.$hourPanelWrap = this.$hourPanelInner = null;
    this.$minutePanel = this.$minutePanelWrap = this.$minutePanelInner = null;
    this.$secondPanel = this.$secondPanelWrap = this.$secondPanelInner = null;
    this.$hourScroll = this.$minuteScroll = this.$secondScroll = null;

    this.monthList = [], this.dateList = [],
      this.hourList = [], this.minuteList = [] , this.secondList = [];

    for (var i = 0; i < 12; i++) {      //from 1 to 12
      this.monthList.push(i+1);
    }
    for (var i = 0; i < 31; i++) {  // from 1 to 31
      this.dateList.push(i+1);
    }

    for (var i = 0; i < 24; i++) {  // from 0 to 23
      this.hourList.push(i);
    }

    if (60%parseInt(this.minuteInterval)!=0) {
      this.minuteInterval = 1;
    }
    for (var i = 0; i < 60; i++) {
      if (this.minuteInterval>1 ){
        if(((i+1)%this.minuteInterval == 0 && i+1<60) || i == 0) {
          var tmpVal = i;
          if (this.minuteInterval>1 && i>0) {
            tmpVal = i+1;
          }
          this.minuteList.push(tmpVal);
        }
      } else {
        this.minuteList.push(i);
      }
    }

    for (var i = 0; i < 60; i++) {  // from 0 to 59
      this.secondList.push(i);
    }

    console.log(this.minuteList.join(","));
    this.year = this.month = this.date = this.hour = this.minute = this.second = null;
    var datetime = opt.datetime || null;
    if (!datetime) {
      var d = new Date();
      this.year = parseInt(d.getFullYear());  //2015
      this.month = parseInt(d.getMonth()) ; //0-11
      this.date = parseInt(d.getDate()) ;//1-31
      if (this.showTimeControl) {
        this.hour = parseInt(d.getHours());//0-23
        this.minute = parseInt(d.getMinutes());//0-59
        if (!this.ignoreSecondPanel) {
          this.second = parseInt(d.getSeconds());//0-59
        }
      }
    } else {
      var list = datetime.split(" "),
        d = (list[0]).split(this.dateDelimiter),
        t = (list[1]?list[1].split(this.timeDelimiter) : null);
      console.log(datetime);
      this.year = parseInt(d[0]);
      this.month = parseInt(d[1]) - 1 ; //0-11
      this.date = parseInt(d[2])  ;//1-31
      if (t) {
        this.hour = parseInt(t[0]);//0-23
        this.minute = parseInt(t[1]);//0-59
        if (!this.ignoreSecondPanel) {
          this.second = parseInt(t[2]);//0-59
        }
      }
    }

    $.am.components.push(this);
    $.am.Component.call(this, opt);
  };
  $.extend(DatePicker.prototype, {
    componentInit : function () {
      var htmlArr = [];
      htmlArr.push('<div class="_calendar_mask"></div>');
      htmlArr.push('<div id="'+this.id+'" class="_calendar pop" style="display:none;margin-top:0">');
      htmlArr.push('  <div class="calendar_layer">');
      htmlArr.push('    <ul class="ctimeblock">');

      htmlArr.push('      <li class="yearPanel">');
      htmlArr.push('        <h3>年</h3>');
      htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
      htmlArr.push('          <div class="calender-inner">');
      htmlArr.push('          </div>');
      htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
      htmlArr.push('        </div>');
      htmlArr.push('      </li>');

      htmlArr.push('      <li class="monthPanel">');
      htmlArr.push('        <h3>月</h3>');
      htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
      htmlArr.push('          <div class="calender-inner">');
      htmlArr.push('          </div>');
      htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
      htmlArr.push('        </div>');
      htmlArr.push('      </li>');

      htmlArr.push('      <li class="datePanel">');
      htmlArr.push('        <h3>日</h3>');
      htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
      htmlArr.push('          <div class="calender-inner">');
      htmlArr.push('          </div>');
      htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
      htmlArr.push('        </div>');
      htmlArr.push('      </li>');
      if (this.showTimeControl) {
        htmlArr.push('      <li class="hourPanel">');
        htmlArr.push('        <h3>时</h3>');
        htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
        htmlArr.push('          <div class="calender-inner">');
        htmlArr.push('          </div>');
        htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
        htmlArr.push('        </div>');
        htmlArr.push('      </li>');

        htmlArr.push('      <li class="minutePanel">');
        htmlArr.push('        <h3>分</h3>');
        htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
        htmlArr.push('          <div class="calender-inner">');
        htmlArr.push('          </div>');
        htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
        htmlArr.push('        </div>');
        htmlArr.push('      </li>');

        if (!this.ignoreSecondPanel) {
          htmlArr.push('      <li class="secondPanel">');
          htmlArr.push('        <h3>秒</h3>');
          htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
          htmlArr.push('          <div class="calender-inner">');
          htmlArr.push('          </div>');
          htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
          htmlArr.push('        </div>');
          htmlArr.push('      </li>');
        }
      }

      htmlArr.push('    </ul>');
      htmlArr.push('    <div class="save_button am-clickable" style="z-index:199;">设置</div>');
      htmlArr.push('    <div class="cancel_button am-clickable" style="z-index:199;">取消</div>');
      htmlArr.push('  </div>');
      htmlArr.push('</div>');
      $("body").append(htmlArr.join(""));
      this.bind().show();
    },
    bind : function () {
      var self = this;
      this.$ = $("#"+this.id);
      this.$yearPanel = this.$.find(".yearPanel");
      this.$yearPanelWrap = this.$yearPanel.find(".calender-wrap");
      this.$yearPanelInner = this.$yearPanel.find(".calender-inner");

      this.$monthPanel = this.$.find(".monthPanel");
      this.$monthPanelWrap = this.$monthPanel.find(".calender-wrap");
      this.$monthPanelInner = this.$monthPanel.find(".calender-inner");

      this.$datePanel = this.$.find(".datePanel");
      this.$datePanelWrap = this.$datePanel.find(".calender-wrap");
      this.$datePanelInner = this.$datePanel.find(".calender-inner");

      if (this.showTimeControl) {
        this.$hourPanel = this.$.find(".hourPanel");
        this.$hourPanelWrap = this.$hourPanel.find(".calender-wrap");
        this.$hourPanelInner = this.$hourPanel.find(".calender-inner");

        this.$minutePanel = this.$.find(".minutePanel");
        this.$minutePanelWrap = this.$minutePanel.find(".calender-wrap");
        this.$minutePanelInner = this.$minutePanel.find(".calender-inner");

        if (!this.ignoreSecondPanel) {
          this.$secondPanel = this.$.find(".secondPanel");
          this.$secondPanelWrap = this.$secondPanel.find(".calender-wrap");
          this.$secondPanelInner = this.$secondPanel.find(".calender-inner");
        }
      }

      this.$.find(".save_button").on("vclick", function (e) {
        var dateArr = [], timeArr = [],
          indexYear = self.startYear + Math.round((self.$yearScroll._currentPos[1]>0?0:(Math.abs(self.$yearScroll._currentPos[1])/self.gridHeight+1))),
          indexMonth = Math.round(self.$monthScroll._currentPos[1]>0?0:(Math.abs(self.$monthScroll._currentPos[1])/self.gridHeight+1)),
          indexDate = Math.round(self.$dateScroll._currentPos[1]>0?0:(Math.abs(self.$dateScroll._currentPos[1])/self.gridHeight+1));
        dateArr.push(indexYear);
        dateArr.push(self.monthList[indexMonth]<10?'0'+self.monthList[indexMonth]:self.monthList[indexMonth]);
        dateArr.push(self.dateList[indexDate]<10?'0'+self.dateList[indexDate]:self.dateList[indexDate]);

        if (self.showTimeControl) {
          var indexHour = indexMinute = indexSecond = null;
          indexHour = Math.round(self.$hourScroll._currentPos[1]>0?0:(Math.abs(self.$hourScroll._currentPos[1])/self.gridHeight+1));
          indexMinute = Math.round(self.$minuteScroll._currentPos[1]>0?0:(Math.abs(self.$minuteScroll._currentPos[1])/self.gridHeight+1));
          console.log('indexMinute='+indexMinute+'realMinute = '+self.minuteList[indexMinute]);
          if (!self.ignoreSecondPanel) {
            indexSecond = Math.round(self.$secondScroll._currentPos[1]>0?0:(Math.abs(self.$secondScroll._currentPos[1])/self.gridHeight+1));
          }
          timeArr.push(self.hourList[indexHour]<10?'0'+self.hourList[indexHour]:self.hourList[indexHour]);
          timeArr.push(self.minuteList[indexMinute]<10?'0'+self.minuteList[indexMinute]:self.minuteList[indexMinute]);
          if (!self.ignoreSecondPanel) {
            timeArr.push(self.secondList[indexSecond]<10?'0'+self.secondList[indexSecond]:self.secondList[indexSecond]);
          }
        }
        //console.log(timeArr.join(":"));
        self.inputObject.val(timeArr.length>0?[dateArr.join("-"),timeArr.join(self.timeDelimiter)].join(" "):dateArr.join("-"));
        self.hide();
        return false;
      });

      this.$.find(".cancel_button").on("vclick", function (e) {
        self.hide();
        return false;
      });
      return this;
    },
    unbind : function () {
      this.$.find(".save_button").unbind("vclick");
      this.$.find(".cancel_button").unbind("vclick");
    },
    show : function () {
      var self = this,
        year = this.year, month = this.month, date = this.date,
        hour = this.showTimeControl?this.hour:null,
        minute = this.showTimeControl?parseInt(this.minute):null,
        second = this.showTimeControl?this.second:null;
      var yearStep = monthStep = dateStep = hourStep = minuteStep = secondStep = 0;
      this.showYear(year).showMonth(month).showDate(year,month, date);
      if (this.showTimeControl) {
        this.showHour(hour).showMinute(minute);
        if (!this.ignoreSecondPanel) {
          this.showSecond(second);
        }
        //change the layer height.
        var h = this.$.find(".calendar_layer").height();
        this.$.find(".calendar_layer").css("height",(h+160)+'px');
      }
      this.$.show();
      //fetch the grid height.
      this.gridHeight = self.$yearPanelInner.find("p").height();
      this.$yearScroll = new $.am.ScrollView({
        $wrap : self.$yearPanelWrap,
        $inner : self.$yearPanelInner,
        $momentumProperties:{easing:"linear",girdHeight:self.gridHeight,increament:self.increament},
        $callback : function (obj) {self.maxShowDate!==false?self.refreshMaxDate(obj,'y'):self.refreshDate(obj);},
        $caller : self
      });
      this.$monthScroll = new $.am.ScrollView({
        $wrap : self.$monthPanelWrap,
        $inner : self.$monthPanelInner,
        $momentumProperties:{easing:"linear",girdHeight:self.gridHeight,increament:self.increament},
        $callback : function (obj) {self.maxShowDate!==false?self.refreshMaxDate(obj,'m'):self.refreshDate(obj);},
        $caller : self
      });
      this.$dateScroll = new $.am.ScrollView({
        $wrap : self.$datePanelWrap,
        $inner : self.$datePanelInner,
        $momentumProperties:{easing:"linear",girdHeight:self.gridHeight,increament:self.increament}
      });
      monthStep = self.monthList[month]>=2*self.increament?2*self.increament-self.monthList[month]:self.monthList[month];
      dateStep = self.dateList[date-1]>=2*self.increament?2*self.increament-self.dateList[date-1]:self.dateList[date-1];

      this.$yearScroll.scrollTo([0, (year<=0)?(self.gridHeight*(year-this.startYear+self.increament)):(-(self.gridHeight * (year-this.startYear>1?year-this.startYear-1:0)))]);
      this.$monthScroll.scrollTo([0, self.gridHeight * monthStep]);
      this.$dateScroll.scrollTo([0, self.gridHeight * dateStep]);

      this.$yearScroll.refresh();
      this.$monthScroll.refresh();
      this.$dateScroll.refresh();

      if (this.showTimeControl) {
        this.$hourScroll = new $.am.ScrollView({
          $wrap : self.$hourPanelWrap,
          $inner : self.$hourPanelInner,
          $momentumProperties:{easing:"linear",girdHeight:self.gridHeight,increament:self.increament}
        });
        this.$minuteScroll = new $.am.ScrollView({
          $wrap : self.$minutePanelWrap,
          $inner : self.$minutePanelInner,
          $momentumProperties:{easing:"linear",girdHeight:self.gridHeight,increament:self.increament}
        });
        if (!this.ignoreSecondPanel) {
          this.$secondScroll = new $.am.ScrollView({
            $wrap : self.$secondPanelWrap,
            $inner : self.$secondPanelInner,
            $momentumProperties:{easing:"linear",girdHeight:self.gridHeight,increament:self.increament}
          });
        }
        hourStep = self.hourList[hour]+1>=2*self.increament?2*self.increament-(self.hourList[hour]+1):self.hourList[hour]+1;
        this.$hourScroll.scrollTo([0, self.gridHeight * hourStep]);
        if (this.minuteInterval == 1) {
          minuteStep = self.minuteList[minute]+1>=2*self.increament?2*self.increament-(self.minuteList[minute]+1):self.minuteList[minute]+1;
        } else {
          minute = Math.floor(minute/this.minuteInterval);
          minuteStep = (minute+1>=2*self.increament?2*self.increament-(minute+1):minute+1);
        }
        this.$minuteScroll.scrollTo([0, self.gridHeight * minuteStep]);
        if (!this.ignoreSecondPanel) {
          secondStep = self.secondList[second]+1>=2*self.increament?2*self.increament-(self.secondList[second]+1):self.secondList[second]+1;
          this.$secondScroll.scrollTo([0, self.gridHeight * secondStep]);
        }
        this.$hourScroll.refresh();
        this.$minuteScroll.refresh();
        if (!this.ignoreSecondPanel) {
          this.$secondScroll.refresh();
        }
      }
      this.initFinished = true;
    },
    showYear : function (year) {
      var yearArr = [];
      for (var i = this.startYear; i< this.endYear; i++ ) {
        yearArr.push('<p >'+i+'</p>');
      }
      this.$yearPanelInner.html(yearArr.join(""));
      return this;
    },
    showMonth : function(month){
      var monthArr = [];
      var end = 12;
      if (this.maxShowDate !== false) {
        if (this.initFinished === false) {
          if (this.maxYear == this.year) end = this.maxMonth;
        } else {
          var indexYear = this.startYear + Math.round((this.$yearScroll._currentPos[1]>0?0:(Math.abs(this.$yearScroll._currentPos[1])/this.gridHeight+1)));
          console.log('indexY='+indexYear+',maxY='+this.maxYear+',maxM='+this.maxMonth);
          end = indexYear == this.maxYear ? this.maxMonth : 12;
        }
      }
      console.log('------------month end-----------'+end);
      for (var i = 0; i < end; i++ ) {
        monthArr.push('<p>'+this.monthList[i]+'</p>');
      }
      this.$monthPanelInner.html(monthArr.join(""));
      return this;
    },
    showDate : function (year,month,date) {
      var dateArr = [];
      var days = (new Date(year,month+1,0)).getDate();
      var end = days;
      if (this.maxShowDate !== false) {
        if (this.initFinished === true) {
          var indexYear = this.startYear + Math.round((this.$yearScroll._currentPos[1]>0?0:(Math.abs(this.$yearScroll._currentPos[1])/this.gridHeight+1))),
            indexMonth = Math.round(this.$monthScroll._currentPos[1]>0?0:(Math.abs(this.$monthScroll._currentPos[1])/this.gridHeight+1));
          end = (indexYear == this.maxYear && this.monthList[indexMonth] >= this.maxMonth) ? this.maxDate : days;
        }
      }
      console.log('------------date end-----------'+end);
      //for (var i = 0; i< days; i++ ) {
      for (var i = 0; i< end; i++ ) {
        dateArr.push('<p>'+this.dateList[i]+'</p>');
      }
      this.$datePanelInner.html(dateArr.join(""));
      return this;
    },
    refreshDate : function (dateObject) {
      var self = this,
        indexYear = self.startYear + (self.$yearScroll._currentPos[1]>0?0:(Math.abs(self.$yearScroll._currentPos[1])/self.gridHeight+1)),
        indexMonth = self.$monthScroll._currentPos[1]>0?0:(Math.abs(self.$monthScroll._currentPos[1])/self.gridHeight+1),
        indexDate = self.$dateScroll._currentPos[1]>0?0:(Math.abs(self.$dateScroll._currentPos[1])/self.gridHeight+1);
      console.log('indexDate='+indexDate+',realDate='+self.dateList[indexDate]);
      console.log('indexYear='+indexYear+',indexMonth='+indexMonth);
      self.showDate(indexYear,indexMonth,self.dateList[indexDate]);
      self.$dateScroll.refresh();
      var days = (new Date(indexYear,indexMonth+1,0)).getDate();
      var newDate = self.dateList[indexDate]>days?days:self.dateList[indexDate];
      var moveToY = (newDate<=0)?(self.gridHeight*(newDate+self.increament)):(-(self.gridHeight * (newDate>1?newDate-1:0))) + 40;
      console.log('days='+days+',newDate='+newDate+',moveToY='+moveToY);
      self.$dateScroll.scrollTo([0, moveToY]);
      self.$dateScroll.refresh();
    },
    refreshMaxDate : function (dateObject, type) {
      var self = this,
        indexYear = self.startYear + (self.$yearScroll._currentPos[1]>0?0:(Math.abs(self.$yearScroll._currentPos[1])/self.gridHeight+1)),
        indexMonth = self.$monthScroll._currentPos[1]>0?0:(Math.abs(self.$monthScroll._currentPos[1])/self.gridHeight+1),
        indexDate = self.$dateScroll._currentPos[1]>0?0:(Math.abs(self.$dateScroll._currentPos[1])/self.gridHeight+1);
      console.log('----refreshMaxDate start----');
      console.log('indexDate='+indexDate+',realDate='+self.dateList[indexDate]);
      console.log('indexYear='+indexYear+',indexMonth='+indexMonth);
      console.log('----refreshMaxDate end----');

      console.log('maxY='+this.maxYear+',indexY='+indexYear+',res='+(this.maxYear == indexYear));
      if (this.maxYear == indexYear) {
        console.log('-----equals year---');
        //refresh month;
        if (type == 'y') {
          console.log('-----year---');
          self.showMonth(indexMonth);
          self.$monthScroll.refresh();
          var newMonth = self.monthList[indexMonth] > this.maxMonth ? this.maxMonth : self.monthList[indexMonth];
          var monthMoveToY = (newMonth>=2*self.increament?2*self.increament-newMonth:newMonth)*self.gridHeight;
          console.log('newMonth=' + newMonth + ',moveToY=' + monthMoveToY);
          self.$monthScroll.scrollTo([0, monthMoveToY]);
          self.$monthScroll.refresh();
        }
        //refresh day;
        if (this.maxMonth <= self.monthList[indexMonth]) {
          self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
          self.$dateScroll.refresh();
          console.log('indexDate='+self.dateList[indexDate]+',maxDate='+this.maxDate);
          var newDate = self.dateList[indexDate] > this.maxDate ? this.maxDate : self.dateList[indexDate];
          var dayMoveToY = (newDate <= 0) ? (self.gridHeight * (newDate + self.increament)) : (-(self.gridHeight * (newDate > 1 ? newDate - 1 : 0))) + 40;
          console.log('newDate=' + newDate + ',moveToY=' + dayMoveToY);
          self.$dateScroll.scrollTo([0, dayMoveToY]);
          self.$dateScroll.refresh();
        } else {
          self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
          self.$dateScroll.refresh();

          self.refreshDate(dateObject);
        }
      } else {
        //还原
        self.showMonth();
        self.$monthScroll.refresh();

        self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
        self.$dateScroll.refresh();

        self.refreshDate(dateObject);
      }
    },
    showHour : function (hour) {
      var hourArr = [];
      for (var i = 0; i<24; i++ ) {
        hourArr.push('<p >'+(this.hourList[i]>9?this.hourList[i]:'0'+this.hourList[i])+'</p>');
      }
      this.$hourPanelInner.html(hourArr.join(""));
      return this;
    },
    showMinute : function(minute){
      var minuteArr = [], len = this.minuteList.length;
      for (var i = 0; i < len; i++) {
        minuteArr.push('<p>'+(this.minuteList[i]>9?this.minuteList[i]:'0'+this.minuteList[i])+'</p>');
      }
      this.$minutePanelInner.html(minuteArr.join(""));
      return this;
    },
    showSecond : function (second) {
      var secondArr = [];
      for (var i = 0; i<60; i++ ) {
        secondArr.push('<p>'+(this.secondList[i]>9?this.secondList[i]:'0'+this.secondList[i])+'</p>');
      }
      this.$secondPanelInner.html(secondArr.join(""));
      return this;
    },
    hide : function () {
      var self = this;
      this.unbind();
      //delay 350ms for preventing the bottom input focus event from being triggered.
      /*      $('._calendar_mask').fadeOut(350, function(){
       $(this).remove();
       self.$.remove();
       });*/
      $('._calendar_mask').css('pointer-events', 'none');
      setTimeout(function(){
        $('._calendar_mask').css('pointer-events', 'auto');
        self.$.remove();
        $('._calendar_mask').remove();
      }, 400);
    }
  });
  $.am.DatePicker = DatePicker;
})(window, jQuery);