
/**
 * Calendar
 * @param   beginYear           1990
 * @param   endYear             2010
 * @param   language            0(zh_cn)|1(en_us)|2(en_en)|3(zh_tw)
 * @param   patternDelimiter    "-"
 * @param   date2StringPattern  "yyyy-MM-dd"
 * @param   string2DatePattern  "ymd"
 * @version 1.0 build 2006-04-01
 * @version 1.1 build 2006-12-17
 * @author  KimSoft (jinqinghua [at] gmail.com)
 * NOTE!    you can use it free, but keep the copyright please
 * IMPORTANT:you must include this script file inner html body elment 
 */
function Calendar(beginYear, endYear, language, patternDelimiter, date2StringPattern, string2DatePattern) {
	this.initDom = false;
  this.beginYear = beginYear || 1960;
	this.endYear   = endYear   || 2020;
	this.language  = language  || 0;
	this.patternDelimiter = patternDelimiter     || "-";
	this.date2StringPattern = date2StringPattern || Calendar.language["date2StringPattern"][this.language].replace(/\-/g, this.patternDelimiter);
	this.string2DatePattern = string2DatePattern || Calendar.language["string2DatePattern"][this.language];
	
	this.dateControl = null;
	//this.panel  = this.getElementById("__calendarPanel");
	//this.iframe = window.frames["__calendarIframe"];
	this.form   = null;
	
	this.date = new Date();
	this.year = this.date.getFullYear();
	this.month = this.date.getMonth();
	
	this.colors = {"bg_cur_day":"#00CC33","bg_over_cur_day":"#ccc","bg_over":"#ffffff","bg_out":"#FFCC00"}
};

Calendar.language = {
	"year"   : ["\u5e74", "", "", "\u5e74"],
	"months" : [
				["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"],
				["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
				["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
				["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"]
				],
	"weeks"  : [["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"],
				["Sun","Mon","Tur","Wed","Thu","Fri","Sat"],
				["Sun","Mon","Tur","Wed","Thu","Fri","Sat"],
				["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"]
		],
	"clear"  : ["\u6e05\u7a7a", "Clear", "Clear", "\u6e05\u7a7a"],
	"today"  : ["\u4eca\u5929", "Today", "Today", "\u4eca\u5929"],
	"close"  : ["\u786E\u5B9A", "Close", "Close", "\u95dc\u9589"],
	"date2StringPattern" : ["yyyy-MM-dd hh:mm:ss", "yyyy-MM-dd", "yyyy-MM-dd", "yyyy-MM-dd"],
	"string2DatePattern" : ["ymd","ymd", "ymd", "ymd"],
  "tipText" : ["\u4FEE\u6539\u65F6\u95F4"]
};

Calendar.prototype.draw = function() {
	calendar = this;
	
	var _cs = [];
	_cs[_cs.length] = '<form id="__calendarForm" name="__calendarForm" method="post">';
	_cs[_cs.length] = '<table id="__calendarTable" width="100%" border="0" cellpadding="0" cellspacing="0" align="center">';
  //_cs[_cs.length] = ' <tr class="toptit" style="height:10px; width:244px; padding:0;"><th style="height:10px; padding:0;" colspan="7"><\/th><\/tr>';
  _cs[_cs.length] = ' <tr class="toptit">';
	_cs[_cs.length] = '  <th class="toplBtn"><input class="l" name="goPrevMonthButton" type="button" id="goPrevMonthButton" value="&lt;" \/><\/th>';
	_cs[_cs.length] = '  <th class="topSelectWrap" colspan="5"><select class="year" name="yearSelect" id="yearSelect"><\/select><select class="month" name="monthSelect" id="monthSelect"><\/select><\/th>';
	_cs[_cs.length] = '  <th class="toprBtn"><input class="r" name="goNextMonthButton" type="button" id="goNextMonthButton" value="&gt;" \/><\/th>';
	_cs[_cs.length] = ' <\/tr>';
	_cs[_cs.length] = ' <tr class="toptit line">';

	for(var i = 0,thcls = "theader"; i < 7; i++) {
    if (i == 0){
      thcls = "theader first";
    }else if(i==6){
      thcls = "theader last";
    }else {
      thcls = "theader";
    }
		_cs[_cs.length] = '<th class="'+ thcls+ '">';
		_cs[_cs.length] = Calendar.language["weeks"][this.language][i];
		_cs[_cs.length] = '<\/th>';	
	}
	_cs[_cs.length] = '<\/tr>';
	_cs[_cs.length] = ' <tr class="noBg" style="height:1px; width:244px; padding:0;"><th style="height:10px;width:244px; background-color:#fffff; padding:0;" colspan="7"><\/th><\/tr>';
	for(var i = 0; i < 6; i++){
		_cs[_cs.length] = '<tr align="center">';
		for(var j = 0; j < 7; j++) {
			switch (j) {
				case 0: _cs[_cs.length] = '<td class="sun">&nbsp;<\/td>'; break;
				case 6: _cs[_cs.length] = '<td class="sat">&nbsp;<\/td>'; break;
				default:_cs[_cs.length] = '<td class="normal">&nbsp;<\/td>'; break;
			}
		}
		_cs[_cs.length] = '<\/tr>';
	}

  if (this.mmbtn) {
	_cs[_cs.length] = ' <tr class="trchange">';
  this.panel.style.height = '271px';
  } else {
    _cs[_cs.length] = ' <tr class="trchange" style="display:none;">';
    this.panel.style.height = '231px';
  }
  _cs[_cs.length] = '<th class="thCl" colspan="2" style="width:70px; padding-left:10px;"> <span id="tipText" ><\/span><\/th>';
	_cs[_cs.length] = '<th class="thCl" colspan="3" style="width:100px; "> ';
	_cs[_cs.length] = '<div class="inputWrap"> <input type="text" size="2" name="hourVal" value="" id="hourVal"\/>:<input type="text" name="minuteVal" value="" size="2" id="minuteVal"\/><\/div><\/th>';
	_cs[_cs.length] = '<th class="thCl" colspan="2" style="width:70px; padding-left:0;  padding-right:28px;"><div class="btnWrap"> <a href="javascript:" class="buttons" id = "addsBtn">+</a> <a href="javascript:" class="buttons" id="subtractBtn">-</a><\/div><\/th>';
	_cs[_cs.length] = ' <\/tr>';
 
	_cs[_cs.length] = ' <tr class="trbtns" style="display:none;">';
	_cs[_cs.length] = '  <th colspan="2" style="width:65px; padding-left:17px;"><input type="button" class="b" name="clearButton" id="clearButton" \/><\/th>';
	_cs[_cs.length] = '  <th class="thbtn3" colspan="3" style="width:102px;"><input type="button" class="b" name="selectTodayButton" id="selectTodayButton" \/><\/th>';
	_cs[_cs.length] = '  <th colspan="2" style="width:67px; padding-right:17px;"><input type="button" class="b" name="closeButton" id="closeButton" \/><\/th>';
	_cs[_cs.length] = ' <\/tr>';

	//_cs[_cs.length] = '<\/th> <\/tr>';
	_cs[_cs.length] = '<\/table>';
	_cs[_cs.length] = '<\/form>';
	
	this.iframe.document.body.innerHTML = _cs.join("");
	this.form = this.iframe.document.forms["__calendarForm"];

	this.form.clearButton.value = Calendar.language["clear"][this.language];
	this.form.selectTodayButton.value = Calendar.language["today"][this.language];
	this.form.closeButton.value = Calendar.language["close"][this.language];

  calendar.getElementById('tipText',this.iframe.document).innerHTML = Calendar.language["tipText"][this.language]+":";
  calendar.getElementById('addsBtn',this.iframe.document).onclick = function () {calendar.addHours(); return false;};
  calendar.getElementById('subtractBtn',this.iframe.document).onclick = function () {calendar.subtractHours(); return false;};
  
  this.form.hourVal.onchange = function () {calendar.changeHours(this.form); return false;};
  this.form.minuteVal.onchange = function () {calendar.changeHours(this.form); return false;};
	
	this.form.goPrevMonthButton.onclick = function () {calendar.goPrevMonth(this);}
	this.form.goNextMonthButton.onclick = function () {calendar.goNextMonth(this);}
	this.form.yearSelect.onchange = function () {calendar.update(this);}
	this.form.monthSelect.onchange = function () {calendar.update(this);}
	
	this.form.clearButton.onclick = function () {calendar.dateControl.value = "";calendar.hide();}
	this.form.closeButton.onclick = function () {calendar.hide();}
	this.form.selectTodayButton.onclick = function () {
		var today = new Date();
		calendar.date = today;
		calendar.year = today.getFullYear();
		calendar.month = today.getMonth();
		calendar.dateControl.value = today.format(calendar.date2StringPattern);
		calendar.hide();
	}
};

Calendar.prototype.addHours = function(d) {
  var d = this.form;
  var h = d.hourVal.value,
      m = d.minuteVal.value - 0;
  h = isNaN(h) ? 0 : h;
  m = isNaN(m) ? 0 : m;
  var now_h = (h - 0) + 1;
  if (now_h > 24){return;}
  now_h = now_h < 10 ? "0" + now_h : now_h;
  m = m < 10 ? "0" + m : m;
  d.hourVal.value = now_h;
  d.minuteVal.value = m;
  var oldymd = this.dateControl.value.substr(0,10);
  this.dateControl.value = oldymd + " " + d.hourVal.value +":"+ d.minuteVal.value + ":00";

};


Calendar.prototype.subtractHours = function(d) {
  var d = this.form;
  var h = d.hourVal.value,
      m = d.minuteVal.value - 0;
  h = isNaN(h) ? 0 : h;
  m = isNaN(m) ? 0 : m;
  var now_h = (h - 0) - 1;
  if (now_h < 1){return;}
  now_h = now_h < 10 ? "0" + now_h : now_h;
  m = m < 10 ? "0" + m : m;
  d.hourVal.value = now_h;
  d.minuteVal.value = m;
  var oldymd = this.dateControl.value.substr(0,10);
  this.dateControl.value = oldymd + " " + d.hourVal.value +":"+ d.minuteVal.value + ":00";

};

Calendar.prototype.changeHours = function(d) {
  var h = d.hourVal.value,
      m = d.minuteVal.value;
  h = isNaN(h) ? 0 : h;
  m = isNaN(m) ? 0 : m;
  var now_h = (h - 0);
  if (now_h > 24){now_h = 01;}
  var now_m = (m - 0);
  if (now_m > 60){now_m = 01;}
  now_h = now_h < 10 ? "0" + now_h : now_h;
  now_m = now_m < 10 ? "0" + now_m : now_m;
  d.hourVal.value = now_h;
  d.minuteVal.value = now_m;
  var oldymd = this.dateControl.value.substr(0,10);
  this.dateControl.value = oldymd + " " + d.hourVal.value +":"+ d.minuteVal.value + ":00";

};



Calendar.prototype.bindYear = function() {
	var ys = this.form.yearSelect;
	ys.length = 0;
	for (var i = this.beginYear; i <= this.endYear; i++){
		ys.options[ys.length] = new Option(i + Calendar.language["year"][this.language], i);
	}
};

Calendar.prototype.bindMonth = function() {
	var ms = this.form.monthSelect;
	ms.length = 0;
	for (var i = 0; i < 12; i++){
		ms.options[ms.length] = new Option(Calendar.language["months"][this.language][i], i);
	}
};

Calendar.prototype.goPrevMonth = function(e){
	if (this.year == this.beginYear && this.month == 0){return;}
	this.month--;
	if (this.month == -1) {
		this.year--;
		this.month = 11;
	}
	this.date = new Date(this.year, this.month, 1);
	this.changeSelect();
	this.bindData();
};

Calendar.prototype.goNextMonth = function(e){
	if (this.year == this.endYear && this.month == 11){return;}
  if (this.month >= new Date().getMonth() ) return;
	this.month++;
	if (this.month == 12) {
		this.year++;
		this.month = 0;
	}
	this.date = new Date(this.year, this.month, 1);
	this.changeSelect();
	this.bindData();
};

Calendar.prototype.changeSelect = function() {
	var ys = this.form.yearSelect;
	var ms = this.form.monthSelect;
	for (var i= 0; i < ys.length; i++){
		if (ys.options[i].value == this.date.getFullYear()){
			ys[i].selected = true;
			break;
		}
	}
	for (var i= 0; i < ms.length; i++){
		if (ms.options[i].value == this.date.getMonth()){
			ms[i].selected = true;
			break;
		}
	}
};

Calendar.prototype.update = function (e){
	this.year  = e.form.yearSelect.options[e.form.yearSelect.selectedIndex].value;
	this.month = e.form.monthSelect.options[e.form.monthSelect.selectedIndex].value;
	this.date = new Date(this.year, this.month, 1);
	this.changeSelect();
	this.bindData();
};

Calendar.prototype.bindData = function () {
	var calendar = this;

  if (calendar.dateControl && calendar.dateControl.value){
    var val = calendar.dateControl.value,
    y = val.substr(0,4),
    m = val.substr(5,2),
    d = val.substr(8,2),
    h = val.substr(11,2),
    mm = val.substr(14,2),
    s = val.substr(17,2),

    dd = new Date(y,m,d,h,mm,s),
    th = dd.getHours(),
    tm = dd.getMinutes();
    th = th < 10 ? "0" + th : th;
    tm = tm < 10 ? "0" + tm : tm;
    calendar.form.hourVal.value = th;
    calendar.form.minuteVal.value = tm;
  }else {
    var tdata = new Date().format(calendar.date2StringPattern),
    h = tdata.substr(11,2),
    mm = tdata.substr(14,2);
    calendar.dateControl.value = tdata;

    calendar.form.hourVal.value = h;
    calendar.form.minuteVal.value = mm;
  }

	var dateArray = this.getMonthViewDateArray(this.date.getFullYear(), this.date.getMonth());
	var tds = this.getElementsByTagName("td", this.getElementById("__calendarTable", this.iframe.document));
	for(var i = 0; i < tds.length; i++) {
    tds[i].style.backgroundColor = calendar.colors["bg_over"];
		tds[i].onclick = null;
		tds[i].onmouseover = null;
		tds[i].onmouseout = null;
		tds[i].innerHTML = dateArray[i] || "&nbsp;";
		if (i > dateArray.length - 1) continue;
		if (dateArray[i]){

      function clickfun(thtml) {
      	if (calendar.dateControl){
            var ymd = new Date(calendar.date.getFullYear(),
														calendar.date.getMonth(),
														thtml).format(calendar.date2StringPattern);
            var oldhms = calendar.dateControl.value.substr(10);
            if (calendar.mmbtn){
              calendar.dateControl.value = ymd.substr(0,10) + oldhms;
            } else {
              calendar.dateControl.value = ymd.substr(0,10);
            }
            
				}
				//calendar.hide();
      
      }

			tds[i].onclick = function () {
        //document.getElementByName('td').
        //this.style.backgroundColor= "#1A56A4";
        //this.setAttribute('class','cur');
        if (this.getAttribute('class') == 'disabled') return false;
        clickfun(this.innerHTML);
        calendar.panel.style.visibility = "hidden";
        calendar.panel.style.display = "none";
			}
			//tds[i].ondblclick = function () {
       // clickfun(this.innerHTML);
        //calendar.panel.style.visibility = "hidden";
        //calendar.panel.style.display = "none";
			//}

			//tds[i].onmouseover = function () {
        //this.style.backgroundColor = calendar.colors["bg_out"];
        //this.setAttribute('class','over');
      //}
			//tds[i].onmouseout  = function () {
        //this.style.backgroundColor = calendar.colors["bg_over"];
        //this.setAttribute('class','normal');
        //}
      var cls = tds[i].getAttribute('class') || ' ';
      if (cls && cls.indexOf('disabled')>-1) {
          cls = cls.replace('disabled', ' ');
          tds[i].setAttribute('class', cls);
      }

			var today = new Date();
			if (today.getFullYear() == calendar.date.getFullYear() ) {
				if (today.getMonth() == calendar.date.getMonth() ) {
					if (today.getDate() == dateArray[i] ) {
						tds[i].style.backgroundColor = calendar.colors["bg_cur_day"];
						tds[i].onmouseover = function () {this.style.backgroundColor = calendar.colors["bg_out"];}
						tds[i].onmouseout  = function () {this.style.backgroundColor = calendar.colors["bg_cur_day"];}
					} else if (today.getDate() < dateArray[i]) {
            tds[i].removeAttribute('class');
            tds[i].style.backgroundColor = calendar.colors["bg_over_cur_day"];
            tds[i].setAttribute('class','disabled');
          }
				}
			}
      /*if (today.getFullYear() <= calendar.date.getFullYear()) {
        console.log('1:'+today.getMonth());
        console.log('2:'+calendar.date.getMonth());
        if (today.getMonth() <= calendar.date.getMonth() ) {//&& today.getDate() < dateArray[i] 
          console.log('3:'+today.getDate());
          console.log('4:'+dateArray[i]);
          if ( today.getMonth() < calendar.date.getMonth() ) {
            //tds[i].removeAttribute('class');
            tds[i].style.backgroundColor = ''//calendar.colors["bg_over_cur_day"];
            tds[i].setAttribute('class','disabled');
          }
        }
      }*/
		}//end if
	}//end for
};

Calendar.prototype.getMonthViewDateArray = function (y, m) {
	var dateArray = new Array(42);
	var dayOfFirstDate = new Date(y, m, 1).getDay();
	var dateCountOfMonth = new Date(y, m + 1, 0).getDate();
	for (var i = 0; i < dateCountOfMonth; i++) {
		dateArray[i + dayOfFirstDate] = i + 1;
	}
	return dateArray;
};

Calendar.prototype.show = function (dateControl,mmbtn, popuControl) {
  this.mmbtn = mmbtn || false;
  if (!this.initDom) {this.initDoms();}
	if (this.panel.style.visibility == "visible") {
		this.panel.style.visibility = "hidden";
    this.panel.style.display = "none";
	}
	if (!dateControl){
		throw new Error("arguments[0] is necessary!")
	}
	this.dateControl = dateControl;
	popuControl = popuControl || dateControl;

	this.draw();
	this.bindYear();
	this.bindMonth();
	if (dateControl.value.length > 0){
		this.date  = new Date(dateControl.value.toDate(this.patternDelimiter, this.string2DatePattern));
		this.year  = this.date.getFullYear();
		this.month = this.date.getMonth();
	}
	this.changeSelect();
	this.bindData();

	/*var xy = this.getAbsPoint(popuControl);
	this.panel.style.left = xy.x + "px";
	this.panel.style.top = (xy.y + dateControl.offsetHeight) + "px";*/
	this.panel.style.visibility = "visible";
  this.panel.style.display = "block";
};

Calendar.prototype.hide = function() {
	this.panel.style.visibility = "hidden";
  this.panel.style.display = "none";
};

Calendar.prototype.getElementById = function(id, object){
	object = object || document;
	return document.getElementById ? object.getElementById(id) : document.all(id);
};

Calendar.prototype.getElementsByTagName = function(tagName, object){
	object = object || document;
	return document.getElementsByTagName ? object.getElementsByTagName(tagName) : document.all.tags(tagName);
};

Calendar.prototype.getAbsPoint = function (e){
	var x = e.offsetLeft;
	var y = e.offsetTop;
	while(e = e.offsetParent){
		x += e.offsetLeft;
		y += e.offsetTop;
	}
	return {"x": x, "y": y};
};

Calendar.prototype.initDoms = function () {
  var arr = [];
  var titArr = [];
  arr.push('<div id="__calendarPanel" style=" overflow: hidden; left:50%;top:50%;margin: -117px 0px auto -122px;border-radius:5px;  -moz-border-radius:5px;-webkit-border-radius:5px;position:absolute;visibility:hidden;display:none;z-index:9999;background-color:#FFFFFF;padding-top:2px;border:1px solid #cccccc;width:244px;height:271px;">');
  arr.push('<iframe name="__calendarIframe" id="__calendarIframe" width="100%" height="100%" scrolling="no" frameborder="0" style="margin:0px;opacity:1;">');
//var __ci = window.frames['__calendarIframe'];
  arr.push("<!DOCTYPE html>");
  arr.push('<html>');
  arr.push('<head>');
  titArr.push('<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />');
  titArr.push('<title>Web Calendar(UTF-8) Written By KimSoft</title>');

  titArr.push('<style type="text/css">');
  //titArr.push('<!--');
  titArr.push('body {font-size:12px;margin:0px;text-align:center;}');
  titArr.push('form {margin:0px;}');
  titArr.push('select {outline: none;font-size:12px; margin: 0 5px; color: #000000;}');
  titArr.push('table {background-color:#FFFFFF }');
  titArr.push('th {padding:0px;font-size:12px;font-weight:normal;background-color:#FAFAFA;}');
  titArr.push('th.theader {font-weight:normal;background-color:#fafafa;color:#000000;}');
  titArr.push('th.theader.first {color: #B8B8B8;padding-left:18px;width:40px;}');
  titArr.push('th.theader.last {color: #B8B8B8;padding-right:18px;width:40px;}');
  titArr.push('select.year {width:72px; padding:2px 0;}');
  titArr.push('select.month {width:65px; padding:2px 0;}');
  titArr.push('tr {text-align:center;padding: 0px;display:block;margin:0 auto; width:210px;}');
  titArr.push('td { background-color:#FAFAFA; border-radius:15px;  -moz-border-radius:15px;-webkit-border-radius:15px;font-size:12px;text-align:center; height:30px; width:30px;line-height:30px;margin:0 1px;display:inline-block;padding:0px;}');
  titArr.push('td.sat { width:30px; border-radius:15px;  -moz-border-radius:15px;-webkit-border-radius:15px;color:#b8b8b8;background-color:#ffffff;}');
  titArr.push('td.sun { border-radius:15px;  -moz-border-radius:15px;-webkit-border-radius:15px;color:#b8b8b8;background-color:#ffffff;}');
  titArr.push('td.normal {background-color:#ffffff;}');
  titArr.push('td.disabled {background-color:#CCCCCC; opacity:0.5}');

  titArr.push('input.l {outline: none;border: 1px solid #78A4DD; -moz-border-radius: 15px; -webkit-border-radius: 15px; border-radius: 15px; font-weight: 900; color: #78A4DD;background-color:#FFFFFF;width:23px;height:23px;}');

  titArr.push('input.r {outline: none;border: 1px solid #78A4DD;-moz-border-radius: 15px; -webkit-border-radius: 15px; border-radius: 15px; font-weight: 900; color: #78A4DD;background-color:#FFFFFF;width:23px;height:23px;}');
  titArr.push('input.b {outline: none;border: 1px solid #bcbcbc;-moz-border-radius: 3px; -webkit-border-radius: 3px; border-radius: 3px;  color: #000000;background-color:#FFFFFF;width:100%;height:26px;}');

  titArr.push('.thCl{text-align:left; font-weight: bold; padding-left: 5px;}');
  titArr.push('.thCl .cth{text-align:center;}');

  titArr.push('.thCl span{ width:60px; font-size: 12px;display:block;float:left;margin:0px 0px 0 0;}');
  titArr.push('.thCl input {background-color: #FFFFFF;color: #000000; padding: 2px 3px; font-size: 13px;width: 30px;height: 17px;border: 0px solid black;font-weight:bold;font-family: "宋体";text-align: center;}');
  titArr.push('.thCl .inputWrap{ margin: 0 0px 2px 5px; float:left;border: solid 1px #d4d4d4;width: 85px;line-height:30px;height: 30px;background-color: #FFFFFF;overflow: hidden;text-align: center;}');
  titArr.push('.thCl .buttons{outline:none;display:block; text-align: center; text-decoration: none;font-weight: bold;margin:0 0 3px 10px;background-color: #f0f0f0;color:#000000; border: solid 1px #78A4DD; width: 50px;line-height:12px;height: 12px;font-size: 17px;}');
  titArr.push('.thCl .btnWrap{ display:inline-block;}');

  titArr.push('.toptit{width: 244px; background-color:#fafafa;height:24px;padding:0px 0 0;}');
  titArr.push('.toptit .toplBtn{width:40px;}');
  titArr.push('.toptit .toprBtn{width:40px;}');
  titArr.push('.toptit .topSelectWrap{width:184px;}');
  titArr.push('.toptit.line {padding:0 0 0;border-bottom: 1px solid #E4E4E4;margin-bottom:0px;}');
  titArr.push('.toptit.line th{}');
  titArr.push('.toptit th{background-color:#fafafa;padding:0 1px;height:31px;width:31px;}');

  titArr.push('.trchange  { width:244px; height:40px; background-color: #FAFAFA; padding: 0px 0px 0px;border-top: 1px solid #E4E4E4;}');
  titArr.push('.trchange th{height:30px; padding:5px 0 0px 5px; background-color: #FAFAFA; }');

  titArr.push('.trbtns {width:244px; padding:0;background-color: #FAFAFA; height:35px; }');
  titArr.push('.trbtns .thbtn3 {width:90px; }');

  titArr.push('.trbtns th{ padding:0px 5px 0px 0px; height:30px; width: 67px;}');
  titArr.push('td.cur{ background-color:#1a56a4; color:#ffffff;}');
  titArr.push('td:hover{ background-color:#ffcc00; }');
  titArr.push('td.out{ background-color:#ffffff; }');

  titArr.push('.noBg th{ background-color:#ffffff; }');


  //titArr.push('-->');
  titArr.push('</style>');
  titArr.push('</head>');
  arr.push('<body>');
  arr.push('</body>');
  arr.push('</html>');
  arr.push('</iframe>');
//__ci.document.close();
 arr.push('</div>');
  //var bodys = document.getElementsByTagName('body');
  //this.iframe.document.body.innerHTML = arr.join("");
  $('body').append(arr.join(''));
  this.initDom = true;
  this.panel  = this.getElementById("__calendarPanel");
	this.iframe = window.frames["__calendarIframe"];
  this.iframe.document.head.innerHTML = titArr.join("");
};
/**
 * @param   d the delimiter
 * @param   p the pattern of your date
 * @author  meizz
 * @author  kimsoft add w+ pattern
 */
Date.prototype.format = function(style) {
	var o = {
		"M+" : this.getMonth() + 1, //month
		"d+" : this.getDate(),      //day
		"h+" : this.getHours(),     //hour
		"m+" : this.getMinutes(),   //minute
		"s+" : this.getSeconds(),   //second
		"w+" : "\u65e5\u4e00\u4e8c\u4e09\u56db\u4e94\u516d".charAt(this.getDay()),   //week
		"q+" : Math.floor((this.getMonth() + 3) / 3),  //quarter
		"S"  : this.getMilliseconds() //millisecond
	}
	if (/(y+)/.test(style)) {
		style = style.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	for(var k in o){
		if (new RegExp("("+ k +")").test(style)){
			style = style.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return style;
};

/**
 * @param d the delimiter
 * @param p the pattern of your date
 * @rebuilder kimsoft
 * @version build 2006.12.15
 */
String.prototype.toDate = function(delimiter, pattern) {
	delimiter = delimiter || "-";
	pattern = pattern || "ymd";
	var a = this.split(delimiter);
	var y = parseInt(a[pattern.indexOf("y")], 10);
	//remember to change this next century ;)
	if(y.toString().length <= 2) y += 2000;
	if(isNaN(y)) y = new Date().getFullYear();
	var m = parseInt(a[pattern.indexOf("m")], 10) - 1;
	var d = parseInt(a[pattern.indexOf("d")], 10);
	if(isNaN(d)) d = 1;
	return new Date(y, m, d);
};

//var calendar = new Calendar();
//-->