﻿///<jscompress sourcefile="campaign.js" />
window.campaign = {
    isTempUser:function(loginInfo){
        if ((loginInfo.id + "").indexOf("T") == 0 || (loginInfo.su && (loginInfo.su.userType + "").indexOf("3") == 0)) {
            return true;
        } else {
            return false;
        }
    },
    isWeChat: function () {
        var ua = window.navigator.userAgent.toLowerCase();
        if (ua.match(/MicroMessenger/i) == 'micromessenger') {
            return true;
        } else {
            return false;
        }
    },
    isAliPay: function () {
        if (navigator.userAgent.indexOf("AlipayClient") === -1)
            return false;
        else
            return true;
    },
    isCampaignDomain : function (url) { //白名单
		if (null == url) {
			return false;
		}
        if (location.href.indexOf("https://tlogin") == 0) { //uat
            return url.indexOf("https://csr") == 0 || url.indexOf("https://tcsr") == 0 || url.indexOf("localhost") != -1 ? true : false;
        } else if (location.href.indexOf("https://login") == 0) {   //prod
            return url.indexOf("https://csr") == 0 || url.indexOf("https://tcsr") == 0 ? true : false;
        }else{ //本地
            return true;
        }
    },
    filterCampaignUrl:function(url,_3rdUser,loginType){
        var link = "" , queryStr = "";
        if (url.indexOf("?") != -1) {
            var arr = url.split("?");
            link = arr[0];
            queryStr = url.substring(link.length+1).replace("_3rdUser="+_3rdUser,"").replace("loginType="+loginType,"");
            //解决多种参数问题
            var paramArr = queryStr.split("&");
            var tempParamArr = [];
            for(var i in paramArr){
                if (paramArr[i].replace(" ","") != "") {
                    tempParamArr.push(paramArr[i]);
                }
            }
            queryStr = tempParamArr.join("&");
        } else {
            link = url;
        }
        var newUrl = queryStr == "" ? link : [link,queryStr].join("?");
        var hasBizParams = queryStr == "" ? false :true;

        return {
            url : newUrl,
            hasBizParams:hasBizParams
        };
    },
    dealCampaignUrl:function(url) {
        //campaignUrl?_3rdUser=0&loginType=0;_3rdUser需要第三方信息；loginType：0 返回临时用户；login：1 返回正式用户；
        var _3rdUser = this.getQueryParameter("_3rdUser", url) || 0;
        var loginType = this.getQueryParameter("loginType", url) || 1;
        var urlInfo = this.filterCampaignUrl(url,_3rdUser,loginType);
        return {
            _3rdInfo:_3rdUser,
            loginType:loginType,
            campUrl:urlInfo.url,
            hasBizParam:urlInfo.hasBizParams
        };
    },
    getUrlParams:function(url){
        var len = 0;
        if (url.indexOf("?") != -1) {
            var arr = url.split("?");
            len = arr[0].length;
        }
        return url.substring(len);
    },
    getQueryParameter:function (name,url) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var search = this.getUrlParams(url);
        var r = search.substr(1).match(reg);
        // if (r!=null) return unescape(r[2]); return null;
        if (r != null) return decodeURIComponent(r[2]);
        return null;
    },
    /**
     *
     * @param url : campaignUrl，必填
     * @param loginInfo:sso用户信息； 必填
     * @param _3rdInfo：第三方系统用户信息，主要包括用户id，头像和昵称；必填
     *
     * @return newUrl 如果为空，前端不跳转，否则跳转；
     */
    getNewUrlByLoginInfo:function (url,loginInfo,_3rdInfo) {
        //openid作为第三方系统的唯一标识符，支付宝渠道对应支付宝用户id，微信对应openid
        var campObj = this.dealCampaignUrl(url);
        var newUrl = campObj.campUrl;
        var returnFlag = true;  //true：需要返回完整的url，false：返回null；
        if (this.isWeChat()) {
            if (this.isTempUser(loginInfo)) {
                if (campObj.loginType == 0) {   //允许临时用户访问--走transfer逻辑，可以获取_3rdInfo,走cache，暂时不获取_3rdInfo
                    if (campObj._3rdInfo == 1 && _3rdInfo != null) { //传第三方信息
                        newUrl += (campObj.hasBizParam?"&":"?")+"token=" + loginInfo.token + "&userCode=" + loginInfo.muid + "&openId=" + _3rdInfo.openId + "&avatar=" + _3rdInfo.avatar + "&nickName=" + _3rdInfo.nickName;
                    } else {
                        //获取用户信息
                        newUrl += (campObj.hasBizParam?"&":"?")+"token=" + loginInfo.token + "&userCode=" + loginInfo.muid;
                    }
                } else {
                    returnFlag = false; //临时用户，但活动页要求返回正式用户
                }
            } else {    //正式用户--不论loginType是什么值，统一返回正式用户信息--走cache，暂时不获取_3rdInfo
                if (campObj._3rdInfo == 1 && _3rdInfo != null) { //传第三方信息
                    newUrl += (campObj.hasBizParam?"&":"?")+"token=" + loginInfo.token + "&userCode=" + loginInfo.muid + "&openId=" + _3rdInfo.openId + "&avatar=" + _3rdInfo.avatar + "&nickName=" + _3rdInfo.nickName;
                } else {
                    //获取用户信息
                    newUrl += (campObj.hasBizParam?"&":"?")+"token=" + loginInfo.token + "&userCode=" + loginInfo.muid;
                }
            }
        } else if (this.isAliPay()) {   //统一返回正式用户，仅sso信息--支付宝用户id预留处理
            newUrl += (campObj.hasBizParam?"&":"?")+"token=" + loginInfo.token + "&userCode=" + loginInfo.muid;
        } else {    //非微信和支付宝渠道
            newUrl += (campObj.hasBizParam?"&":"?")+"token=" + loginInfo.token + "&userCode=" + loginInfo.muid;
        }
        return returnFlag?newUrl:null;
    }
};
//var link = "http://localhost:8080/poc_test1/modules/normalUser.html";
//var link = "http://localhost:8080/poc_test1/modules/normalUser.html?a=1&b=2";
//var link = "http://localhost:8080/poc_test1/modules/normalUser.html?_3rdUser=1&b=2&loginType=1";
//var link = "http://localhost:8080/poc_test1/modules/normalUser.html?_3rdUser=1&loginType=1&a=1&b=2";
//window.campaign.dealCampaignUrl(link);;
///<jscompress sourcefile="jquery-1.8.0.js" />
/*! jQuery v@1.8.0 jquery.com | jquery.org/license */
(function(a,b){function G(a){var b=F[a]={};return p.each(a.split(s),function(a,c){b[c]=!0}),b}function J(a,c,d){if(d===b&&a.nodeType===1){var e="data-"+c.replace(I,"-$1").toLowerCase();d=a.getAttribute(e);if(typeof d=="string"){try{d=d==="true"?!0:d==="false"?!1:d==="null"?null:+d+""===d?+d:H.test(d)?p.parseJSON(d):d}catch(f){}p.data(a,c,d)}else d=b}return d}function K(a){var b;for(b in a){if(b==="data"&&p.isEmptyObject(a[b]))continue;if(b!=="toJSON")return!1}return!0}function ba(){return!1}function bb(){return!0}function bh(a){return!a||!a.parentNode||a.parentNode.nodeType===11}function bi(a,b){do a=a[b];while(a&&a.nodeType!==1);return a}function bj(a,b,c){b=b||0;if(p.isFunction(b))return p.grep(a,function(a,d){var e=!!b.call(a,d,a);return e===c});if(b.nodeType)return p.grep(a,function(a,d){return a===b===c});if(typeof b=="string"){var d=p.grep(a,function(a){return a.nodeType===1});if(be.test(b))return p.filter(b,d,!c);b=p.filter(b,d)}return p.grep(a,function(a,d){return p.inArray(a,b)>=0===c})}function bk(a){var b=bl.split("|"),c=a.createDocumentFragment();if(c.createElement)while(b.length)c.createElement(b.pop());return c}function bC(a,b){return a.getElementsByTagName(b)[0]||a.appendChild(a.ownerDocument.createElement(b))}function bD(a,b){if(b.nodeType!==1||!p.hasData(a))return;var c,d,e,f=p._data(a),g=p._data(b,f),h=f.events;if(h){delete g.handle,g.events={};for(c in h)for(d=0,e=h[c].length;d<e;d++)p.event.add(b,c,h[c][d])}g.data&&(g.data=p.extend({},g.data))}function bE(a,b){var c;if(b.nodeType!==1)return;b.clearAttributes&&b.clearAttributes(),b.mergeAttributes&&b.mergeAttributes(a),c=b.nodeName.toLowerCase(),c==="object"?(b.parentNode&&(b.outerHTML=a.outerHTML),p.support.html5Clone&&a.innerHTML&&!p.trim(b.innerHTML)&&(b.innerHTML=a.innerHTML)):c==="input"&&bv.test(a.type)?(b.defaultChecked=b.checked=a.checked,b.value!==a.value&&(b.value=a.value)):c==="option"?b.selected=a.defaultSelected:c==="input"||c==="textarea"?b.defaultValue=a.defaultValue:c==="script"&&b.text!==a.text&&(b.text=a.text),b.removeAttribute(p.expando)}function bF(a){return typeof a.getElementsByTagName!="undefined"?a.getElementsByTagName("*"):typeof a.querySelectorAll!="undefined"?a.querySelectorAll("*"):[]}function bG(a){bv.test(a.type)&&(a.defaultChecked=a.checked)}function bX(a,b){if(b in a)return b;var c=b.charAt(0).toUpperCase()+b.slice(1),d=b,e=bV.length;while(e--){b=bV[e]+c;if(b in a)return b}return d}function bY(a,b){return a=b||a,p.css(a,"display")==="none"||!p.contains(a.ownerDocument,a)}function bZ(a,b){var c,d,e=[],f=0,g=a.length;for(;f<g;f++){c=a[f];if(!c.style)continue;e[f]=p._data(c,"olddisplay"),b?(!e[f]&&c.style.display==="none"&&(c.style.display=""),c.style.display===""&&bY(c)&&(e[f]=p._data(c,"olddisplay",cb(c.nodeName)))):(d=bH(c,"display"),!e[f]&&d!=="none"&&p._data(c,"olddisplay",d))}for(f=0;f<g;f++){c=a[f];if(!c.style)continue;if(!b||c.style.display==="none"||c.style.display==="")c.style.display=b?e[f]||"":"none"}return a}function b$(a,b,c){var d=bO.exec(b);return d?Math.max(0,d[1]-(c||0))+(d[2]||"px"):b}function b_(a,b,c,d){var e=c===(d?"border":"content")?4:b==="width"?1:0,f=0;for(;e<4;e+=2)c==="margin"&&(f+=p.css(a,c+bU[e],!0)),d?(c==="content"&&(f-=parseFloat(bH(a,"padding"+bU[e]))||0),c!=="margin"&&(f-=parseFloat(bH(a,"border"+bU[e]+"Width"))||0)):(f+=parseFloat(bH(a,"padding"+bU[e]))||0,c!=="padding"&&(f+=parseFloat(bH(a,"border"+bU[e]+"Width"))||0));return f}function ca(a,b,c){var d=b==="width"?a.offsetWidth:a.offsetHeight,e=!0,f=p.support.boxSizing&&p.css(a,"boxSizing")==="border-box";if(d<=0){d=bH(a,b);if(d<0||d==null)d=a.style[b];if(bP.test(d))return d;e=f&&(p.support.boxSizingReliable||d===a.style[b]),d=parseFloat(d)||0}return d+b_(a,b,c||(f?"border":"content"),e)+"px"}function cb(a){if(bR[a])return bR[a];var b=p("<"+a+">").appendTo(e.body),c=b.css("display");b.remove();if(c==="none"||c===""){bI=e.body.appendChild(bI||p.extend(e.createElement("iframe"),{frameBorder:0,width:0,height:0}));if(!bJ||!bI.createElement)bJ=(bI.contentWindow||bI.contentDocument).document,bJ.write("<!doctype html><html><body>"),bJ.close();b=bJ.body.appendChild(bJ.createElement(a)),c=bH(b,"display"),e.body.removeChild(bI)}return bR[a]=c,c}function ch(a,b,c,d){var e;if(p.isArray(b))p.each(b,function(b,e){c||cd.test(a)?d(a,e):ch(a+"["+(typeof e=="object"?b:"")+"]",e,c,d)});else if(!c&&p.type(b)==="object")for(e in b)ch(a+"["+e+"]",b[e],c,d);else d(a,b)}function cy(a){return function(b,c){typeof b!="string"&&(c=b,b="*");var d,e,f,g=b.toLowerCase().split(s),h=0,i=g.length;if(p.isFunction(c))for(;h<i;h++)d=g[h],f=/^\+/.test(d),f&&(d=d.substr(1)||"*"),e=a[d]=a[d]||[],e[f?"unshift":"push"](c)}}function cz(a,c,d,e,f,g){f=f||c.dataTypes[0],g=g||{},g[f]=!0;var h,i=a[f],j=0,k=i?i.length:0,l=a===cu;for(;j<k&&(l||!h);j++)h=i[j](c,d,e),typeof h=="string"&&(!l||g[h]?h=b:(c.dataTypes.unshift(h),h=cz(a,c,d,e,h,g)));return(l||!h)&&!g["*"]&&(h=cz(a,c,d,e,"*",g)),h}function cA(a,c){var d,e,f=p.ajaxSettings.flatOptions||{};for(d in c)c[d]!==b&&((f[d]?a:e||(e={}))[d]=c[d]);e&&p.extend(!0,a,e)}function cB(a,c,d){var e,f,g,h,i=a.contents,j=a.dataTypes,k=a.responseFields;for(f in k)f in d&&(c[k[f]]=d[f]);while(j[0]==="*")j.shift(),e===b&&(e=a.mimeType||c.getResponseHeader("content-type"));if(e)for(f in i)if(i[f]&&i[f].test(e)){j.unshift(f);break}if(j[0]in d)g=j[0];else{for(f in d){if(!j[0]||a.converters[f+" "+j[0]]){g=f;break}h||(h=f)}g=g||h}if(g)return g!==j[0]&&j.unshift(g),d[g]}function cC(a,b){var c,d,e,f,g=a.dataTypes.slice(),h=g[0],i={},j=0;a.dataFilter&&(b=a.dataFilter(b,a.dataType));if(g[1])for(c in a.converters)i[c.toLowerCase()]=a.converters[c];for(;e=g[++j];)if(e!=="*"){if(h!=="*"&&h!==e){c=i[h+" "+e]||i["* "+e];if(!c)for(d in i){f=d.split(" ");if(f[1]===e){c=i[h+" "+f[0]]||i["* "+f[0]];if(c){c===!0?c=i[d]:i[d]!==!0&&(e=f[0],g.splice(j--,0,e));break}}}if(c!==!0)if(c&&a["throws"])b=c(b);else try{b=c(b)}catch(k){return{state:"parsererror",error:c?k:"No conversion from "+h+" to "+e}}}h=e}return{state:"success",data:b}}function cK(){try{return new a.XMLHttpRequest}catch(b){}}function cL(){try{return new a.ActiveXObject("Microsoft.XMLHTTP")}catch(b){}}function cT(){return setTimeout(function(){cM=b},0),cM=p.now()}function cU(a,b){p.each(b,function(b,c){var d=(cS[b]||[]).concat(cS["*"]),e=0,f=d.length;for(;e<f;e++)if(d[e].call(a,b,c))return})}function cV(a,b,c){var d,e=0,f=0,g=cR.length,h=p.Deferred().always(function(){delete i.elem}),i=function(){var b=cM||cT(),c=Math.max(0,j.startTime+j.duration-b),d=1-(c/j.duration||0),e=0,f=j.tweens.length;for(;e<f;e++)j.tweens[e].run(d);return h.notifyWith(a,[j,d,c]),d<1&&f?c:(h.resolveWith(a,[j]),!1)},j=h.promise({elem:a,props:p.extend({},b),opts:p.extend(!0,{specialEasing:{}},c),originalProperties:b,originalOptions:c,startTime:cM||cT(),duration:c.duration,tweens:[],createTween:function(b,c,d){var e=p.Tween(a,j.opts,b,c,j.opts.specialEasing[b]||j.opts.easing);return j.tweens.push(e),e},stop:function(b){var c=0,d=b?j.tweens.length:0;for(;c<d;c++)j.tweens[c].run(1);return b?h.resolveWith(a,[j,b]):h.rejectWith(a,[j,b]),this}}),k=j.props;cW(k,j.opts.specialEasing);for(;e<g;e++){d=cR[e].call(j,a,k,j.opts);if(d)return d}return cU(j,k),p.isFunction(j.opts.start)&&j.opts.start.call(a,j),p.fx.timer(p.extend(i,{anim:j,queue:j.opts.queue,elem:a})),j.progress(j.opts.progress).done(j.opts.done,j.opts.complete).fail(j.opts.fail).always(j.opts.always)}function cW(a,b){var c,d,e,f,g;for(c in a){d=p.camelCase(c),e=b[d],f=a[c],p.isArray(f)&&(e=f[1],f=a[c]=f[0]),c!==d&&(a[d]=f,delete a[c]),g=p.cssHooks[d];if(g&&"expand"in g){f=g.expand(f),delete a[d];for(c in f)c in a||(a[c]=f[c],b[c]=e)}else b[d]=e}}function cX(a,b,c){var d,e,f,g,h,i,j,k,l=this,m=a.style,n={},o=[],q=a.nodeType&&bY(a);c.queue||(j=p._queueHooks(a,"fx"),j.unqueued==null&&(j.unqueued=0,k=j.empty.fire,j.empty.fire=function(){j.unqueued||k()}),j.unqueued++,l.always(function(){l.always(function(){j.unqueued--,p.queue(a,"fx").length||j.empty.fire()})})),a.nodeType===1&&("height"in b||"width"in b)&&(c.overflow=[m.overflow,m.overflowX,m.overflowY],p.css(a,"display")==="inline"&&p.css(a,"float")==="none"&&(!p.support.inlineBlockNeedsLayout||cb(a.nodeName)==="inline"?m.display="inline-block":m.zoom=1)),c.overflow&&(m.overflow="hidden",p.support.shrinkWrapBlocks||l.done(function(){m.overflow=c.overflow[0],m.overflowX=c.overflow[1],m.overflowY=c.overflow[2]}));for(d in b){f=b[d];if(cO.exec(f)){delete b[d];if(f===(q?"hide":"show"))continue;o.push(d)}}g=o.length;if(g){h=p._data(a,"fxshow")||p._data(a,"fxshow",{}),q?p(a).show():l.done(function(){p(a).hide()}),l.done(function(){var b;p.removeData(a,"fxshow",!0);for(b in n)p.style(a,b,n[b])});for(d=0;d<g;d++)e=o[d],i=l.createTween(e,q?h[e]:0),n[e]=h[e]||p.style(a,e),e in h||(h[e]=i.start,q&&(i.end=i.start,i.start=e==="width"||e==="height"?1:0))}}function cY(a,b,c,d,e){return new cY.prototype.init(a,b,c,d,e)}function cZ(a,b){var c,d={height:a},e=0;for(;e<4;e+=2-b)c=bU[e],d["margin"+c]=d["padding"+c]=a;return b&&(d.opacity=d.width=a),d}function c_(a){return p.isWindow(a)?a:a.nodeType===9?a.defaultView||a.parentWindow:!1}var c,d,e=a.document,f=a.location,g=a.navigator,h=a.jQuery,i=a.$,j=Array.prototype.push,k=Array.prototype.slice,l=Array.prototype.indexOf,m=Object.prototype.toString,n=Object.prototype.hasOwnProperty,o=String.prototype.trim,p=function(a,b){return new p.fn.init(a,b,c)},q=/[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source,r=/\S/,s=/\s+/,t=r.test(" ")?/^[\s\xA0]+|[\s\xA0]+$/g:/^\s+|\s+$/g,u=/^(?:[^#<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,v=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,w=/^[\],:{}\s]*$/,x=/(?:^|:|,)(?:\s*\[)+/g,y=/\\(?:["\\\/bfnrt]|u[\da-fA-F]{4})/g,z=/"[^"\\\r\n]*"|true|false|null|-?(?:\d\d*\.|)\d+(?:[eE][\-+]?\d+|)/g,A=/^-ms-/,B=/-([\da-z])/gi,C=function(a,b){return(b+"").toUpperCase()},D=function(){e.addEventListener?(e.removeEventListener("DOMContentLoaded",D,!1),p.ready()):e.readyState==="complete"&&(e.detachEvent("onreadystatechange",D),p.ready())},E={};p.fn=p.prototype={constructor:p,init:function(a,c,d){var f,g,h,i;if(!a)return this;if(a.nodeType)return this.context=this[0]=a,this.length=1,this;if(typeof a=="string"){a.charAt(0)==="<"&&a.charAt(a.length-1)===">"&&a.length>=3?f=[null,a,null]:f=u.exec(a);if(f&&(f[1]||!c)){if(f[1])return c=c instanceof p?c[0]:c,i=c&&c.nodeType?c.ownerDocument||c:e,a=p.parseHTML(f[1],i,!0),v.test(f[1])&&p.isPlainObject(c)&&this.attr.call(a,c,!0),p.merge(this,a);g=e.getElementById(f[2]);if(g&&g.parentNode){if(g.id!==f[2])return d.find(a);this.length=1,this[0]=g}return this.context=e,this.selector=a,this}return!c||c.jquery?(c||d).find(a):this.constructor(c).find(a)}return p.isFunction(a)?d.ready(a):(a.selector!==b&&(this.selector=a.selector,this.context=a.context),p.makeArray(a,this))},selector:"",jquery:"1.8.0",length:0,size:function(){return this.length},toArray:function(){return k.call(this)},get:function(a){return a==null?this.toArray():a<0?this[this.length+a]:this[a]},pushStack:function(a,b,c){var d=p.merge(this.constructor(),a);return d.prevObject=this,d.context=this.context,b==="find"?d.selector=this.selector+(this.selector?" ":"")+c:b&&(d.selector=this.selector+"."+b+"("+c+")"),d},each:function(a,b){return p.each(this,a,b)},ready:function(a){return p.ready.promise().done(a),this},eq:function(a){return a=+a,a===-1?this.slice(a):this.slice(a,a+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(k.apply(this,arguments),"slice",k.call(arguments).join(","))},map:function(a){return this.pushStack(p.map(this,function(b,c){return a.call(b,c,b)}))},end:function(){return this.prevObject||this.constructor(null)},push:j,sort:[].sort,splice:[].splice},p.fn.init.prototype=p.fn,p.extend=p.fn.extend=function(){var a,c,d,e,f,g,h=arguments[0]||{},i=1,j=arguments.length,k=!1;typeof h=="boolean"&&(k=h,h=arguments[1]||{},i=2),typeof h!="object"&&!p.isFunction(h)&&(h={}),j===i&&(h=this,--i);for(;i<j;i++)if((a=arguments[i])!=null)for(c in a){d=h[c],e=a[c];if(h===e)continue;k&&e&&(p.isPlainObject(e)||(f=p.isArray(e)))?(f?(f=!1,g=d&&p.isArray(d)?d:[]):g=d&&p.isPlainObject(d)?d:{},h[c]=p.extend(k,g,e)):e!==b&&(h[c]=e)}return h},p.extend({noConflict:function(b){return a.$===p&&(a.$=i),b&&a.jQuery===p&&(a.jQuery=h),p},isReady:!1,readyWait:1,holdReady:function(a){a?p.readyWait++:p.ready(!0)},ready:function(a){if(a===!0?--p.readyWait:p.isReady)return;if(!e.body)return setTimeout(p.ready,1);p.isReady=!0;if(a!==!0&&--p.readyWait>0)return;d.resolveWith(e,[p]),p.fn.trigger&&p(e).trigger("ready").off("ready")},isFunction:function(a){return p.type(a)==="function"},isArray:Array.isArray||function(a){return p.type(a)==="array"},isWindow:function(a){return a!=null&&a==a.window},isNumeric:function(a){return!isNaN(parseFloat(a))&&isFinite(a)},type:function(a){return a==null?String(a):E[m.call(a)]||"object"},isPlainObject:function(a){if(!a||p.type(a)!=="object"||a.nodeType||p.isWindow(a))return!1;try{if(a.constructor&&!n.call(a,"constructor")&&!n.call(a.constructor.prototype,"isPrototypeOf"))return!1}catch(c){return!1}var d;for(d in a);return d===b||n.call(a,d)},isEmptyObject:function(a){var b;for(b in a)return!1;return!0},error:function(a){throw new Error(a)},parseHTML:function(a,b,c){var d;return!a||typeof a!="string"?null:(typeof b=="boolean"&&(c=b,b=0),b=b||e,(d=v.exec(a))?[b.createElement(d[1])]:(d=p.buildFragment([a],b,c?null:[]),p.merge([],(d.cacheable?p.clone(d.fragment):d.fragment).childNodes)))},parseJSON:function(b){if(!b||typeof b!="string")return null;b=p.trim(b);if(a.JSON&&a.JSON.parse)return a.JSON.parse(b);if(w.test(b.replace(y,"@").replace(z,"]").replace(x,"")))return(new Function("return "+b))();p.error("Invalid JSON: "+b)},parseXML:function(c){var d,e;if(!c||typeof c!="string")return null;try{a.DOMParser?(e=new DOMParser,d=e.parseFromString(c,"text/xml")):(d=new ActiveXObject("Microsoft.XMLDOM"),d.async="false",d.loadXML(c))}catch(f){d=b}return(!d||!d.documentElement||d.getElementsByTagName("parsererror").length)&&p.error("Invalid XML: "+c),d},noop:function(){},globalEval:function(b){b&&r.test(b)&&(a.execScript||function(b){a.eval.call(a,b)})(b)},camelCase:function(a){return a.replace(A,"ms-").replace(B,C)},nodeName:function(a,b){return a.nodeName&&a.nodeName.toUpperCase()===b.toUpperCase()},each:function(a,c,d){var e,f=0,g=a.length,h=g===b||p.isFunction(a);if(d){if(h){for(e in a)if(c.apply(a[e],d)===!1)break}else for(;f<g;)if(c.apply(a[f++],d)===!1)break}else if(h){for(e in a)if(c.call(a[e],e,a[e])===!1)break}else for(;f<g;)if(c.call(a[f],f,a[f++])===!1)break;return a},trim:o?function(a){return a==null?"":o.call(a)}:function(a){return a==null?"":a.toString().replace(t,"")},makeArray:function(a,b){var c,d=b||[];return a!=null&&(c=p.type(a),a.length==null||c==="string"||c==="function"||c==="regexp"||p.isWindow(a)?j.call(d,a):p.merge(d,a)),d},inArray:function(a,b,c){var d;if(b){if(l)return l.call(b,a,c);d=b.length,c=c?c<0?Math.max(0,d+c):c:0;for(;c<d;c++)if(c in b&&b[c]===a)return c}return-1},merge:function(a,c){var d=c.length,e=a.length,f=0;if(typeof d=="number")for(;f<d;f++)a[e++]=c[f];else while(c[f]!==b)a[e++]=c[f++];return a.length=e,a},grep:function(a,b,c){var d,e=[],f=0,g=a.length;c=!!c;for(;f<g;f++)d=!!b(a[f],f),c!==d&&e.push(a[f]);return e},map:function(a,c,d){var e,f,g=[],h=0,i=a.length,j=a instanceof p||i!==b&&typeof i=="number"&&(i>0&&a[0]&&a[i-1]||i===0||p.isArray(a));if(j)for(;h<i;h++)e=c(a[h],h,d),e!=null&&(g[g.length]=e);else for(f in a)e=c(a[f],f,d),e!=null&&(g[g.length]=e);return g.concat.apply([],g)},guid:1,proxy:function(a,c){var d,e,f;return typeof c=="string"&&(d=a[c],c=a,a=d),p.isFunction(a)?(e=k.call(arguments,2),f=function(){return a.apply(c,e.concat(k.call(arguments)))},f.guid=a.guid=a.guid||f.guid||p.guid++,f):b},access:function(a,c,d,e,f,g,h){var i,j=d==null,k=0,l=a.length;if(d&&typeof d=="object"){for(k in d)p.access(a,c,k,d[k],1,g,e);f=1}else if(e!==b){i=h===b&&p.isFunction(e),j&&(i?(i=c,c=function(a,b,c){return i.call(p(a),c)}):(c.call(a,e),c=null));if(c)for(;k<l;k++)c(a[k],d,i?e.call(a[k],k,c(a[k],d)):e,h);f=1}return f?a:j?c.call(a):l?c(a[0],d):g},now:function(){return(new Date).getTime()}}),p.ready.promise=function(b){if(!d){d=p.Deferred();if(e.readyState==="complete"||e.readyState!=="loading"&&e.addEventListener)setTimeout(p.ready,1);else if(e.addEventListener)e.addEventListener("DOMContentLoaded",D,!1),a.addEventListener("load",p.ready,!1);else{e.attachEvent("onreadystatechange",D),a.attachEvent("onload",p.ready);var c=!1;try{c=a.frameElement==null&&e.documentElement}catch(f){}c&&c.doScroll&&function g(){if(!p.isReady){try{c.doScroll("left")}catch(a){return setTimeout(g,50)}p.ready()}}()}}return d.promise(b)},p.each("Boolean Number String Function Array Date RegExp Object".split(" "),function(a,b){E["[object "+b+"]"]=b.toLowerCase()}),c=p(e);var F={};p.Callbacks=function(a){a=typeof a=="string"?F[a]||G(a):p.extend({},a);var c,d,e,f,g,h,i=[],j=!a.once&&[],k=function(b){c=a.memory&&b,d=!0,h=f||0,f=0,g=i.length,e=!0;for(;i&&h<g;h++)if(i[h].apply(b[0],b[1])===!1&&a.stopOnFalse){c=!1;break}e=!1,i&&(j?j.length&&k(j.shift()):c?i=[]:l.disable())},l={add:function(){if(i){var b=i.length;(function d(b){p.each(b,function(b,c){p.isFunction(c)&&(!a.unique||!l.has(c))?i.push(c):c&&c.length&&d(c)})})(arguments),e?g=i.length:c&&(f=b,k(c))}return this},remove:function(){return i&&p.each(arguments,function(a,b){var c;while((c=p.inArray(b,i,c))>-1)i.splice(c,1),e&&(c<=g&&g--,c<=h&&h--)}),this},has:function(a){return p.inArray(a,i)>-1},empty:function(){return i=[],this},disable:function(){return i=j=c=b,this},disabled:function(){return!i},lock:function(){return j=b,c||l.disable(),this},locked:function(){return!j},fireWith:function(a,b){return b=b||[],b=[a,b.slice?b.slice():b],i&&(!d||j)&&(e?j.push(b):k(b)),this},fire:function(){return l.fireWith(this,arguments),this},fired:function(){return!!d}};return l},p.extend({Deferred:function(a){var b=[["resolve","done",p.Callbacks("once memory"),"resolved"],["reject","fail",p.Callbacks("once memory"),"rejected"],["notify","progress",p.Callbacks("memory")]],c="pending",d={state:function(){return c},always:function(){return e.done(arguments).fail(arguments),this},then:function(){var a=arguments;return p.Deferred(function(c){p.each(b,function(b,d){var f=d[0],g=a[b];e[d[1]](p.isFunction(g)?function(){var a=g.apply(this,arguments);a&&p.isFunction(a.promise)?a.promise().done(c.resolve).fail(c.reject).progress(c.notify):c[f+"With"](this===e?c:this,[a])}:c[f])}),a=null}).promise()},promise:function(a){return typeof a=="object"?p.extend(a,d):d}},e={};return d.pipe=d.then,p.each(b,function(a,f){var g=f[2],h=f[3];d[f[1]]=g.add,h&&g.add(function(){c=h},b[a^1][2].disable,b[2][2].lock),e[f[0]]=g.fire,e[f[0]+"With"]=g.fireWith}),d.promise(e),a&&a.call(e,e),e},when:function(a){var b=0,c=k.call(arguments),d=c.length,e=d!==1||a&&p.isFunction(a.promise)?d:0,f=e===1?a:p.Deferred(),g=function(a,b,c){return function(d){b[a]=this,c[a]=arguments.length>1?k.call(arguments):d,c===h?f.notifyWith(b,c):--e||f.resolveWith(b,c)}},h,i,j;if(d>1){h=new Array(d),i=new Array(d),j=new Array(d);for(;b<d;b++)c[b]&&p.isFunction(c[b].promise)?c[b].promise().done(g(b,j,c)).fail(f.reject).progress(g(b,i,h)):--e}return e||f.resolveWith(j,c),f.promise()}}),p.support=function(){var b,c,d,f,g,h,i,j,k,l,m,n=e.createElement("div");n.setAttribute("className","t"),n.innerHTML="  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>",c=n.getElementsByTagName("*"),d=n.getElementsByTagName("a")[0],d.style.cssText="top:1px;float:left;opacity:.5";if(!c||!c.length||!d)return{};f=e.createElement("select"),g=f.appendChild(e.createElement("option")),h=n.getElementsByTagName("input")[0],b={leadingWhitespace:n.firstChild.nodeType===3,tbody:!n.getElementsByTagName("tbody").length,htmlSerialize:!!n.getElementsByTagName("link").length,style:/top/.test(d.getAttribute("style")),hrefNormalized:d.getAttribute("href")==="/a",opacity:/^0.5/.test(d.style.opacity),cssFloat:!!d.style.cssFloat,checkOn:h.value==="on",optSelected:g.selected,getSetAttribute:n.className!=="t",enctype:!!e.createElement("form").enctype,html5Clone:e.createElement("nav").cloneNode(!0).outerHTML!=="<:nav></:nav>",boxModel:e.compatMode==="CSS1Compat",submitBubbles:!0,changeBubbles:!0,focusinBubbles:!1,deleteExpando:!0,noCloneEvent:!0,inlineBlockNeedsLayout:!1,shrinkWrapBlocks:!1,reliableMarginRight:!0,boxSizingReliable:!0,pixelPosition:!1},h.checked=!0,b.noCloneChecked=h.cloneNode(!0).checked,f.disabled=!0,b.optDisabled=!g.disabled;try{delete n.test}catch(o){b.deleteExpando=!1}!n.addEventListener&&n.attachEvent&&n.fireEvent&&(n.attachEvent("onclick",m=function(){b.noCloneEvent=!1}),n.cloneNode(!0).fireEvent("onclick"),n.detachEvent("onclick",m)),h=e.createElement("input"),h.value="t",h.setAttribute("type","radio"),b.radioValue=h.value==="t",h.setAttribute("checked","checked"),h.setAttribute("name","t"),n.appendChild(h),i=e.createDocumentFragment(),i.appendChild(n.lastChild),b.checkClone=i.cloneNode(!0).cloneNode(!0).lastChild.checked,b.appendChecked=h.checked,i.removeChild(h),i.appendChild(n);if(n.attachEvent)for(k in{submit:!0,change:!0,focusin:!0})j="on"+k,l=j in n,l||(n.setAttribute(j,"return;"),l=typeof n[j]=="function"),b[k+"Bubbles"]=l;return p(function(){var c,d,f,g,h="padding:0;margin:0;border:0;display:block;overflow:hidden;",i=e.getElementsByTagName("body")[0];if(!i)return;c=e.createElement("div"),c.style.cssText="visibility:hidden;border:0;width:0;height:0;position:static;top:0;margin-top:1px",i.insertBefore(c,i.firstChild),d=e.createElement("div"),c.appendChild(d),d.innerHTML="<table><tr><td></td><td>t</td></tr></table>",f=d.getElementsByTagName("td"),f[0].style.cssText="padding:0;margin:0;border:0;display:none",l=f[0].offsetHeight===0,f[0].style.display="",f[1].style.display="none",b.reliableHiddenOffsets=l&&f[0].offsetHeight===0,d.innerHTML="",d.style.cssText="box-sizing:border-box;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;padding:1px;border:1px;display:block;width:4px;margin-top:1%;position:absolute;top:1%;",b.boxSizing=d.offsetWidth===4,b.doesNotIncludeMarginInBodyOffset=i.offsetTop!==1,a.getComputedStyle&&(b.pixelPosition=(a.getComputedStyle(d,null)||{}).top!=="1%",b.boxSizingReliable=(a.getComputedStyle(d,null)||{width:"4px"}).width==="4px",g=e.createElement("div"),g.style.cssText=d.style.cssText=h,g.style.marginRight=g.style.width="0",d.style.width="1px",d.appendChild(g),b.reliableMarginRight=!parseFloat((a.getComputedStyle(g,null)||{}).marginRight)),typeof d.style.zoom!="undefined"&&(d.innerHTML="",d.style.cssText=h+"width:1px;padding:1px;display:inline;zoom:1",b.inlineBlockNeedsLayout=d.offsetWidth===3,d.style.display="block",d.style.overflow="visible",d.innerHTML="<div></div>",d.firstChild.style.width="5px",b.shrinkWrapBlocks=d.offsetWidth!==3,c.style.zoom=1),i.removeChild(c),c=d=f=g=null}),i.removeChild(n),c=d=f=g=h=i=n=null,b}();var H=/^(?:\{.*\}|\[.*\])$/,I=/([A-Z])/g;p.extend({cache:{},deletedIds:[],uuid:0,expando:"jQuery"+(p.fn.jquery+Math.random()).replace(/\D/g,""),noData:{embed:!0,object:"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",applet:!0},hasData:function(a){return a=a.nodeType?p.cache[a[p.expando]]:a[p.expando],!!a&&!K(a)},data:function(a,c,d,e){if(!p.acceptData(a))return;var f,g,h=p.expando,i=typeof c=="string",j=a.nodeType,k=j?p.cache:a,l=j?a[h]:a[h]&&h;if((!l||!k[l]||!e&&!k[l].data)&&i&&d===b)return;l||(j?a[h]=l=p.deletedIds.pop()||++p.uuid:l=h),k[l]||(k[l]={},j||(k[l].toJSON=p.noop));if(typeof c=="object"||typeof c=="function")e?k[l]=p.extend(k[l],c):k[l].data=p.extend(k[l].data,c);return f=k[l],e||(f.data||(f.data={}),f=f.data),d!==b&&(f[p.camelCase(c)]=d),i?(g=f[c],g==null&&(g=f[p.camelCase(c)])):g=f,g},removeData:function(a,b,c){if(!p.acceptData(a))return;var d,e,f,g=a.nodeType,h=g?p.cache:a,i=g?a[p.expando]:p.expando;if(!h[i])return;if(b){d=c?h[i]:h[i].data;if(d){p.isArray(b)||(b in d?b=[b]:(b=p.camelCase(b),b in d?b=[b]:b=b.split(" ")));for(e=0,f=b.length;e<f;e++)delete d[b[e]];if(!(c?K:p.isEmptyObject)(d))return}}if(!c){delete h[i].data;if(!K(h[i]))return}g?p.cleanData([a],!0):p.support.deleteExpando||h!=h.window?delete h[i]:h[i]=null},_data:function(a,b,c){return p.data(a,b,c,!0)},acceptData:function(a){var b=a.nodeName&&p.noData[a.nodeName.toLowerCase()];return!b||b!==!0&&a.getAttribute("classid")===b}}),p.fn.extend({data:function(a,c){var d,e,f,g,h,i=this[0],j=0,k=null;if(a===b){if(this.length){k=p.data(i);if(i.nodeType===1&&!p._data(i,"parsedAttrs")){f=i.attributes;for(h=f.length;j<h;j++)g=f[j].name,g.indexOf("data-")===0&&(g=p.camelCase(g.substring(5)),J(i,g,k[g]));p._data(i,"parsedAttrs",!0)}}return k}return typeof a=="object"?this.each(function(){p.data(this,a)}):(d=a.split(".",2),d[1]=d[1]?"."+d[1]:"",e=d[1]+"!",p.access(this,function(c){if(c===b)return k=this.triggerHandler("getData"+e,[d[0]]),k===b&&i&&(k=p.data(i,a),k=J(i,a,k)),k===b&&d[1]?this.data(d[0]):k;d[1]=c,this.each(function(){var b=p(this);b.triggerHandler("setData"+e,d),p.data(this,a,c),b.triggerHandler("changeData"+e,d)})},null,c,arguments.length>1,null,!1))},removeData:function(a){return this.each(function(){p.removeData(this,a)})}}),p.extend({queue:function(a,b,c){var d;if(a)return b=(b||"fx")+"queue",d=p._data(a,b),c&&(!d||p.isArray(c)?d=p._data(a,b,p.makeArray(c)):d.push(c)),d||[]},dequeue:function(a,b){b=b||"fx";var c=p.queue(a,b),d=c.shift(),e=p._queueHooks(a,b),f=function(){p.dequeue(a,b)};d==="inprogress"&&(d=c.shift()),d&&(b==="fx"&&c.unshift("inprogress"),delete e.stop,d.call(a,f,e)),!c.length&&e&&e.empty.fire()},_queueHooks:function(a,b){var c=b+"queueHooks";return p._data(a,c)||p._data(a,c,{empty:p.Callbacks("once memory").add(function(){p.removeData(a,b+"queue",!0),p.removeData(a,c,!0)})})}}),p.fn.extend({queue:function(a,c){var d=2;return typeof a!="string"&&(c=a,a="fx",d--),arguments.length<d?p.queue(this[0],a):c===b?this:this.each(function(){var b=p.queue(this,a,c);p._queueHooks(this,a),a==="fx"&&b[0]!=="inprogress"&&p.dequeue(this,a)})},dequeue:function(a){return this.each(function(){p.dequeue(this,a)})},delay:function(a,b){return a=p.fx?p.fx.speeds[a]||a:a,b=b||"fx",this.queue(b,function(b,c){var d=setTimeout(b,a);c.stop=function(){clearTimeout(d)}})},clearQueue:function(a){return this.queue(a||"fx",[])},promise:function(a,c){var d,e=1,f=p.Deferred(),g=this,h=this.length,i=function(){--e||f.resolveWith(g,[g])};typeof a!="string"&&(c=a,a=b),a=a||"fx";while(h--)(d=p._data(g[h],a+"queueHooks"))&&d.empty&&(e++,d.empty.add(i));return i(),f.promise(c)}});var L,M,N,O=/[\t\r\n]/g,P=/\r/g,Q=/^(?:button|input)$/i,R=/^(?:button|input|object|select|textarea)$/i,S=/^a(?:rea|)$/i,T=/^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i,U=p.support.getSetAttribute;p.fn.extend({attr:function(a,b){return p.access(this,p.attr,a,b,arguments.length>1)},removeAttr:function(a){return this.each(function(){p.removeAttr(this,a)})},prop:function(a,b){return p.access(this,p.prop,a,b,arguments.length>1)},removeProp:function(a){return a=p.propFix[a]||a,this.each(function(){try{this[a]=b,delete this[a]}catch(c){}})},addClass:function(a){var b,c,d,e,f,g,h;if(p.isFunction(a))return this.each(function(b){p(this).addClass(a.call(this,b,this.className))});if(a&&typeof a=="string"){b=a.split(s);for(c=0,d=this.length;c<d;c++){e=this[c];if(e.nodeType===1)if(!e.className&&b.length===1)e.className=a;else{f=" "+e.className+" ";for(g=0,h=b.length;g<h;g++)~f.indexOf(" "+b[g]+" ")||(f+=b[g]+" ");e.className=p.trim(f)}}}return this},removeClass:function(a){var c,d,e,f,g,h,i;if(p.isFunction(a))return this.each(function(b){p(this).removeClass(a.call(this,b,this.className))});if(a&&typeof a=="string"||a===b){c=(a||"").split(s);for(h=0,i=this.length;h<i;h++){e=this[h];if(e.nodeType===1&&e.className){d=(" "+e.className+" ").replace(O," ");for(f=0,g=c.length;f<g;f++)while(d.indexOf(" "+c[f]+" ")>-1)d=d.replace(" "+c[f]+" "," ");e.className=a?p.trim(d):""}}}return this},toggleClass:function(a,b){var c=typeof a,d=typeof b=="boolean";return p.isFunction(a)?this.each(function(c){p(this).toggleClass(a.call(this,c,this.className,b),b)}):this.each(function(){if(c==="string"){var e,f=0,g=p(this),h=b,i=a.split(s);while(e=i[f++])h=d?h:!g.hasClass(e),g[h?"addClass":"removeClass"](e)}else if(c==="undefined"||c==="boolean")this.className&&p._data(this,"__className__",this.className),this.className=this.className||a===!1?"":p._data(this,"__className__")||""})},hasClass:function(a){var b=" "+a+" ",c=0,d=this.length;for(;c<d;c++)if(this[c].nodeType===1&&(" "+this[c].className+" ").replace(O," ").indexOf(b)>-1)return!0;return!1},val:function(a){var c,d,e,f=this[0];if(!arguments.length){if(f)return c=p.valHooks[f.type]||p.valHooks[f.nodeName.toLowerCase()],c&&"get"in c&&(d=c.get(f,"value"))!==b?d:(d=f.value,typeof d=="string"?d.replace(P,""):d==null?"":d);return}return e=p.isFunction(a),this.each(function(d){var f,g=p(this);if(this.nodeType!==1)return;e?f=a.call(this,d,g.val()):f=a,f==null?f="":typeof f=="number"?f+="":p.isArray(f)&&(f=p.map(f,function(a){return a==null?"":a+""})),c=p.valHooks[this.type]||p.valHooks[this.nodeName.toLowerCase()];if(!c||!("set"in c)||c.set(this,f,"value")===b)this.value=f})}}),p.extend({valHooks:{option:{get:function(a){var b=a.attributes.value;return!b||b.specified?a.value:a.text}},select:{get:function(a){var b,c,d,e,f=a.selectedIndex,g=[],h=a.options,i=a.type==="select-one";if(f<0)return null;c=i?f:0,d=i?f+1:h.length;for(;c<d;c++){e=h[c];if(e.selected&&(p.support.optDisabled?!e.disabled:e.getAttribute("disabled")===null)&&(!e.parentNode.disabled||!p.nodeName(e.parentNode,"optgroup"))){b=p(e).val();if(i)return b;g.push(b)}}return i&&!g.length&&h.length?p(h[f]).val():g},set:function(a,b){var c=p.makeArray(b);return p(a).find("option").each(function(){this.selected=p.inArray(p(this).val(),c)>=0}),c.length||(a.selectedIndex=-1),c}}},attrFn:{},attr:function(a,c,d,e){var f,g,h,i=a.nodeType;if(!a||i===3||i===8||i===2)return;if(e&&p.isFunction(p.fn[c]))return p(a)[c](d);if(typeof a.getAttribute=="undefined")return p.prop(a,c,d);h=i!==1||!p.isXMLDoc(a),h&&(c=c.toLowerCase(),g=p.attrHooks[c]||(T.test(c)?M:L));if(d!==b){if(d===null){p.removeAttr(a,c);return}return g&&"set"in g&&h&&(f=g.set(a,d,c))!==b?f:(a.setAttribute(c,""+d),d)}return g&&"get"in g&&h&&(f=g.get(a,c))!==null?f:(f=a.getAttribute(c),f===null?b:f)},removeAttr:function(a,b){var c,d,e,f,g=0;if(b&&a.nodeType===1){d=b.split(s);for(;g<d.length;g++)e=d[g],e&&(c=p.propFix[e]||e,f=T.test(e),f||p.attr(a,e,""),a.removeAttribute(U?e:c),f&&c in a&&(a[c]=!1))}},attrHooks:{type:{set:function(a,b){if(Q.test(a.nodeName)&&a.parentNode)p.error("type property can't be changed");else if(!p.support.radioValue&&b==="radio"&&p.nodeName(a,"input")){var c=a.value;return a.setAttribute("type",b),c&&(a.value=c),b}}},value:{get:function(a,b){return L&&p.nodeName(a,"button")?L.get(a,b):b in a?a.value:null},set:function(a,b,c){if(L&&p.nodeName(a,"button"))return L.set(a,b,c);a.value=b}}},propFix:{tabindex:"tabIndex",readonly:"readOnly","for":"htmlFor","class":"className",maxlength:"maxLength",cellspacing:"cellSpacing",cellpadding:"cellPadding",rowspan:"rowSpan",colspan:"colSpan",usemap:"useMap",frameborder:"frameBorder",contenteditable:"contentEditable"},prop:function(a,c,d){var e,f,g,h=a.nodeType;if(!a||h===3||h===8||h===2)return;return g=h!==1||!p.isXMLDoc(a),g&&(c=p.propFix[c]||c,f=p.propHooks[c]),d!==b?f&&"set"in f&&(e=f.set(a,d,c))!==b?e:a[c]=d:f&&"get"in f&&(e=f.get(a,c))!==null?e:a[c]},propHooks:{tabIndex:{get:function(a){var c=a.getAttributeNode("tabindex");return c&&c.specified?parseInt(c.value,10):R.test(a.nodeName)||S.test(a.nodeName)&&a.href?0:b}}}}),M={get:function(a,c){var d,e=p.prop(a,c);return e===!0||typeof e!="boolean"&&(d=a.getAttributeNode(c))&&d.nodeValue!==!1?c.toLowerCase():b},set:function(a,b,c){var d;return b===!1?p.removeAttr(a,c):(d=p.propFix[c]||c,d in a&&(a[d]=!0),a.setAttribute(c,c.toLowerCase())),c}},U||(N={name:!0,id:!0,coords:!0},L=p.valHooks.button={get:function(a,c){var d;return d=a.getAttributeNode(c),d&&(N[c]?d.value!=="":d.specified)?d.value:b},set:function(a,b,c){var d=a.getAttributeNode(c);return d||(d=e.createAttribute(c),a.setAttributeNode(d)),d.value=b+""}},p.each(["width","height"],function(a,b){p.attrHooks[b]=p.extend(p.attrHooks[b],{set:function(a,c){if(c==="")return a.setAttribute(b,"auto"),c}})}),p.attrHooks.contenteditable={get:L.get,set:function(a,b,c){b===""&&(b="false"),L.set(a,b,c)}}),p.support.hrefNormalized||p.each(["href","src","width","height"],function(a,c){p.attrHooks[c]=p.extend(p.attrHooks[c],{get:function(a){var d=a.getAttribute(c,2);return d===null?b:d}})}),p.support.style||(p.attrHooks.style={get:function(a){return a.style.cssText.toLowerCase()||b},set:function(a,b){return a.style.cssText=""+b}}),p.support.optSelected||(p.propHooks.selected=p.extend(p.propHooks.selected,{get:function(a){var b=a.parentNode;return b&&(b.selectedIndex,b.parentNode&&b.parentNode.selectedIndex),null}})),p.support.enctype||(p.propFix.enctype="encoding"),p.support.checkOn||p.each(["radio","checkbox"],function(){p.valHooks[this]={get:function(a){return a.getAttribute("value")===null?"on":a.value}}}),p.each(["radio","checkbox"],function(){p.valHooks[this]=p.extend(p.valHooks[this],{set:function(a,b){if(p.isArray(b))return a.checked=p.inArray(p(a).val(),b)>=0}})});var V=/^(?:textarea|input|select)$/i,W=/^([^\.]*|)(?:\.(.+)|)$/,X=/(?:^|\s)hover(\.\S+|)\b/,Y=/^key/,Z=/^(?:mouse|contextmenu)|click/,$=/^(?:focusinfocus|focusoutblur)$/,_=function(a){return p.event.special.hover?a:a.replace(X,"mouseenter$1 mouseleave$1")};p.event={add:function(a,c,d,e,f){var g,h,i,j,k,l,m,n,o,q,r;if(a.nodeType===3||a.nodeType===8||!c||!d||!(g=p._data(a)))return;d.handler&&(o=d,d=o.handler,f=o.selector),d.guid||(d.guid=p.guid++),i=g.events,i||(g.events=i={}),h=g.handle,h||(g.handle=h=function(a){return typeof p!="undefined"&&(!a||p.event.triggered!==a.type)?p.event.dispatch.apply(h.elem,arguments):b},h.elem=a),c=p.trim(_(c)).split(" ");for(j=0;j<c.length;j++){k=W.exec(c[j])||[],l=k[1],m=(k[2]||"").split(".").sort(),r=p.event.special[l]||{},l=(f?r.delegateType:r.bindType)||l,r=p.event.special[l]||{},n=p.extend({type:l,origType:k[1],data:e,handler:d,guid:d.guid,selector:f,namespace:m.join(".")},o),q=i[l];if(!q){q=i[l]=[],q.delegateCount=0;if(!r.setup||r.setup.call(a,e,m,h)===!1)a.addEventListener?a.addEventListener(l,h,!1):a.attachEvent&&a.attachEvent("on"+l,h)}r.add&&(r.add.call(a,n),n.handler.guid||(n.handler.guid=d.guid)),f?q.splice(q.delegateCount++,0,n):q.push(n),p.event.global[l]=!0}a=null},global:{},remove:function(a,b,c,d,e){var f,g,h,i,j,k,l,m,n,o,q,r=p.hasData(a)&&p._data(a);if(!r||!(m=r.events))return;b=p.trim(_(b||"")).split(" ");for(f=0;f<b.length;f++){g=W.exec(b[f])||[],h=i=g[1],j=g[2];if(!h){for(h in m)p.event.remove(a,h+b[f],c,d,!0);continue}n=p.event.special[h]||{},h=(d?n.delegateType:n.bindType)||h,o=m[h]||[],k=o.length,j=j?new RegExp("(^|\\.)"+j.split(".").sort().join("\\.(?:.*\\.|)")+"(\\.|$)"):null;for(l=0;l<o.length;l++)q=o[l],(e||i===q.origType)&&(!c||c.guid===q.guid)&&(!j||j.test(q.namespace))&&(!d||d===q.selector||d==="**"&&q.selector)&&(o.splice(l--,1),q.selector&&o.delegateCount--,n.remove&&n.remove.call(a,q));o.length===0&&k!==o.length&&((!n.teardown||n.teardown.call(a,j,r.handle)===!1)&&p.removeEvent(a,h,r.handle),delete m[h])}p.isEmptyObject(m)&&(delete r.handle,p.removeData(a,"events",!0))},customEvent:{getData:!0,setData:!0,changeData:!0},trigger:function(c,d,f,g){if(!f||f.nodeType!==3&&f.nodeType!==8){var h,i,j,k,l,m,n,o,q,r,s=c.type||c,t=[];if($.test(s+p.event.triggered))return;s.indexOf("!")>=0&&(s=s.slice(0,-1),i=!0),s.indexOf(".")>=0&&(t=s.split("."),s=t.shift(),t.sort());if((!f||p.event.customEvent[s])&&!p.event.global[s])return;c=typeof c=="object"?c[p.expando]?c:new p.Event(s,c):new p.Event(s),c.type=s,c.isTrigger=!0,c.exclusive=i,c.namespace=t.join("."),c.namespace_re=c.namespace?new RegExp("(^|\\.)"+t.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,m=s.indexOf(":")<0?"on"+s:"";if(!f){h=p.cache;for(j in h)h[j].events&&h[j].events[s]&&p.event.trigger(c,d,h[j].handle.elem,!0);return}c.result=b,c.target||(c.target=f),d=d!=null?p.makeArray(d):[],d.unshift(c),n=p.event.special[s]||{};if(n.trigger&&n.trigger.apply(f,d)===!1)return;q=[[f,n.bindType||s]];if(!g&&!n.noBubble&&!p.isWindow(f)){r=n.delegateType||s,k=$.test(r+s)?f:f.parentNode;for(l=f;k;k=k.parentNode)q.push([k,r]),l=k;l===(f.ownerDocument||e)&&q.push([l.defaultView||l.parentWindow||a,r])}for(j=0;j<q.length&&!c.isPropagationStopped();j++)k=q[j][0],c.type=q[j][1],o=(p._data(k,"events")||{})[c.type]&&p._data(k,"handle"),o&&o.apply(k,d),o=m&&k[m],o&&p.acceptData(k)&&o.apply(k,d)===!1&&c.preventDefault();return c.type=s,!g&&!c.isDefaultPrevented()&&(!n._default||n._default.apply(f.ownerDocument,d)===!1)&&(s!=="click"||!p.nodeName(f,"a"))&&p.acceptData(f)&&m&&f[s]&&(s!=="focus"&&s!=="blur"||c.target.offsetWidth!==0)&&!p.isWindow(f)&&(l=f[m],l&&(f[m]=null),p.event.triggered=s,f[s](),p.event.triggered=b,l&&(f[m]=l)),c.result}return},dispatch:function(c){c=p.event.fix(c||a.event);var d,e,f,g,h,i,j,k,l,m,n,o=(p._data(this,"events")||{})[c.type]||[],q=o.delegateCount,r=[].slice.call(arguments),s=!c.exclusive&&!c.namespace,t=p.event.special[c.type]||{},u=[];r[0]=c,c.delegateTarget=this;if(t.preDispatch&&t.preDispatch.call(this,c)===!1)return;if(q&&(!c.button||c.type!=="click")){g=p(this),g.context=this;for(f=c.target;f!=this;f=f.parentNode||this)if(f.disabled!==!0||c.type!=="click"){i={},k=[],g[0]=f;for(d=0;d<q;d++)l=o[d],m=l.selector,i[m]===b&&(i[m]=g.is(m)),i[m]&&k.push(l);k.length&&u.push({elem:f,matches:k})}}o.length>q&&u.push({elem:this,matches:o.slice(q)});for(d=0;d<u.length&&!c.isPropagationStopped();d++){j=u[d],c.currentTarget=j.elem;for(e=0;e<j.matches.length&&!c.isImmediatePropagationStopped();e++){l=j.matches[e];if(s||!c.namespace&&!l.namespace||c.namespace_re&&c.namespace_re.test(l.namespace))c.data=l.data,c.handleObj=l,h=((p.event.special[l.origType]||{}).handle||l.handler).apply(j.elem,r),h!==b&&(c.result=h,h===!1&&(c.preventDefault(),c.stopPropagation()))}}return t.postDispatch&&t.postDispatch.call(this,c),c.result},props:"attrChange attrName relatedNode srcElement altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(a,b){return a.which==null&&(a.which=b.charCode!=null?b.charCode:b.keyCode),a}},mouseHooks:{props:"button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(a,c){var d,f,g,h=c.button,i=c.fromElement;return a.pageX==null&&c.clientX!=null&&(d=a.target.ownerDocument||e,f=d.documentElement,g=d.body,a.pageX=c.clientX+(f&&f.scrollLeft||g&&g.scrollLeft||0)-(f&&f.clientLeft||g&&g.clientLeft||0),a.pageY=c.clientY+(f&&f.scrollTop||g&&g.scrollTop||0)-(f&&f.clientTop||g&&g.clientTop||0)),!a.relatedTarget&&i&&(a.relatedTarget=i===a.target?c.toElement:i),!a.which&&h!==b&&(a.which=h&1?1:h&2?3:h&4?2:0),a}},fix:function(a){if(a[p.expando])return a;var b,c,d=a,f=p.event.fixHooks[a.type]||{},g=f.props?this.props.concat(f.props):this.props;a=p.Event(d);for(b=g.length;b;)c=g[--b],a[c]=d[c];return a.target||(a.target=d.srcElement||e),a.target.nodeType===3&&(a.target=a.target.parentNode),a.metaKey=!!a.metaKey,f.filter?f.filter(a,d):a},special:{ready:{setup:p.bindReady},load:{noBubble:!0},focus:{delegateType:"focusin"},blur:{delegateType:"focusout"},beforeunload:{setup:function(a,b,c){p.isWindow(this)&&(this.onbeforeunload=c)},teardown:function(a,b){this.onbeforeunload===b&&(this.onbeforeunload=null)}}},simulate:function(a,b,c,d){var e=p.extend(new p.Event,c,{type:a,isSimulated:!0,originalEvent:{}});d?p.event.trigger(e,null,b):p.event.dispatch.call(b,e),e.isDefaultPrevented()&&c.preventDefault()}},p.event.handle=p.event.dispatch,p.removeEvent=e.removeEventListener?function(a,b,c){a.removeEventListener&&a.removeEventListener(b,c,!1)}:function(a,b,c){var d="on"+b;a.detachEvent&&(typeof a[d]=="undefined"&&(a[d]=null),a.detachEvent(d,c))},p.Event=function(a,b){if(this instanceof p.Event)a&&a.type?(this.originalEvent=a,this.type=a.type,this.isDefaultPrevented=a.defaultPrevented||a.returnValue===!1||a.getPreventDefault&&a.getPreventDefault()?bb:ba):this.type=a,b&&p.extend(this,b),this.timeStamp=a&&a.timeStamp||p.now(),this[p.expando]=!0;else return new p.Event(a,b)},p.Event.prototype={preventDefault:function(){this.isDefaultPrevented=bb;var a=this.originalEvent;if(!a)return;a.preventDefault?a.preventDefault():a.returnValue=!1},stopPropagation:function(){this.isPropagationStopped=bb;var a=this.originalEvent;if(!a)return;a.stopPropagation&&a.stopPropagation(),a.cancelBubble=!0},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=bb,this.stopPropagation()},isDefaultPrevented:ba,isPropagationStopped:ba,isImmediatePropagationStopped:ba},p.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(a,b){p.event.special[a]={delegateType:b,bindType:b,handle:function(a){var c,d=this,e=a.relatedTarget,f=a.handleObj,g=f.selector;if(!e||e!==d&&!p.contains(d,e))a.type=f.origType,c=f.handler.apply(this,arguments),a.type=b;return c}}}),p.support.submitBubbles||(p.event.special.submit={setup:function(){if(p.nodeName(this,"form"))return!1;p.event.add(this,"click._submit keypress._submit",function(a){var c=a.target,d=p.nodeName(c,"input")||p.nodeName(c,"button")?c.form:b;d&&!p._data(d,"_submit_attached")&&(p.event.add(d,"submit._submit",function(a){a._submit_bubble=!0}),p._data(d,"_submit_attached",!0))})},postDispatch:function(a){a._submit_bubble&&(delete a._submit_bubble,this.parentNode&&!a.isTrigger&&p.event.simulate("submit",this.parentNode,a,!0))},teardown:function(){if(p.nodeName(this,"form"))return!1;p.event.remove(this,"._submit")}}),p.support.changeBubbles||(p.event.special.change={setup:function(){if(V.test(this.nodeName)){if(this.type==="checkbox"||this.type==="radio")p.event.add(this,"propertychange._change",function(a){a.originalEvent.propertyName==="checked"&&(this._just_changed=!0)}),p.event.add(this,"click._change",function(a){this._just_changed&&!a.isTrigger&&(this._just_changed=!1),p.event.simulate("change",this,a,!0)});return!1}p.event.add(this,"beforeactivate._change",function(a){var b=a.target;V.test(b.nodeName)&&!p._data(b,"_change_attached")&&(p.event.add(b,"change._change",function(a){this.parentNode&&!a.isSimulated&&!a.isTrigger&&p.event.simulate("change",this.parentNode,a,!0)}),p._data(b,"_change_attached",!0))})},handle:function(a){var b=a.target;if(this!==b||a.isSimulated||a.isTrigger||b.type!=="radio"&&b.type!=="checkbox")return a.handleObj.handler.apply(this,arguments)},teardown:function(){return p.event.remove(this,"._change"),V.test(this.nodeName)}}),p.support.focusinBubbles||p.each({focus:"focusin",blur:"focusout"},function(a,b){var c=0,d=function(a){p.event.simulate(b,a.target,p.event.fix(a),!0)};p.event.special[b]={setup:function(){c++===0&&e.addEventListener(a,d,!0)},teardown:function(){--c===0&&e.removeEventListener(a,d,!0)}}}),p.fn.extend({on:function(a,c,d,e,f){var g,h;if(typeof a=="object"){typeof c!="string"&&(d=d||c,c=b);for(h in a)this.on(h,c,d,a[h],f);return this}d==null&&e==null?(e=c,d=c=b):e==null&&(typeof c=="string"?(e=d,d=b):(e=d,d=c,c=b));if(e===!1)e=ba;else if(!e)return this;return f===1&&(g=e,e=function(a){return p().off(a),g.apply(this,arguments)},e.guid=g.guid||(g.guid=p.guid++)),this.each(function(){p.event.add(this,a,e,d,c)})},one:function(a,b,c,d){return this.on(a,b,c,d,1)},off:function(a,c,d){var e,f;if(a&&a.preventDefault&&a.handleObj)return e=a.handleObj,p(a.delegateTarget).off(e.namespace?e.origType+"."+e.namespace:e.origType,e.selector,e.handler),this;if(typeof a=="object"){for(f in a)this.off(f,c,a[f]);return this}if(c===!1||typeof c=="function")d=c,c=b;return d===!1&&(d=ba),this.each(function(){p.event.remove(this,a,d,c)})},bind:function(a,b,c){return this.on(a,null,b,c)},unbind:function(a,b){return this.off(a,null,b)},live:function(a,b,c){return p(this.context).on(a,this.selector,b,c),this},die:function(a,b){return p(this.context).off(a,this.selector||"**",b),this},delegate:function(a,b,c,d){return this.on(b,a,c,d)},undelegate:function(a,b,c){return arguments.length==1?this.off(a,"**"):this.off(b,a||"**",c)},trigger:function(a,b){return this.each(function(){p.event.trigger(a,b,this)})},triggerHandler:function(a,b){if(this[0])return p.event.trigger(a,b,this[0],!0)},toggle:function(a){var b=arguments,c=a.guid||p.guid++,d=0,e=function(c){var e=(p._data(this,"lastToggle"+a.guid)||0)%d;return p._data(this,"lastToggle"+a.guid,e+1),c.preventDefault(),b[e].apply(this,arguments)||!1};e.guid=c;while(d<b.length)b[d++].guid=c;return this.click(e)},hover:function(a,b){return this.mouseenter(a).mouseleave(b||a)}}),p.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(a,b){p.fn[b]=function(a,c){return c==null&&(c=a,a=null),arguments.length>0?this.on(b,null,a,c):this.trigger(b)},Y.test(b)&&(p.event.fixHooks[b]=p.event.keyHooks),Z.test(b)&&(p.event.fixHooks[b]=p.event.mouseHooks)}),function(a,b){function bd(a,b,c,d){var e=0,f=b.length;for(;e<f;e++)Z(a,b[e],c,d)}function be(a,b,c,d,e,f){var g,h=$.setFilters[b.toLowerCase()];return h||Z.error(b),(a||!(g=e))&&bd(a||"*",d,g=[],e),g.length>0?h(g,c,f):[]}function bf(a,c,d,e,f){var g,h,i,j,k,l,m,n,p=0,q=f.length,s=L.POS,t=new RegExp("^"+s.source+"(?!"+r+")","i"),u=function(){var a=1,c=arguments.length-2;for(;a<c;a++)arguments[a]===b&&(g[a]=b)};for(;p<q;p++){s.exec(""),a=f[p],j=[],i=0,k=e;while(g=s.exec(a)){n=s.lastIndex=g.index+g[0].length;if(n>i){m=a.slice(i,g.index),i=n,l=[c],B.test(m)&&(k&&(l=k),k=e);if(h=H.test(m))m=m.slice(0,-5).replace(B,"$&*");g.length>1&&g[0].replace(t,u),k=be(m,g[1],g[2],l,k,h)}}k?(j=j.concat(k),(m=a.slice(i))&&m!==")"?B.test(m)?bd(m,j,d,e):Z(m,c,d,e?e.concat(k):k):o.apply(d,j)):Z(a,c,d,e)}return q===1?d:Z.uniqueSort(d)}function bg(a,b,c){var d,e,f,g=[],i=0,j=D.exec(a),k=!j.pop()&&!j.pop(),l=k&&a.match(C)||[""],m=$.preFilter,n=$.filter,o=!c&&b!==h;for(;(e=l[i])!=null&&k;i++){g.push(d=[]),o&&(e=" "+e);while(e){k=!1;if(j=B.exec(e))e=e.slice(j[0].length),k=d.push({part:j.pop().replace(A," "),captures:j});for(f in n)(j=L[f].exec(e))&&(!m[f]||(j=m[f](j,b,c)))&&(e=e.slice(j.shift().length),k=d.push({part:f,captures:j}));if(!k)break}}return k||Z.error(a),g}function bh(a,b,e){var f=b.dir,g=m++;return a||(a=function(a){return a===e}),b.first?function(b,c){while(b=b[f])if(b.nodeType===1)return a(b,c)&&b}:function(b,e){var h,i=g+"."+d,j=i+"."+c;while(b=b[f])if(b.nodeType===1){if((h=b[q])===j)return b.sizset;if(typeof h=="string"&&h.indexOf(i)===0){if(b.sizset)return b}else{b[q]=j;if(a(b,e))return b.sizset=!0,b;b.sizset=!1}}}}function bi(a,b){return a?function(c,d){var e=b(c,d);return e&&a(e===!0?c:e,d)}:b}function bj(a,b,c){var d,e,f=0;for(;d=a[f];f++)$.relative[d.part]?e=bh(e,$.relative[d.part],b):(d.captures.push(b,c),e=bi(e,$.filter[d.part].apply(null,d.captures)));return e}function bk(a){return function(b,c){var d,e=0;for(;d=a[e];e++)if(d(b,c))return!0;return!1}}var c,d,e,f,g,h=a.document,i=h.documentElement,j="undefined",k=!1,l=!0,m=0,n=[].slice,o=[].push,q=("sizcache"+Math.random()).replace(".",""),r="[\\x20\\t\\r\\n\\f]",s="(?:\\\\.|[-\\w]|[^\\x00-\\xa0])+",t=s.replace("w","w#"),u="([*^$|!~]?=)",v="\\["+r+"*("+s+")"+r+"*(?:"+u+r+"*(?:(['\"])((?:\\\\.|[^\\\\])*?)\\3|("+t+")|)|)"+r+"*\\]",w=":("+s+")(?:\\((?:(['\"])((?:\\\\.|[^\\\\])*?)\\2|((?:[^,]|\\\\,|(?:,(?=[^\\[]*\\]))|(?:,(?=[^\\(]*\\))))*))\\)|)",x=":(nth|eq|gt|lt|first|last|even|odd)(?:\\((\\d*)\\)|)(?=[^-]|$)",y=r+"*([\\x20\\t\\r\\n\\f>+~])"+r+"*",z="(?=[^\\x20\\t\\r\\n\\f])(?:\\\\.|"+v+"|"+w.replace(2,7)+"|[^\\\\(),])+",A=new RegExp("^"+r+"+|((?:^|[^\\\\])(?:\\\\.)*)"+r+"+$","g"),B=new RegExp("^"+y),C=new RegExp(z+"?(?="+r+"*,|$)","g"),D=new RegExp("^(?:(?!,)(?:(?:^|,)"+r+"*"+z+")*?|"+r+"*(.*?))(\\)|$)"),E=new RegExp(z.slice(19,-6)+"\\x20\\t\\r\\n\\f>+~])+|"+y,"g"),F=/^(?:#([\w\-]+)|(\w+)|\.([\w\-]+))$/,G=/[\x20\t\r\n\f]*[+~]/,H=/:not\($/,I=/h\d/i,J=/input|select|textarea|button/i,K=/\\(?!\\)/g,L={ID:new RegExp("^#("+s+")"),CLASS:new RegExp("^\\.("+s+")"),NAME:new RegExp("^\\[name=['\"]?("+s+")['\"]?\\]"),TAG:new RegExp("^("+s.replace("[-","[-\\*")+")"),ATTR:new RegExp("^"+v),PSEUDO:new RegExp("^"+w),CHILD:new RegExp("^:(only|nth|last|first)-child(?:\\("+r+"*(even|odd|(([+-]|)(\\d*)n|)"+r+"*(?:([+-]|)"+r+"*(\\d+)|))"+r+"*\\)|)","i"),POS:new RegExp(x,"ig"),needsContext:new RegExp("^"+r+"*[>+~]|"+x,"i")},M={},N=[],O={},P=[],Q=function(a){return a.sizzleFilter=!0,a},R=function(a){return function(b){return b.nodeName.toLowerCase()==="input"&&b.type===a}},S=function(a){return function(b){var c=b.nodeName.toLowerCase();return(c==="input"||c==="button")&&b.type===a}},T=function(a){var b=!1,c=h.createElement("div");try{b=a(c)}catch(d){}return c=null,b},U=T(function(a){a.innerHTML="<select></select>";var b=typeof a.lastChild.getAttribute("multiple");return b!=="boolean"&&b!=="string"}),V=T(function(a){a.id=q+0,a.innerHTML="<a name='"+q+"'></a><div name='"+q+"'></div>",i.insertBefore(a,i.firstChild);var b=h.getElementsByName&&h.getElementsByName(q).length===2+h.getElementsByName(q+0).length;return g=!h.getElementById(q),i.removeChild(a),b}),W=T(function(a){return a.appendChild(h.createComment("")),a.getElementsByTagName("*").length===0}),X=T(function(a){return a.innerHTML="<a href='#'></a>",a.firstChild&&typeof a.firstChild.getAttribute!==j&&a.firstChild.getAttribute("href")==="#"}),Y=T(function(a){return a.innerHTML="<div class='hidden e'></div><div class='hidden'></div>",!a.getElementsByClassName||a.getElementsByClassName("e").length===0?!1:(a.lastChild.className="e",a.getElementsByClassName("e").length!==1)}),Z=function(a,b,c,d){c=c||[],b=b||h;var e,f,g,i,j=b.nodeType;if(j!==1&&j!==9)return[];if(!a||typeof a!="string")return c;g=ba(b);if(!g&&!d)if(e=F.exec(a))if(i=e[1]){if(j===9){f=b.getElementById(i);if(!f||!f.parentNode)return c;if(f.id===i)return c.push(f),c}else if(b.ownerDocument&&(f=b.ownerDocument.getElementById(i))&&bb(b,f)&&f.id===i)return c.push(f),c}else{if(e[2])return o.apply(c,n.call(b.getElementsByTagName(a),0)),c;if((i=e[3])&&Y&&b.getElementsByClassName)return o.apply(c,n.call(b.getElementsByClassName(i),0)),c}return bm(a,b,c,d,g)},$=Z.selectors={cacheLength:50,match:L,order:["ID","TAG"],attrHandle:{},createPseudo:Q,find:{ID:g?function(a,b,c){if(typeof b.getElementById!==j&&!c){var d=b.getElementById(a);return d&&d.parentNode?[d]:[]}}:function(a,c,d){if(typeof c.getElementById!==j&&!d){var e=c.getElementById(a);return e?e.id===a||typeof e.getAttributeNode!==j&&e.getAttributeNode("id").value===a?[e]:b:[]}},TAG:W?function(a,b){if(typeof b.getElementsByTagName!==j)return b.getElementsByTagName(a)}:function(a,b){var c=b.getElementsByTagName(a);if(a==="*"){var d,e=[],f=0;for(;d=c[f];f++)d.nodeType===1&&e.push(d);return e}return c}},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(a){return a[1]=a[1].replace(K,""),a[3]=(a[4]||a[5]||"").replace(K,""),a[2]==="~="&&(a[3]=" "+a[3]+" "),a.slice(0,4)},CHILD:function(a){return a[1]=a[1].toLowerCase(),a[1]==="nth"?(a[2]||Z.error(a[0]),a[3]=+(a[3]?a[4]+(a[5]||1):2*(a[2]==="even"||a[2]==="odd")),a[4]=+(a[6]+a[7]||a[2]==="odd")):a[2]&&Z.error(a[0]),a},PSEUDO:function(a){var b,c=a[4];return L.CHILD.test(a[0])?null:(c&&(b=D.exec(c))&&b.pop()&&(a[0]=a[0].slice(0,b[0].length-c.length-1),c=b[0].slice(0,-1)),a.splice(2,3,c||a[3]),a)}},filter:{ID:g?function(a){return a=a.replace(K,""),function(b){return b.getAttribute("id")===a}}:function(a){return a=a.replace(K,""),function(b){var c=typeof b.getAttributeNode!==j&&b.getAttributeNode("id");return c&&c.value===a}},TAG:function(a){return a==="*"?function(){return!0}:(a=a.replace(K,"").toLowerCase(),function(b){return b.nodeName&&b.nodeName.toLowerCase()===a})},CLASS:function(a){var b=M[a];return b||(b=M[a]=new RegExp("(^|"+r+")"+a+"("+r+"|$)"),N.push(a),N.length>$.cacheLength&&delete M[N.shift()]),function(a){return b.test(a.className||typeof a.getAttribute!==j&&a.getAttribute("class")||"")}},ATTR:function(a,b,c){return b?function(d){var e=Z.attr(d,a),f=e+"";if(e==null)return b==="!=";switch(b){case"=":return f===c;case"!=":return f!==c;case"^=":return c&&f.indexOf(c)===0;case"*=":return c&&f.indexOf(c)>-1;case"$=":return c&&f.substr(f.length-c.length)===c;case"~=":return(" "+f+" ").indexOf(c)>-1;case"|=":return f===c||f.substr(0,c.length+1)===c+"-"}}:function(b){return Z.attr(b,a)!=null}},CHILD:function(a,b,c,d){if(a==="nth"){var e=m++;return function(a){var b,f,g=0,h=a;if(c===1&&d===0)return!0;b=a.parentNode;if(b&&(b[q]!==e||!a.sizset)){for(h=b.firstChild;h;h=h.nextSibling)if(h.nodeType===1){h.sizset=++g;if(h===a)break}b[q]=e}return f=a.sizset-d,c===0?f===0:f%c===0&&f/c>=0}}return function(b){var c=b;switch(a){case"only":case"first":while(c=c.previousSibling)if(c.nodeType===1)return!1;if(a==="first")return!0;c=b;case"last":while(c=c.nextSibling)if(c.nodeType===1)return!1;return!0}}},PSEUDO:function(a,b,c,d){var e=$.pseudos[a]||$.pseudos[a.toLowerCase()];return e||Z.error("unsupported pseudo: "+a),e.sizzleFilter?e(b,c,d):e}},pseudos:{not:Q(function(a,b,c){var d=bl(a.replace(A,"$1"),b,c);return function(a){return!d(a)}}),enabled:function(a){return a.disabled===!1},disabled:function(a){return a.disabled===!0},checked:function(a){var b=a.nodeName.toLowerCase();return b==="input"&&!!a.checked||b==="option"&&!!a.selected},selected:function(a){return a.parentNode&&a.parentNode.selectedIndex,a.selected===!0},parent:function(a){return!$.pseudos.empty(a)},empty:function(a){var b;a=a.firstChild;while(a){if(a.nodeName>"@"||(b=a.nodeType)===3||b===4)return!1;a=a.nextSibling}return!0},contains:Q(function(a){return function(b){return(b.textContent||b.innerText||bc(b)).indexOf(a)>-1}}),has:Q(function(a){return function(b){return Z(a,b).length>0}}),header:function(a){return I.test(a.nodeName)},text:function(a){var b,c;return a.nodeName.toLowerCase()==="input"&&(b=a.type)==="text"&&((c=a.getAttribute("type"))==null||c.toLowerCase()===b)},radio:R("radio"),checkbox:R("checkbox"),file:R("file"),password:R("password"),image:R("image"),submit:S("submit"),reset:S("reset"),button:function(a){var b=a.nodeName.toLowerCase();return b==="input"&&a.type==="button"||b==="button"},input:function(a){return J.test(a.nodeName)},focus:function(a){var b=a.ownerDocument;return a===b.activeElement&&(!b.hasFocus||b.hasFocus())&&(!!a.type||!!a.href)},active:function(a){return a===a.ownerDocument.activeElement}},setFilters:{first:function(a,b,c){return c?a.slice(1):[a[0]]},last:function(a,b,c){var d=a.pop();return c?a:[d]},even:function(a,b,c){var d=[],e=c?1:0,f=a.length;for(;e<f;e=e+2)d.push(a[e]);return d},odd:function(a,b,c){var d=[],e=c?0:1,f=a.length;for(;e<f;e=e+2)d.push(a[e]);return d},lt:function(a,b,c){return c?a.slice(+b):a.slice(0,+b)},gt:function(a,b,c){return c?a.slice(0,+b+1):a.slice(+b+1)},eq:function(a,b,c){var d=a.splice(+b,1);return c?a:d}}};$.setFilters.nth=$.setFilters.eq,$.filters=$.pseudos,X||($.attrHandle={href:function(a){return a.getAttribute("href",2)},type:function(a){return a.getAttribute("type")}}),V&&($.order.push("NAME"),$.find.NAME=function(a,b){if(typeof b.getElementsByName!==j)return b.getElementsByName(a)}),Y&&($.order.splice(1,0,"CLASS"),$.find.CLASS=function(a,b,c){if(typeof b.getElementsByClassName!==j&&!c)return b.getElementsByClassName(a)});try{n.call(i.childNodes,0)[0].nodeType}catch(_){n=function(a){var b,c=[];for(;b=this[a];a++)c.push(b);return c}}var ba=Z.isXML=function(a){var b=a&&(a.ownerDocument||a).documentElement;return b?b.nodeName!=="HTML":!1},bb=Z.contains=i.compareDocumentPosition?function(a,b){return!!(a.compareDocumentPosition(b)&16)}:i.contains?function(a,b){var c=a.nodeType===9?a.documentElement:a,d=b.parentNode;return a===d||!!(d&&d.nodeType===1&&c.contains&&c.contains(d))}:function(a,b){while(b=b.parentNode)if(b===a)return!0;return!1},bc=Z.getText=function(a){var b,c="",d=0,e=a.nodeType;if(e){if(e===1||e===9||e===11){if(typeof a.textContent=="string")return a.textContent;for(a=a.firstChild;a;a=a.nextSibling)c+=bc(a)}else if(e===3||e===4)return a.nodeValue}else for(;b=a[d];d++)c+=bc(b);return c};Z.attr=function(a,b){var c,d=ba(a);return d||(b=b.toLowerCase()),$.attrHandle[b]?$.attrHandle[b](a):U||d?a.getAttribute(b):(c=a.getAttributeNode(b),c?typeof a[b]=="boolean"?a[b]?b:null:c.specified?c.value:null:null)},Z.error=function(a){throw new Error("Syntax error, unrecognized expression: "+a)},[0,0].sort(function(){return l=0}),i.compareDocumentPosition?e=function(a,b){return a===b?(k=!0,0):(!a.compareDocumentPosition||!b.compareDocumentPosition?a.compareDocumentPosition:a.compareDocumentPosition(b)&4)?-1:1}:(e=function(a,b){if(a===b)return k=!0,0;if(a.sourceIndex&&b.sourceIndex)return a.sourceIndex-b.sourceIndex;var c,d,e=[],g=[],h=a.parentNode,i=b.parentNode,j=h;if(h===i)return f(a,b);if(!h)return-1;if(!i)return 1;while(j)e.unshift(j),j=j.parentNode;j=i;while(j)g.unshift(j),j=j.parentNode;c=e.length,d=g.length;for(var l=0;l<c&&l<d;l++)if(e[l]!==g[l])return f(e[l],g[l]);return l===c?f(a,g[l],-1):f(e[l],b,1)},f=function(a,b,c){if(a===b)return c;var d=a.nextSibling;while(d){if(d===b)return-1;d=d.nextSibling}return 1}),Z.uniqueSort=function(a){var b,c=1;if(e){k=l,a.sort(e);if(k)for(;b=a[c];c++)b===a[c-1]&&a.splice(c--,1)}return a};var bl=Z.compile=function(a,b,c){var d,e,f,g=O[a];if(g&&g.context===b)return g;e=bg(a,b,c);for(f=0;d=e[f];f++)e[f]=bj(d,b,c);return g=O[a]=bk(e),g.context=b,g.runs=g.dirruns=0,P.push(a),P.length>$.cacheLength&&delete O[P.shift()],g};Z.matches=function(a,b){return Z(a,null,null,b)},Z.matchesSelector=function(a,b){return Z(b,null,null,[a]).length>0};var bm=function(a,b,e,f,g){a=a.replace(A,"$1");var h,i,j,k,l,m,p,q,r,s=a.match(C),t=a.match(E),u=b.nodeType;if(L.POS.test(a))return bf(a,b,e,f,s);if(f)h=n.call(f,0);else if(s&&s.length===1){if(t.length>1&&u===9&&!g&&(s=L.ID.exec(t[0]))){b=$.find.ID(s[1],b,g)[0];if(!b)return e;a=a.slice(t.shift().length)}q=(s=G.exec(t[0]))&&!s.index&&b.parentNode||b,r=t.pop(),m=r.split(":not")[0];for(j=0,k=$.order.length;j<k;j++){p=$.order[j];if(s=L[p].exec(m)){h=$.find[p]((s[1]||"").replace(K,""),q,g);if(h==null)continue;m===r&&(a=a.slice(0,a.length-r.length)+m.replace(L[p],""),a||o.apply(e,n.call(h,0)));break}}}if(a){i=bl(a,b,g),d=i.dirruns++,h==null&&(h=$.find.TAG("*",G.test(a)&&b.parentNode||b));for(j=0;l=h[j];j++)c=i.runs++,i(l,b)&&e.push(l)}return e};h.querySelectorAll&&function(){var a,b=bm,c=/'|\\/g,d=/\=[\x20\t\r\n\f]*([^'"\]]*)[\x20\t\r\n\f]*\]/g,e=[],f=[":active"],g=i.matchesSelector||i.mozMatchesSelector||i.webkitMatchesSelector||i.oMatchesSelector||i.msMatchesSelector;T(function(a){a.innerHTML="<select><option selected></option></select>",a.querySelectorAll("[selected]").length||e.push("\\["+r+"*(?:checked|disabled|ismap|multiple|readonly|selected|value)"),a.querySelectorAll(":checked").length||e.push(":checked")}),T(function(a){a.innerHTML="<p test=''></p>",a.querySelectorAll("[test^='']").length&&e.push("[*^$]="+r+"*(?:\"\"|'')"),a.innerHTML="<input type='hidden'>",a.querySelectorAll(":enabled").length||e.push(":enabled",":disabled")}),e=e.length&&new RegExp(e.join("|")),bm=function(a,d,f,g,h){if(!g&&!h&&(!e||!e.test(a)))if(d.nodeType===9)try{return o.apply(f,n.call(d.querySelectorAll(a),0)),f}catch(i){}else if(d.nodeType===1&&d.nodeName.toLowerCase()!=="object"){var j=d.getAttribute("id"),k=j||q,l=G.test(a)&&d.parentNode||d;j?k=k.replace(c,"\\$&"):d.setAttribute("id",k);try{return o.apply(f,n.call(l.querySelectorAll(a.replace(C,"[id='"+k+"'] $&")),0)),f}catch(i){}finally{j||d.removeAttribute("id")}}return b(a,d,f,g,h)},g&&(T(function(b){a=g.call(b,"div");try{g.call(b,"[test!='']:sizzle"),f.push($.match.PSEUDO)}catch(c){}}),f=new RegExp(f.join("|")),Z.matchesSelector=function(b,c){c=c.replace(d,"='$1']");if(!ba(b)&&!f.test(c)&&(!e||!e.test(c)))try{var h=g.call(b,c);if(h||a||b.document&&b.document.nodeType!==11)return h}catch(i){}return Z(c,null,null,[b]).length>0})}(),Z.attr=p.attr,p.find=Z,p.expr=Z.selectors,p.expr[":"]=p.expr.pseudos,p.unique=Z.uniqueSort,p.text=Z.getText,p.isXMLDoc=Z.isXML,p.contains=Z.contains}(a);var bc=/Until$/,bd=/^(?:parents|prev(?:Until|All))/,be=/^.[^:#\[\.,]*$/,bf=p.expr.match.needsContext,bg={children:!0,contents:!0,next:!0,prev:!0};p.fn.extend({find:function(a){var b,c,d,e,f,g,h=this;if(typeof a!="string")return p(a).filter(function(){for(b=0,c=h.length;b<c;b++)if(p.contains(h[b],this))return!0});g=this.pushStack("","find",a);for(b=0,c=this.length;b<c;b++){d=g.length,p.find(a,this[b],g);if(b>0)for(e=d;e<g.length;e++)for(f=0;f<d;f++)if(g[f]===g[e]){g.splice(e--,1);break}}return g},has:function(a){var b,c=p(a,this),d=c.length;return this.filter(function(){for(b=0;b<d;b++)if(p.contains(this,c[b]))return!0})},not:function(a){return this.pushStack(bj(this,a,!1),"not",a)},filter:function(a){return this.pushStack(bj(this,a,!0),"filter",a)},is:function(a){return!!a&&(typeof a=="string"?bf.test(a)?p(a,this.context).index(this[0])>=0:p.filter(a,this).length>0:this.filter(a).length>0)},closest:function(a,b){var c,d=0,e=this.length,f=[],g=bf.test(a)||typeof a!="string"?p(a,b||this.context):0;for(;d<e;d++){c=this[d];while(c&&c.ownerDocument&&c!==b&&c.nodeType!==11){if(g?g.index(c)>-1:p.find.matchesSelector(c,a)){f.push(c);break}c=c.parentNode}}return f=f.length>1?p.unique(f):f,this.pushStack(f,"closest",a)},index:function(a){return a?typeof a=="string"?p.inArray(this[0],p(a)):p.inArray(a.jquery?a[0]:a,this):this[0]&&this[0].parentNode?this.prevAll().length:-1},add:function(a,b){var c=typeof a=="string"?p(a,b):p.makeArray(a&&a.nodeType?[a]:a),d=p.merge(this.get(),c);return this.pushStack(bh(c[0])||bh(d[0])?d:p.unique(d))},addBack:function(a){return this.add(a==null?this.prevObject:this.prevObject.filter(a))}}),p.fn.andSelf=p.fn.addBack,p.each({parent:function(a){var b=a.parentNode;return b&&b.nodeType!==11?b:null},parents:function(a){return p.dir(a,"parentNode")},parentsUntil:function(a,b,c){return p.dir(a,"parentNode",c)},next:function(a){return bi(a,"nextSibling")},prev:function(a){return bi(a,"previousSibling")},nextAll:function(a){return p.dir(a,"nextSibling")},prevAll:function(a){return p.dir(a,"previousSibling")},nextUntil:function(a,b,c){return p.dir(a,"nextSibling",c)},prevUntil:function(a,b,c){return p.dir(a,"previousSibling",c)},siblings:function(a){return p.sibling((a.parentNode||{}).firstChild,a)},children:function(a){return p.sibling(a.firstChild)},contents:function(a){return p.nodeName(a,"iframe")?a.contentDocument||a.contentWindow.document:p.merge([],a.childNodes)}},function(a,b){p.fn[a]=function(c,d){var e=p.map(this,b,c);return bc.test(a)||(d=c),d&&typeof d=="string"&&(e=p.filter(d,e)),e=this.length>1&&!bg[a]?p.unique(e):e,this.length>1&&bd.test(a)&&(e=e.reverse()),this.pushStack(e,a,k.call(arguments).join(","))}}),p.extend({filter:function(a,b,c){return c&&(a=":not("+a+")"),b.length===1?p.find.matchesSelector(b[0],a)?[b[0]]:[]:p.find.matches(a,b)},dir:function(a,c,d){var e=[],f=a[c];while(f&&f.nodeType!==9&&(d===b||f.nodeType!==1||!p(f).is(d)))f.nodeType===1&&e.push(f),f=f[c];return e},sibling:function(a,b){var c=[];for(;a;a=a.nextSibling)a.nodeType===1&&a!==b&&c.push(a);return c}});var bl="abbr|article|aside|audio|bdi|canvas|data|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",bm=/ jQuery\d+="(?:null|\d+)"/g,bn=/^\s+/,bo=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,bp=/<([\w:]+)/,bq=/<tbody/i,br=/<|&#?\w+;/,bs=/<(?:script|style|link)/i,bt=/<(?:script|object|embed|option|style)/i,bu=new RegExp("<(?:"+bl+")[\\s/>]","i"),bv=/^(?:checkbox|radio)$/,bw=/checked\s*(?:[^=]|=\s*.checked.)/i,bx=/\/(java|ecma)script/i,by=/^\s*<!(?:\[CDATA\[|\-\-)|[\]\-]{2}>\s*$/g,bz={option:[1,"<select multiple='multiple'>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]},bA=bk(e),bB=bA.appendChild(e.createElement("div"));bz.optgroup=bz.option,bz.tbody=bz.tfoot=bz.colgroup=bz.caption=bz.thead,bz.th=bz.td,p.support.htmlSerialize||(bz._default=[1,"X<div>","</div>"]),p.fn.extend({text:function(a){return p.access(this,function(a){return a===b?p.text(this):this.empty().append((this[0]&&this[0].ownerDocument||e).createTextNode(a))},null,a,arguments.length)},wrapAll:function(a){if(p.isFunction(a))return this.each(function(b){p(this).wrapAll(a.call(this,b))});if(this[0]){var b=p(a,this[0].ownerDocument).eq(0).clone(!0);this[0].parentNode&&b.insertBefore(this[0]),b.map(function(){var a=this;while(a.firstChild&&a.firstChild.nodeType===1)a=a.firstChild;return a}).append(this)}return this},wrapInner:function(a){return p.isFunction(a)?this.each(function(b){p(this).wrapInner(a.call(this,b))}):this.each(function(){var b=p(this),c=b.contents();c.length?c.wrapAll(a):b.append(a)})},wrap:function(a){var b=p.isFunction(a);return this.each(function(c){p(this).wrapAll(b?a.call(this,c):a)})},unwrap:function(){return this.parent().each(function(){p.nodeName(this,"body")||p(this).replaceWith(this.childNodes)}).end()},append:function(){return this.domManip(arguments,!0,function(a){(this.nodeType===1||this.nodeType===11)&&this.appendChild(a)})},prepend:function(){return this.domManip(arguments,!0,function(a){(this.nodeType===1||this.nodeType===11)&&this.insertBefore(a,this.firstChild)})},before:function(){if(!bh(this[0]))return this.domManip(arguments,!1,function(a){this.parentNode.insertBefore(a,this)});if(arguments.length){var a=p.clean(arguments);return this.pushStack(p.merge(a,this),"before",this.selector)}},after:function(){if(!bh(this[0]))return this.domManip(arguments,!1,function(a){this.parentNode.insertBefore(a,this.nextSibling)});if(arguments.length){var a=p.clean(arguments);return this.pushStack(p.merge(this,a),"after",this.selector)}},remove:function(a,b){var c,d=0;for(;(c=this[d])!=null;d++)if(!a||p.filter(a,[c]).length)!b&&c.nodeType===1&&(p.cleanData(c.getElementsByTagName("*")),p.cleanData([c])),c.parentNode&&c.parentNode.removeChild(c);return this},empty:function(){var a,b=0;for(;(a=this[b])!=null;b++){a.nodeType===1&&p.cleanData(a.getElementsByTagName("*"));while(a.firstChild)a.removeChild(a.firstChild)}return this},clone:function(a,b){return a=a==null?!1:a,b=b==null?a:b,this.map(function(){return p.clone(this,a,b)})},html:function(a){return p.access(this,function(a){var c=this[0]||{},d=0,e=this.length;if(a===b)return c.nodeType===1?c.innerHTML.replace(bm,""):b;if(typeof a=="string"&&!bs.test(a)&&(p.support.htmlSerialize||!bu.test(a))&&(p.support.leadingWhitespace||!bn.test(a))&&!bz[(bp.exec(a)||["",""])[1].toLowerCase()]){a=a.replace(bo,"<$1></$2>");try{for(;d<e;d++)c=this[d]||{},c.nodeType===1&&(p.cleanData(c.getElementsByTagName("*")),c.innerHTML=a);c=0}catch(f){}}c&&this.empty().append(a)},null,a,arguments.length)},replaceWith:function(a){return bh(this[0])?this.length?this.pushStack(p(p.isFunction(a)?a():a),"replaceWith",a):this:p.isFunction(a)?this.each(function(b){var c=p(this),d=c.html();c.replaceWith(a.call(this,b,d))}):(typeof a!="string"&&(a=p(a).detach()),this.each(function(){var b=this.nextSibling,c=this.parentNode;p(this).remove(),b?p(b).before(a):p(c).append(a)}))},detach:function(a){return this.remove(a,!0)},domManip:function(a,c,d){a=[].concat.apply([],a);var e,f,g,h,i=0,j=a[0],k=[],l=this.length;if(!p.support.checkClone&&l>1&&typeof j=="string"&&bw.test(j))return this.each(function(){p(this).domManip(a,c,d)});if(p.isFunction(j))return this.each(function(e){var f=p(this);a[0]=j.call(this,e,c?f.html():b),f.domManip(a,c,d)});if(this[0]){e=p.buildFragment(a,this,k),g=e.fragment,f=g.firstChild,g.childNodes.length===1&&(g=f);if(f){c=c&&p.nodeName(f,"tr");for(h=e.cacheable||l-1;i<l;i++)d.call(c&&p.nodeName(this[i],"table")?bC(this[i],"tbody"):this[i],i===h?g:p.clone(g,!0,!0))}g=f=null,k.length&&p.each(k,function(a,b){b.src?p.ajax?p.ajax({url:b.src,type:"GET",dataType:"script",async:!1,global:!1,"throws":!0}):p.error("no ajax"):p.globalEval((b.text||b.textContent||b.innerHTML||"").replace(by,"")),b.parentNode&&b.parentNode.removeChild(b)})}return this}}),p.buildFragment=function(a,c,d){var f,g,h,i=a[0];return c=c||e,c=(c[0]||c).ownerDocument||c[0]||c,typeof c.createDocumentFragment=="undefined"&&(c=e),a.length===1&&typeof i=="string"&&i.length<512&&c===e&&i.charAt(0)==="<"&&!bt.test(i)&&(p.support.checkClone||!bw.test(i))&&(p.support.html5Clone||!bu.test(i))&&(g=!0,f=p.fragments[i],h=f!==b),f||(f=c.createDocumentFragment(),p.clean(a,c,f,d),g&&(p.fragments[i]=h&&f)),{fragment:f,cacheable:g}},p.fragments={},p.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,b){p.fn[a]=function(c){var d,e=0,f=[],g=p(c),h=g.length,i=this.length===1&&this[0].parentNode;if((i==null||i&&i.nodeType===11&&i.childNodes.length===1)&&h===1)return g[b](this[0]),this;for(;e<h;e++)d=(e>0?this.clone(!0):this).get(),p(g[e])[b](d),f=f.concat(d);return this.pushStack(f,a,g.selector)}}),p.extend({clone:function(a,b,c){var d,e,f,g;p.support.html5Clone||p.isXMLDoc(a)||!bu.test("<"+a.nodeName+">")?g=a.cloneNode(!0):(bB.innerHTML=a.outerHTML,bB.removeChild(g=bB.firstChild));if((!p.support.noCloneEvent||!p.support.noCloneChecked)&&(a.nodeType===1||a.nodeType===11)&&!p.isXMLDoc(a)){bE(a,g),d=bF(a),e=bF(g);for(f=0;d[f];++f)e[f]&&bE(d[f],e[f])}if(b){bD(a,g);if(c){d=bF(a),e=bF(g);for(f=0;d[f];++f)bD(d[f],e[f])}}return d=e=null,g},clean:function(a,b,c,d){var f,g,h,i,j,k,l,m,n,o,q,r,s=0,t=[];if(!b||typeof b.createDocumentFragment=="undefined")b=e;for(g=b===e&&bA;(h=a[s])!=null;s++){typeof h=="number"&&(h+="");if(!h)continue;if(typeof h=="string")if(!br.test(h))h=b.createTextNode(h);else{g=g||bk(b),l=l||g.appendChild(b.createElement("div")),h=h.replace(bo,"<$1></$2>"),i=(bp.exec(h)||["",""])[1].toLowerCase(),j=bz[i]||bz._default,k=j[0],l.innerHTML=j[1]+h+j[2];while(k--)l=l.lastChild;if(!p.support.tbody){m=bq.test(h),n=i==="table"&&!m?l.firstChild&&l.firstChild.childNodes:j[1]==="<table>"&&!m?l.childNodes:[];for(f=n.length-1;f>=0;--f)p.nodeName(n[f],"tbody")&&!n[f].childNodes.length&&n[f].parentNode.removeChild(n[f])}!p.support.leadingWhitespace&&bn.test(h)&&l.insertBefore(b.createTextNode(bn.exec(h)[0]),l.firstChild),h=l.childNodes,l=g.lastChild}h.nodeType?t.push(h):t=p.merge(t,h)}l&&(g.removeChild(l),h=l=g=null);if(!p.support.appendChecked)for(s=0;(h=t[s])!=null;s++)p.nodeName(h,"input")?bG(h):typeof h.getElementsByTagName!="undefined"&&p.grep(h.getElementsByTagName("input"),bG);if(c){q=function(a){if(!a.type||bx.test(a.type))return d?d.push(a.parentNode?a.parentNode.removeChild(a):a):c.appendChild(a)};for(s=0;(h=t[s])!=null;s++)if(!p.nodeName(h,"script")||!q(h))c.appendChild(h),typeof h.getElementsByTagName!="undefined"&&(r=p.grep(p.merge([],h.getElementsByTagName("script")),q),t.splice.apply(t,[s+1,0].concat(r)),s+=r.length)}return t},cleanData:function(a,b){var c,d,e,f,g=0,h=p.expando,i=p.cache,j=p.support.deleteExpando,k=p.event.special;for(;(e=a[g])!=null;g++)if(b||p.acceptData(e)){d=e[h],c=d&&i[d];if(c){if(c.events)for(f in c.events)k[f]?p.event.remove(e,f):p.removeEvent(e,f,c.handle);i[d]&&(delete i[d],j?delete e[h]:e.removeAttribute?e.removeAttribute(h):e[h]=null,p.deletedIds.push(d))}}}}),function(){var a,b;p.uaMatch=function(a){a=a.toLowerCase();var b=/(chrome)[ \/]([\w.]+)/.exec(a)||/(webkit)[ \/]([\w.]+)/.exec(a)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(a)||/(msie) ([\w.]+)/.exec(a)||a.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(a)||[];return{browser:b[1]||"",version:b[2]||"0"}},a=p.uaMatch(g.userAgent),b={},a.browser&&(b[a.browser]=!0,b.version=a.version),b.webkit&&(b.safari=!0),p.browser=b,p.sub=function(){function a(b,c){return new a.fn.init(b,c)}p.extend(!0,a,this),a.superclass=this,a.fn=a.prototype=this(),a.fn.constructor=a,a.sub=this.sub,a.fn.init=function c(c,d){return d&&d instanceof p&&!(d instanceof a)&&(d=a(d)),p.fn.init.call(this,c,d,b)},a.fn.init.prototype=a.fn;var b=a(e);return a}}();var bH,bI,bJ,bK=/alpha\([^)]*\)/i,bL=/opacity=([^)]*)/,bM=/^(top|right|bottom|left)$/,bN=/^margin/,bO=new RegExp("^("+q+")(.*)$","i"),bP=new RegExp("^("+q+")(?!px)[a-z%]+$","i"),bQ=new RegExp("^([-+])=("+q+")","i"),bR={},bS={position:"absolute",visibility:"hidden",display:"block"},bT={letterSpacing:0,fontWeight:400,lineHeight:1},bU=["Top","Right","Bottom","Left"],bV=["Webkit","O","Moz","ms"],bW=p.fn.toggle;p.fn.extend({css:function(a,c){return p.access(this,function(a,c,d){return d!==b?p.style(a,c,d):p.css(a,c)},a,c,arguments.length>1)},show:function(){return bZ(this,!0)},hide:function(){return bZ(this)},toggle:function(a,b){var c=typeof a=="boolean";return p.isFunction(a)&&p.isFunction(b)?bW.apply(this,arguments):this.each(function(){(c?a:bY(this))?p(this).show():p(this).hide()})}}),p.extend({cssHooks:{opacity:{get:function(a,b){if(b){var c=bH(a,"opacity");return c===""?"1":c}}}},cssNumber:{fillOpacity:!0,fontWeight:!0,lineHeight:!0,opacity:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{"float":p.support.cssFloat?"cssFloat":"styleFloat"},style:function(a,c,d,e){if(!a||a.nodeType===3||a.nodeType===8||!a.style)return;var f,g,h,i=p.camelCase(c),j=a.style;c=p.cssProps[i]||(p.cssProps[i]=bX(j,i)),h=p.cssHooks[c]||p.cssHooks[i];if(d===b)return h&&"get"in h&&(f=h.get(a,!1,e))!==b?f:j[c];g=typeof d,g==="string"&&(f=bQ.exec(d))&&(d=(f[1]+1)*f[2]+parseFloat(p.css(a,c)),g="number");if(d==null||g==="number"&&isNaN(d))return;g==="number"&&!p.cssNumber[i]&&(d+="px");if(!h||!("set"in h)||(d=h.set(a,d,e))!==b)try{j[c]=d}catch(k){}},css:function(a,c,d,e){var f,g,h,i=p.camelCase(c);return c=p.cssProps[i]||(p.cssProps[i]=bX(a.style,i)),h=p.cssHooks[c]||p.cssHooks[i],h&&"get"in h&&(f=h.get(a,!0,e)),f===b&&(f=bH(a,c)),f==="normal"&&c in bT&&(f=bT[c]),d||e!==b?(g=parseFloat(f),d||p.isNumeric(g)?g||0:f):f},swap:function(a,b,c){var d,e,f={};for(e in b)f[e]=a.style[e],a.style[e]=b[e];d=c.call(a);for(e in b)a.style[e]=f[e];return d}}),a.getComputedStyle?bH=function(a,b){var c,d,e,f,g=getComputedStyle(a,null),h=a.style;return g&&(c=g[b],c===""&&!p.contains(a.ownerDocument.documentElement,a)&&(c=p.style(a,b)),bP.test(c)&&bN.test(b)&&(d=h.width,e=h.minWidth,f=h.maxWidth,h.minWidth=h.maxWidth=h.width=c,c=g.width,h.width=d,h.minWidth=e,h.maxWidth=f)),c}:e.documentElement.currentStyle&&(bH=function(a,b){var c,d,e=a.currentStyle&&a.currentStyle[b],f=a.style;return e==null&&f&&f[b]&&(e=f[b]),bP.test(e)&&!bM.test(b)&&(c=f.left,d=a.runtimeStyle&&a.runtimeStyle.left,d&&(a.runtimeStyle.left=a.currentStyle.left),f.left=b==="fontSize"?"1em":e,e=f.pixelLeft+"px",f.left=c,d&&(a.runtimeStyle.left=d)),e===""?"auto":e}),p.each(["height","width"],function(a,b){p.cssHooks[b]={get:function(a,c,d){if(c)return a.offsetWidth!==0||bH(a,"display")!=="none"?ca(a,b,d):p.swap(a,bS,function(){return ca(a,b,d)})},set:function(a,c,d){return b$(a,c,d?b_(a,b,d,p.support.boxSizing&&p.css(a,"boxSizing")==="border-box"):0)}}}),p.support.opacity||(p.cssHooks.opacity={get:function(a,b){return bL.test((b&&a.currentStyle?a.currentStyle.filter:a.style.filter)||"")?.01*parseFloat(RegExp.$1)+"":b?"1":""},set:function(a,b){var c=a.style,d=a.currentStyle,e=p.isNumeric(b)?"alpha(opacity="+b*100+")":"",f=d&&d.filter||c.filter||"";c.zoom=1;if(b>=1&&p.trim(f.replace(bK,""))===""&&c.removeAttribute){c.removeAttribute("filter");if(d&&!d.filter)return}c.filter=bK.test(f)?f.replace(bK,e):f+" "+e}}),p(function(){p.support.reliableMarginRight||(p.cssHooks.marginRight={get:function(a,b){return p.swap(a,{display:"inline-block"},function(){if(b)return bH(a,"marginRight")})}}),!p.support.pixelPosition&&p.fn.position&&p.each(["top","left"],function(a,b){p.cssHooks[b]={get:function(a,c){if(c){var d=bH(a,b);return bP.test(d)?p(a).position()[b]+"px":d}}}})}),p.expr&&p.expr.filters&&(p.expr.filters.hidden=function(a){return a.offsetWidth===0&&a.offsetHeight===0||!p.support.reliableHiddenOffsets&&(a.style&&a.style.display||bH(a,"display"))==="none"},p.expr.filters.visible=function(a){return!p.expr.filters.hidden(a)}),p.each({margin:"",padding:"",border:"Width"},function(a,b){p.cssHooks[a+b]={expand:function(c){var d,e=typeof c=="string"?c.split(" "):[c],f={};for(d=0;d<4;d++)f[a+bU[d]+b]=e[d]||e[d-2]||e[0];return f}},bN.test(a)||(p.cssHooks[a+b].set=b$)});var cc=/%20/g,cd=/\[\]$/,ce=/\r?\n/g,cf=/^(?:color|date|datetime|datetime-local|email|hidden|month|number|password|range|search|tel|text|time|url|week)$/i,cg=/^(?:select|textarea)/i;p.fn.extend({serialize:function(){return p.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?p.makeArray(this.elements):this}).filter(function(){return this.name&&!this.disabled&&(this.checked||cg.test(this.nodeName)||cf.test(this.type))}).map(function(a,b){var c=p(this).val();return c==null?null:p.isArray(c)?p.map(c,function(a,c){return{name:b.name,value:a.replace(ce,"\r\n")}}):{name:b.name,value:c.replace(ce,"\r\n")}}).get()}}),p.param=function(a,c){var d,e=[],f=function(a,b){b=p.isFunction(b)?b():b==null?"":b,e[e.length]=encodeURIComponent(a)+"="+encodeURIComponent(b)};c===b&&(c=p.ajaxSettings&&p.ajaxSettings.traditional);if(p.isArray(a)||a.jquery&&!p.isPlainObject(a))p.each(a,function(){f(this.name,this.value)});else for(d in a)ch(d,a[d],c,f);return e.join("&").replace(cc,"+")};var ci,cj,ck=/#.*$/,cl=/^(.*?):[ \t]*([^\r\n]*)\r?$/mg,cm=/^(?:about|app|app\-storage|.+\-extension|file|res|widget):$/,cn=/^(?:GET|HEAD)$/,co=/^\/\//,cp=/\?/,cq=/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi,cr=/([?&])_=[^&]*/,cs=/^([\w\+\.\-]+:)(?:\/\/([^\/?#:]*)(?::(\d+)|)|)/,ct=p.fn.load,cu={},cv={},cw=["*/"]+["*"];try{ci=f.href}catch(cx){ci=e.createElement("a"),ci.href="",ci=ci.href}cj=cs.exec(ci.toLowerCase())||[],p.fn.load=function(a,c,d){if(typeof a!="string"&&ct)return ct.apply(this,arguments);if(!this.length)return this;var e,f,g,h=this,i=a.indexOf(" ");return i>=0&&(e=a.slice(i,a.length),a=a.slice(0,i)),p.isFunction(c)?(d=c,c=b):typeof c=="object"&&(f="POST"),p.ajax({url:a,type:f,dataType:"html",data:c,complete:function(a,b){d&&h.each(d,g||[a.responseText,b,a])}}).done(function(a){g=arguments,h.html(e?p("<div>").append(a.replace(cq,"")).find(e):a)}),this},p.each("ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split(" "),function(a,b){p.fn[b]=function(a){return this.on(b,a)}}),p.each(["get","post"],function(a,c){p[c]=function(a,d,e,f){return p.isFunction(d)&&(f=f||e,e=d,d=b),p.ajax({type:c,url:a,data:d,success:e,dataType:f})}}),p.extend({getScript:function(a,c){return p.get(a,b,c,"script")},getJSON:function(a,b,c){return p.get(a,b,c,"json")},ajaxSetup:function(a,b){return b?cA(a,p.ajaxSettings):(b=a,a=p.ajaxSettings),cA(a,b),a},ajaxSettings:{url:ci,isLocal:cm.test(cj[1]),global:!0,type:"GET",contentType:"application/x-www-form-urlencoded; charset=UTF-8",processData:!0,async:!0,accepts:{xml:"application/xml, text/xml",html:"text/html",text:"text/plain",json:"application/json, text/javascript","*":cw},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText"},converters:{"* text":a.String,"text html":!0,"text json":p.parseJSON,"text xml":p.parseXML},flatOptions:{context:!0,url:!0}},ajaxPrefilter:cy(cu),ajaxTransport:cy(cv),ajax:function(a,c){function y(a,c,f,i){var k,s,t,u,w,y=c;if(v===2)return;v=2,h&&clearTimeout(h),g=b,e=i||"",x.readyState=a>0?4:0,f&&(u=cB(l,x,f));if(a>=200&&a<300||a===304)l.ifModified&&(w=x.getResponseHeader("Last-Modified"),w&&(p.lastModified[d]=w),w=x.getResponseHeader("Etag"),w&&(p.etag[d]=w)),a===304?(y="notmodified",k=!0):(k=cC(l,u),y=k.state,s=k.data,t=k.error,k=!t);else{t=y;if(!y||a)y="error",a<0&&(a=0)}x.status=a,x.statusText=""+(c||y),k?o.resolveWith(m,[s,y,x]):o.rejectWith(m,[x,y,t]),x.statusCode(r),r=b,j&&n.trigger("ajax"+(k?"Success":"Error"),[x,l,k?s:t]),q.fireWith(m,[x,y]),j&&(n.trigger("ajaxComplete",[x,l]),--p.active||p.event.trigger("ajaxStop"))}typeof a=="object"&&(c=a,a=b),c=c||{};var d,e,f,g,h,i,j,k,l=p.ajaxSetup({},c),m=l.context||l,n=m!==l&&(m.nodeType||m instanceof p)?p(m):p.event,o=p.Deferred(),q=p.Callbacks("once memory"),r=l.statusCode||{},t={},u={},v=0,w="canceled",x={readyState:0,setRequestHeader:function(a,b){if(!v){var c=a.toLowerCase();a=u[c]=u[c]||a,t[a]=b}return this},getAllResponseHeaders:function(){return v===2?e:null},getResponseHeader:function(a){var c;if(v===2){if(!f){f={};while(c=cl.exec(e))f[c[1].toLowerCase()]=c[2]}c=f[a.toLowerCase()]}return c===b?null:c},overrideMimeType:function(a){return v||(l.mimeType=a),this},abort:function(a){return a=a||w,g&&g.abort(a),y(0,a),this}};o.promise(x),x.success=x.done,x.error=x.fail,x.complete=q.add,x.statusCode=function(a){if(a){var b;if(v<2)for(b in a)r[b]=[r[b],a[b]];else b=a[x.status],x.always(b)}return this},l.url=((a||l.url)+"").replace(ck,"").replace(co,cj[1]+"//"),l.dataTypes=p.trim(l.dataType||"*").toLowerCase().split(s),l.crossDomain==null&&(i=cs.exec(l.url.toLowerCase()),l.crossDomain=!(!i||i[1]==cj[1]&&i[2]==cj[2]&&(i[3]||(i[1]==="http:"?80:443))==(cj[3]||(cj[1]==="http:"?80:443)))),l.data&&l.processData&&typeof l.data!="string"&&(l.data=p.param(l.data,l.traditional)),cz(cu,l,c,x);if(v===2)return x;j=l.global,l.type=l.type.toUpperCase(),l.hasContent=!cn.test(l.type),j&&p.active++===0&&p.event.trigger("ajaxStart");if(!l.hasContent){l.data&&(l.url+=(cp.test(l.url)?"&":"?")+l.data,delete l.data),d=l.url;if(l.cache===!1){var z=p.now(),A=l.url.replace(cr,"$1_="+z);l.url=A+(A===l.url?(cp.test(l.url)?"&":"?")+"_="+z:"")}}(l.data&&l.hasContent&&l.contentType!==!1||c.contentType)&&x.setRequestHeader("Content-Type",l.contentType),l.ifModified&&(d=d||l.url,p.lastModified[d]&&x.setRequestHeader("If-Modified-Since",p.lastModified[d]),p.etag[d]&&x.setRequestHeader("If-None-Match",p.etag[d])),x.setRequestHeader("Accept",l.dataTypes[0]&&l.accepts[l.dataTypes[0]]?l.accepts[l.dataTypes[0]]+(l.dataTypes[0]!=="*"?", "+cw+"; q=0.01":""):l.accepts["*"]);for(k in l.headers)x.setRequestHeader(k,l.headers[k]);if(!l.beforeSend||l.beforeSend.call(m,x,l)!==!1&&v!==2){w="abort";for(k in{success:1,error:1,complete:1})x[k](l[k]);g=cz(cv,l,c,x);if(!g)y(-1,"No Transport");else{x.readyState=1,j&&n.trigger("ajaxSend",[x,l]),l.async&&l.timeout>0&&(h=setTimeout(function(){x.abort("timeout")},l.timeout));try{v=1,g.send(t,y)}catch(B){if(v<2)y(-1,B);else throw B}}return x}return x.abort()},active:0,lastModified:{},etag:{}});var cD=[],cE=/\?/,cF=/(=)\?(?=&|$)|\?\?/,cG=p.now();p.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var a=cD.pop()||p.expando+"_"+cG++;return this[a]=!0,a}}),p.ajaxPrefilter("json jsonp",function(c,d,e){var f,g,h,i=c.data,j=c.url,k=c.jsonp!==!1,l=k&&cF.test(j),m=k&&!l&&typeof i=="string"&&!(c.contentType||"").indexOf("application/x-www-form-urlencoded")&&cF.test(i);if(c.dataTypes[0]==="jsonp"||l||m)return f=c.jsonpCallback=p.isFunction(c.jsonpCallback)?c.jsonpCallback():c.jsonpCallback,g=a[f],l?c.url=j.replace(cF,"$1"+f):m?c.data=i.replace(cF,"$1"+f):k&&(c.url+=(cE.test(j)?"&":"?")+c.jsonp+"="+f),c.converters["script json"]=function(){return h||p.error(f+" was not called"),h[0]},c.dataTypes[0]="json",a[f]=function(){h=arguments},e.always(function(){a[f]=g,c[f]&&(c.jsonpCallback=d.jsonpCallback,cD.push(f)),h&&p.isFunction(g)&&g(h[0]),h=g=b}),"script"}),p.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/javascript|ecmascript/},converters:{"text script":function(a){return p.globalEval(a),a}}}),p.ajaxPrefilter("script",function(a){a.cache===b&&(a.cache=!1),a.crossDomain&&(a.type="GET",a.global=!1)}),p.ajaxTransport("script",function(a){if(a.crossDomain){var c,d=e.head||e.getElementsByTagName("head")[0]||e.documentElement;return{send:function(f,g){c=e.createElement("script"),c.async="async",a.scriptCharset&&(c.charset=a.scriptCharset),c.src=a.url,c.onload=c.onreadystatechange=function(a,e){if(e||!c.readyState||/loaded|complete/.test(c.readyState))c.onload=c.onreadystatechange=null,d&&c.parentNode&&d.removeChild(c),c=b,e||g(200,"success")},d.insertBefore(c,d.firstChild)},abort:function(){c&&c.onload(0,1)}}}});var cH,cI=a.ActiveXObject?function(){for(var a in cH)cH[a](0,1)}:!1,cJ=0;p.ajaxSettings.xhr=a.ActiveXObject?function(){return!this.isLocal&&cK()||cL()}:cK,function(a){p.extend(p.support,{ajax:!!a,cors:!!a&&"withCredentials"in a})}(p.ajaxSettings.xhr()),p.support.ajax&&p.ajaxTransport(function(c){if(!c.crossDomain||p.support.cors){var d;return{send:function(e,f){var g,h,i=c.xhr();c.username?i.open(c.type,c.url,c.async,c.username,c.password):i.open(c.type,c.url,c.async);if(c.xhrFields)for(h in c.xhrFields)i[h]=c.xhrFields[h];c.mimeType&&i.overrideMimeType&&i.overrideMimeType(c.mimeType),!c.crossDomain&&!e["X-Requested-With"]&&(e["X-Requested-With"]="XMLHttpRequest");try{for(h in e)i.setRequestHeader(h,e[h])}catch(j){}i.send(c.hasContent&&c.data||null),d=function(a,e){var h,j,k,l,m;try{if(d&&(e||i.readyState===4)){d=b,g&&(i.onreadystatechange=p.noop,cI&&delete cH[g]);if(e)i.readyState!==4&&i.abort();else{h=i.status,k=i.getAllResponseHeaders(),l={},m=i.responseXML,m&&m.documentElement&&(l.xml=m);try{l.text=i.responseText}catch(a){}try{j=i.statusText}catch(n){j=""}!h&&c.isLocal&&!c.crossDomain?h=l.text?200:404:h===1223&&(h=204)}}}catch(o){e||f(-1,o)}l&&f(h,j,l,k)},c.async?i.readyState===4?setTimeout(d,0):(g=++cJ,cI&&(cH||(cH={},p(a).unload(cI)),cH[g]=d),i.onreadystatechange=d):d()},abort:function(){d&&d(0,1)}}}});var cM,cN,cO=/^(?:toggle|show|hide)$/,cP=new RegExp("^(?:([-+])=|)("+q+")([a-z%]*)$","i"),cQ=/queueHooks$/,cR=[cX],cS={"*":[function(a,b){var c,d,e,f=this.createTween(a,b),g=cP.exec(b),h=f.cur(),i=+h||0,j=1;if(g){c=+g[2],d=g[3]||(p.cssNumber[a]?"":"px");if(d!=="px"&&i){i=p.css(f.elem,a,!0)||c||1;do e=j=j||".5",i=i/j,p.style(f.elem,a,i+d),j=f.cur()/h;while(j!==1&&j!==e)}f.unit=d,f.start=i,f.end=g[1]?i+(g[1]+1)*c:c}return f}]};p.Animation=p.extend(cV,{tweener:function(a,b){p.isFunction(a)?(b=a,a=["*"]):a=a.split(" ");var c,d=0,e=a.length;for(;d<e;d++)c=a[d],cS[c]=cS[c]||[],cS[c].unshift(b)},prefilter:function(a,b){b?cR.unshift(a):cR.push(a)}}),p.Tween=cY,cY.prototype={constructor:cY,init:function(a,b,c,d,e,f){this.elem=a,this.prop=c,this.easing=e||"swing",this.options=b,this.start=this.now=this.cur(),this.end=d,this.unit=f||(p.cssNumber[c]?"":"px")},cur:function(){var a=cY.propHooks[this.prop];return a&&a.get?a.get(this):cY.propHooks._default.get(this)},run:function(a){var b,c=cY.propHooks[this.prop];return this.pos=b=p.easing[this.easing](a,this.options.duration*a,0,1,this.options.duration),this.now=(this.end-this.start)*b+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),c&&c.set?c.set(this):cY.propHooks._default.set(this),this}},cY.prototype.init.prototype=cY.prototype,cY.propHooks={_default:{get:function(a){var b;return a.elem[a.prop]==null||!!a.elem.style&&a.elem.style[a.prop]!=null?(b=p.css(a.elem,a.prop,!1,""),!b||b==="auto"?0:b):a.elem[a.prop]},set:function(a){p.fx.step[a.prop]?p.fx.step[a.prop](a):a.elem.style&&(a.elem.style[p.cssProps[a.prop]]!=null||p.cssHooks[a.prop])?p.style(a.elem,a.prop,a.now+a.unit):a.elem[a.prop]=a.now}}},cY.propHooks.scrollTop=cY.propHooks.scrollLeft={set:function(a){a.elem.nodeType&&a.elem.parentNode&&(a.elem[a.prop]=a.now)}},p.each(["toggle","show","hide"],function(a,b){var c=p.fn[b];p.fn[b]=function(d,e,f){return d==null||typeof d=="boolean"||!a&&p.isFunction(d)&&p.isFunction(e)?c.apply(this,arguments):this.animate(cZ(b,!0),d,e,f)}}),p.fn.extend({fadeTo:function(a,b,c,d){return this.filter(bY).css("opacity",0).show().end().animate({opacity:b},a,c,d)},animate:function(a,b,c,d){var e=p.isEmptyObject(a),f=p.speed(b,c,d),g=function(){var b=cV(this,p.extend({},a),f);e&&b.stop(!0)};return e||f.queue===!1?this.each(g):this.queue(f.queue,g)},stop:function(a,c,d){var e=function(a){var b=a.stop;delete a.stop,b(d)};return typeof a!="string"&&(d=c,c=a,a=b),c&&a!==!1&&this.queue(a||"fx",[]),this.each(function(){var b=!0,c=a!=null&&a+"queueHooks",f=p.timers,g=p._data(this);if(c)g[c]&&g[c].stop&&e(g[c]);else for(c in g)g[c]&&g[c].stop&&cQ.test(c)&&e(g[c]);for(c=f.length;c--;)f[c].elem===this&&(a==null||f[c].queue===a)&&(f[c].anim.stop(d),b=!1,f.splice(c,1));(b||!d)&&p.dequeue(this,a)})}}),p.each({slideDown:cZ("show"),slideUp:cZ("hide"),slideToggle:cZ("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(a,b){p.fn[a]=function(a,c,d){return this.animate(b,a,c,d)}}),p.speed=function(a,b,c){var d=a&&typeof a=="object"?p.extend({},a):{complete:c||!c&&b||p.isFunction(a)&&a,duration:a,easing:c&&b||b&&!p.isFunction(b)&&b};d.duration=p.fx.off?0:typeof d.duration=="number"?d.duration:d.duration in p.fx.speeds?p.fx.speeds[d.duration]:p.fx.speeds._default;if(d.queue==null||d.queue===!0)d.queue="fx";return d.old=d.complete,d.complete=function(){p.isFunction(d.old)&&d.old.call(this),d.queue&&p.dequeue(this,d.queue)},d},p.easing={linear:function(a){return a},swing:function(a){return.5-Math.cos(a*Math.PI)/2}},p.timers=[],p.fx=cY.prototype.init,p.fx.tick=function(){var a,b=p.timers,c=0;for(;c<b.length;c++)a=b[c],!a()&&b[c]===a&&b.splice(c--,1);b.length||p.fx.stop()},p.fx.timer=function(a){a()&&p.timers.push(a)&&!cN&&(cN=setInterval(p.fx.tick,p.fx.interval))},p.fx.interval=13,p.fx.stop=function(){clearInterval(cN),cN=null},p.fx.speeds={slow:600,fast:200,_default:400},p.fx.step={},p.expr&&p.expr.filters&&(p.expr.filters.animated=function(a){return p.grep(p.timers,function(b){return a===b.elem}).length});var c$=/^(?:body|html)$/i;p.fn.offset=function(a){if(arguments.length)return a===b?this:this.each(function(b){p.offset.setOffset(this,a,b)});var c,d,e,f,g,h,i,j,k,l,m=this[0],n=m&&m.ownerDocument;if(!n)return;return(e=n.body)===m?p.offset.bodyOffset(m):(d=n.documentElement,p.contains(d,m)?(c=m.getBoundingClientRect(),f=c_(n),g=d.clientTop||e.clientTop||0,h=d.clientLeft||e.clientLeft||0,i=f.pageYOffset||d.scrollTop,j=f.pageXOffset||d.scrollLeft,k=c.top+i-g,l=c.left+j-h,{top:k,left:l}):{top:0,left:0})},p.offset={bodyOffset:function(a){var b=a.offsetTop,c=a.offsetLeft;return p.support.doesNotIncludeMarginInBodyOffset&&(b+=parseFloat(p.css(a,"marginTop"))||0,c+=parseFloat(p.css(a,"marginLeft"))||0),{top:b,left:c}},setOffset:function(a,b,c){var d=p.css(a,"position");d==="static"&&(a.style.position="relative");var e=p(a),f=e.offset(),g=p.css(a,"top"),h=p.css(a,"left"),i=(d==="absolute"||d==="fixed")&&p.inArray("auto",[g,h])>-1,j={},k={},l,m;i?(k=e.position(),l=k.top,m=k.left):(l=parseFloat(g)||0,m=parseFloat(h)||0),p.isFunction(b)&&(b=b.call(a,c,f)),b.top!=null&&(j.top=b.top-f.top+l),b.left!=null&&(j.left=b.left-f.left+m),"using"in b?b.using.call(a,j):e.css(j)}},p.fn.extend({position:function(){if(!this[0])return;var a=this[0],b=this.offsetParent(),c=this.offset(),d=c$.test(b[0].nodeName)?{top:0,left:0}:b.offset();return c.top-=parseFloat(p.css(a,"marginTop"))||0,c.left-=parseFloat(p.css(a,"marginLeft"))||0,d.top+=parseFloat(p.css(b[0],"borderTopWidth"))||0,d.left+=parseFloat(p.css(b[0],"borderLeftWidth"))||0,{top:c.top-d.top,left:c.left-d.left}},offsetParent:function(){return this.map(function(){var a=this.offsetParent||e.body;while(a&&!c$.test(a.nodeName)&&p.css(a,"position")==="static")a=a.offsetParent;return a||e.body})}}),p.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(a,c){var d=/Y/.test(c);p.fn[a]=function(e){return p.access(this,function(a,e,f){var g=c_(a);if(f===b)return g?c in g?g[c]:g.document.documentElement[e]:a[e];g?g.scrollTo(d?p(g).scrollLeft():f,d?f:p(g).scrollTop()):a[e]=f},a,e,arguments.length,null)}}),p.each({Height:"height",Width:"width"},function(a,c){p.each({padding:"inner"+a,content:c,"":"outer"+a},function(d,e){p.fn[e]=function(e,f){var g=arguments.length&&(d||typeof e!="boolean"),h=d||(e===!0||f===!0?"margin":"border");return p.access(this,function(c,d,e){var f;return p.isWindow(c)?c.document.documentElement["client"+a]:c.nodeType===9?(f=c.documentElement,Math.max(c.body["scroll"+a],f["scroll"+a],c.body["offset"+a],f["offset"+a],f["client"+a])):e===b?p.css(c,d,e,h):p.style(c,d,e,h)},c,g?e:b,g)}})}),a.jQuery=a.$=p,typeof define=="function"&&define.amd&&define.amd.jQuery&&define("jquery",[],function(){return p})})(window);;
///<jscompress sourcefile="jquery.easing.1.3.js" />
/*
 * jQuery Easing v1.3 - http://gsgd.co.uk/sandbox/jquery/easing/
 *
 * Uses the built in easing capabilities added In jQuery 1.1
 * to offer multiple easing options
 *
 * TERMS OF USE - jQuery Easing
 * 
 * Open source under the BSD License. 
 * 
 * Copyright © 2008 George McGinley Smith
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice, this list of 
 * conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list 
 * of conditions and the following disclaimer in the documentation and/or other materials 
 * provided with the distribution.
 * 
 * Neither the name of the author nor the names of contributors may be used to endorse 
 * or promote products derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 *  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE. 
 *
*/

// t: current time, b: begInnIng value, c: change In value, d: duration
jQuery.easing['jswing'] = jQuery.easing['swing'];

jQuery.extend( jQuery.easing,
{
	def: 'easeOutQuad',
	swing: function (x, t, b, c, d) {
		//alert(jQuery.easing.default);
		return jQuery.easing[jQuery.easing.def](x, t, b, c, d);
	},
	easeInQuad: function (x, t, b, c, d) {
		return c*(t/=d)*t + b;
	},
	easeOutQuad: function (x, t, b, c, d) {
		return -c *(t/=d)*(t-2) + b;
	},
	easeInOutQuad: function (x, t, b, c, d) {
		if ((t/=d/2) < 1) return c/2*t*t + b;
		return -c/2 * ((--t)*(t-2) - 1) + b;
	},
	easeInCubic: function (x, t, b, c, d) {
		return c*(t/=d)*t*t + b;
	},
	easeOutCubic: function (x, t, b, c, d) {
		return c*((t=t/d-1)*t*t + 1) + b;
	},
	easeInOutCubic: function (x, t, b, c, d) {
		if ((t/=d/2) < 1) return c/2*t*t*t + b;
		return c/2*((t-=2)*t*t + 2) + b;
	},
	easeInQuart: function (x, t, b, c, d) {
		return c*(t/=d)*t*t*t + b;
	},
	easeOutQuart: function (x, t, b, c, d) {
		return -c * ((t=t/d-1)*t*t*t - 1) + b;
	},
	easeInOutQuart: function (x, t, b, c, d) {
		if ((t/=d/2) < 1) return c/2*t*t*t*t + b;
		return -c/2 * ((t-=2)*t*t*t - 2) + b;
	},
	easeInQuint: function (x, t, b, c, d) {
		return c*(t/=d)*t*t*t*t + b;
	},
	easeOutQuint: function (x, t, b, c, d) {
		return c*((t=t/d-1)*t*t*t*t + 1) + b;
	},
	easeInOutQuint: function (x, t, b, c, d) {
		if ((t/=d/2) < 1) return c/2*t*t*t*t*t + b;
		return c/2*((t-=2)*t*t*t*t + 2) + b;
	},
	easeInSine: function (x, t, b, c, d) {
		return -c * Math.cos(t/d * (Math.PI/2)) + c + b;
	},
	easeOutSine: function (x, t, b, c, d) {
		return c * Math.sin(t/d * (Math.PI/2)) + b;
	},
	easeInOutSine: function (x, t, b, c, d) {
		return -c/2 * (Math.cos(Math.PI*t/d) - 1) + b;
	},
	easeInExpo: function (x, t, b, c, d) {
		return (t==0) ? b : c * Math.pow(2, 10 * (t/d - 1)) + b;
	},
	easeOutExpo: function (x, t, b, c, d) {
		return (t==d) ? b+c : c * (-Math.pow(2, -10 * t/d) + 1) + b;
	},
	easeInOutExpo: function (x, t, b, c, d) {
		if (t==0) return b;
		if (t==d) return b+c;
		if ((t/=d/2) < 1) return c/2 * Math.pow(2, 10 * (t - 1)) + b;
		return c/2 * (-Math.pow(2, -10 * --t) + 2) + b;
	},
	easeInCirc: function (x, t, b, c, d) {
		return -c * (Math.sqrt(1 - (t/=d)*t) - 1) + b;
	},
	easeOutCirc: function (x, t, b, c, d) {
		return c * Math.sqrt(1 - (t=t/d-1)*t) + b;
	},
	easeInOutCirc: function (x, t, b, c, d) {
		if ((t/=d/2) < 1) return -c/2 * (Math.sqrt(1 - t*t) - 1) + b;
		return c/2 * (Math.sqrt(1 - (t-=2)*t) + 1) + b;
	},
	easeInElastic: function (x, t, b, c, d) {
		var s=1.70158;var p=0;var a=c;
		if (t==0) return b;  if ((t/=d)==1) return b+c;  if (!p) p=d*.3;
		if (a < Math.abs(c)) { a=c; var s=p/4; }
		else var s = p/(2*Math.PI) * Math.asin (c/a);
		return -(a*Math.pow(2,10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )) + b;
	},
	easeOutElastic: function (x, t, b, c, d) {
		var s=1.70158;var p=0;var a=c;
		if (t==0) return b;  if ((t/=d)==1) return b+c;  if (!p) p=d*.3;
		if (a < Math.abs(c)) { a=c; var s=p/4; }
		else var s = p/(2*Math.PI) * Math.asin (c/a);
		return a*Math.pow(2,-10*t) * Math.sin( (t*d-s)*(2*Math.PI)/p ) + c + b;
	},
	easeInOutElastic: function (x, t, b, c, d) {
		var s=1.70158;var p=0;var a=c;
		if (t==0) return b;  if ((t/=d/2)==2) return b+c;  if (!p) p=d*(.3*1.5);
		if (a < Math.abs(c)) { a=c; var s=p/4; }
		else var s = p/(2*Math.PI) * Math.asin (c/a);
		if (t < 1) return -.5*(a*Math.pow(2,10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )) + b;
		return a*Math.pow(2,-10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )*.5 + c + b;
	},
	easeInBack: function (x, t, b, c, d, s) {
		if (s == undefined) s = 1.70158;
		return c*(t/=d)*t*((s+1)*t - s) + b;
	},
	easeOutBack: function (x, t, b, c, d, s) {
		if (s == undefined) s = 1.70158;
		return c*((t=t/d-1)*t*((s+1)*t + s) + 1) + b;
	},
	easeInOutBack: function (x, t, b, c, d, s) {
		if (s == undefined) s = 1.70158; 
		if ((t/=d/2) < 1) return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
		return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
	},
	easeInBounce: function (x, t, b, c, d) {
		return c - jQuery.easing.easeOutBounce (x, d-t, 0, c, d) + b;
	},
	easeOutBounce: function (x, t, b, c, d) {
		if ((t/=d) < (1/2.75)) {
			return c*(7.5625*t*t) + b;
		} else if (t < (2/2.75)) {
			return c*(7.5625*(t-=(1.5/2.75))*t + .75) + b;
		} else if (t < (2.5/2.75)) {
			return c*(7.5625*(t-=(2.25/2.75))*t + .9375) + b;
		} else {
			return c*(7.5625*(t-=(2.625/2.75))*t + .984375) + b;
		}
	},
	easeInOutBounce: function (x, t, b, c, d) {
		if (t < d/2) return jQuery.easing.easeInBounce (x, t*2, 0, c, d) * .5 + b;
		return jQuery.easing.easeOutBounce (x, t*2-d, 0, c, d) * .5 + c*.5 + b;
	}
});

/*
 *
 * TERMS OF USE - EASING EQUATIONS
 * 
 * Open source under the BSD License. 
 * 
 * Copyright © 2001 Robert Penner
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice, this list of 
 * conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list 
 * of conditions and the following disclaimer in the documentation and/or other materials 
 * provided with the distribution.
 * 
 * Neither the name of the author nor the names of contributors may be used to endorse 
 * or promote products derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 *  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE. 
 *
 */;
///<jscompress sourcefile="smartMobile-1.0.js" />
/** ***********@mobileAPI js *************** */

(function() {

	/*
	 * 
	 * @param {Object} target 目标对象。
	 * 
	 * @param {Object} source 源对象。
	 * 
	 * @param {boolean} deep 是否复制(继承)对象中的对象。
	 * 
	 * @returns {Object} 返回继承了source对象属性的新对象。
	 * 
	 */

	var extend = function(target, /* optional */source, /* optional */deep) {
		target = target || {};

		var i = 0;

		if (typeof source !== 'object'
				&& Object.prototype.toString.call(source) !== '[object Function]')

			source = {};

		while (i <= 2) {
			option = i === 1 ? target : source;

			if (option != null) {

				for ( var name in option) {

					var src = target[name], copy = option[name];

					if (target === copy)

						continue;

					if (deep && copy && typeof copy === 'object'
							&& !copy.nodeType)

						target[name] = extend(src
								|| (copy.length != null ? [] : {}), copy, deep);

					else if (copy !== undefined)

						target[name] = copy;

				}

			}
			i++;

		}

		return target;

	};
	var mobileApi = {

		webService : {
		    execServiceConnector : function(option, successCallback,
					failedCallback) {

		        var ajaxOption = { "type": "POST" };
		        try{
		            if (config && config.server && config.protocol && config.port && config.virtualDirectory) {
		                ajaxOption["url"] = config.protocol + "://" + config.server + ":" + config.port + "/" +config.virtualDirectory+ "/mas/mobile/invokeService";
		            }else{
		                ajaxOption["url"] = "http://16.156.254.90:8081/mos2server/mas/mobile/invokeService";
		            }
		        } catch (e) {
		            ajaxOption["url"] = "http://16.156.254.90:8081/mos2server/mas/mobile/invokeService";
		        }
				var data = {
				    "deviceType":"Phone",
                    "language":"zh",
                    "platform": device.platform || "Android",
                    // "mobilet":"ORDERING",
                    "dataType":"JSON",
                    "resouceVersion":smartMobile.app.resourceVersion || "2.032",
                    "apkVersion":smartMobile.app.apkVersion || "3",

                    deviceId: smartMobile.app.deviceId || "00000000000",
                    mobilet: "KFC_mos3",
                    versionFlag: "P",
                    macAddress: smartMobile.app.macAddress || "0000-0000-0000-0000",
				    "data": option
				}
				typeof(option.timeOut)=="number" && (ajaxOption["timeout"] = option.timeOut);
				if(!ajaxOption["timeout"]){
					ajaxOption["timeout"]=30*1000
				}
				ajaxOption["data"] = JSON.stringify(data);
				ajaxOption["success"] = function (ret) {
				    var res = ret;
				    if(typeof(ret) == "string"){
				        try{
				            res = JSON.parse(ret);
				        } catch (e) {
				            console.log(e);
				        }
				    }
				    successCallback(res);
				};
				ajaxOption["error"] = function (ret) {
				    failedCallback(ret);
				};
				ajaxOption.contentType = 'application/json; charset=UTF-8';
				$.ajax(ajaxOption);
			}
		},

		nativeUI : {
			setAttribute : function(option, successCallback, failedCallback) {
			    mobileApi.tab.setAttribute(option, successCallback, failedCallback);
			}
		},
		webtrend :{
		  pushEvent : function(option, successCallback, failedCallback) {
			try{
				yum.webtrend.pushEvent(option, successCallback, failedCallback);
			}catch(e){
			}

		  }
		},

		nativeUIWidget : {
			confirm : function(options, successCallback, failedCallback) {
				//mobileApi.execNativeAPI("nativeUIWidget", "confirm", options,
			    //		successCallback, failedCallback);
			    navigator.notification.confirm(options.description, function (ret) {
			        if (ret == 1) {
			            successCallback();
			        } else {
			            failedCallback();
			        }
			    }, options.caption, [options.okCaption, options.cancelCaption])
			},
			datePicker : function(options, successCallback, failedCallback) {
				try{
				    yum.nativeUIWidget.showTimePicker(options, function (ret) {
				        //alert(JSON.stringify(ret));
				        var content;
				        if (typeof ret.content == "string") {
				            content = JSON.parse(ret.content);
				        } else if (typeof ret.content == "undefined") {
				            successCallback(JSON.stringify(ret));
				            return;
				        }else{
				            content = ret.content;
				        }
				        ret.hourOfDay = content.hourOfDay;
				        ret.minute = content.minute;
						successCallback(JSON.stringify(ret));
					}, function(ret){
					    failedCallback(JSON.stringify(ret));
					});
				}catch(e){
					console.log(e);
				}
			},
			citySelecter: function (options, successCallback, failedCallback) {
			    smartmobile.nativeUIWidget.openSearchList(options, function (ret) {
			        if (ret.result == 0 && ret.content) {
			            successCallback(JSON.stringify(ret.content));
			        } else if (typeof (ret.result) == "undefined") {
			            successCallback(JSON.stringify(ret));
			        }else{
			            failedCallback();
			        }
			    }, function (ret) {
			        failedCallback(ret);
			    });
			},
			startBusy: function (option) {
			    smartmobile.nativeUIWidget.startBusy(option || {});
			},
			stopBusy : function() {
			    smartmobile.nativeUIWidget.stopBusy();
			},
      startSplash : function() {
        try{
          smartmobile.nativeUIWidget.startSplash();
        }catch(e){
          //alert(e);
				}
			},
			stopSplash : function() {
        try{
          smartmobile.nativeUIWidget.stopSplash();
        }catch(e){
          //alert(e);
        }
			},
			showMap : function(option) {

				//mobileApi.execNativeAPI("nativeUIWidget", "showMap", option);

			},
			showInstantMessage : function(option) {
				smartmobile.nativeUIWidget.showInstantMessage(option);

			},
			showMessageBox : function(option, successCallback, failedCallback) {
			    navigator.notification.alert(option.content, option.title, '确定');
			},
			selectPicture : function(successCallback, failedCallback, option) {
			    alert("selectPicture");
			},
			showPopupMenu : function(option, successCallback, failedCallback) {
			    smartmobile.nativeUIWidget.showPopupMenu(option, function (ret) {
			        //alert(JSON.stringify(ret));
			        if (ret && ret.result == 0) {
			            var i = ret.content;
			            eval(option.items[i].action);
			        } else {

			        }
			    });

			},
			readBarCode : function(successCallback, failedCallback) {
			    alert("readBarCode");
			},
			readRQcode : function(successCallback, failedCallback) {
			    alert("readRQcode");
			},
			openUrl : function(option, successCallback, failedCallback) {
			    alert("openUrl");
			},
			viewFile : function(option, successCallback, failedCallback) {
			    alert("viewFile");
			},
			popupWebsite : function(option, successCallback, failedCallback) {
			    alert("popupWebsite");
			},
			showComboBox: function (option, successCallback, failedCallback) {
			    try{
			        smartmobile.nativeUIWidget.showComboBox(option, function (ret) {
			            console.log(JSON.stringify(ret));
			            if (ret && ret.result == 0) {
			                var i = ret.content;
			                successCallback({
			                    result:0,
			                    selected:i
			                });
			            } 
			        });
			    } catch (e) {
			        alert("error:"+e);
			    }
			},
			openSearchList : function(option, successCallback, failedCallback) {
			    alert("openSearchList");
			}
		},

    media : {
        photoToAlbum: function (option, successCallback, failedCallback) {
            try{
                smartmobile.media.photoToAlbum(option, successCallback, failedCallback);
            } catch (e) {
                alert(e);
            }
      },

      startAudioRecord: function (option, successCallback, failedCallback) {
            try{
                smartmobile.media.startAudioRecord(option, successCallback, failedCallback);
            } catch (e) {
                alert(e);
            }
      },

      stopAudioRecord: function (option, successCallback, failedCallback) {
            try{
                smartmobile.media.stopAudioRecord(option, successCallback, failedCallback);
            } catch (e) {
                alert(e);
            }
      },

      getAudioRecorderDuration: function (option, successCallback, failedCallback) {
            try{
                smartmobile.media.getAudioRecorderDuration(option, successCallback, failedCallback);
            } catch (e) {
                alert(e);
            }
      },

      getAudioRecorderStatus: function (option, successCallback, failedCallback) {
            try{
                smartmobile.media.getAudioRecorderStatus(option, successCallback, failedCallback);
            } catch (e) {
                alert(e);
            }
      }

		},

		phoneService : {
			dial : function(option, successCallback, failedCallback) {
			    alert("dial");
			},
			tel : function(option, successCallback, failedCallback) {
			    alert("tel");
			},

			sms : function(option, successCallback, failedCallback) {
			    smartmobile.phoneService.sms(option, successCallback, failedCallback);
			},
			email: function (option, successCallback, failedCallback) {
			    smartmobile.phoneService.email(option, successCallback, failedCallback);
			}

		},
		appManager : {

			switchApp : function(option, successCallback, failedCallback) {

			    //mobileApi.execNativeAPI("appManager", "switchApp", option);
			    location.href = "."+option.page;

			}
		},

		network : {

			isReachable : function(callback) {

				//mobileApi.execNativeAPI("network", "isReachable", null,
				//		callback, callback);

			}
		},

		userInfo : {

			userName : ""

		},

		download : {
		    download: function (option, successCallback, failedCallback) {
		        //alert(JSON.stringify(option));
		        smartmobile.download.download(option, function (ret) {
		            //alert(JSON.stringify(ret));
			        try {
			            typeof (ret) == "string" && (ret = JSON.parse(ret));
			            if (!ret.responseData) {
			                var res = {
			                    result: ret.result,
			                    message: ret.message,
			                    responseData: {
			                        filename: ret.content.filename,
			                        relativePath: ret.content.relativePath
			                    }
			                };
			                successCallback(JSON.stringify(res));
			            } else {
			                if (ret.status == "ok") {
			                    successCallback(JSON.stringify(ret));
			                } else {
			                    failedCallback(JSON.stringify(ret));
			                }
			            }
			        } catch (e) {
			            alert(e);
			        }
			        
			    }, function (err) {
			        //console.log("fail download:"+JSON.stringify(err));
			        var res = {
			            result: err.result,
			            message: err.message
			        };

			        failedCallback(JSON.stringify(res));
			    });

			},
			getProgress : function(option, successCallback, failedCallback) {
				//mobileApi.execNativeAPI("download", "getProgress", option,
				//		successCallback, failedCallback);
			},
			deleteDownloadedFile : function(option, successCallback,
					failedCallback) {
				//mobileApi.execNativeAPI("download", "deleteDownloadedFile",
				//		option, successCallback, failedCallback);
			},
			cancel : function(option, successCallback, failedCallback) {
				//mobileApi.execNativeAPI("download", "cancel", option,
				//		successCallback, failedCallback);
			},
			upload : function(option, successCallback, failedCallback) {
				//mobileApi.execNativeAPI("download", "upload", option,
				//		successCallback, failedCallback);
			}
		},
		execNativeAPI : function(serviceName, actionName, option,
				successCallback, failedCallback) {
		    //alert("execNativeAPI:" + serviceName);
			if (!window.device) {

				console.log("yqa===>smartMobileApi未初始化");

				return false;

			}

			// alert(window.device.platform);

			switch (window.device.platform) {

			case "iPad":

			case "iPhone":

			case "iPod touch":

			case "iPhone Simulator":

			case "iPad Simulator":

				// alert("ios: " + serviceName + " | " + actionName + " | " +
				// JSON.stringify(option) + " | " + successCallback + " | " +
				// failedCallback);

				PhoneGap.exec(serviceName + "." + actionName, option,
						GetFunctionName(successCallback),
						GetFunctionName(failedCallback))

				break;

			case "Android":

				// alert("Android: " + serviceName + " | " + actionName + " | "
				// + JSON.stringify(option) + " | " + successCallback + " | " +
				// failedCallback)

				PhoneGap.exec(successCallback, failedCallback, serviceName,
						actionName, [ option ]);

				break;

			case "BlackBerry":

				break;

			}

		},
		// 支付宝
		pay : {
		    securepay: function (option, successCallback, failedCallback) {
		        try {
		            yum.pay.securepay(function (ar) {
		                typeof (ar) == "string" && (ar = JSON.parse(ar));
		                if (ar.content) {
		                    successCallback(ar.content);
		                } else if (typeof ar.isInstalled != "undefined") {
		                    successCallback(ar);
		                } else {
		                    failedCallback(ar);
		                }
		            }, function (ar) {
		                failedCallback(ar);
		            });
		        } catch (e) {
		            alert(e);
		        }
			},
		    prepareinfo: function (option, successCallback, failedCallback) {
		        //alert("prepareinfo");
		        try{
		            yum.pay.prepareinfo(option, successCallback, failedCallback);
		        } catch (e) {
		            alert(e);
		        }
			},
		    reqpay: function (option, successCallback, failedCallback) {
		        try {
		            yum.pay.reqpay(option, function (ar) {
		                //alert(JSON.stringify(ar));
		                successCallback(ar);
		            }, function (ar) {
		                //alert(JSON.stringify(ar));
		                failedCallback(ar);
		            });
		        } catch (e) {
		            alert("d" + e);
		        }
			}
		},
		social : {
		    shareTo: function (option, successCallback, failedCallback) {
		        try{
		            smartmobile.social.shareTo(option, successCallback, failedCallback);
		        } catch (e) {
		            alert(e);
		        }
			},
			bind : function(option, successCallback, failedCallback) {
				//for ( var i in option) {
				//	console.log(i + ":" + option[i]);
				//}
				//mobileApi.execNativeAPI("social", "bind", option,
				//		successCallback, failedCallback);
			    try {
			        smartmobile.social.bind(option, successCallback, failedCallback);
			    } catch (e) {
			        alert(e);
			    }
			},
			unbind : function(option, successCallback, failedCallback) {
			    try {
			        smartmobile.social.unbind(option, successCallback, failedCallback);
			    } catch (e) {
			        alert(e);
			    }
			},

			follow : function(option, successCallback, failedCallback) {
			    try {
			        smartmobile.social.follow(option, successCallback, failedCallback);
			    } catch (e) {
			        alert(e);
			    }
			},
			isBound : function(option, successCallback, failedCallback) {
			    try {
			        smartmobile.social.isBound(option, successCallback, failedCallback);
			    } catch (e) {
			        alert(e);
			    }
			},

      login : function(option, successCallback, failedCallback) {
        try {
            smartmobile.social.login(option, successCallback, failedCallback);
        } catch (e) {
            alert(e);
        }
      },

      //列出可以调用 login site
      /*availableLoginSite : function (successCallback, failedCallback) {
        try {
            smartmobile.social.availableLoginSite(successCallback, failedCallback);
        } catch (e) {
            alert(e);
        }
      },

      //列出 可 bind unbind isBound 的site
      /*availableBindSite : function (successCallback, failedCallback) {
        try {
            smartmobile.social.availableBindSite(successCallback, failedCallback);
        } catch (e) {
            alert(e);
        }
      },*/

      //列出可调用shareTo方法的site
      availableShareSite : function (successCallback, failedCallback) {
        try {
            smartmobile.social.availableBindSite(successCallback, failedCallback);
        } catch (e) {
            //alert(e);
        }
      },

      //列出已经安装客户端site
      availableSite : function (successCallback, failedCallback) {
        try {
            smartmobile.social.availableSite(successCallback, failedCallback);
        } catch (e) {
            //alert(e);
        }
      }

		},
		sys : {
			postLog : function(option, successCallback, failedCallback) {
			    try {
			        yum.sys.postLog(option, successCallback, failedCallback);
			    } catch (e) {
			        //alert(e);
			    }
			},
			syncTime : function(successCallback, failedCallback) {
			    try {
			        yum.sys.syncTime("", successCallback, failedCallback);
			    } catch (e) {
			        //alert(e);
			    }
			},
			appLoadReady : function(successCallback, failedCallback) {
				//mobileApi.execNativeAPI("system", "appLoadReady",
				//		successCallback, failedCallback);

			},
			locale : function(option, successCallback, failedCallback) {
			    try {
			        yum.sys.locale(option, successCallback, failedCallback);
			    } catch (e) {
			        //alert(e);
			    }
			},
      //是否开启推送ios
      isPushEnable : function (successCallback, failedCallback) {
          try {
              yum.sys.isPushEnable(successCallback, failedCallback);
          } catch (e) {
              //alert(e);
          }
      },
      /*//是否开启推送android
      isPushStopped : function (successCallback, failedCallback) {
          try {
              window.plugins.jPushPlugin.isPushStopped(successCallback, failedCallback);
          } catch (e) {
              //alert(e);
          }
      },*/

      openApp : function (option, successCallback, failedCallback) {
          try {
              yum.sys.openApp(option, successCallback, failedCallback);
              //{"url":"itms-apps://itunes.apple.com/cn/app/id587238847?mt=8","jsonParams":""}
          } catch (e) {
              //alert(e);
          }
      },

      isOpenAppEnable :  function (option, successCallback, failedCallback) {
          try {
              yum.sys.isOpenAppEnable(option, successCallback, failedCallback);
          } catch (e) {
              //alert(e);
          }
      },

      installApk : function (option, successCallback, failedCallback) {
          try {
              yum.sys.installApk(option, successCallback, failedCallback);
          } catch (e) {
              //alert(e);
          }
      },

			setBrightness : function(option, successCallback, failedCallback) {
				try {
					yum.sys.setBrightness(option, successCallback, failedCallback);
				} catch (e) {
					alert(e);
				}
			},
			getBrightness : function(successCallback, failedCallback) {
				try {
					yum.sys.getBrightness(successCallback, failedCallback);
				} catch (e) {
					alert(e);
				}
			}

		},

		usageProfile : {
			trackPage : function(option, successCallback, failedCallback) {
				//for ( var i in option) {
				//	console.log(i + ":" + option[i]);
				//}
				//mobileApi.execNativeAPI("usageProfile", "trackPage", option,
				//		successCallback, failedCallback);

			}
		},
		// 注册apiReady事件，该事件在PhoneGap的deviceready事件执行之后执行，

		// mobilet开发人员需要将所有涉及取smartMobile数据的请求放置在apiReady事件内执行

		Init : function() {
			window.smartMobile.container = {version:"1.0"};
			window.smartMobile.app = {id:"Mock",sourceRoot:""};
		},
		apiReady : function(callback) {
			if (typeof callback == "function") {
			    mobileApi.Init();
				this._apiReady = callback;
			}
		},
		extend : extend
	}


	document.addEventListener("deviceready", function () {
	    mobileApi.tab = new Tab("bottomBarPH");

	    yum.sys.getInfo(function (ret) {
	        $.am.debug.log("getInfo:" + JSON.stringify(ret));
            if (typeof ret == "string") {
                try{
                    ret = JSON.parse(ret);
                } catch (e) {
                    alert("yum.sys.getInfo error:" + e);
                }
            }
            if (ret && ret.result == 0) {
                window.smartMobile.app = extend(window.smartMobile.app, ret.content);
            } else {

            }

            if (typeof mobileApi._apiReady == "function") {
                mobileApi._apiReady();
            }
        }, function (ret) {
            if (typeof mobileApi._apiReady == "function") {
                mobileApi._apiReady();
            }
        });
	    try{
	        yum.appInfo.getAppInfo(function (ret) {
	            $.am.debug.log(JSON.stringify(ret));
	            if (ret && ret.result == 0) {
	                ret.content.appSourceRoot = ret.content.sourceRoot;
	                delete ret.content.sourceRoot;
	                window.smartMobile.app = extend(window.smartMobile.app, ret.content);
	                /*if (device.platform == "Android") {
	                    window.smartMobile.app.version = "A_" + window.smartMobile.app.version;
	                } else {
	                    window.smartMobile.app.version = "I_" + window.smartMobile.app.version;
	                }*/
	            } else{
	                if (typeof ret.content == "string") {
	                    content = JSON.parse(ret.content);
	                }
	                ret.content.appSourceRoot = ret.content.sourceRoot;
	                delete ret.content.sourceRoot;
	                window.smartMobile.app = extend(window.smartMobile.app, ret);
	                /*if (device.platform == "Android") {
	                    window.smartMobile.app.version = "A_" + window.smartMobile.app.version;
	                } else {
	                    window.smartMobile.app.version = "I_" + window.smartMobile.app.version;
	                }*/
	            }
	        }, function (ret) {
	            if (typeof mobileApi._apiReady == "function") {

	            }
	        });
	    } catch (e) {
	        alert(e);
	    }
	}, false);

	window.smartMobile = mobileApi;


	var Tab = function (id) {
	    this.$ = $("#" + id);
	    this.$.find("li").addClass("am-clickable").each(function (i,item) {
	        $(this).vclick(function () {
	            var f = $.am.nativeUi.event["tabitem" + (i + 1)];
	            typeof(f)=="function" && f();
	        });
	    });
	}
	Tab.prototype = {
	    setAttribute: function (opt, cb, fb) {
	        var id = opt.id;
	        var option = opt.parameters;
	        var $c = $("#" + id);
	        if (option.image && option.selectedImage) {
	            $c.attr("bg", option.image);
	            $c.attr("sbg", option.selectedImage);

	            if ($c.hasClass("selected")) {
	                if (option.selectedImage.indexOf("2x") == -1) {
	                    $c.find("div.childItem").css("background-image", "url(" + option.selectedImage.replace(".png", "@2x.png") + ")");
	                } else {
	                    $c.find("div.childItem").css("background-image", "url(" + option.selectedImage + ")");
	                }
	            } else {
	                if (option.image.indexOf("2x") == -1) {
	                    $c.find("div.childItem").css("background-image", "url(" + option.image.replace(".png", "@2x.png") + ")");
	                } else {
	                    $c.find("div.childItem").css("background-image", "url(" + option.image + ")");
	                }
	            }
	        }
	        if (option.visible == "true") {
	            $c.show();
	        } else if (option.visible == "false") {
	            $c.hide();
	        }
	        if (option.title) {
	            $c.find(".childItem").text(option.title);
	        }
	        
	        if (option.badgeValue) {
	            $c.find(".badge").remove();
	            $c.append('<div class="badge">'+option.badgeValue+'</div>');
	        } else if (option.badgeValue == "") {
	            $c.find(".badge").remove();
	        } else {
	            //$c.find(".badge").remove();
	        }

	        if (option.newMsg == "true") {
	            $c.append('<div class="newMsg"></div>');
	        } else if (option.newMsg == "false") {
	            $c.find(".newMsg").remove();
	        } else {

	        }

	        if (option.onclick) {
	            var n = $c.parent().children().index($c);
	            $.am.nativeUi.event["tabitem" + (n + 1)] = option.onclick;
	        }
	        console.log(JSON.stringify(opt));
	        if (option.selected == "true") {
	            $c.addClass("selected");
	            if ($c.attr("bg") && $c.attr("sbg")) {
	                var sbg = $c.attr("sbg");
	                if (sbg.indexOf("2x") == -1) {
	                    $c.find("div.childItem").css("background-image", "url(" + sbg.replace(".png", "@2x.png") + ")");
	                } else {
	                    $c.find("div.childItem").css("background-image", "url(" + sbg + ")");
	                }
	            }
	        } else if (option.selected == "false") {
	            $c.removeClass("selected");
	            if ($c.attr("bg") && $c.attr("sbg")) {
	                var sbg = $c.attr("bg");
	                if (sbg.indexOf("2x") == -1) {
	                    $c.find("div.childItem").css("background-image", "url(" + sbg.replace(".png", "@2x.png") + ")");
	                } else {
	                    $c.find("div.childItem").css("background-image", "url(" + sbg + ")");
	                }
	            }
	        }
	        cb && cb();
	    }
	}
})();
;
///<jscompress sourcefile="cordova.js" />
if (navigator) {
    if (!navigator.notification) {
        navigator.notification = {
            alert: function (content, title, btn) {
                alert(content);
            },
            confirm: function (content, cb) {
                if (confirm(content)) {
                    cb(1);
                } else {
                    cb(0);
                }
            }
        }
    }

    if (!navigator.camera) {
        navigator.camera = {}
    }
    navigator.camera.getPicture = function (success, failed, option) {
        setTimeout(function () {
            success("../res/home_activity.png");
        })
    }
}

var smartmobile = {
    fileTransfer: {
        download: function (option, cb, fb) {
            cb({
                result: 0,
                message: "y",
                content: {
                    sourceRoot: option.url,
                    relativePath: ""
                }
            })
        }
    },
    nativeUIWidget: {
        confirm: function (options, successCallback, failedCallback) {
            if (confirm(options.description)) {
                successCallback && successCallback();
            } else {
                failedCallback && failedCallback();
            }
        },
        datePicker: function (options, successCallback, failedCallback) {

        },
        citySelecter: function (options, successCallback, failedCallback) {

        },
        startBusy: function (option) {
            $(document.body).append('<div class="cordova_busy"><div class="cordova_busy_c"><div class="cordova_busy_text">' + (option.caption || "正在加载") + '</div></div></div>');
        },
        stopBusy: function () {
            $("div.cordova_busy").remove();
        },
        showMap: function (option) {
        },
        showInstantMessage: function (option) {
            $("div.cordova_instantMessage").remove();
            clearTimeout(this.instantmsgTimer);
            $(document.body).append('<div class="cordova_instantMessage"><div class="text">' + (option.content) + '</div></div>');
            this.instantmsgTimer = setTimeout(function () {
                $("div.cordova_instantMessage").remove();
            }, option.duration || 3 * 1000);
        },
        showMessageBox: function (option, successCallback, failedCallback) {

        },
        selectPicture: function (successCallback, failedCallback, option) {
            alert("selectPicture");
        },
        showPopupMenu: function (opt, scb, fcb) {
            console.log("showPopupMenu:", opt);
            var self = this;

            if (!this._$comboBox) {
                this._$comboBox = $(".comp-showComboBox");
            }

            var html = [];
            $(opt.items).each(function (i, item) {
                html.push("<li>" + item.caption + "</li>");
            });
            this._$comboBox.find("ul").html(html.join(""));
            this._$comboBox.show();
            this._$comboBox.find("li").unbind().bind("click", function () {
                var idx = self._$comboBox.find("li").index($(this));
                self._$comboBox.hide();
                //eval('globle.$mobilet.' + opt.items[idx].action);
                //return false;
                scb && scb({
                    "name": opt.items[idx].caption
                });
            });

            this._$comboBox.find("span").unbind().click(function () {
                fcb && fcb({
                    "result": -2,
                    "message": "Canceled by user"
                });
                self._$comboBox.hide();
            });
        },
        readBarCode: function (successCallback, failedCallback) {
            alert("readBarCode");
        },
        readRQcode: function (successCallback, failedCallback) {
            alert("readRQcode");
        },
        openUrl: function (option, successCallback, failedCallback) {
            alert("openUrl");
        },
        viewFile: function (option, successCallback, failedCallback) {
            alert("viewFile");
        },
        popupWebsite: function (option, successCallback, failedCallback) {
            alert("popupWebsite");
        },
        showComboBox: function (option, successCallback, failedCallback) {
            console.log("showComboBox:", option);
            var i = prompt("showComboBox", "输入返回的序号");
            successCallback({
                result: 0,
                content: i
            });
        },
        openSearchList: function (option, successCallback, failedCallback) {
            console.log("openSearchList:", JSON.stringify(option));
            console.log("openSearch-items:", JSON.stringify(option.items));
            for (var p in option.items) {
                if (option.items[p].id == '6522') {
                    console.log('index:' + p);
                }
            }
            //.indexOf('{"id":6522,"pinyin":"S","name":"上海市","egiftcard":false}')//206
            var i = prompt("openSearchList", "输入返回的序号");
            option.items[i].cityName = option.items[i].text;
            successCallback(option.items[i]);
        }
    },
    storage: {
        persistProperty: function (opt, scb, fcb) {
            if (typeof opt.value == "string")
                opt.value = JSON.parse(opt.value);
            var content = {"content": opt.value};
            localStorage.setItem(opt.key, JSON.stringify(content));
            scb && scb();
        },
        readProperty: function (opt, scb, fcb) {
            var ret = localStorage.getItem(opt.key);
            if (ret == null || ret == "undefined" || ret == "") {
                fcb && fcb();
            } else
                scb && scb(ret);
        },
        removeProperty: function (opt, scb) {
            localStorage.removeItem(opt.key);
            scb && scb();
        }
    },
    appmanager: {
        stopTopApp: function () {
            if (confirm("您确定要关闭本页吗？")) {
                window.close();
            } else {
            }
        }
    }

}
var yum = {
    sys: {
        getBrightness: function (cb) {
            cb && cb({content: {brightness: 0.5}})
        },
        setBrightness: function () {
        },
        postLog: function () {
        },
        syncTime: function () {
        },
        locale: function () {
        },
        getInfo: function (cb) {
            cb({
                result: 0,
                content: {
                    resourceVersion: "3",
                    apkVersion: "3",
                    sec: window.baseUrl && window.baseUrl.indexOf("tlogin") != -1 ? "jkJrRIacBwcpK68d" : "WYjEbpFholuphDuO",
                    deviceId: "123123123",
                    currentContainerVer: "3.00"
                }
            });
        },
        post: function (paras, scb, fcb) {
            var para = paras.params;
            var url = para.url;
            var data = para.data;
            var dataType = para.dataType;
            var contentType = para.contentType;
            var timeout = para.timeout;

            console.log(url);
            $.ajax({
                url: url, //接口url
                type: "POST",
                data: JSON.stringify(data),
                dataType: dataType,
                contentType: contentType,
                timeout: timeout,
                success: function (ret, a, b) {
                    console.log(ret, a, b)
                    var r = {
                        content: {
                            responseStatusCode: b.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    scb && scb(r);
                },
                error: function (ret) {
                    var r = {
                        content: {
                            responseStatusCode: ret.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    fcb && fcb(r);
                    //if (ret.status == 406)
                    //    amGloble.giftCardSSOBind(scb, fcb);
                    //else if (ret.status == 401) {
                    //    amGloble.giftCardUpdatePhone(scb, fcb);
                    //} else {
                    //    fcb && fcb();
                    //}
                }
            });
        },
        get: function (paras, scb, fcb) {
            var para = paras.params;
            var url = para.url;
            var dataType = para.dataType;
            var contentType = para.contentType;
            var timeout = para.timeout;

            console.log(url);
            $.ajax({
                url: url, //接口url
                type: "GET",
                dataType: dataType,
                contentType: contentType,
                timeout: timeout,
                success: function (ret) {
                    var r = {
                        content: {
                            responseStatusCode: ret.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    scb && scb(r);
                },
                error: function (ret) {
                    var r = {
                        content: {
                            responseStatusCode: ret.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    fcb && fcb(r);
                }
            });
            //$.ajax({
            //    url: url, //接口url
            //    type: "POST",
            //    data: JSON.stringify(data),
            //    dataType: dataType,
            //    contentType: contentType,
            //    timeout: timeout,
            //    success: function(ret) {
            //        var content={responseStatusCode:ret.status, responseHeaders:{"Set-Cookie":"JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"}, responseData:ret, responseCookies:{}};
            //        scb && scb(content);
            //    },
            //    error: function(ret) {
            //        var content={responseStatusCode:ret.status, responseHeaders:{"Set-Cookie":"JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"}, responseData:ret, responseCookies:{}};
            //        fcb && fcb(content);
            //        //if (ret.status == 406)
            //        //    amGloble.giftCardSSOBind(scb, fcb);
            //        //else if (ret.status == 401) {
            //        //    amGloble.giftCardUpdatePhone(scb, fcb);
            //        //} else {
            //        //    fcb && fcb();
            //        //}
            //    }
            //});
        }

    },
    appInfo: {
        getAppInfo: function () {

        }
    },
    geocoder: {
        resolveAddr: function (opt, cb) {
            setTimeout(function () {
                cb({
                    result: 0,
                    content: {
                        Name: "假地址"
                    }
                });
            }, 1000);
        }
    },
    pay: {
        alipay: function (payData, scb, fcb) {
            setTimeout(function () {
                scb && scb({
                    content: {resultStatus: 9000}
                });
            }, 1000);
        }
    },
    biz: {
        login: function (scb, fcb) {
            scb && scb({"message": "login success", "content": "", "result": 0});
        }
    }

}

$(function () {
    setTimeout(function () {
        window.device = {
            platform: "Android"
        }
        var ev = document.createEvent('HTMLEvents');
        ev.initEvent('deviceready', false, false);
        document.dispatchEvent(ev);

        $("head").append('<link href="libs/cordova.css" rel="stylesheet" type="text/css">');
    }, 500);
});
;
///<jscompress sourcefile="am.js" />
//创建am命名空间
window.$ && (window.$.am = {});
$.am.supports = {
	CSS3DTransform : ( typeof WebKitCSSMatrix != 'undefined' && new WebKitCSSMatrix().hasOwnProperty('m41'))
};
$.am.components = [];
$.am.Component = function(e) {
	if ($.am.apiReady) {
		this.componentInit && this.componentInit();
	}
};
$.am.use2d = false;
$.am.getInnerHeight = function() {
	var h = window.innerHeight;
	return h < 400 ? 400 : h;
};
//fix JSON.parse bug
JSON.originalParse = JSON.parse;
JSON.parse = function(text) {
	try {
		return text ? JSON.originalParse(text) : text;
	} catch(e) {
		return text;
	}
};
//$ready事件做的事
$(function() {
	//解决smartMobile的100%为0的bug
	var lasth = 0;
    var lastt = new Date().getTime();
	var timer = setInterval(function() {
		var thish = window.innerHeight;
		var thist = new Date().getTime();
		if (thish != lasth) {
			$.am.debug.log(thish);
			$("body").height(window.innerHeight);
			lasth = thish;
			lastt = thist;
		}
		if (thist - lastt > 1000) {
			$.am.debug.log("get height end");
			clearInterval(timer);
		}
	}, 100);
	//报错时打印到log
	window.onerror = function(msg, url, l) {
		$.am.debug.log(msg + "\n" + url + "\n" + l);
	};
	//解决触摸非input键盘不消失的问题
	$("body").bind("touchstart", function(e) {
		// $.am.debug.log("touches");
		if (!$(e.target).is("input") && !$(e.target).is("textarea")) {
			setTimeout(function() {
				$("input:focus, textarea:focus").blur();
			}, 100);
		}
	});
	$.am.page && $.am.page.init();
	$.am.events && $.am.events.init();
	$.am.debug && $.am.debug.init();
});
//api.ready做的事
$(document).ready(function() {
	$.am.elements && $.am.elements.init();
	var device = window.device;
	$.am.relativePath = "";
	for (var i = 0; i < $.am.components.length; i++) {
		$.am.components[i].componentInit && $.am.components[i].componentInit();
	}
	$.am.apiReady = true;
	for (var i in $.am.pages) {
		$.am.pages[i].init && $.am.pages[i].init();
	}
	//console.log($.am.init);
	$.am.init && $.am.init();
	//android上的返回按钮

	//if (window.BackButton) {
		//BackButton.override();
		document.addEventListener("backbutton", function () {
			var cPage = $.am.getActivePage();
			cPage.backButtonOnclick ? cPage.backButtonOnclick() : $.am.page.back();
		}, true);
	//}

	$.am.innerWidth = window.innerWidth > 500 ? 500 : window.innerWidth;
});


//$.am.checkTS("开始定位");
//$.am.checkTS("结束定位");
(function () {
    var names = [];
    var ts = [];
    $.am.checkTS = function (name, reset) {
        if (reset) {
            names = [];
            ts = [];
        }
        names.push(name);
        ts.push(new Date().getTime());
    }
    $.am.printTS = function () {
        for (var i = 0; i < names.length; i++) {
            if (ts[i + 1]) {
                var time = ts[i + 1] - ts[i];
                $.am.debug.log("TS:" + names[i] + time);
            } else {
                var time = new Date().getTime() - ts[i];
                $.am.debug.log("TS:" + names[i] + time);
                $.am.debug.log("TS end");
            }
        }

        names = [];
        ts = [];
    }
})();
;
///<jscompress sourcefile="am.elements.js" />
//创建am命名空间
$.am.elements = {
    init: function () {
        var $swiths = $("div.page-switch");
        $swiths.addClass("am-clickable").vclick(function () {
            $(this).children().toggleClass("selected");
            return false;
        });
    }
};

$.fn.disabled = function (a) {
    this.attr("disabled", a);
    if (this.next().is(".am-input-inner")) {
        a ? this.parent().addClass("disabled") : this.parent().removeClass("disabled");
    }
    return this;
};
$.fn.checked = function (a) {
    this.attr("checked", a);
    if (this.next().is(".am-input-inner")) {
        this.trigger("change");
    }
    return this;
};
$.fn.getVal = function () {
    if (this.hasClass("page-switch")) {
        return this.find(".selected").attr("value");
    }
};
$.fn.setVal = function (i) {
    if (this.hasClass("page-switch")) {
        this.children().eq(i).addClass("selected").siblings().removeClass("selected");
    }
    return this;
};

$.formatNumber = function (nStr) {
    nStr += '';
    x = nStr.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
};
;
///<jscompress sourcefile="am.events.js" />
(function(w, $) {
    var setTextareaPointerEvents = function(value) {
        // var nodes = document.getElementsByTagName('input');
        // for (var i = 0; i < nodes.length; i++) {
        // nodes[i].style.pointerEvents = value;
        // }
    };
    //寻找target父元素中含有am-event的第一个元素
    var findEventElement = function($target, eventName) {
        if ($target.hasClass(eventName)) {
            return $target;
        }
        var ret = $target.parents("." + eventName + ":first");
        if (ret.length) {
            return ret;
        } else {
            return null;
        }
    };
    /*
     var hideInput = function() {
     $.am.debug.log("auto hideInput");
     var field = document.getElementById('hdieKeyboard');
     field.removeAttribute("disabled")
     setTimeout(function() {
     $.am.debug.log("auto focus");
     field.focus();
     setTimeout(function() {
     $.am.debug.log("auto none");
     field.style.display = "none"
     setTimeout(function() {
     $.am.debug.log("auto disabled");
     field.style.display = "block";
     field.blur();
     // field.setAttribute("disabled", "disabled");
     }, 5000)
     }, 50)
     }, 50)
     }
     */
    var _$slideTarget = null;
    var _$touchableTarget = null;
    var _$clickableTarget = null;
    var _touch = null;
    var _startTouch = null;
    var _clickTimer = null;
    var _isHovering = false;
    var _isClick = true;
    var _$longTouchTarget = null;
    var _longTouchTimer = null;

    var events = $.am.events = {
        init : function() {
            // setTextareaPointerEvents('none');

            if ("ontouchend" in document) {
                // $(document).bind({
                // 	touchstart : this.touchstart,
                // 	touchmove : this.touchmove,
                // 	touchend : this.touchend
                // });
                document.addEventListener("touchstart",this.touchstart,{
                    passive:false
                });
                document.addEventListener("touchmove",this.touchmove,{
                    passive:false
                });
                document.addEventListener("touchend",this.touchend,{
                    passive:false
                })
            } else if (window.navigator.msPointerEnabled) {

                $(document).bind({
                    "MSPointerDown" : this.touchstart,
                    "MSPointerMove" : this.touchmove,
                    "MSPointerUp" : this.touchend
                });

            } else {

                // $(document).bind({
                // 	"mousedown" : this.touchstart,
                // 	"mousemove" : this.touchmove,
                // 	"mouseup" : this.touchend
                // });
                document.addEventListener("mousedown",this.touchstart,{
                    passive:false
                });
                document.addEventListener("mousemove",this.touchmove,{
                    passive:false
                });
                document.addEventListener("mouseup",this.touchend,{
                    passive:false
                })
            }

        },
        touchstart : function(e) {
            //onsole.log("touchstart", e.clientX, e.target);
            //e.preventDefault();
            // setTextareaPointerEvents('auto');
            if (_$touchableTarget || _$clickableTarget) {
                return;
            }
            //处理touchable
            var touches = e.touches;
            if (!touches) {
                touches = [{
                    identifier : 1,
                    clientX : e.clientX,
                    clientY : e.clientY,
                    target : e.target
                }];
            }
            var touch = touches[0];

            // var touchableTarget = findEventElement($(touch.target), "touchable");
            // var clickableTarget = findEventElement($(touch.target), "clickable");

            //查找最近的元素
            var $target = $(touch.target);
            _$touchableTarget = findEventElement($target, "am-touchable");
            _$clickableTarget = findEventElement($target, "am-clickable");
            _$slideTarget = findEventElement($target, "am-slideable");
            _$longTouchTarget = findEventElement($target, "am-longtouchable");
            //自动关键盘
            /*
            var focus = $("input:focus");
            if (focus.length && touch.target != focus[0]) {
            focus.blur();
            if (window.device && window.device.platform == "Android") {
            hideInput();
            } else {
            }
            }
            */

            //console.log(e, _$touchableTarget, _$clickableTarget);
            //如果都不存在就退出
            if (!_$touchableTarget && !_$clickableTarget) {
                return;
            }

            _startTouch = _touch = $.extend({}, touch);
            //_startPos = [_touch.clientX, _touch.clientY];

            if (_$touchableTarget) {
                _$touchableTarget.trigger("vtouchstart", {
                    x : _touch.clientX,
                    y : _touch.clientY
                });
            }
            if (_$clickableTarget) {
                // console.log("_clickTimer", _$clickableTarget);
                _clickTimer = setTimeout(function() {

                    if (!_$clickableTarget.hasClass("am-disabled")) {
                        _$clickableTarget.trigger("vhover").addClass("am-clickable-active");
                    }
                    _isHovering = true;
                    _clickTimer = null;
                }, 50);
            }
            if (_$longTouchTarget) {
                _longTouchTimer = setTimeout(function() {
                    _$longTouchTarget.trigger("vlongtouch");
                    _longTouchTimer = null;
                },1500);
            }

        },
        touchmove : function(e) {
            e.preventDefault();
            // setTextareaPointerEvents('none');
            if (!_$touchableTarget && !_$clickableTarget) {
                return;
            }
            var touches = e.touches;

            if (!touches) {
                touches = [{
                    identifier : 1,
                    clientX : e.clientX,
                    clientY : e.clientY,
                    target : e.target
                }];
            }

            var touch = null;
            for (var i = 0; i < touches.length; i++) {
                var touch = touches[i];
                // console.log((touch == _touch))
                if (touch.identifier == _touch.identifier && (touch.clientX != _touch.clientX || touch.clientY != _touch.clientY)) {
                    _touch = $.extend({}, touch);

                    if (_$touchableTarget) {
                        _$touchableTarget.trigger("vtouchmove", {
                            x : _touch.clientX,
                            y : _touch.clientY
                        });
                    }
                    //console.log("touchmove", touch, touch.clientY - _startTouch.clientY);
                    //$.am.debug.log("touchmove" + (touch, touch.clientY +" "+ _startTouch.clientY));
                    if (_$clickableTarget && (Math.abs(touch.clientX - _startTouch.clientX) >= 15 || Math.abs(touch.clientY - _startTouch.clientY) >= 15)) {
                        if (_isHovering) {
                            _isHovering = false;
                            // console.log("vblur", touch.clientY)
                            _$clickableTarget.trigger("vblur").removeClass("am-clickable-active");
                        }
                        _isClick = false;
                        clearTimeout(_clickTimer);
                        _clickTimer = null;
                    }

                }
            }
        },
        touchend : function(e) {
            //console.log("touchend", e.clientX, e.clientY);
            //$.am.debug.log("touchend");
            // e.preventDefault();
            // setTimeout(function() {
            // setTextareaPointerEvents('none');
            // }, 0);
            _longTouchTimer && clearTimeout( _longTouchTimer );

            if (!_$touchableTarget && !_$clickableTarget && !_$slideTarget) {
                return;
            }
            var touches = e.touches;
            if (!touches) {
                touches = [{
                    clientX : e.clientX,
                    clientY : e.clientY,
                    target : e.target
                }];
            }

            for (var i = 0; i < touches.length; i++) {
                var touch = touches[i];
                if (touch.identifier == _touch.identifier) {
                    return;
                }
            }

            if (_$touchableTarget) {
                _$touchableTarget.trigger("vtouchend", {
                    x : _touch.clientX,
                    y : _touch.clientY
                });
            }
            if (_$clickableTarget) {
                if (_isHovering) {
                    _isHovering = false;
                    _$clickableTarget.trigger("vblur").removeClass("am-clickable-active");
                    if (!_$clickableTarget.hasClass("am-disabled")) {
                        _$clickableTarget.trigger("vclick");
                    }
                } else if (_isClick) {
                    var $target = _$clickableTarget;
                    // console.log("touchstart", _$clickableTarget);
                    if (!$target.hasClass("am-disabled")) {
                        $target.trigger("vhover").addClass("am-clickable-active");
                    }
                    setTimeout(function() {
                        $target.trigger("vblur").removeClass("am-clickable-active");
                        if (!$target.hasClass("am-disabled")) {
                            $target.trigger("vclick");
                        }
                    }, 50);
                }
                clearTimeout(_clickTimer);
                _clickTimer = null;
            }

            if (_$slideTarget && Math.abs(_touch.clientY - _startTouch.clientY) < _$slideTarget.height()) {
                var _move = _touch.clientX - _startTouch.clientX;
                var _max = $.am.innerWidth / 5;
                if (_move > _max) {
                    _$slideTarget.trigger("slideright");
                } else if (_move < -_max) {
                    _$slideTarget.trigger("slideleft");
                }
            }

            _$touchableTarget = _$clickableTarget = _touch = _$slideTarget = _longTouchTimer = _$longTouchTarget = null;
            _isClick = true;

        }
    };

    $.fn.vclick = function(cb) {
        this.addClass("am-clickable").bind("vclick", cb);
        return this;
    };

    $.fn.vlongtouch = function(cb) {
        this.addClass("am-longtouchable").bind("vlongtouch", cb);
        return this;
    };

})(window, jQuery);

//绑定Document事件
//根据Target寻找

//vtouchstart
//vtouchmove
//vtouchend

//vhover
//vblur
//vclick;
///<jscompress sourcefile="am.nativeUI.js" />
(function(w, $) {
	var nativeUi = {
		"_history" : {},
		"_uiCache" : [],
		"event" : {
			left : function() {
				smartMobile.appManager.switchApp({
					appName : "HomeApp"
				});
			},
			right : function() {
				console.log("right")
			},
			/**
			 * tabBar button
			 */
			tabitem1 : function() {
				console.log("tabitem1");
			},
			tabitem2 : function() {
				console.log("tabitem2");
			},
			tabitem3 : function() {
				console.log("tabitem3");
			},
			tabitem4 : function() {
				console.log("tabitem4");
			},
			tabitem5 : function() {
				console.log("tabitem5");
			},
			tabitem6 : function() {
				console.log("tabitem6");
			},
			tabitem7 : function() {
				console.log("tabitem7");
			},
			tabitem8 : function() {
				console.log("tabitem8");
			},
			tabitem9 : function() {
				console.log("tabitem9");
			},
			tabitem10 : function() {
				console.log("tabitem10");
			},
			tabitem11 : function() {
				console.log("tabitem11");
			},
			tabitem12 : function() {
				console.log("tabitem12");
			}
		},
		nameEventMap : {
			left : "left",
			right : "right",
			tabitem1 : "tabitem1",
			tabitem2 : "tabitem2",
			tabitem3 : "tabitem3",
			tabitem4 : "tabitem4",
			tabitem5 : "tabitem5",
			tabitem6 : "tabitem6",
			tabitem7 : "tabitem7",
			tabitem8 : "tabitem8",
			tabitem9 : "tabitem9",
			tabitem10 : "tabitem10",
			tabitem11 : "tabitem11",
			tabitem12 : "tabitem12"
		},
		change : function(uis, options) {

			if (!uis)
				return;
			var _options = options ? options : {};
			$.extend(uis, _options);

			var args = this.historyfilter(uis);
			for (var $id in args) {
				if (args[$id]) {
					var paras = {};
					for (var key in args[$id]) {
						if (key == "onclick")
							continue;
						paras[key] = args[$id][key];
					}

					if (!$.isEmptyObject(paras)) {

						smartMobile.nativeUI.setAttribute({
							id : $id.toString(),
							parameters : paras
						});
					}
				}
			}
			//args
			$.extend(true, this._history, uis);
		},
		update : function(uis, options) {
			if (!uis)
				return;
			var _options = options ? options : {};
			$.extend(uis, _options);
		},
		//        reset: function (id) {
		//            var page = $.am.pages[id];
		//            if (page) {
		//                page.nativeUi = $.extend(true, {}, this._uiCache[id]);
		//            }
		//        },
		historyfilter : function(uis) {
			var options = {};
			for (var id in uis) {
				var style = uis[id], _laststyle = this._history[id] ? this._history[id] : {};
				var empty = {};
				empty[id] = {};
				//$.extend(options, empty);
				for (var key in style) {
					if (key == "onclick") {
						this.event[this.nameEventMap[id]] = style[key];
						continue;
					}
					if (_laststyle[key] && (style[key] == _laststyle[key]))
						continue;

					empty[id][key] = style[key];
				}

				$.extend(options, empty);
			}

			return options;
		},
		setUiEventMap : function(option) {
			var _option = option ? option : {};
			$.extend(true, this.nameEventMap, _option);
		}
		//        addCache: function (page) {
		//            if (page && page.id && page.nativeUi) {
		//                this._uiCache[page.id] = $.extend(true, {}, page.nativeUi); ;
		//            }
		//        }
	}
	$.am.nativeUi = {
		setUiEventMap : function(option) {
			nativeUi.setUiEventMap(option);
		},
		reset : function(id) {
			nativeUi.reset(id);
		},
		change : function(uis, options) {
			nativeUi.change(uis, options);
		},
		event : nativeUi.event
		//        addCache:function(page){
		//            nativeUi.addCache(page);
		//        }
	}

})(window, jQuery);
;
///<jscompress sourcefile="am.Page.js" />
/**
 * $.am.Page.js
 * @description  1.定义一个page对象
 *---------------------------------------------------------------------------
 * @ 目录:
 * 1. sns
 *
 *---------------------------------------------------------------------------
 * @version        0.1
 * @author        shu.wu@hp.com
 * @lastEdit        2012-7-4
 *
 */
(function (window, $) {

    $.fn.setTransformPos = function (pos, d, hasInput) {
        //$("input:focus").blur();

        var opt;

        if (hasInput && $.am.use2d) {

            switch (d) {
                case "x":
                    opt = 'translate(' + pos + 'px, 0)';
                    // this.parent().scrollLeft(-pos)
                    //this[0].style.left = pos+"px";
                    break;
                case "y":
                    opt = 'translate(0,' + pos + 'px)';
                    // this.parent().scrollTop(-pos)
                    // this[0].style.top = pos + "px";
                    break;
                case "xy":
                    opt = 'translate(' + pos[0] + 'px,' + pos[1] + 'px)';
                    break;
            }
            this[0].style.transform = opt;
            this[0].style.webkitTransform = opt;
        } else {

            switch (d) {
                case "x":
                    opt = 'matrix3d(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, ' + pos + ', 0, 0, 1)';
                    break;
                case "y":
                    opt = 'matrix3d(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, ' + pos + ', 0, 1)';
                    break;
                case "z":
                    opt = 'matrix3d(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, ' + pos + ')';
                    break;
                case "xy":
                    opt = 'matrix3d(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, ' + pos[0] + "," + pos[1] + ', 0, 1)';
                    break;
            }
            this[0].style.transform = opt;
            this[0].style.webkitTransform = opt;
        }

        return this;
    };

    $.fn.animateTranslate3d = function (cPos, tPos, d, t, cb) {
        //console.log(cPos+" | "+tPos+" | "+d+" | "+t);
        var ot = new Date().getTime();
        var _this = this;
        this.doAnimateTranslate3d = function () {
            var nt = new Date().getTime();
            var step = nt - ot;
            var nPos = cPos + (tPos - cPos) * step / t;
            _this.setTransformPos(nPos, d);
            if (step >= t) {
                _this.setTransformPos(tPos, d);
                //setTimeout(function(){
                cb && cb();
                //},300);
            } else {
                setTimeout(function () {
                    _this.doAnimateTranslate3d();
                }, 10);
            }
        };
        this.doAnimateTranslate3d();
    };
    $.am.pages = {};
    //当前活动的page
    var activePage = null;
    //存放显示的page历史记录的堆栈
    $.am.history = [];
    $.am.getActivePage = function () {
        return activePage;
    };
    /**
     * 1. Page类,用于创建一个Page对象
     * @class
     * @param [string]    opt.id
     * @return [object]     产生的Page对象
     * @description  1.
     *
     * @example
     */
    var Page = function (e) {

        // this.id = e.id;
        $.extend(this, e);
        $.am.pages[e.id] = this;
        $.am.components.push(this);
        $.am.Component.call(this, e);
    };
    Page.prototype = {
        componentInit: function () {
            var self = this;
            this.$ = $("#" + this.id);
            var $wrap = this.$.children(".am-body-wrap");
            var $inner = $wrap.children(".am-body-inner");
            if ($wrap.length && $inner.length) {
                this.scrollview = new $.am.ScrollView({
                    $wrap: $wrap,
                    $inner: $inner,
                    direction: [false, !this.disableScroll],
                    hasInput: this.hasInput
                });

                if (self.touchTop) {
                    $inner.prepend('<div class="am-drag top down" style="display:none"><span class="icon">T</span><span class="am-drag-text">' + (self.amDragTopTips[0]) + '</span></div>');

                    this.scrollview.touchTop = function (e) {
                        if (this.pauseTouchTop) {
                            return;
                        }
                        $.am.debug.log("touchTop:" + e);
                        if (e == 3) {
                            $.am.debug.log("loading Show:" + e);
                            $inner.find(".am-drag.top").removeClass("up").addClass("down").find(".am-drag-text").text(self.amDragTopTips[2]);
                            $inner.find(".am-drag.top").addClass("loading");
                            self.touchTop();
                        } else if (e == 2) {

                        } else if (e == 1) {
                            $inner.find(".am-drag.top").removeClass("down").addClass("up").find(".am-drag-text").text(self.amDragTopTips[1]);
                        } else {
                            $inner.find(".am-drag.top").show().removeClass("loading").removeClass("up").addClass("down").find(".am-drag-text").text(self.amDragTopTips[0]);
                        }
                    }
                }

                if (self.touchBottom) {
                    $inner.append('<div class="am-drag bottom up" style="display:none"><span class="icon">B</span><span class="am-drag-text">' + (self.amDragBottomTips[0]) + '</span></div>');

                    this.scrollview.touchBottom = function (e) {
                        if (this.pauseTouchBottom) {
                            return;
                        }
                        if (e == 3) {
                            $inner.find(".am-drag.bottom").removeClass("up").addClass("down").find(".am-drag-text").text(self.amDragBottomTips[2]);
                            $inner.find(".am-drag.bottom").addClass("loading");
                            self.touchBottom();
                        } else if (e == 2) {

                        } else if (e == 1) {
                            $inner.find(".am-drag.bottom").removeClass("up").addClass("down").find(".am-drag-text").text(self.amDragBottomTips[1]);
                        } else {
                            $inner.find(".am-drag.bottom").show().removeClass("loading").removeClass("down").addClass("up").find(".am-drag-text").text(self.amDragBottomTips[0]);
                        }
                    }
                }
            }
            this.$header = this.$.children(".am-header");
            this.$footer = this.$.children(".am-footer");
            this.$body = this.$.children(".am-body-wrap");

            this.$backButton = this.$header.find(".am-backbutton");
            if (this.$backButton.length > 0) {
                this.$backButton.addClass("am-clickable").vclick(function () {
                    self.backButtonOnclick ? self.backButtonOnclick() : $.am.page.back();
                    //android back bug
                    $('#share_cover').hide();
                });
            }
        },
        closeTopLoading: function () {
            $.am.debug.log("closeTopLoading:" + typeof (this.scrollview._originalMax));
            try {
                if (typeof (this.scrollview._originalMax) == "object") {
                    $.am.debug.log("GO");
                    this.scrollview._max = [this.scrollview._originalMax[0], this.scrollview._originalMax[1]];
                    this.scrollview._originalMax = 0;
                    this.scrollview._startAnimation();
                    this.scrollview.$inner.find(".am-drag.top").hide();

                    $.am.debug.log("closeTopLoading: DONE!");

                }
            } catch (e) {
                $.am.debug.log("ERROR:" + e);
            }
        },
        closeBottomLoading: function () {
            if (this.scrollview._originalMin) {
                this.scrollview._min = [this.scrollview._originalMin[0], this.scrollview._originalMin[1]];
                this.scrollview._originalMin = 0;
                this.scrollview._startAnimation();
                this.scrollview.$inner.find(".am-drag.bottom").hide();
            }
        },
        setBodyHeight: function (wh) {

            var h1 = 0;
            var h2 = 0;
            this.$body.prevAll(":visible").each(function () {
                var $this = $(this);
                if ($(this).css("position") == "absolute") {
                    return;
                }
                h1 += $(this).outerHeight(true);
            });
            // console.log("setBodyHeight", h1);
            this.$body.nextAll(":visible").each(function () {
                if ($(this).css("position") == "absolute" && !$(this).hasClass("am-placeholder")) {
                    return;
                }
                h2 += $(this).outerHeight(true);
            });
            var $tab = $("div.am-tab:visible");
            if ($tab.length > 0) {
                h2 += $tab.outerHeight();
            }
            // console.log("setBodyHeight", h2);
            this.$body.css({
                "top": h1,
                "bottom": h2
            });
            this.scrollview && this.scrollview.refresh();

        },
        changeToMe: function (animation, para) {
            $.am.changePage(this, animation, para);
        },
        refresh: function () {
            //console.log("refresh");
            this.setBodyHeight($.am.getInnerHeight());
        },
        setStatus: function (status, text) {
            var $page = this.$.removeClass("am-status-loading am-status-error am-status-empty");
            switch (status) {
                case "loading":
                    $page.addClass("am-status-loading");
                    break;
                case "error":
                    $page.addClass("am-status-error");
                    break;
                case "empty":
                    $page.addClass("am-status-empty");
                    break;
                case "normal":
                default:

            }

        },

        bindImgs: function ($imgs, sync) {
            if (!this._$imgs) {
                this._$imgs = $imgs;
            } else {
                var arrDom = [];
                this._$imgs.each(function () {
                    arrDom.push(this);
                });
                $imgs.each(function () {
                    arrDom.push(this);
                });
                this._$imgs = $(arrDom);
            }
            this.sync = sync;

            var _this = this;
            this.scrollview.onScrollStop = function () {
                _this._showActiveImgs();
            };
        },
        unbindImgs: function () {
            this._$imgs = undefined;
            this._rendered = [];
            this.sync = undefined;
            this.scrollview.onScrollStop = undefined;
            return this;
        },
        _rendered: [],
        _showActiveImgs: function () {
            if (!this._$imgs || this._$imgs.length < 1) {
                return;
            }
            this.arrImgs = [];
            var yMin = this.scrollview.$wrap.offset().top;
            var yMax = this.scrollview.$wrap.height();
            for (var i = 0; i < this._$imgs.length; i++) {
                var pos = this._$imgs.eq(i).parent().offset().top - yMin;
                var h = this._$imgs.eq(i).parent().height();
                //console.log(pos);
                if (!this._rendered[i] && pos > -h && pos < yMax) {
                    if (this.sync) {
                        this.arrImgs.push(this._$imgs.eq(i));
                    } else {
                        this._$imgs.eq(i).getPicture(this._$imgs.eq(i).attr("picId"));
                    }
                    this._rendered[i] = true;
                }
            }

            if (this.arrImgs.length > 0) {
                this._renderImgCount = 0;
                this._renderImgSync();
            }
        },
        _renderImgSync: function () {
            var obj = this.arrImgs[this._renderImgCount], _this = this;
            if (obj) {
                if (obj.attr("picId")) {
                    $.am.debug.log("_renderImgSync:" + obj.attr("picId"));
                    obj.getPicture(obj.attr("picId"), function () {
                        _this._renderImgCount++;
                        _this._renderImgSync();
                    }, function () {
                        _this._renderImgCount++;
                        _this._renderImgSync();
                    });
                } else {
                    setTimeout(function () {
                        _this._renderImgCount++;
                        _this._renderImgSync();
                    }, 50);
                }
            } else {

                $.am.debug.log("_renderImgSync: no picId");
            }
        }
    };
    $.am.Page = Page;

    var showClassName, hideClassName, width, height, hideObj, animating = false, param;
    var afterPageShowCall = function (a, b) {
        setTimeout(function () {
            a.setBodyHeight(height);
            animating = false;
            a.backButtonClick && ($.am.backButtonClick = a.backButtonClick);
            b.$.css({
                "display": "none"
            });
            if (b && typeof (b.afterHide) == 'function') {
                b.afterHide && b.afterHide();
            }
            if (a && typeof (a.afterShow) == 'function') {
                a.afterShow && a.afterShow(param);
            }
        }, 200);
    };
    /**
     * 显示Page
     * @function
     * @private
     * @param e {jQuery} 需要显示的jQuery对象
     * @param c {jQuery} 需要隐藏的jQuery对象
     * @param p {boolean} 隐藏的方向
     */
    var _showPage = function (e, c, p, cb) {
        if (p) {
            c.setTransformPos(0, "x");
            e.setTransformPos(width, "x");
            $.am.page.$app.animateTranslate3d(0, -width, "x", 200, function () {
                $.am.page.$app.setTransformPos(0, "x");
                e.setTransformPos(0, "x");
                c.setTransformPos(5000, "x");
                cb && cb();
            });
        } else {
            c.setTransformPos(width, "x");
            $.am.page.$app.setTransformPos(-width, "x");
            $.am.page.$app.animateTranslate3d(-width, 0, "x", 200, function () {
                $.am.page.$app.setTransformPos(0, "x");
                c.setTransformPos(5000, "x");
                cb && cb();
            });
            e.setTransformPos(0, "x");
        }
    };
    /**
     * ChangePage
     *@function
     *@param [object] obj     必须  需要显示的page对象
     *@param [string] animate 可选  动画执行方式 [slideup / slidedown / slideleft / slideright]
     *@return
     *@description 1.
     */
    $.am.changePage = function (obj, animate, para) {
        var self = this;
        if (!activePage) {
            activePage = obj;
            obj.$.show().setTransformPos(0, "x");
            if (obj.beforeShow && typeof (obj.beforeShow) == 'function') {
                obj.beforeShow();
            }
            obj.setBodyHeight($.am.getInnerHeight());
            if (obj.afterShow && typeof (obj.afterShow) == 'function') {
                obj.afterShow(para);
            }
            return;
        }
        if (animating)
            return;
        if (obj == activePage)
            return;
        amGloble.loading.hide();
        param = para;
        if (activePage.id)
            $("#" + activePage.id).find("input").blur();
        //call befor
        if (activePage && typeof (activePage.beforeHide) == 'function') {
            if (activePage.beforeHide(obj)) {
                return;
            }
        }
        if (obj.beforeShow && typeof (obj.beforeShow) == 'function') {
            obj.beforeShow(param);
        }
        animating = true;
        width = $.am.page.$app.width();
        height = $.am.getInnerHeight();
        self.animateType = animate;
        //get the jQuery obj
        var $showPage = obj.$;
        var $hidePage = activePage ? activePage.$ : null;
        self.history.push(activePage);
        var isInHistory = self.history.indexOf(obj);
        if (isInHistory != -1) {
            self.history.splice(isInHistory);
        }
        $showPage.show();
        // show

        if (!$hidePage) {
            $showPage.show();
        } else {
            //excuse animate
            switch (animate) {
                case 'slideup':
                    setTimeout(function () {
                        $showPage.css({
                            'z-index': '1'
                        });
                        $showPage.setTransformPos(0, "x");
                        $showPage.setTransformPos(height, "y");
                        $showPage.animateTranslate3d(height, 0, "y", 200, function () {
                            $showPage.css({
                                'z-index': '0'
                            });
                            $hidePage.setTransformPos(5000, "x");
                            afterPageShowCall(obj, hideObj);
                        });
                    }, 200);
                    break;
                case 'slidedown':
                    setTimeout(function () {
                        $showPage.setTransformPos(0, "x");
                        $hidePage.css({
                            'z-index': '1'
                        }).setTransformPos(0, "y").animateTranslate3d(0, height, "y", 200, function () {
                            $hidePage.setTransformPos(0, "y").setTransformPos(5000, "x");
                            afterPageShowCall(obj, hideObj);
                        });
                    }, 200);
                    break;
                case 'popup':
                    setTimeout(function () {
                        $showPage.css({
                            'z-index': '1'
                        }).setTransformPos(0, "x").setTransformPos(100, "z").animateTranslate3d(100, 1, "z", 300, function () {
                            $showPage.css({
                                'z-index': '0'
                            });
                            $hidePage.setTransformPos(5000, "x");
                            afterPageShowCall(obj, hideObj);
                        });
                    }, 200);
                    break;
                case 'popdown':
                    setTimeout(function () {
                        $hidePage.css({
                            'z-index': '1'
                        }).setTransformPos(1, "z").animateTranslate3d(1, 100, "z", 300, function () {
                            $hidePage.setTransformPos(1, "z").setTransformPos(5000, "x");
                            afterPageShowCall(obj, hideObj);
                        });
                        $showPage.setTransformPos(0, "x");
                    }, 200);
                    break;
                case 'slideleft':
                    setTimeout(function () {
                        _showPage($showPage, $hidePage, true, function () {
                            afterPageShowCall(obj, hideObj);
                        });
                    }, 200);
                    break;
                case 'slideright':
                    setTimeout(function () {
                        _showPage($showPage, $hidePage, false, function () {
                            afterPageShowCall(obj, hideObj);
                        });
                    }, 200);
                    break;
                default:
                    $hidePage.setTransformPos(5000, "x");
                    $showPage.setTransformPos(0, "x");
                    obj.backButtonClick && ($.am.backButtonClick = obj.backButtonClick);
                    //hideObj = activePage;
                    //activePage = obj;
                    afterPageShowCall(obj, activePage);
                    break;
            }
        }
        //change activePage
        hideObj = activePage;
        activePage = obj;


    };

    $.am.page = {
        init: function () {
            this.$app = $("div.am-app");
            height = $.am.getInnerHeight();
        },
        back: function (animation, params) {
            animation = animation || "slideright";
            params = params || "back";
            if ($.am.history.length > 0) {
                if (typeof $.am.history[$.am.history.length - 1].params !== 'undefined') {
                    params = $.am.history[$.am.history.length - 1].params;
                }
                $.am.changePage($.am.history[$.am.history.length - 1], animation, params);
            }
            //android back bug
            $('#share_cover').hide();
        }
    };
})(window, jQuery);
;
///<jscompress sourcefile="am.Scrollview.js" />
(function(w, $) {

	var ScrollView = function(opt) {
		var self = this;
		$.extend(this, opt);

		var start;
		this.$wrap.addClass("am-touchable").bind({
			"vtouchstart" : function(e, p) {
				//console.log("vtouchstart");
				start = [p.x, p.y];
				self._start();
				return false;
			},
			"vtouchmove" : function(e, p) {
				//console.log("vtouchmove");
				self._move([p.x - start[0], p.y - start[1]]);
				return false;
			},
			"vtouchend" : function(e, p) {
				//console.log("vtouchend");
				self._end();
				return false;
			}
		});

		this.direction = this.direction || [false, true];
		//开始的位置
		this._startPos = [0, 0];
		//当前的位置
		this._currentPos = [0, 0];
		//动画开始时的位置
		this._endPos = [0, 0];
		//当前滚动的速度
		this._speed = [0, 0];
		//上次计算的时间
		this._lastTimeStamp = null;
		//定时器
		this._timer = null;

		this.setMax();

		this.vt = [new MomentumTracker(), new MomentumTracker()];

	};
	//方法
	$.extend(ScrollView.prototype, {
		_start : function() {
			// console.log("start")
			//停止动画
			this._stopAnimation();
			//初始化下一次动作需要的属性
			$.extend(this._startPos, this._currentPos);
			this._speed = [0, 0];

			this.overTop = 0;
			this.overBottom = 0;
			this._overT = 0;
			this._overB = 0;
		},
		_move : function(displacement) {
			// console.log("move", displacement)

			var nowTimeStamp = new Date();
			var dt = nowTimeStamp - this._lastTimeStamp;
			dt = dt < 10 ? 10 : dt;
			var newPos = [0, 0];
			var ds = [];
			var min = $.extend([], this._min);
			var max = $.extend([], this._max);

			for (var i = 0; i < this.direction.length; i++) {
				if (this.direction[i]) {

					//当前时间
					//新位置
					newPos[i] = this._startPos[i] + displacement[i];
					ds[i] = newPos[i] - this._currentPos[i];
					//如果超过范围
					if (newPos[i] > max[i]) {
					    //console.log("top_0");
					    if (!this._originalMax || !this.touchTop) {
					        var n = 1 - this._currentPos[i] / 55;
					        n = n < 0 ? 0 : n;
					        newPos[i] = this._currentPos[i] + ((newPos[i] + max[i]) / 2 - this._currentPos[i]) * n;

					        if (this.touchTop && !this.pauseTouchTop) {
					            if (!this.overTop && n<0.1) {
					                this.overTop = new Date().getTime();
					                this.touchTop && this.touchTop(1);
					            } else if (this.overTop > 0 && new Date().getTime() - this.overTop > 500) {
					                this.touchTop && this.touchTop(2);
					                this.overTop = -1;
					            }

					            if (!this._overT) {
					                this._overT = 1;
                                    this.touchTop && this.touchTop(0);
					            }
					        }
					    } else {
					        newPos[i] = this._currentPos[i];
					        ds[i] = 0;
					    }
					} else if (newPos[i] < min[i]) {
					    //console.log("bottom_0");
					    if (!this._originalMin || !this.touchBottom) {
					        var n = 1 - (min[i] - this._currentPos[i]) / 55;
					        n = n < 0 ? 0 : n;
					        newPos[i] = this._currentPos[i] + ((newPos[i] + min[i]) / 2 - this._currentPos[i]) * n;

					        if (this.touchBottom && !this.pauseTouchBottom) {
					            if (!this.overBottom && n < 0.1) {
					                this.overBottom = new Date().getTime();
					                this.touchBottom && this.touchBottom(1);
					            } else if (this.overBottom > 0 && new Date().getTime() - this.overBottom > 500) {
					                this.touchBottom && this.touchBottom(2);
					                this.overBottom = -1;
					            }

					            if (!this._overB) {
					                this._overB = 1;
					                this.touchBottom && this.touchBottom(0);
					            }
					        }
					    } else {
					        newPos[i] = this._currentPos[i];
					        ds[i] = 0;
					    }
					}
					//console.log("newPos[i]:"+newPos[i]);
					//计算速度v = ds/dt
					this._speed[i] = ds[i] / dt;
					//保存新值
					this._currentPos[i] = newPos[i];
				}
			}
			// console.log("move - " + ds + " - " + dt)
			this._lastTimeStamp = nowTimeStamp;

			//产生位置更新事件
			this._onupdate(newPos);
		},
		_end : function() {
			$.extend(this._endPos, this._currentPos);
      if (this.$momentumProperties && this.$momentumProperties.gridHeight ) {
        if (this._currentPos[1]%this.$momentumProperties.gridHeight!=0) {
          this._endPos[1] = this._currentPos[1] = Math.round(this._currentPos[1]/this.$momentumProperties.gridHeight)*this.$momentumProperties.gridHeight;
        }
      }
			//设定动画开始i位置
			// console.log("end", this._speed)
			if (this.touchTop && !this.pauseTouchTop &&  this.overTop > 0 && new Date().getTime() - this.overTop > 200) {
			    this.overTop = -1;
			    this.touchTop && this.touchTop(2);
			}
			if (this.touchBottom && !this.pauseTouchBottom && this.overBottom > 0 && new Date().getTime() - this.overBottom > 200) {
			    this.overBottom = -1;
			    this.touchBottom && this.touchBottom(2);
			}

			if (this.touchTop && !this.pauseTouchTop && this.overTop == -1 && !this._originalMax) {
			    this._originalMax = [this._max[0], this._max[1]];
			    this._max = [0, 55];
			    this.overTop = -2;
			    this.touchTop(3);
			    return;
			}
			if (this.touchBottom && !this.pauseTouchBottom && this.overBottom == -1 && !this._originalMin) {
			    this._originalMin = [this._min[0],this._min[1]];
			    this._min = [0, this._min[1] - 55];
			    this.overBottom = -2;
			    this.touchBottom(3);
			    return;
			}
			this._startAnimation();
		},
		_startAnimation : function() {
			var self = this;
			var min = $.extend([], this._min);
			var max = $.extend([], this._max);
			var startDisplacement = this._endPos;
			var startSpeed = $.extend([], this._speed);
			var vt = [];
			var direction = this.direction;

			for (var i = 0; i < direction.length; i++) {
				if (direction[i]) {
					startSpeed[i] = (startSpeed[i] <= 0.4 && startSpeed[i] >= -0.4) ? 0 : startSpeed[i];

					// console.log(startSpeed);
					vt[i] = this.vt[i];
					vt[i].start(startDisplacement[i], startSpeed[i], 2000, min[i], max[i]);
				}
			}

			if (this._timer) clearInterval(this._timer);
			this._timer = setInterval(function() {
				var done = [true, true];
				var p = [0, 0];
				for (var i = 0; i < direction.length; i++) {
					if (direction[i]) {
						p[i] = vt[i].update();
						// console.log(p);
						done[i] = vt[i].done();
					}
				}

				self._onupdate(p);
				self._currentPos = p;

				// console.log(done);
				if (done[0] && done[1]) {
          if (self.$momentumProperties && self.$momentumProperties.easing && self.$momentumProperties.girdHeight) {
            if (self._currentPos[1]%self.$momentumProperties.girdHeight!=0) {
              self._endPos[1] = self._currentPos[1] = Math.round(self._currentPos[1]/self.$momentumProperties.girdHeight)*self.$momentumProperties.girdHeight;
              self._onupdate(self._currentPos);
            }
          }
					self._stopAnimation();
          self.$callback && self.$callback(self.$caller || undefined);
				}

			}, 10);

		},
		_stopAnimation: function () {
		    if (this._timer) {
		        clearInterval(this._timer);
		    } else {
		        this._timer = null;
		    }

		    //this.onScrollStop && this.onScrollStop();

		    //var _this = this;
		    //if (_this._currentPos[1] == 0) {
		    //    console.log("top:" + _this._currentPos[1]);
		    //    _this.onScrollEnd && _this.onScrollEnd("top");
		    //} else if (_this._currentPos[1] <= _this._min[1]) {
		    //    console.log("bottom:" + _this._currentPos[1]);
		    //    _this.onScrollEnd && _this.onScrollEnd("bottom")
		    //}
		},
		_onupdate: function (pos) {
		    //console.log("_onupdate:" + pos);
			//判断是否触碰上下边界
			//TODO 左右尚未实现
			// $(".inner").css("top", pos);
			// this.$inner[0].style.webkitTransform = "matrix3d(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0," + pos[0] + "," + pos[1] + ",0, 1)";
			this.$inner.setTransformPos(pos, "xy", this.hasInput);
			// inner.style.webkitTransform = "translate3d(0," + pos + "px,0)";
			// $(".inner").css("-webkit-transform", "translate(0," + pos + "px)");
		},
		scrollTo : function(pos) {
			var min = $.extend([], this._min);
			var max = $.extend([], this._max);

			switch(pos) {
				case "top":
					pos = max;
					break;
				case "bottom":
					pos = min;
					break;
				default:
			}
			// console.log("scrollTo",min,max,pos)
			this._stopAnimation();
			this._currentPos = pos;
			this._onupdate(pos);
		},
		refresh : function(cb) {
			if (this.isRefreshing) {
				// console.log("refresh() disable");
				return false;
			}
			// console.log("refresh() start");
			this.isRefreshing = true;
			var self = this;
			var last = [0, 0, 0, 0];
			var lastTime = 0;

			var timer = null;

			var step = function() {
				var now = new Date().getTime();
				var w = self.$inner.outerWidth(true);
				var h = self.$inner.outerHeight(true);
				var ow = self.$wrap.width();
				var oh = self.$wrap.height();

				if (w != last[0]) {
					last[0] = w;
					lastTime = now;
				}
				if (h != last[1]) {
					last[1] = h;
					lastTime = now;
				}
				if (ow != last[2]) {
					last[2] = ow;
					lastTime = now;
				}
				if (ow != last[3]) {
					last[3] = ow;
					lastTime = now;
				}
				// console.log(w, h, lastTime, now - lastTime);
				//检查时间
				if (now - lastTime > 150) {
					self.isRefreshing = false;
					// console.log("refresh() done");
					self.setMax();
					clearTimeout(timer);
					timer = null;
					cb && cb();
				} else {
					setTimeout(step, 50);
				}
			};

			step();

		},
		setMax : function() {
			var dx = this.$wrap.width() - this.$inner.outerWidth(true);
			var dy = this.$wrap.height() - this.$inner.outerHeight(true);
			if (this._originalMin) {
			    this._originalMin = [dx > 0 ? 0 : dx, dy > 0 ? 0 : dy];
			} else {
			    this._min = [dx > 0 ? 0 : dx, (dy > 0 ? 0 : dy)];
        if (this.$momentumProperties && this.$momentumProperties.easing && this.$momentumProperties.girdHeight) {
          var d = this.$inner.outerHeight(true)/this.$momentumProperties.girdHeight;
	        if(d >=3 ){
		        this._min = [dx > 0 ? 0 : dx, (dy > 0 ? 0 : dy)-this.$momentumProperties.girdHeight*this.$momentumProperties.increament];
          } else if (d == 1) {
		        this._min = [dx > 0 ? 0 : dx, (dy > 0 ? 0 : dy)+this.$momentumProperties.girdHeight*this.$momentumProperties.increament];
					}
        }
      }
			if (this._originalMax) {
			    this._originalMax = [0, 0];
			} else {
			    this._max = [0, 0];
          if (this.$momentumProperties && this.$momentumProperties.easing && this.$momentumProperties.girdHeight) {
            this._max = [0, 0+this.$momentumProperties.girdHeight*this.$momentumProperties.increament];
          }
			}
		}
	});

	$.am.ScrollView = ScrollView;

	//定义运动精灵
	var defaultConfig = {
		fps : 60, // Frames per second in msecs.
		direction : null, // "vertical", "horizontal", or null for both.

		scrollDuration : 2000, // Duration of the scrolling animation in msecs.
		overshootDuration : 150, // Duration of the overshoot animation in msecs.
		snapbackDuration : 300, // Duration of the snapback animation in msecs.

		moveThreshold : 100, // Time between mousemoves must not exceed this threshold.

		startEventName : "MomentumScroller.start",
		updateEventName : "MomentumScroller.update",
		stopEventName : "MomentumScroller.stop",

		eventType : ("ontouchend" in document) ? "touch" : "mouse", // Type of events to track. Switch to $.support.touch.

		showScrollBars : true
	};

	var tstates = {
		scrolling : 0,
		overshot : 1,
		snapback : 2,
		done : 3
	};

	var getCurrentTime = function() {
		return (new Date()).getTime();
	};
	var MomentumTracker = function() {
		this.easing = "easeOutQuad";
		this.reset();
	};

	$.extend(MomentumTracker.prototype, {
		start : function(pos, speed, duration, minPos, maxPos) {
			this.state = (pos < minPos || pos > maxPos) ? tstates.snapback : ((speed != 0) ? tstates.scrolling : tstates.done);

			this.pos = pos;
			this.speed = speed;
			this.duration = (this.state == tstates.snapback) ? defaultConfig.snapbackDuration : duration;
			this.minPos = minPos;
			this.maxPos = maxPos;

			this.fromPos = (this.state == tstates.snapback) ? this.pos : 0;
			this.toPos = (this.state == tstates.snapback) ? ((this.pos < this.minPos) ? this.minPos : this.maxPos) : 0;

			this.startTime = this.lastTime = getCurrentTime();
		},

		reset : function() {
			this.state = tstates.done;
			this.pos = 0;
			this.speed = 0;
			this.minPos = 0;
			this.maxPos = 0;
			this.duration = 0;
		},

		update : function() {
			var state = this.state;
			if (state == tstates.done)
				return this.pos;

			var duration = this.duration;
			var currentTime = getCurrentTime();
			var elapsed = currentTime - this.startTime;
			var dt = currentTime - this.lastTime;
			elapsed = elapsed > duration ? duration : elapsed;

			if (state == tstates.scrolling || state == tstates.overshot) {
				var dx = this.speed * (1 - $.easing[this.easing](elapsed / duration, elapsed, 0, 1, duration));

				var x = this.pos + dx * dt;

				var didOverShoot = (state == tstates.scrolling) && (x < this.minPos || x > this.maxPos);
				if (didOverShoot)
					x = (x < this.minPos) ? this.minPos : this.maxPos;

				this.pos = x;

				if (state == tstates.overshot) {
					if (elapsed >= duration) {
						this.state = tstates.snapback;
						this.fromPos = this.pos;
						this.toPos = (x < this.minPos) ? this.minPos : this.maxPos;
						this.duration = defaultConfig.snapbackDuration;
						this.startTime = getCurrentTime();
						elapsed = 0;
					}
				} else if (state == tstates.scrolling) {
					if (didOverShoot) {
						this.state = tstates.overshot;
						this.speed = dx / 2;
						this.duration = defaultConfig.overshootDuration;
						this.startTime = getCurrentTime();
					} else if (elapsed >= duration)
						this.state = tstates.done;
				}
			} else if (state == tstates.snapback) {
				if (elapsed >= duration) {
					this.pos = this.toPos;
					this.state = tstates.done;
				} else
					this.pos = this.fromPos + ((this.toPos - this.fromPos) * $.easing[this.easing](elapsed / duration, elapsed, 0, 1, duration));
			}

			this.lastTime = currentTime;
			return this.pos;
		},

		done : function() {
			return this.state == tstates.done;
		},
		getPosition : function() {
			return this.pos;
		}
	});

})(window, jQuery);
;
///<jscompress sourcefile="am.Carrousel.js" />
(function(window, $) {
	/**
	 * 1. Carrousel类,用于创建一个Carrousel对象
	 * @class
	 * @param [string]    	opt.id			必需						Carrousel控件ID
	 * @param [int]			opt.height		必需						控件高度
	 * @param [int]			opt.width  		可选		默认100%			控件宽度
	 * @param [int]			opt.visible		可选  	默认1			显示区包含的item的个数
	 * @param [int]			opt.time		可选  	默认300ms		回弹时间
	 * @param [function]		opt.onchange	可选
	 * @param [function]		opt.autoSwitch	可选 	默认10s,0disable	自动切换

	 * @return [object]	 产生的Carrousel对象
	 * @description  1.
	 *
	 * @example
	 */
	var Carrousel = function(opt) {
		this.id = opt.id;
    this.scrollviewY = opt.scrollviewY;
		this.width = opt.width;
		this.visible = opt.visible || 1;
		this.height = opt.height;
		this.time = opt.time || 200;
		this.onchange = opt.onchange;
		this.current = 0;
		this.autoSwitch = typeof (opt.autoSwitch) == "undefined" ? 5000 : opt.autoSwitch;
		$.am.components.push(this);
		$.am.Component.call(this, opt);
	};
	Carrousel.prototype = {
		componentInit : function() {
			this.$ = $("#" + this.id).addClass("am-touchable");
			this.$inner = this.$.children(".am-carrousel-inner");
			var cssSet = {};
			if (this.width) {
				cssSet.width = this.width + "px";
			}
			cssSet.height = this.height + "px";
			this.$.css(cssSet);

			var _this = this;
			this.$.bind({
				"vtouchstart" : function(event, position) {
					if (_this.$items)
						_this.start(position);
					return false;
				},
				"vtouchmove" : function(event, position) {
					if (_this.$items)
						_this.move(position);
					return false;
				},
				"vtouchend" : function(event, position) {
					if (_this.$items)
						_this.end(position);
					return false;
				}
			});
		},
		refresh : function() {
		    var w = this._itemw = (this.width || window.innerWidth) / this.visible, h = this.height;
			this.$items = this.$inner.children();
			if (this.$items.length < 1) {
				return;
			}

			this.$inner.css({
				width : w * this.$items.length + "px"
			});
			this.$items.each(function() {
			    $(this).css({
			        'width': w + "px",
			        'height': h + "px",
			        'float': "left"
			    });
			});
			this.nPos = 0;
			this.current = 0;
			this.show(0);
		},
		start : function(e) {
      if(this.scrollviewY){
        this.scrollviewY.start = [e.x, e.y];
        this.scrollviewY._start();
      }

			this.carrouselTimer && clearTimeout(this.carrouselTimer);
			this.startPos = e.x;
			this.startTime = new Date().getTime();
		},
		move: function (e) {
      //$.am.debug.log(e.y);
      if(this.scrollviewY){
        var min = Math.abs( (e.y - this.scrollviewY.start[1]) );
        $.am.debug.log("y:"+ min );
        if (min > 25){
          this.scrollviewY._move([e.x - this.scrollviewY.start[0], e.y - this.scrollviewY.start[1]]);
        }
      }

			if (e.x - this.startPos > this.current * this._itemw)
				return;
			if (e.x - this.startPos < -(this.$items.length - this.current - this.visible) * this._itemw)
				return;
			this.endPos = e.x;
			var m = this.endPos - this.startPos;
			this.nPos = -this._itemw * this.current + m;
			this.$inner.setTransformPos(this.nPos, "x");

		},
		end : function() {
      this.scrollviewY && this.scrollviewY._end();

			var m = this.endPos - this.startPos;
			var duration = new Date().getTime() - this.startTime;
			var speed = m / duration;
			// console.log(speed);
			if (m && ((m > this._itemw / 2) || speed > 0.6)) {
				var i = Math.ceil(m / this._itemw);
				this.show(this.current - i);
        this.scrollviewY && this.scrollviewY.scrollTo("top");
			} else if (m && (m < -this._itemw / 2 || speed < -0.6)) {
				var i = Math.ceil(Math.abs(m) / this._itemw);
				this.show(this.current + i);
        this.scrollviewY && this.scrollviewY.scrollTo("top");
			} else if (m) {
				this.show(this.current);
			}
			this.endPos = 'undefined';
		},
		show : function(i) {
			if (this.$items.length < 1) {
				return;
			}
			this.current = i;
			if (i < 0) {
				this.current = 0;
			}
			if (i >= this.$items.length - this.visible) {
				this.current = this.$items.length - this.visible;
			}
			var _this = this;
			this.$inner.animateTranslate3d(this.nPos, -this._itemw * this.current, "x", this.time, function() {
				_this.nPos = -_this._itemw * _this.current;
				_this.onchange && _this.onchange(_this.current);
			});

			this.carrouselTimer && clearTimeout(this.carrouselTimer);
			if (this.autoSwitch != 0) {
				this.carrouselTimer = setTimeout(function() {
					// console.log("auto move:"+ (_this.current+1));
					_this.show(i >= _this.$items.length - _this.visible ? 0 : _this.current + 1);
				}, this.autoSwitch);
			}
		}
	};
	$.am.Carrousel = Carrousel;

})(window, jQuery);



(function (window, $) {
    /**
	 * 1. Carrousel类,用于创建一个Carrousel对象
	 * @class
	 * @param [string]    	opt.id			必需						Carrousel控件ID
	 * @param [int]			opt.height		必需						控件高度
	 * @param [int]			opt.width  		可选		默认100%			控件宽度
	 * @param [int]			opt.visible		可选  	默认1			显示区包含的item的个数
	 * @param [int]			opt.time		可选  	默认300ms		回弹时间
	 * @param [function]		opt.onchange	可选
	 * @param [function]		opt.autoSwitch	可选 	默认10s,0disable	自动切换

	 * @return [object]	 产生的Carrousel对象
	 * @description  1.
	 *
	 * @example
	 */
    var Carrousel = function (opt) {
        this.id = opt.id;
        this.$ = opt.$;
        this.width = opt.width;
        this.visible = opt.visible || 1;
        this.height = opt.height;
        this.time = opt.time || 200;
        this.onchange = opt.onchange;
        this.current = 0;
        this.autoSwitch = typeof (opt.autoSwitch) == "undefined" ? 5000 : opt.autoSwitch;
        $.am.components.push(this);
        $.am.Component.call(this, opt);
    }
    Carrousel.prototype = {
        componentInit: function () {
            this.$ = this.$ || $("#" + this.id);
            this.$.addClass("am-touchable")
            this.$inner = this.$.children(".am-carrousel-inner");
            var cssSet = {};
            if (this.width) {
                this.width = cssSet.width = this.width + "px";
            }
            cssSet.height = this.height + "px";
            this.$.css(cssSet);

            var _this = this;
            var sPos = null;
            var mPos = null;
            var isMove = false;
            this.$.bind({
                "vtouchstart": function (event, position) {
                    sPos = {
                        x: position.x,
                        y: position.y
                    }
                    if (_this.$items) {
                        _this.start(sPos.x);
                    }
                    isMove = false;
                    mPos = null;
                    //return false;
                },
                "vtouchmove": function (event, position) {
                    if (!mPos) {
                        mPos = {
                            x: position.x,
                            y: position.y
                        }
                        var t = Math.abs(mPos.x - sPos.x) > Math.abs(mPos.y - sPos.y);
                        if (t) {
                            isMove = true;
                            if (_this.$items) {
                                _this.move(mPos.x);
                            }
                            return false;
                        } else {

                        }
                    } else {
                        mPos = {
                            x: position.x,
                            y: position.y
                        }
                        if (isMove) {
                            if (_this.$items) {
                                _this.move(mPos.x);
                            }
                            return false;
                        } else {

                        }
                    }
                    //position.e.preventDefault();
                    //return false;
                },
                "vtouchend": function (event, position) {
                    if (isMove && _this.$items) {
                        _this.end();//position.x
                    }
                    isMove = false;
                    sPos = null;
                    mPos = null;
                }
            });
        },
        refresh: function () {
            var innerWidth = this.$.innerWidth();
            var w = this._itemw = innerWidth / this.visible, h = this.height;
            this.$items = this.$inner.children();
		        this.$items.each(function () {
			        $(this).css({
				        'width': w + "px",
				        'height': h + "px",
				        'float': "left"
			        });
		        });
            if (this.$items.length <= 1) {
                return;
            }

            this.nPos = -w;
            this.current = 0;
            if (!this.$inner.find(".cloneItem").length) {
                this.cloned = true;
                this.$inner.prepend(this.$items.last().clone().addClass("cloneItem"));
                this.$inner.append(this.$items.first().clone().addClass("cloneItem"));
            } else {
                this.$items = this.$inner.children(":not(.cloneItem)");
            }
            this.$inner.css({
                width: w * (this.$items.length + 2) + "px"
            });
            this.show(0);
        },
        start: function (e) {
            if (this.$items.length <= 1) {
                return;
            }
            this.startPos = e;
            this.startTime = new Date().getTime();
        },
        move: function (e) {
            if (this.$items.length <= 1) {
                return;
            }
            this.carrouselTimer && clearTimeout(this.carrouselTimer);
            /*if (e - this.startPos > this.current * this._itemw)
				return;
			if (e - this.startPos < -(this.$items.length - this.current - this.visible) * this._itemw)
				return;*/
            this.endPos = e;
            var m = this.endPos - this.startPos;
            this.nPos = -this._itemw * (this.current + 1) + m;
            this.$inner.setTransformPos(this.nPos, "x");
        },
        end: function () {
            if (this.$items.length <= 1) {
                return;
            }
            var m = this.endPos - this.startPos;
            var duration = new Date().getTime() - this.startTime;
            var speed = m / duration;
            // console.log(speed);
            if (m && ((m > this._itemw / 2) || speed > 0.6)) {
                var i = Math.ceil(m / this._itemw);
                this.show(this.current - i);
            } else if (m && (m < -this._itemw / 2 || speed < -0.6)) {
                var i = Math.ceil(Math.abs(m) / this._itemw);
                this.show(this.current + i);
            } else if (m) {
                this.show(this.current);
            }
            this.endPos = 'undefined';
        },
        show: function (i) {
            if (this.$items.length < 1) {
                return;
            }
            this.current = i;
            //$("div.page-header").text("current:"+ i);
            //$("div.page-header").append(this.nPos+" | "+(-this._itemw *(this.current+1)));
            var _this = this;
            this.$inner.animateTranslate3d(this.nPos, -this._itemw * (this.current + 1), "x", this.time, function () {
                if (i < 0) {
                    _this.current = _this.$items.length - _this.visible;//0
                }
                if (i > _this.$items.length - _this.visible) {
                    _this.current = 0;//this.$items.length - this.visible;
                }
                _this.nPos = -_this._itemw * (_this.current + 1);
                _this.$inner.setTransformPos(_this.nPos, "x");
                _this.onchange && _this.onchange(_this.current);
            });

            this.carrouselTimer && clearTimeout(this.carrouselTimer);
            if (this.autoSwitch != 0) {
                this.carrouselTimer = setTimeout(function () {
                    _this.show(_this.current + 1);
                }, this.autoSwitch);
            }
        }
    }
    $.am.CarrouselLoop = Carrousel

})(window, jQuery);;
///<jscompress sourcefile="am.Slider.js" />
/**
* 1. Slider类,用于创建一个Slider对象
* @class
* @param [string]    	opt.id			必需						Carrousel控件ID
* @param [int]			opt.nPos		必需						当前位置
* @param [int]			opt.minPos  	必需						最小X坐标
* @param [int]			opt.maxPos  	必需						最大X坐标
* @param [int]			opt.onchange  	可选						callback
* @return [object]	 产生的Slider对象
* @description  1.
*
* @example
*/
$.am.Slider = function(e){
	this.id=e.id;
	this.nPos = this.pos=e.pos;
	this.minPos = e.minPos;
	this.maxPos = e.maxPos;
	this.onchange = e.onchange;
	$.am.components.push(this);
	$.am.Component.call(this,e);
}
$.am.Slider.prototype = {
	componentInit : function(){
		this.$ = $("#"+this.id);
		this.$.setTransformPos(this.pos,"x");
		var _this = this;
		this.$.bind({
			"vtouchstart" : function(event,position){
				_this.start(position.x);
				return false;
			},
			"vtouchmove" : function(event, position){
				_this.move(position.x);
				return false;
			},
			"vtouchend" : function(event, position){
				_this.end(position.x);
				return false;
			}
		});
	},
	start : function(e){
		this.startPos = e;
	},
	move : function(e){
		this.endPos = e;
		var m = e-this.startPos;
		if((m<0 && this.pos+m>this.minPos) || m>0 && this.pos < this.maxPos-m){
			this.nPos=this.pos+m;
			this.$.setTransformPos(this.nPos,"x");
		}
	},
	end : function(e){
		var m = this.endPos-this.startPos, hw = (this.maxPos-this.minPos)/2;
		if(m && m > hw){
			this._goto(this.maxPos);
		}else if(m && m < -hw){
			this._goto(this.minPos);
		}else{
			this._goto(this.pos);
		}
		this.endPos = 'undefined';
	},
	toggle : function(){
		if(this.nPos == this.maxPos){
			this._goto(this.minPos);
		}else{
			this._goto(this.maxPos);
		}
	},
	_goto : function(end, time){
		this.$.animateTranslate3d(this.nPos,end,"x",time || 200);
		this.nPos=this.pos=end;
		this.onchange && this.onchange(this.nPos);
	}
};




;
///<jscompress sourcefile="am.img.js" />
(function() {
    var _name = "BRANDKFC_img_";
    var _threadId = 0;

    var _downloadedList = {};
    var _downloadingList = {};

    var _runCallbacks = function(id, ret) {
        var cbs = _downloadingList[id].callbacks;
        for (var i = 0; i < cbs.length; i++) {
            cbs[i](ret);
        };
    };
    var _saveData = function(id, value) {
        window.localStorage.setItem(_name + id, value);
    };
    var _getData = function(id) {
        return window.localStorage.getItem(_name + id);
    };
    var _removeData = function(id) {
        // $.am.debug.log("remove" + id);
        delete _downloadedList[id];
        window.localStorage.removeItem(_name + id);
    };
    var getPicture = function (id, cb) {
        try{
            id = id.replace(/\\/g, "/");
            if(id.indexOf($.am.imgSvr)!=-1)
            {
                id=id.replace($.am.imgSvr,"");
            }
        } catch (e) {

        }
        if (id == null) {
            cb && cb({
                error : 1,
        id: id,
                data : "Download failed!"
            });
            return;
        }
        //在cache中检索到
        var filename = _downloadedList[id];
        // $.am.debug.log("cache:" + filename + ":" + id);

        if (filename) {
            //callback
            cb && cb({
                type : 2, //local
                error : 0,
        id: id,
                data: smartMobile.app.sourceRoot + filename
            });
            return;
        }

        //在storage中检索到
        filename = _getData(id);
        if (filename) {
            //save in cache
            _downloadedList[id] = filename;
            
            //callback
            cb && cb({
                type : 1, //local
                error : 0,
        id: id,
                data: smartMobile.app.sourceRoot + filename
            });
            $.am.debug.log("local:" + smartMobile.app.sourceRoot + filename);
            return;
        }

        var item = _downloadingList[id];
        if (item) {
            //add callback to callbacks array
            item.callbacks.push(cb);
            return;
        }

        //add download
        //add info to downloading list, status is 1
        var down = _downloadingList[id] = {
            threadId : _threadId++,
            filename : "",
            callbacks : [cb]
        };
        //$.am.debug.log($.am.imgSvr + id);
        var url;
        if(id.indexOf("http")!=-1)
            url=id;
        else
            url=$.am.imgSvr + id;
        smartmobile.fileTransfer.download({
            threadId: 1,
            url: url
        }, function (ret) {
            //成功时
            if (typeof ret == "string") {
                ret = JSON.parse(ret);
            }

            //$.am.debug.log(JSON.stringify(ret));

            var filename = "SUPER_APP_FILE:///" + ret.content.sourceRoot + ret.content.relativePath;
            amGloble.sourceRoot = ret.content.sourceRoot;
            //$.am.debug.log(filename);

            //转移到cache和storage
            _downloadedList[id] = ret.content.relativePath;
            _saveData(id, ret.content.relativePath);
            //callbacks
            _runCallbacks(id, {
                error: 0,
            id: id,
                data: filename
            });
            //删除downloading列表中
            delete _downloadingList[id];
        }, function (ret) {
            //失败时
            //callbacks
            _runCallbacks(id, {
                error: 1,
            id: id,
                data: "Download failed!"
            });
            //删除downloading列表中
            delete _downloadingList[id];
        });
    };

    $.am.preloadImgs = function(id) {
        getPicture(id);
    };
    $.fn.getPicture1 = function(id, scb, fcb) {
        var self = this;
        var getOnce = function() {
            getPicture(id, function(ret) {
                if (!ret.error) {
                    self.unbind().bind({
                        "load" : function() {
                            //$.am.debug.log("img loaded" + ret.data);
                            self.show();
                            scb && scb.call(self, ret);
                        },
                        "error" : function() {
                            //$.am.debug.log("img load failed! clear"+ret.data);
                            _removeData(id);
                            if (ret.type) {
                                getOnce();
                            }
                        }
                    });
                    self.attr("src", ret.data);
                } else {
                    //$.am.debug.log("img download error "+id);
                    fcb && fcb.call(self);
                }
            });
        };
        getOnce();
        return this;
    };
    $.fn.getPicture = function(id, scb, fcb) {
        id = id.replace(/\\/g, "/");
        if(id.indexOf('http') == -1)
        {
            id = $.am.imgSvr + id;
        }
        $.am.debug.log("src="+id);
        this.attr("src", id);

        var self = this;
        this.unbind().bind({
            "load": function () {
                console.log("load success");
                scb && scb();
            },
            "error" : function () {
                console.log("error success");
                self.attr("src", "images/default_list.png");
                fcb && fcb();
            }
        });
    };
    $.am.imgSvr = ""
})();
;
///<jscompress sourcefile="am.debug.js" />
$.am.debug = {
    enable: false,
    count:0,
	init : function() {
	    //this.enable = (window.localStorage.getItem("kfcmos_debug") == "open");
	    //var _this = this;
	    /*$("#enabledebug").vclick(function () {
	        _this.count++;
	        if (_this.count > 5) {
	            if (_this.enable) {
	                _this.enable = false;
	                window.localStorage.setItem("kfcmos_debug", "close");
	                _this.hide();
	            }else{
	                _this.enable = true;
	                window.localStorage.setItem("kfcmos_debug", "open");
	                _this.log("debug open");
	            }
	            _this.count = 0;
	        }
	    });*/
	},
	show : function() {
		var self = this;
		if (this.div) {
			return;
		}
		this.div = $('<div id="am-consolediv" class="am-clickable" style="word-break: break-all; position: absolute; z-index: 1000; background: rgba(0,0,0,0.5); width: 80%; height: 300px; top: 45px; right:0px; color: white; font-size: 9px; overflow: hidden;"></div>');
		this.div.vclick(function() {
			self.hide();
		});
		$("body").append(this.div);
	},
	hide : function() {
		if (this.div) {
			this.div.remove();
			delete this.div;
		}
	},
	log : function(msg) {
		if (!this.enable) {
			return false;
		}
		if (!this.div) {
			this.show();
		}
		var date = new Date();
		this.div.prepend(date.getMinutes() + ":" + date.getSeconds() + " " + msg + "<br>");
	},
	checkErr : function(service, ret) {
		var errorMsg = false;
		var isTimeout = 0;
		if (!ret || typeof (ret) != "object") {
			this.log(service + ":err:ret invalid");
		} else if (ret.result != 0) {
			this.log(service + ":err:result=" + ret.result);
			if (ret.result > 500) {
				isTimeout = 1;
			}
		} else if ( typeof (ret.responseData) != "object") {
			this.log(service + ":err:responseData invalid");
		} else if (ret.responseData.errorCode) {
			this.log(service + ":err:errorCode exist");
			if (ret.responseData.errorMsg) {
				errorMsg = ret.responseData.errorMsg;
			}
		}
		var errHash = [{
			"placeOrder" : {
				"errCode" : "ERR01001",
				"errName" : "Fail to place order",
				"errMsg" : errorMsg || ""
			},
			"checkOrder" : {
				"errCode" : "ERR01003",
				"errName" : "Fail to sync order",
				"errMsg" : errorMsg || ""
			},
			"login" : {
				"errCode" : "ERR01005",
				"errName" : "Fail to login",
				"errMsg" : errorMsg || ""
			},
			"getDataStatus" : {
				"errCode" : "ERR01007",
				"errName" : "Fail to get server time",
				"errMsg" : errorMsg || ""
			},
			"regInfo" : {
				"errCode" : "ERR01008",
				"errName" : "Fail to save user info",
				"errMsg" : errorMsg || ""
			},
			"getMenu" : {
				"errCode" : "ERR01010",
				"errName" : "Fail to get menu",
				"errMsg" : errorMsg || ""
			}
		}, {
			//超时错误
			"placeOrder" : {
				"errCode" : "ERR01002",
				"errName" : "Timeout when placing order",
				"errMsg" : errorMsg || ""
			},
			"checkOrder" : {
				"errCode" : "ERR01004",
				"errName" : "Sync order timeout",
				"errMsg" : errorMsg || ""
			},
			"login" : {
				"errCode" : "ERR01006",
				"errName" : "Login timeout",
				"errMsg" : errorMsg || ""
			},
			"getDataStatus" : null,
			"regInfo" : {
				"errCode" : "ERR01009",
				"errName" : "Saving user info timeout",
				"errMsg" : errorMsg || ""
			},
			"getMenu" : {
				"errCode" : "ERR01011",
				"errName" : "Get menu timeout",
				"errMsg" : errorMsg || ""
			}
		}];
		try {
			var opt = errHash[isTimeout][service];
			if (opt) {
				this.log("postLog:" + JSON.stringify(opt));
				smartMobile.sys.postLog(opt, function(ret) {
				}, function(ret) {
				});
			}
		} catch(e) {
			this.log("postLog:err:" + e);
		}

		return errorMsg;
	},
	postLog : function() {
	}
};
;
///<jscompress sourcefile="am.datepicker.js" />
/**
 * Created by cheguoli on 10/19/2015.
 */
(function (window, $) {
    var guid = function () {
        var guid = "";
        for (var i = 1; i <= 32; i++) {
            var n = Math.floor(Math.random() * 16.0).toString(16);
            guid += n;
        }
        guid += new Date().getTime();
        return guid.toUpperCase();
    };
    var DatePicker = function (opt) {
        //config  e.g 2015-10-19 09:06:27
        this.id = "_datepicker_" + guid();
        console.log(this.id);
        this.gridHeight = 0;
        this.maxGrid = 3;
        this.increament = (this.maxGrid - 1) / 2;

        //input object
        this.inputObject = opt.inputObject || null;
        this.datePattern = opt.datePattern || 'yyyy-MM-dd';
        this.timePattern = opt.timePattern || 'hh:ii:ss';
        this.dateDelimiter = opt.dateDelimiter || "-";
        this.timeDelimiter = opt.timeDelimiter || ":";

        this.showTimeControl = opt.showTimeControl || false;
        this.ignoreSecondPanel = opt.ignoreSecondPanel || false;//custom requirement;
        this.minuteInterval = opt.minuteInterval || 1;//custom requirement
        this.maxShowDate = opt.maxShowDate || false; //custom requirement e.g maxShowDate: new Date()
        this.maxYear = this.maxMonth = this.maxDate = null;
        this.initFinished = false;

        //date
        this.startYear = opt.startYear || 1920;
        this.endYear = opt.endYear || 2030;

        if (this.maxShowDate !== false) {
            this.maxYear = parseInt(this.maxShowDate.getFullYear());  //2015
            this.maxMonth = parseInt(this.maxShowDate.getMonth()) + 1; //1-12
            this.maxDate = parseInt(this.maxShowDate.getDate());//1-31
            //var d = this.maxShowDate.split('-');
            //this.maxYear = d[0] * 1, this.maxMonth = d[1]* 1, this.maxDate = d[2]*1;
            if (this.maxYear <= this.startYear) {
                this.startYear = this.maxYear;
            }
            this.endYear = this.maxYear + 1;
        }
        console.log('endY=' + this.endYear);

        this.$ = null;
        this.$yearPanel = this.$yearPanelWrap = this.$yearPanelInner = null;
        this.$monthPanel = this.$monthPanelWrap = this.$monthPanelInner = null;
        this.$datePanel = this.$datePanelWrap = this.$datePanelInner = null;
        this.$yearScroll = this.$monthScroll = this.$dateScroll = null;
        //time
        this.$hourPanel = this.$hourPanelWrap = this.$hourPanelInner = null;
        this.$minutePanel = this.$minutePanelWrap = this.$minutePanelInner = null;
        this.$secondPanel = this.$secondPanelWrap = this.$secondPanelInner = null;
        this.$hourScroll = this.$minuteScroll = this.$secondScroll = null;

        this.monthList = [], this.dateList = [],
            this.hourList = [], this.minuteList = [] , this.secondList = [];

        for (var i = 0; i < 12; i++) {      //from 1 to 12
            this.monthList.push(i + 1);
        }
        for (var i = 0; i < 31; i++) {  // from 1 to 31
            this.dateList.push(i + 1);
        }

        for (var i = 0; i < 24; i++) {  // from 0 to 23
            this.hourList.push(i);
        }

        if (60 % parseInt(this.minuteInterval) != 0) {
            this.minuteInterval = 1;
        }
        for (var i = 0; i < 60; i++) {
            if (this.minuteInterval > 1) {
                if (((i + 1) % this.minuteInterval == 0 && i + 1 < 60) || i == 0) {
                    var tmpVal = i;
                    if (this.minuteInterval > 1 && i > 0) {
                        tmpVal = i + 1;
                    }
                    this.minuteList.push(tmpVal);
                }
            } else {
                this.minuteList.push(i);
            }
        }

        for (var i = 0; i < 60; i++) {  // from 0 to 59
            this.secondList.push(i);
        }

        console.log(this.minuteList.join(","));
        this.year = this.month = this.date = this.hour = this.minute = this.second = null;
        var datetime = opt.datetime || null;
        if (!datetime) {
            var d = new Date();
            this.year = parseInt(d.getFullYear());  //2015
            this.month = parseInt(d.getMonth()); //0-11
            this.date = parseInt(d.getDate());//1-31
            if (this.showTimeControl) {
                this.hour = parseInt(d.getHours());//0-23
                this.minute = parseInt(d.getMinutes());//0-59
                if (!this.ignoreSecondPanel) {
                    this.second = parseInt(d.getSeconds());//0-59
                }
            }
        } else {
            var list = datetime.split(" "),
                d = (list[0]).split(this.dateDelimiter),
                t = (list[1] ? list[1].split(this.timeDelimiter) : null);
            console.log(datetime);
            this.year = parseInt(d[0]);
            this.month = parseInt(d[1]) - 1; //0-11
            this.date = parseInt(d[2]);//1-31
            if (t) {
                this.hour = parseInt(t[0]);//0-23
                this.minute = parseInt(t[1]);//0-59
                if (!this.ignoreSecondPanel) {
                    this.second = parseInt(t[2]);//0-59
                }
            }
        }

        $.am.components.push(this);
        $.am.Component.call(this, opt);
    };
    $.extend(DatePicker.prototype, {
        componentInit: function () {
            var htmlArr = [];
            //htmlArr.push('<div class="_calendar_mask"></div>');
            htmlArr.push('<div id="' + this.id + '" class="pop" style="display:none;margin-top: 0px">');
            if (this.showTimeControl)
                htmlArr.push('<div  class="_calendar full" >');
            else
                htmlArr.push('<div  class="_calendar" >');
            htmlArr.push('<div  class="header" ><span>请选择日期</span></div>');
            htmlArr.push('  <div class="calendar_layer">');
            htmlArr.push('    <ul class="ctimeblock">');

            htmlArr.push('      <li class="yearPanel">');
            htmlArr.push('        <h3>年</h3>');
            htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
            htmlArr.push('          <div class="calender-inner">');
            htmlArr.push('          </div>');
            htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
            htmlArr.push('        </div>');
            htmlArr.push('      </li>');

            htmlArr.push('      <li class="monthPanel">');
            htmlArr.push('        <h3>月</h3>');
            htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
            htmlArr.push('          <div class="calender-inner">');
            htmlArr.push('          </div>');
            htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
            htmlArr.push('        </div>');
            htmlArr.push('      </li>');

            htmlArr.push('      <li class="datePanel">');
            htmlArr.push('        <h3>日</h3>');
            htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
            htmlArr.push('          <div class="calender-inner">');
            htmlArr.push('          </div>');
            htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
            htmlArr.push('        </div>');
            htmlArr.push('      </li>');
            if (this.showTimeControl) {
                htmlArr.push('      <li class="hourPanel">');
                htmlArr.push('        <h3>时</h3>');
                htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
                htmlArr.push('          <div class="calender-inner">');
                htmlArr.push('          </div>');
                htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
                htmlArr.push('        </div>');
                htmlArr.push('      </li>');

                htmlArr.push('      <li class="minutePanel">');
                htmlArr.push('        <h3>分</h3>');
                htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
                htmlArr.push('          <div class="calender-inner">');
                htmlArr.push('          </div>');
                htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
                htmlArr.push('        </div>');
                htmlArr.push('      </li>');

                if (!this.ignoreSecondPanel) {
                    htmlArr.push('      <li class="secondPanel">');
                    htmlArr.push('        <h3>秒</h3>');
                    htmlArr.push('        <div class="ctimeblock_c calender-wrap">');
                    htmlArr.push('          <div class="calender-inner">');
                    htmlArr.push('          </div>');
                    htmlArr.push('          <span class="bottomred1"></span><span class="bottomred2"></span>');
                    htmlArr.push('        </div>');
                    htmlArr.push('      </li>');
                }
            }

            htmlArr.push('    </ul>');
            htmlArr.push('<div class="buttons">');
            htmlArr.push('    <div class="calendar_cancel_button am-clickable" style="z-index:199;">取消</div>');
            htmlArr.push('    <div class="save_button am-clickable" style="z-index:199;">设置</div>');
            htmlArr.push('</div>');
            htmlArr.push('  </div>');
            htmlArr.push('</div>');
            htmlArr.push('</div>');
            $("body").append(htmlArr.join(""));
            this.bind().show();
        },
        bind: function () {
            var self = this;
            this.$ = $("#" + this.id);
            this.$yearPanel = this.$.find(".yearPanel");
            this.$yearPanelWrap = this.$yearPanel.find(".calender-wrap");
            this.$yearPanelInner = this.$yearPanel.find(".calender-inner");

            this.$monthPanel = this.$.find(".monthPanel");
            this.$monthPanelWrap = this.$monthPanel.find(".calender-wrap");
            this.$monthPanelInner = this.$monthPanel.find(".calender-inner");

            this.$datePanel = this.$.find(".datePanel");
            this.$datePanelWrap = this.$datePanel.find(".calender-wrap");
            this.$datePanelInner = this.$datePanel.find(".calender-inner");

            if (this.showTimeControl) {
                this.$hourPanel = this.$.find(".hourPanel");
                this.$hourPanelWrap = this.$hourPanel.find(".calender-wrap");
                this.$hourPanelInner = this.$hourPanel.find(".calender-inner");

                this.$minutePanel = this.$.find(".minutePanel");
                this.$minutePanelWrap = this.$minutePanel.find(".calender-wrap");
                this.$minutePanelInner = this.$minutePanel.find(".calender-inner");

                if (!this.ignoreSecondPanel) {
                    this.$secondPanel = this.$.find(".secondPanel");
                    this.$secondPanelWrap = this.$secondPanel.find(".calender-wrap");
                    this.$secondPanelInner = this.$secondPanel.find(".calender-inner");
                }
            }

            this.$.find(".save_button").on("vclick", function (e) {
                var dateArr = [], timeArr = [],
                    indexYear = self.startYear + Math.round((self.$yearScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$yearScroll._currentPos[1]) / self.gridHeight + 1))),
                    indexMonth = Math.round(self.$monthScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$monthScroll._currentPos[1]) / self.gridHeight + 1)),
                    indexDate = Math.round(self.$dateScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$dateScroll._currentPos[1]) / self.gridHeight + 1));
                dateArr.push(indexYear);
                dateArr.push(self.monthList[indexMonth] < 10 ? '0' + self.monthList[indexMonth] : self.monthList[indexMonth]);
                dateArr.push(self.dateList[indexDate] < 10 ? '0' + self.dateList[indexDate] : self.dateList[indexDate]);

                if (self.showTimeControl) {
                    var indexHour = indexMinute = indexSecond = null;
                    indexHour = Math.round(self.$hourScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$hourScroll._currentPos[1]) / self.gridHeight + 1));
                    indexMinute = Math.round(self.$minuteScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$minuteScroll._currentPos[1]) / self.gridHeight + 1));
                    console.log('indexMinute=' + indexMinute + 'realMinute = ' + self.minuteList[indexMinute]);
                    if (!self.ignoreSecondPanel) {
                        indexSecond = Math.round(self.$secondScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$secondScroll._currentPos[1]) / self.gridHeight + 1));
                    }
                    timeArr.push(self.hourList[indexHour] < 10 ? '0' + self.hourList[indexHour] : self.hourList[indexHour]);
                    timeArr.push(self.minuteList[indexMinute] < 10 ? '0' + self.minuteList[indexMinute] : self.minuteList[indexMinute]);
                    if (!self.ignoreSecondPanel) {
                        timeArr.push(self.secondList[indexSecond] < 10 ? '0' + self.secondList[indexSecond] : self.secondList[indexSecond]);
                    }
                }
                //console.log(timeArr.join(":"));
                //self.inputObject.val(timeArr.length>0?[dateArr.join("-"),timeArr.join(self.timeDelimiter)].join(" "):dateArr.join("-"));
                self.inputObject.val(timeArr.length > 0 ? [dateArr.join("-"), timeArr.join(self.timeDelimiter)].join(" ") : dateArr[0] + '-' + dateArr[1] + '-' + dateArr[2]);
                self.hide();
                return false;
            });

            this.$.find(".calendar_cancel_button").on("vclick", function (e) {
                self.hide();
                return false;
            });
            return this;
        },
        unbind: function () {
            this.$.find(".save_button").unbind("vclick");
            this.$.find(".calendar_cancel_button").unbind("vclick");
        },
        show: function () {
            var self = this,
                year = this.year, month = this.month, date = this.date,
                hour = this.showTimeControl ? this.hour : null,
                minute = this.showTimeControl ? parseInt(this.minute) : null,
                second = this.showTimeControl ? this.second : null;
            var yearStep = monthStep = dateStep = hourStep = minuteStep = secondStep = 0;
            this.showYear(year).showMonth(month).showDate(year, month, date);
            if (this.showTimeControl) {
                this.showHour(hour).showMinute(minute);
                if (!this.ignoreSecondPanel) {
                    this.showSecond(second);
                }
                //change the layer height.
                var h = this.$.find(".calendar_layer").height();
                this.$.find(".calendar_layer").css("height", (h + 160) + 'px');
            }
            this.$.show();
            //fetch the grid height.
            this.gridHeight = self.$yearPanelInner.find("p").height();
            this.$yearScroll = new $.am.ScrollView({
                $wrap: self.$yearPanelWrap,
                $inner: self.$yearPanelInner,
                $momentumProperties: {easing: "linear", girdHeight: self.gridHeight, increament: self.increament},
                $callback: function (obj) {
                    self.maxShowDate !== false ? self.refreshMaxDate(obj, 'y') : self.refreshDate(obj);
                },
                $caller: self
            });
            this.$monthScroll = new $.am.ScrollView({
                $wrap: self.$monthPanelWrap,
                $inner: self.$monthPanelInner,
                $momentumProperties: {easing: "linear", girdHeight: self.gridHeight, increament: self.increament},
                $callback: function (obj) {
                    self.maxShowDate !== false ? self.refreshMaxDate(obj, 'm') : self.refreshDate(obj);
                },
                $caller: self
            });
            this.$dateScroll = new $.am.ScrollView({
                $wrap: self.$datePanelWrap,
                $inner: self.$datePanelInner,
                $momentumProperties: {easing: "linear", girdHeight: self.gridHeight, increament: self.increament}
            });
            monthStep = self.monthList[month] >= 2 * self.increament ? 2 * self.increament - self.monthList[month] : self.monthList[month];
            dateStep = self.dateList[date - 1] >= 2 * self.increament ? 2 * self.increament - self.dateList[date - 1] : self.dateList[date - 1];

            this.$yearScroll.scrollTo([0, (year <= 0) ? (self.gridHeight * (year - this.startYear + self.increament)) : (-(self.gridHeight * (year - this.startYear > 1 ? year - this.startYear - 1 : 0)))]);
            this.$monthScroll.scrollTo([0, self.gridHeight * monthStep]);
            this.$dateScroll.scrollTo([0, self.gridHeight * dateStep]);

            this.$yearScroll.refresh();
            this.$monthScroll.refresh();
            this.$dateScroll.refresh();

            if (this.showTimeControl) {
                this.$hourScroll = new $.am.ScrollView({
                    $wrap: self.$hourPanelWrap,
                    $inner: self.$hourPanelInner,
                    $momentumProperties: {easing: "linear", girdHeight: self.gridHeight, increament: self.increament}
                });
                this.$minuteScroll = new $.am.ScrollView({
                    $wrap: self.$minutePanelWrap,
                    $inner: self.$minutePanelInner,
                    $momentumProperties: {easing: "linear", girdHeight: self.gridHeight, increament: self.increament}
                });
                if (!this.ignoreSecondPanel) {
                    this.$secondScroll = new $.am.ScrollView({
                        $wrap: self.$secondPanelWrap,
                        $inner: self.$secondPanelInner,
                        $momentumProperties: {
                            easing: "linear",
                            girdHeight: self.gridHeight,
                            increament: self.increament
                        }
                    });
                }
                hourStep = self.hourList[hour] + 1 >= 2 * self.increament ? 2 * self.increament - (self.hourList[hour] + 1) : self.hourList[hour] + 1;
                this.$hourScroll.scrollTo([0, self.gridHeight * hourStep]);
                if (this.minuteInterval == 1) {
                    minuteStep = self.minuteList[minute] + 1 >= 2 * self.increament ? 2 * self.increament - (self.minuteList[minute] + 1) : self.minuteList[minute] + 1;
                } else {
                    minute = Math.floor(minute / this.minuteInterval);
                    minuteStep = (minute + 1 >= 2 * self.increament ? 2 * self.increament - (minute + 1) : minute + 1);
                }
                this.$minuteScroll.scrollTo([0, self.gridHeight * minuteStep]);
                if (!this.ignoreSecondPanel) {
                    secondStep = self.secondList[second] + 1 >= 2 * self.increament ? 2 * self.increament - (self.secondList[second] + 1) : self.secondList[second] + 1;
                    this.$secondScroll.scrollTo([0, self.gridHeight * secondStep]);
                }
                this.$hourScroll.refresh();
                this.$minuteScroll.refresh();
                if (!this.ignoreSecondPanel) {
                    this.$secondScroll.refresh();
                }
            }
            this.initFinished = true;
        },
        showYear: function (year) {
            var yearArr = [];
            for (var i = this.startYear; i < this.endYear; i++) {
                yearArr.push('<p >' + i + '</p>');
            }
            this.$yearPanelInner.html(yearArr.join(""));
            return this;
        },
        showMonth: function (month) {
            var monthArr = [];
            var end = 12;
            if (this.maxShowDate !== false) {
                if (this.initFinished === false) {
                    if (this.maxYear == this.year) end = this.maxMonth;
                } else {
                    var indexYear = this.startYear + Math.round((this.$yearScroll._currentPos[1] > 0 ? 0 : (Math.abs(this.$yearScroll._currentPos[1]) / this.gridHeight + 1)));
                    console.log('indexY=' + indexYear + ',maxY=' + this.maxYear + ',maxM=' + this.maxMonth);
                    end = indexYear == this.maxYear ? this.maxMonth : 12;
                }
            }
            console.log('------------month end-----------' + end);
            for (var i = 0; i < end; i++) {
                monthArr.push('<p>' + this.monthList[i] + '</p>');
            }
            this.$monthPanelInner.html(monthArr.join(""));
            return this;
        },
        showDate: function (year, month, date) {
            var dateArr = [];
            var days = (new Date(year, month + 1, 0)).getDate();
            var end = days;
            if (this.maxShowDate !== false) {
                if (this.initFinished === true) {
                    var indexYear = this.startYear + Math.round((this.$yearScroll._currentPos[1] > 0 ? 0 : (Math.abs(this.$yearScroll._currentPos[1]) / this.gridHeight + 1))),
                        indexMonth = Math.round(this.$monthScroll._currentPos[1] > 0 ? 0 : (Math.abs(this.$monthScroll._currentPos[1]) / this.gridHeight + 1));
                    end = (indexYear == this.maxYear && this.monthList[indexMonth] >= this.maxMonth) ? this.maxDate : days;
                }
            }
            console.log('------------date end-----------' + end);
            //for (var i = 0; i< days; i++ ) {
            for (var i = 0; i < end; i++) {
                dateArr.push('<p>' + this.dateList[i] + '</p>');
            }
            this.$datePanelInner.html(dateArr.join(""));
            return this;
        },
        refreshDate: function (dateObject) {
            var self = this,
                indexYear = self.startYear + (self.$yearScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$yearScroll._currentPos[1]) / self.gridHeight + 1)),
                indexMonth = self.$monthScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$monthScroll._currentPos[1]) / self.gridHeight + 1),
                indexDate = self.$dateScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$dateScroll._currentPos[1]) / self.gridHeight + 1);
            console.log('indexDate=' + indexDate + ',realDate=' + self.dateList[indexDate]);
            console.log('indexYear=' + indexYear + ',indexMonth=' + indexMonth);
            self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
            self.$dateScroll.refresh();
            var days = (new Date(indexYear, indexMonth + 1, 0)).getDate();
            var newDate = self.dateList[indexDate] > days ? days : self.dateList[indexDate];
            var moveToY = (newDate <= 0) ? (self.gridHeight * (newDate + self.increament)) : (-(self.gridHeight * (newDate > 1 ? newDate - 1 : 0))) + 40;
            console.log('days=' + days + ',newDate=' + newDate + ',moveToY=' + moveToY);
            self.$dateScroll.scrollTo([0, moveToY]);
            self.$dateScroll.refresh();
        },
        refreshMaxDate: function (dateObject, type) {
            var self = this,
                indexYear = self.startYear + (self.$yearScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$yearScroll._currentPos[1]) / self.gridHeight + 1)),
                indexMonth = self.$monthScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$monthScroll._currentPos[1]) / self.gridHeight + 1),
                indexDate = self.$dateScroll._currentPos[1] > 0 ? 0 : (Math.abs(self.$dateScroll._currentPos[1]) / self.gridHeight + 1);
            console.log('----refreshMaxDate start----');
            console.log('indexDate=' + indexDate + ',realDate=' + self.dateList[indexDate]);
            console.log('indexYear=' + indexYear + ',indexMonth=' + indexMonth);
            console.log('----refreshMaxDate end----');

            console.log('maxY=' + this.maxYear + ',indexY=' + indexYear + ',res=' + (this.maxYear == indexYear));
            if (this.maxYear == indexYear) {
                console.log('-----equals year---');
                //refresh month;
                if (type == 'y') {
                    console.log('-----year---');
                    self.showMonth(indexMonth);
                    self.$monthScroll.refresh();
                    var newMonth = self.monthList[indexMonth] > this.maxMonth ? this.maxMonth : self.monthList[indexMonth];
                    var monthMoveToY = (newMonth >= 2 * self.increament ? 2 * self.increament - newMonth : newMonth) * self.gridHeight;
                    console.log('newMonth=' + newMonth + ',moveToY=' + monthMoveToY);
                    self.$monthScroll.scrollTo([0, monthMoveToY]);
                    self.$monthScroll.refresh();
                }
                //refresh day;
                if (this.maxMonth <= self.monthList[indexMonth]) {
                    self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
                    self.$dateScroll.refresh();
                    console.log('indexDate=' + self.dateList[indexDate] + ',maxDate=' + this.maxDate);
                    var newDate = self.dateList[indexDate] > this.maxDate ? this.maxDate : self.dateList[indexDate];
                    var dayMoveToY = (newDate <= 0) ? (self.gridHeight * (newDate + self.increament)) : (-(self.gridHeight * (newDate > 1 ? newDate - 1 : 0))) + 40;
                    console.log('newDate=' + newDate + ',moveToY=' + dayMoveToY);
                    self.$dateScroll.scrollTo([0, dayMoveToY]);
                    self.$dateScroll.refresh();
                } else {
                    self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
                    self.$dateScroll.refresh();

                    self.refreshDate(dateObject);
                }
            } else {
                //还原
                self.showMonth();
                self.$monthScroll.refresh();

                self.showDate(indexYear, indexMonth, self.dateList[indexDate]);
                self.$dateScroll.refresh();

                self.refreshDate(dateObject);
            }
        },
        showHour: function (hour) {
            var hourArr = [];
            for (var i = 0; i < 24; i++) {
                hourArr.push('<p >' + (this.hourList[i] > 9 ? this.hourList[i] : '0' + this.hourList[i]) + '</p>');
            }
            this.$hourPanelInner.html(hourArr.join(""));
            return this;
        },
        showMinute: function (minute) {
            var minuteArr = [], len = this.minuteList.length;
            for (var i = 0; i < len; i++) {
                minuteArr.push('<p>' + (this.minuteList[i] > 9 ? this.minuteList[i] : '0' + this.minuteList[i]) + '</p>');
            }
            this.$minutePanelInner.html(minuteArr.join(""));
            return this;
        },
        showSecond: function (second) {
            var secondArr = [];
            for (var i = 0; i < 60; i++) {
                secondArr.push('<p>' + (this.secondList[i] > 9 ? this.secondList[i] : '0' + this.secondList[i]) + '</p>');
            }
            this.$secondPanelInner.html(secondArr.join(""));
            return this;
        },
        hide: function () {
            var self = this;
            this.unbind();
            //delay 350ms for preventing the bottom input focus event from being triggered.
            /*      $('._calendar_mask').fadeOut(350, function(){
             $(this).remove();
             self.$.remove();
             });*/
            $('._calendar_mask').css('pointer-events', 'none');
            setTimeout(function () {
                $('._calendar_mask').css('pointer-events', 'auto');
                self.$.remove();
                $('._calendar_mask').remove();
            }, 400);
        }
    });
    $.am.DatePicker = DatePicker;
})(window, jQuery);;
///<jscompress sourcefile="jquery.md5.js" />
/*
 * jQuery MD5 Plugin 1.2.1
 * https://github.com/blueimp/jQuery-MD5
 *
 * Copyright 2010, Sebastian Tschan
 * https://blueimp.net
 *
 * Licensed under the MIT license:
 * http://creativecommons.org/licenses/MIT/
 * 
 * Based on
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*jslint bitwise: true */
/*global unescape, jQuery */

(function ($) {
    'use strict';

    /*
    * Add integers, wrapping at 2^32. This uses 16-bit operations internally
    * to work around bugs in some JS interpreters.
    */
    function safe_add(x, y) {
        var lsw = (x & 0xFFFF) + (y & 0xFFFF),
            msw = (x >> 16) + (y >> 16) + (lsw >> 16);
        return (msw << 16) | (lsw & 0xFFFF);
    }

    /*
    * Bitwise rotate a 32-bit number to the left.
    */
    function bit_rol(num, cnt) {
        return (num << cnt) | (num >>> (32 - cnt));
    }

    /*
    * These functions implement the four basic operations the algorithm uses.
    */
    function md5_cmn(q, a, b, x, s, t) {
        return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
    }
    function md5_ff(a, b, c, d, x, s, t) {
        return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
    }
    function md5_gg(a, b, c, d, x, s, t) {
        return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
    }
    function md5_hh(a, b, c, d, x, s, t) {
        return md5_cmn(b ^ c ^ d, a, b, x, s, t);
    }
    function md5_ii(a, b, c, d, x, s, t) {
        return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
    }

    /*
    * Calculate the MD5 of an array of little-endian words, and a bit length.
    */
    function binl_md5(x, len) {
        /* append padding */
        x[len >> 5] |= 0x80 << ((len) % 32);
        x[(((len + 64) >>> 9) << 4) + 14] = len;

        var i, olda, oldb, oldc, oldd,
            a =  1732584193,
            b = -271733879,
            c = -1732584194,
            d =  271733878;

        for (i = 0; i < x.length; i += 16) {
            olda = a;
            oldb = b;
            oldc = c;
            oldd = d;

            a = md5_ff(a, b, c, d, x[i],       7, -680876936);
            d = md5_ff(d, a, b, c, x[i +  1], 12, -389564586);
            c = md5_ff(c, d, a, b, x[i +  2], 17,  606105819);
            b = md5_ff(b, c, d, a, x[i +  3], 22, -1044525330);
            a = md5_ff(a, b, c, d, x[i +  4],  7, -176418897);
            d = md5_ff(d, a, b, c, x[i +  5], 12,  1200080426);
            c = md5_ff(c, d, a, b, x[i +  6], 17, -1473231341);
            b = md5_ff(b, c, d, a, x[i +  7], 22, -45705983);
            a = md5_ff(a, b, c, d, x[i +  8],  7,  1770035416);
            d = md5_ff(d, a, b, c, x[i +  9], 12, -1958414417);
            c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
            b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
            a = md5_ff(a, b, c, d, x[i + 12],  7,  1804603682);
            d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
            c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
            b = md5_ff(b, c, d, a, x[i + 15], 22,  1236535329);

            a = md5_gg(a, b, c, d, x[i +  1],  5, -165796510);
            d = md5_gg(d, a, b, c, x[i +  6],  9, -1069501632);
            c = md5_gg(c, d, a, b, x[i + 11], 14,  643717713);
            b = md5_gg(b, c, d, a, x[i],      20, -373897302);
            a = md5_gg(a, b, c, d, x[i +  5],  5, -701558691);
            d = md5_gg(d, a, b, c, x[i + 10],  9,  38016083);
            c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
            b = md5_gg(b, c, d, a, x[i +  4], 20, -405537848);
            a = md5_gg(a, b, c, d, x[i +  9],  5,  568446438);
            d = md5_gg(d, a, b, c, x[i + 14],  9, -1019803690);
            c = md5_gg(c, d, a, b, x[i +  3], 14, -187363961);
            b = md5_gg(b, c, d, a, x[i +  8], 20,  1163531501);
            a = md5_gg(a, b, c, d, x[i + 13],  5, -1444681467);
            d = md5_gg(d, a, b, c, x[i +  2],  9, -51403784);
            c = md5_gg(c, d, a, b, x[i +  7], 14,  1735328473);
            b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);

            a = md5_hh(a, b, c, d, x[i +  5],  4, -378558);
            d = md5_hh(d, a, b, c, x[i +  8], 11, -2022574463);
            c = md5_hh(c, d, a, b, x[i + 11], 16,  1839030562);
            b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
            a = md5_hh(a, b, c, d, x[i +  1],  4, -1530992060);
            d = md5_hh(d, a, b, c, x[i +  4], 11,  1272893353);
            c = md5_hh(c, d, a, b, x[i +  7], 16, -155497632);
            b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
            a = md5_hh(a, b, c, d, x[i + 13],  4,  681279174);
            d = md5_hh(d, a, b, c, x[i],      11, -358537222);
            c = md5_hh(c, d, a, b, x[i +  3], 16, -722521979);
            b = md5_hh(b, c, d, a, x[i +  6], 23,  76029189);
            a = md5_hh(a, b, c, d, x[i +  9],  4, -640364487);
            d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
            c = md5_hh(c, d, a, b, x[i + 15], 16,  530742520);
            b = md5_hh(b, c, d, a, x[i +  2], 23, -995338651);

            a = md5_ii(a, b, c, d, x[i],       6, -198630844);
            d = md5_ii(d, a, b, c, x[i +  7], 10,  1126891415);
            c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
            b = md5_ii(b, c, d, a, x[i +  5], 21, -57434055);
            a = md5_ii(a, b, c, d, x[i + 12],  6,  1700485571);
            d = md5_ii(d, a, b, c, x[i +  3], 10, -1894986606);
            c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
            b = md5_ii(b, c, d, a, x[i +  1], 21, -2054922799);
            a = md5_ii(a, b, c, d, x[i +  8],  6,  1873313359);
            d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
            c = md5_ii(c, d, a, b, x[i +  6], 15, -1560198380);
            b = md5_ii(b, c, d, a, x[i + 13], 21,  1309151649);
            a = md5_ii(a, b, c, d, x[i +  4],  6, -145523070);
            d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
            c = md5_ii(c, d, a, b, x[i +  2], 15,  718787259);
            b = md5_ii(b, c, d, a, x[i +  9], 21, -343485551);

            a = safe_add(a, olda);
            b = safe_add(b, oldb);
            c = safe_add(c, oldc);
            d = safe_add(d, oldd);
        }
        return [a, b, c, d];
    }

    /*
    * Convert an array of little-endian words to a string
    */
    function binl2rstr(input) {
        var i,
            output = '';
        for (i = 0; i < input.length * 32; i += 8) {
            output += String.fromCharCode((input[i >> 5] >>> (i % 32)) & 0xFF);
        }
        return output;
    }

    /*
    * Convert a raw string to an array of little-endian words
    * Characters >255 have their high-byte silently ignored.
    */
    function rstr2binl(input) {
        var i,
            output = [];
        output[(input.length >> 2) - 1] = undefined;
        for (i = 0; i < output.length; i += 1) {
            output[i] = 0;
        }
        for (i = 0; i < input.length * 8; i += 8) {
            output[i >> 5] |= (input.charCodeAt(i / 8) & 0xFF) << (i % 32);
        }
        return output;
    }

    /*
    * Calculate the MD5 of a raw string
    */
    function rstr_md5(s) {
        return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
    }

    /*
    * Calculate the HMAC-MD5, of a key and some data (raw strings)
    */
    function rstr_hmac_md5(key, data) {
        var i,
            bkey = rstr2binl(key),
            ipad = [],
            opad = [],
            hash;
        ipad[15] = opad[15] = undefined;                        
        if (bkey.length > 16) {
            bkey = binl_md5(bkey, key.length * 8);
        }
        for (i = 0; i < 16; i += 1) {
            ipad[i] = bkey[i] ^ 0x36363636;
            opad[i] = bkey[i] ^ 0x5C5C5C5C;
        }
        hash = binl_md5(ipad.concat(rstr2binl(data)), 512 + data.length * 8);
        return binl2rstr(binl_md5(opad.concat(hash), 512 + 128));
    }

    /*
    * Convert a raw string to a hex string
    */
    function rstr2hex(input) {
        var hex_tab = '0123456789abcdef',
            output = '',
            x,
            i;
        for (i = 0; i < input.length; i += 1) {
            x = input.charCodeAt(i);
            output += hex_tab.charAt((x >>> 4) & 0x0F) +
                hex_tab.charAt(x & 0x0F);
        }
        return output;
    }

    /*
    * Encode a string as utf-8
    */
    function str2rstr_utf8(input) {
        return unescape(encodeURIComponent(input));
    }

    /*
    * Take string arguments and return either raw or hex encoded strings
    */
    function raw_md5(s) {
        return rstr_md5(str2rstr_utf8(s));
    }
    function hex_md5(s) {
        return rstr2hex(raw_md5(s));
    }
    function raw_hmac_md5(k, d) {
        return rstr_hmac_md5(str2rstr_utf8(k), str2rstr_utf8(d));
    }
    function hex_hmac_md5(k, d) {
        return rstr2hex(raw_hmac_md5(k, d));
    }
    
    $.md5 = function (string, key, raw) {
        if (!key) {
            if (!raw) {
                return hex_md5(string);
            } else {
                return raw_md5(string);
            }
        }
        if (!raw) {
            return hex_hmac_md5(key, string);
        } else {
            return raw_hmac_md5(key, string);
        }
    };
    
}(typeof jQuery === 'function' ? jQuery : this));;
///<jscompress sourcefile="decode.js" />
(function ($) {
    $.b64 = function (options) {
        var defaults = {
            data: "",
            type: 0,
            unicode: true
        };
        var opts = $.extend(defaults, options);
        var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

        UnicodeChr = function () {
            return '00A4,00A7,00A8,00B0,00B1,00B7,00D7,00E0,00E1,00E8,00E9,00EA,00EC,00ED,00F2,00F3,00F7,00F9,00FA,00FC,0101,0113,011B,012B,014D,016B,01CE,01D0,01D2,01D4,01D6,01D8,01DA,01DC,02C7,02C9,0391,0392,0393,0394,0395,0396,0397,0398,0399,039A,039B,039C,039D,039E,039F,03A0,03A1,03A3,03A4,03A5,03A6,03A7,03A8,03A9,03B1,03B2,03B3,03B4,03B5,03B6,03B7,03B8,03B9,03BA,03BB,03BC,03BD,03BE,03BF,03C0,03C1,03C3,03C4,03C5,03C6,03C7,03C8,03C9,0401,0410,0411,0412,0413,0414,0415,0416,0417,0418,0419,041A,041B,041C,041D,041E,041F,0420,0421,0422,0423,0424,0425,0426,0427,0428,0429,042A,042B,042C,042D,042E,042F,0430,0431,0432,0433,0434,0435,0436,0437,0438,0439,043A,043B,043C,043D,043E,043F,0440,0441,0442,0443,0444,0445,0446,0447,0448,0449,044A,044B,044C,044D,044E,044F,0451,2014,2016,2018,2019,201C,201D,2026,2030,2032,2033,203B,2103,2116,2160,2161,2162,2163,2164,2165,2166,2167,2168,2169,216A,216B,2190,2191,2192,2193,2208,220F,2211,221A,221D,221E,2220,2225,2227,2228,2229,222A,222B,222E,2234,2235,2236,2237,223D,2248,224C,2260,2261,2264,2265,226E,226F,2299,22A5,2312,2460,2461,2462,2463,2464,2465,2466,2467,2468,2469,2474,2475,2476,2477,2478,2479,247A,247B,247C,247D,247E,247F,2480,2481,2482,2483,2484,2485,2486,2487,2488,2489,248A,248B,248C,248D,248E,248F,2490,2491,2492,2493,2494,2495,2496,2497,2498,2499,249A,249B,2500,2501,2502,2503,2504,2505,2506,2507,2508,2509,250A,250B,250C,250D,250E,250F,2510,2511,2512,2513,2514,2515,2516,2517,2518,2519,251A,251B,251C,251D,251E,251F,2520,2521,2522,2523,2524,2525,2526,2527,2528,2529,252A,252B,252C,252D,252E,252F,2530,2531,2532,2533,2534,2535,2536,2537,2538,2539,253A,253B,253C,253D,253E,253F,2540,2541,2542,2543,2544,2545,2546,2547,2548,2549,254A,254B,25A0,25A1,25B2,25B3,25C6,25C7,25CB,25CE,25CF,2605,2606,2640,2642,3000,3001,3002,3003,3005,3008,3009,300A,300B,300C,300D,300E,300F,3010,3011,3013,3014,3015,3016,3017,3041,3042,3043,3044,3045,3046,3047,3048,3049,304A,304B,304C,304D,304E,304F,3050,3051,3052,3053,3054,3055,3056,3057,3058,3059,305A,305B,305C,305D,305E,305F,3060,3061,3062,3063,3064,3065,3066,3067,3068,3069,306A,306B,306C,306D,306E,306F,3070,3071,3072,3073,3074,3075,3076,3077,3078,3079,307A,307B,307C,307D,307E,307F,3080,3081,3082,3083,3084,3085,3086,3087,3088,3089,308A,308B,308C,308D,308E,308F,3090,3091,3092,3093,30A1,30A2,30A3,30A4,30A5,30A6,30A7,30A8,30A9,30AA,30AB,30AC,30AD,30AE,30AF,30B0,30B1,30B2,30B3,30B4,30B5,30B6,30B7,30B8,30B9,30BA,30BB,30BC,30BD,30BE,30BF,30C0,30C1,30C2,30C3,30C4,30C5,30C6,30C7,30C8,30C9,30CA,30CB,30CC,30CD,30CE,30CF,30D0,30D1,30D2,30D3,30D4,30D5,30D6,30D7,30D8,30D9,30DA,30DB,30DC,30DD,30DE,30DF,30E0,30E1,30E2,30E3,30E4,30E5,30E6,30E7,30E8,30E9,30EA,30EB,30EC,30ED,30EE,30EF,30F0,30F1,30F2,30F3,30F4,30F5,30F6,3105,3106,3107,3108,3109,310A,310B,310C,310D,310E,310F,3110,3111,3112,3113,3114,3115,3116,3117,3118,3119,311A,311B,311C,311D,311E,311F,3120,3121,3122,3123,3124,3125,3126,3127,3128,3129,3220,3221,3222,3223,3224,3225,3226,3227,3228,3229,4E00,4E01,4E03,4E07,4E08,4E09,4E0A,4E0B,4E0C,4E0D,4E0E,4E10,4E11,4E13,4E14,4E15,4E16,4E18,4E19,4E1A,4E1B,4E1C,4E1D,4E1E,4E22,4E24,4E25,4E27,4E28,4E2A,4E2B,4E2C,4E2D,4E30,4E32,4E34,4E36,4E38,4E39,4E3A,4E3B,4E3D,4E3E,4E3F,4E43,4E45,4E47,4E48,4E49,4E4B,4E4C,4E4D,4E4E,4E4F,4E50,4E52,4E53,4E54,4E56,4E58,4E59,4E5C,4E5D,4E5E,4E5F,4E60,4E61,4E66,4E69,4E70,4E71,4E73,4E7E,4E86,4E88,4E89,4E8B,4E8C,4E8D,4E8E,4E8F,4E91,4E92,4E93,4E94,4E95,4E98,4E9A,4E9B,4E9F,4EA0,4EA1,4EA2,4EA4,4EA5,4EA6,4EA7,4EA8,4EA9,4EAB,4EAC,4EAD,4EAE,4EB2,4EB3,4EB5,4EBA,4EBB,4EBF,4EC0,4EC1,4EC2,4EC3,4EC4,4EC5,4EC6,4EC7,4EC9,4ECA,4ECB,4ECD,4ECE,4ED1,4ED3,4ED4,4ED5,4ED6,4ED7,4ED8,4ED9,4EDD,4EDE,4EDF,4EE1,4EE3,4EE4,4EE5,4EE8,4EEA,4EEB,4EEC,4EF0,4EF2,4EF3,4EF5,4EF6,4EF7,4EFB,4EFD,4EFF,4F01,4F09,4F0A,4F0D,4F0E,4F0F,4F10,4F11,4F17,4F18,4F19,4F1A,4F1B,4F1E,4F1F,4F20,4F22,4F24,4F25,4F26,4F27,4F2A,4F2B,4F2F,4F30,4F32,4F34,4F36,4F38,4F3A,4F3C,4F3D,4F43,4F46,4F4D,4F4E,4F4F,4F50,4F51,4F53,4F55,4F57,4F58,4F59,4F5A,4F5B,4F5C,4F5D,4F5E,4F5F,4F60,4F63,4F64,4F65,4F67,4F69,4F6C,4F6F,4F70,4F73,4F74,4F76,4F7B,4F7C,4F7E,4F7F,4F83,4F84,4F88,4F89,4F8B,4F8D,4F8F,4F91,4F94,4F97,4F9B,4F9D,4FA0,4FA3,4FA5,4FA6,4FA7,4FA8,4FA9,4FAA,4FAC,4FAE,4FAF,4FB5,4FBF,4FC3,4FC4,4FC5,4FCA,4FCE,4FCF,4FD0,4FD1,4FD7,4FD8,4FDA,4FDC,4FDD,4FDE,4FDF,4FE1,4FE3,4FE6,4FE8,4FE9,4FEA,4FED,4FEE,4FEF,4FF1,4FF3,4FF8,4FFA,4FFE,500C,500D,500F,5012,5014,5018,5019,501A,501C,501F,5021,5025,5026,5028,5029,502A,502C,502D,502E,503A,503C,503E,5043,5047,5048,504C,504E,504F,5055,505A,505C,5065,506C,5076,5077,507B,507E,507F,5080,5085,5088,508D,50A3,50A5,50A7,50A8,50A9,50AC,50B2,50BA,50BB,50CF,50D6,50DA,50E6,50E7,50EC,50ED,50EE,50F3,50F5,50FB,5106,5107,510B,5112,5121,513F,5140,5141,5143,5144,5145,5146,5148,5149,514B,514D,5151,5154,5155,5156,515A,515C,5162,5165,5168,516B,516C,516D,516E,5170,5171,5173,5174,5175,5176,5177,5178,5179,517B,517C,517D,5180,5181,5182,5185,5188,5189,518C,518D,5192,5195,5196,5197,5199,519B,519C,51A0,51A2,51A4,51A5,51AB,51AC,51AF,51B0,51B1,51B2,51B3,51B5,51B6,51B7,51BB,51BC,51BD,51C0,51C4,51C6,51C7,51C9,51CB,51CC,51CF,51D1,51DB,51DD,51E0,51E1,51E4,51EB,51ED,51EF,51F0,51F3,51F5,51F6,51F8,51F9,51FA,51FB,51FC,51FD,51FF,5200,5201,5202,5203,5206,5207,5208,520A,520D,520E,5211,5212,5216,5217,5218,5219,521A,521B,521D,5220,5224,5228,5229,522B,522D,522E,5230,5233,5236,5237,5238,5239,523A,523B,523D,523F,5240,5241,5242,5243,524A,524C,524D,5250,5251,5254,5256,525C,525E,5261,5265,5267,5269,526A,526F,5272,527D,527F,5281,5282,5288,5290,5293,529B,529D,529E,529F,52A0,52A1,52A2,52A3,52A8,52A9,52AA,52AB,52AC,52AD,52B1,52B2,52B3,52BE,52BF,52C3,52C7,52C9,52CB,52D0,52D2,52D6,52D8,52DF,52E4,52F0,52F9,52FA,52FE,52FF,5300,5305,5306,5308,530D,530F,5310,5315,5316,5317,5319,531A,531D,5320,5321,5323,5326,532A,532E,5339,533A,533B,533E,533F,5341,5343,5345,5347,5348,5349,534A,534E,534F,5351,5352,5353,5355,5356,5357,535A,535C,535E,535F,5360,5361,5362,5363,5364,5366,5367,5369,536B,536E,536F,5370,5371,5373,5374,5375,5377,5378,537A,537F,5382,5384,5385,5386,5389,538B,538C,538D,5395,5398,539A,539D,539F,53A2,53A3,53A5,53A6,53A8,53A9,53AE,53B6,53BB,53BF,53C1,53C2,53C8,53C9,53CA,53CB,53CC,53CD,53D1,53D4,53D6,53D7,53D8,53D9,53DB,53DF,53E0,53E3,53E4,53E5,53E6,53E8,53E9,53EA,53EB,53EC,53ED,53EE,53EF,53F0,53F1,53F2,53F3,53F5,53F6,53F7,53F8,53F9,53FB,53FC,53FD,5401,5403,5404,5406,5408,5409,540A,540C,540D,540E,540F,5410,5411,5412,5413,5415,5416,5417,541B,541D,541E,541F,5420,5421,5423,5426,5427,5428,5429,542B,542C,542D,542E,542F,5431,5432,5434,5435,5438,5439,543B,543C,543E,5440,5443,5446,5448,544A,544B,5450,5452,5453,5454,5455,5456,5457,5458,5459,545B,545C,5462,5464,5466,5468,5471,5472,5473,5475,5476,5477,5478,547B,547C,547D,5480,5482,5484,5486,548B,548C,548E,548F,5490,5492,5494,5495,5496,5499,549A,549B,549D,54A3,54A4,54A6,54A7,54A8,54A9,54AA,54AB,54AC,54AD,54AF,54B1,54B3,54B4,54B8,54BB,54BD,54BF,54C0,54C1,54C2,54C4,54C6,54C7,54C8,54C9,54CC,54CD,54CE,54CF,54D0,54D1,54D2,54D3,54D4,54D5,54D7,54D9,54DA,54DC,54DD,54DE,54DF,54E5,54E6,54E7,54E8,54E9,54EA,54ED,54EE,54F2,54F3,54FA,54FC,54FD,54FF,5501,5506,5507,5509,550F,5510,5511,5514,551B,5520,5522,5523,5524,5527,552A,552C,552E,552F,5530,5531,5533,5537,553C,553E,553F,5541,5543,5544,5546,5549,554A,5550,5555,5556,555C,5561,5564,5565,5566,5567,556A,556C,556D,556E,5575,5576,5577,5578,557B,557C,557E,5580,5581,5582,5583,5584,5587,5588,5589,558A,558B,558F,5591,5594,5598,5599,559C,559D,559F,55A7,55B1,55B3,55B5,55B7,55B9,55BB,55BD,55BE,55C4,55C5,55C9,55CC,55CD,55D1,55D2,55D3,55D4,55D6,55DC,55DD,55DF,55E1,55E3,55E4,55E5,55E6,55E8,55EA,55EB,55EC,55EF,55F2,55F3,55F5,55F7,55FD,55FE,5600,5601,5608,5609,560C,560E,560F,5618,561B,561E,561F,5623,5624,5627,562C,562D,5631,5632,5634,5636,5639,563B,563F,564C,564D,564E,5654,5657,5658,5659,565C,5662,5664,5668,5669,566A,566B,566C,5671,5676,567B,567C,5685,5686,568E,568F,5693,56A3,56AF,56B7,56BC,56CA,56D4,56D7,56DA,56DB,56DD,56DE,56DF,56E0,56E1,56E2,56E4,56EB,56ED,56F0,56F1,56F4,56F5,56F9,56FA,56FD,56FE,56FF,5703,5704,5706,5708,5709,570A,571C,571F,5723,5728,5729,572A,572C,572D,572E,572F,5730,5733,5739,573A,573B,573E,5740,5742,5747,574A,574C,574D,574E,574F,5750,5751,5757,575A,575B,575C,575D,575E,575F,5760,5761,5764,5766,5768,5769,576A,576B,576D,576F,5773,5776,5777,577B,577C,5782,5783,5784,5785,5786,578B,578C,5792,5793,579B,57A0,57A1,57A2,57A3,57A4,57A6,57A7,57A9,57AB,57AD,57AE,57B2,57B4,57B8,57C2,57C3,57CB,57CE,57CF,57D2,57D4,57D5,57D8,57D9,57DA,57DD,57DF,57E0,57E4,57ED,57EF,57F4,57F8,57F9,57FA,57FD,5800,5802,5806,5807,580B,580D,5811,5815,5819,581E,5820,5821,5824,582A,5830,5835,5844,584C,584D,5851,5854,5858,585E,5865,586B,586C,587E,5880,5881,5883,5885,5889,5892,5893,5899,589A,589E,589F,58A8,58A9,58BC,58C1,58C5,58D1,58D5,58E4,58EB,58EC,58EE,58F0,58F3,58F6,58F9,5902,5904,5907,590D,590F,5914,5915,5916,5919,591A,591C,591F,5924,5925,5927,5929,592A,592B,592D,592E,592F,5931,5934,5937,5938,5939,593A,593C,5941,5942,5944,5947,5948,5949,594B,594E,594F,5951,5954,5955,5956,5957,5958,595A,5960,5962,5965,5973,5974,5976,5978,5979,597D,5981,5982,5983,5984,5986,5987,5988,598A,598D,5992,5993,5996,5997,5999,599E,59A3,59A4,59A5,59A8,59A9,59AA,59AB,59AE,59AF,59B2,59B9,59BB,59BE,59C6,59CA,59CB,59D0,59D1,59D2,59D3,59D4,59D7,59D8,59DA,59DC,59DD,59E3,59E5,59E8,59EC,59F9,59FB,59FF,5A01,5A03,5A04,5A05,5A06,5A07,5A08,5A09,5A0C,5A11,5A13,5A18,5A1C,5A1F,5A20,5A23,5A25,5A29,5A31,5A32,5A34,5A36,5A3C,5A40,5A46,5A49,5A4A,5A55,5A5A,5A62,5A67,5A6A,5A74,5A75,5A76,5A77,5A7A,5A7F,5A92,5A9A,5A9B,5AAA,5AB2,5AB3,5AB5,5AB8,5ABE,5AC1,5AC2,5AC9,5ACC,5AD2,5AD4,5AD6,5AD8,5ADC,5AE0,5AE1,5AE3,5AE6,5AE9,5AEB,5AF1,5B09,5B16,5B17,5B32,5B34,5B37,5B40,5B50,5B51,5B53,5B54,5B55,5B57,5B58,5B59,5B5A,5B5B,5B5C,5B5D,5B5F,5B62,5B63,5B64,5B65,5B66,5B69,5B6A,5B6C,5B70,5B71,5B73,5B75,5B7A,5B7D,5B80,5B81,5B83,5B84,5B85,5B87,5B88,5B89,5B8B,5B8C,5B8F,5B93,5B95,5B97,5B98,5B99,5B9A,5B9B,5B9C,5B9D,5B9E,5BA0,5BA1,5BA2,5BA3,5BA4,5BA5,5BA6,5BAA,5BAB,5BB0,5BB3,5BB4,5BB5,5BB6,5BB8,5BB9,5BBD,5BBE,5BBF,5BC2,5BC4,5BC5,5BC6,5BC7,5BCC,5BD0,5BD2,5BD3,5BDD,5BDE,5BDF,5BE1,5BE4,5BE5,5BE8,5BEE,5BF0,5BF8,5BF9,5BFA,5BFB,5BFC,5BFF,5C01,5C04,5C06,5C09,5C0A,5C0F,5C11,5C14,5C15,5C16,5C18,5C1A,5C1C,5C1D,5C22,5C24,5C25,5C27,5C2C,5C31,5C34,5C38,5C39,5C3A,5C3B,5C3C,5C3D,5C3E,5C3F,5C40,5C41,5C42,5C45,5C48,5C49,5C4A,5C4B,5C4E,5C4F,5C50,5C51,5C55,5C59,5C5E,5C60,5C61,5C63,5C65,5C66,5C6E,5C6F,5C71,5C79,5C7A,5C7F,5C81,5C82,5C88,5C8C,5C8D,5C90,5C91,5C94,5C96,5C97,5C98,5C99,5C9A,5C9B,5C9C,5CA2,5CA3,5CA9,5CAB,5CAC,5CAD,5CB1,5CB3,5CB5,5CB7,5CB8,5CBD,5CBF,5CC1,5CC4,5CCB,5CD2,5CD9,5CE1,5CE4,5CE5,5CE6,5CE8,5CEA,5CED,5CF0,5CFB,5D02,5D03,5D06,5D07,5D0E,5D14,5D16,5D1B,5D1E,5D24,5D26,5D27,5D29,5D2D,5D2E,5D34,5D3D,5D3E,5D47,5D4A,5D4B,5D4C,5D58,5D5B,5D5D,5D69,5D6B,5D6C,5D6F,5D74,5D82,5D99,5D9D,5DB7,5DC5,5DCD,5DDB,5DDD,5DDE,5DE1,5DE2,5DE5,5DE6,5DE7,5DE8,5DE9,5DEB,5DEE,5DEF,5DF1,5DF2,5DF3,5DF4,5DF7,5DFD,5DFE,5E01,5E02,5E03,5E05,5E06,5E08,5E0C,5E0F,5E10,5E11,5E14,5E15,5E16,5E18,5E19,5E1A,5E1B,5E1C,5E1D,5E26,5E27,5E2D,5E2E,5E31,5E37,5E38,5E3B,5E3C,5E3D,5E42,5E44,5E45,5E4C,5E54,5E55,5E5B,5E5E,5E61,5E62,5E72,5E73,5E74,5E76,5E78,5E7A,5E7B,5E7C,5E7D,5E7F,5E80,5E84,5E86,5E87,5E8A,5E8B,5E8F,5E90,5E91,5E93,5E94,5E95,5E96,5E97,5E99,5E9A,5E9C,5E9E,5E9F,5EA0,5EA5,5EA6,5EA7,5EAD,5EB3,5EB5,5EB6,5EB7,5EB8,5EB9,5EBE,5EC9,5ECA,5ED1,5ED2,5ED3,5ED6,5EDB,5EE8,5EEA,5EF4,5EF6,5EF7,5EFA,5EFE,5EFF,5F00,5F01,5F02,5F03,5F04,5F08,5F0A,5F0B,5F0F,5F11,5F13,5F15,5F17,5F18,5F1B,5F1F,5F20,5F25,5F26,5F27,5F29,5F2A,5F2D,5F2F,5F31,5F39,5F3A,5F3C,5F40,5F50,5F52,5F53,5F55,5F56,5F57,5F58,5F5D,5F61,5F62,5F64,5F66,5F69,5F6A,5F6C,5F6D,5F70,5F71,5F73,5F77,5F79,5F7B,5F7C,5F80,5F81,5F82,5F84,5F85,5F87,5F88,5F89,5F8A,5F8B,5F8C,5F90,5F92,5F95,5F97,5F98,5F99,5F9C,5FA1,5FA8,5FAA,5FAD,5FAE,5FB5,5FB7,5FBC,5FBD,5FC3,5FC4,5FC5,5FC6,5FC9,5FCC,5FCD,5FCF,5FD0,5FD1,5FD2,5FD6,5FD7,5FD8,5FD9,5FDD,5FE0,5FE1,5FE4,5FE7,5FEA,5FEB,5FED,5FEE,5FF1,5FF5,5FF8,5FFB,5FFD,5FFE,5FFF,6000,6001,6002,6003,6004,6005,6006,600A,600D,600E,600F,6012,6014,6015,6016,6019,601B,601C,601D,6020,6021,6025,6026,6027,6028,6029,602A,602B,602F,6035,603B,603C,603F,6041,6042,6043,604B,604D,6050,6052,6055,6059,605A,605D,6062,6063,6064,6067,6068,6069,606A,606B,606C,606D,606F,6070,6073,6076,6078,6079,607A,607B,607C,607D,607F,6083,6084,6089,608C,608D,6092,6094,6096,609A,609B,609D,609F,60A0,60A3,60A6,60A8,60AB,60AC,60AD,60AF,60B1,60B2,60B4,60B8,60BB,60BC,60C5,60C6,60CA,60CB,60D1,60D5,60D8,60DA,60DC,60DD,60DF,60E0,60E6,60E7,60E8,60E9,60EB,60EC,60ED,60EE,60EF,60F0,60F3,60F4,60F6,60F9,60FA,6100,6101,6106,6108,6109,610D,610E,610F,6115,611A,611F,6120,6123,6124,6126,6127,612B,613F,6148,614A,614C,614E,6151,6155,615D,6162,6167,6168,6170,6175,6177,618B,618E,6194,619D,61A7,61A8,61A9,61AC,61B7,61BE,61C2,61C8,61CA,61CB,61D1,61D2,61D4,61E6,61F5,61FF,6206,6208,620A,620B,620C,620D,620E,620F,6210,6211,6212,6215,6216,6217,6218,621A,621B,621F,6221,6222,6224,6225,622A,622C,622E,6233,6234,6237,623D,623E,623F,6240,6241,6243,6247,6248,6249,624B,624C,624D,624E,6251,6252,6253,6254,6258,625B,6263,6266,6267,6269,626A,626B,626C,626D,626E,626F,6270,6273,6276,6279,627C,627E,627F,6280,6284,6289,628A,6291,6292,6293,6295,6296,6297,6298,629A,629B,629F,62A0,62A1,62A2,62A4,62A5,62A8,62AB,62AC,62B1,62B5,62B9,62BB,62BC,62BD,62BF,62C2,62C4,62C5,62C6,62C7,62C8,62C9,62CA,62CC,62CD,62CE,62D0,62D2,62D3,62D4,62D6,62D7,62D8,62D9,62DA,62DB,62DC,62DF,62E2,62E3,62E5,62E6,62E7,62E8,62E9,62EC,62ED,62EE,62EF,62F1,62F3,62F4,62F6,62F7,62FC,62FD,62FE,62FF,6301,6302,6307,6308,6309,630E,6311,6316,631A,631B,631D,631E,631F,6320,6321,6322,6323,6324,6325,6328,632A,632B,632F,6332,6339,633A,633D,6342,6343,6345,6346,6349,634B,634C,634D,634E,634F,6350,6355,635E,635F,6361,6362,6363,6367,6369,636D,636E,6371,6376,6377,637A,637B,6380,6382,6387,6388,6389,638A,638C,638E,638F,6390,6392,6396,6398,63A0,63A2,63A3,63A5,63A7,63A8,63A9,63AA,63AC,63AD,63AE,63B0,63B3,63B4,63B7,63B8,63BA,63BC,63BE,63C4,63C6,63C9,63CD,63CE,63CF,63D0,63D2,63D6,63DE,63E0,63E1,63E3,63E9,63EA,63ED,63F2,63F4,63F6,63F8,63FD,63FF,6400,6401,6402,6405,640B,640C,640F,6410,6413,6414,641B,641C,641E,6420,6421,6426,642A,642C,642D,6434,643A,643D,643F,6441,6444,6445,6446,6447,6448,644A,6452,6454,6458,645E,6467,6469,646D,6478,6479,647A,6482,6484,6485,6487,6491,6492,6495,6496,6499,649E,64A4,64A9,64AC,64AD,64AE,64B0,64B5,64B7,64B8,64BA,64BC,64C0,64C2,64C5,64CD,64CE,64D0,64D2,64D7,64D8,64DE,64E2,64E4,64E6,6500,6509,6512,6518,6525,652B,652E,652F,6534,6535,6536,6538,6539,653B,653E,653F,6545,6548,6549,654C,654F,6551,6555,6556,6559,655B,655D,655E,6562,6563,6566,656B,656C,6570,6572,6574,6577,6587,658B,658C,6590,6591,6593,6597,6599,659B,659C,659F,65A1,65A4,65A5,65A7,65A9,65AB,65AD,65AF,65B0,65B9,65BC,65BD,65C1,65C3,65C4,65C5,65C6,65CB,65CC,65CE,65CF,65D2,65D6,65D7,65E0,65E2,65E5,65E6,65E7,65E8,65E9,65EC,65ED,65EE,65EF,65F0,65F1,65F6,65F7,65FA,6600,6602,6603,6606,660A,660C,660E,660F,6613,6614,6615,6619,661D,661F,6620,6625,6627,6628,662D,662F,6631,6634,6635,6636,663C,663E,6641,6643,664B,664C,664F,6652,6653,6654,6655,6656,6657,665A,665F,6661,6664,6666,6668,666E,666F,6670,6674,6676,6677,667A,667E,6682,6684,6687,668C,6691,6696,6697,669D,66A7,66A8,66AE,66B4,66B9,66BE,66D9,66DB,66DC,66DD,66E6,66E9,66F0,66F2,66F3,66F4,66F7,66F9,66FC,66FE,66FF,6700,6708,6709,670A,670B,670D,6710,6714,6715,6717,671B,671D,671F,6726,6728,672A,672B,672C,672D,672F,6731,6734,6735,673A,673D,6740,6742,6743,6746,6748,6749,674C,674E,674F,6750,6751,6753,6756,675C,675E,675F,6760,6761,6765,6768,6769,676A,676D,676F,6770,6772,6773,6775,6777,677C,677E,677F,6781,6784,6787,6789,678B,6790,6795,6797,6798,679A,679C,679D,679E,67A2,67A3,67A5,67A7,67A8,67AA,67AB,67AD,67AF,67B0,67B3,67B5,67B6,67B7,67B8,67C1,67C3,67C4,67CF,67D0,67D1,67D2,67D3,67D4,67D8,67D9,67DA,67DC,67DD,67DE,67E0,67E2,67E5,67E9,67EC,67EF,67F0,67F1,67F3,67F4,67FD,67FF,6800,6805,6807,6808,6809,680A,680B,680C,680E,680F,6811,6813,6816,6817,681D,6821,6829,682A,6832,6833,6837,6838,6839,683C,683D,683E,6840,6841,6842,6843,6844,6845,6846,6848,6849,684A,684C,684E,6850,6851,6853,6854,6855,6860,6861,6862,6863,6864,6865,6866,6867,6868,6869,686B,6874,6876,6877,6881,6883,6885,6886,688F,6893,6897,68A2,68A6,68A7,68A8,68AD,68AF,68B0,68B3,68B5,68C0,68C2,68C9,68CB,68CD,68D2,68D5,68D8,68DA,68E0,68E3,68EE,68F0,68F1,68F5,68F9,68FA,68FC,6901,6905,690B,690D,690E,6910,6912,691F,6920,6924,692D,6930,6934,6939,693D,693F,6942,6954,6957,695A,695D,695E,6960,6963,6966,696B,696E,6971,6977,6978,6979,697C,6980,6982,6984,6986,6987,6988,6989,698D,6994,6995,6998,699B,699C,69A7,69A8,69AB,69AD,69B1,69B4,69B7,69BB,69C1,69CA,69CC,69CE,69D0,69D4,69DB,69DF,69E0,69ED,69F2,69FD,69FF,6A0A,6A17,6A18,6A1F,6A21,6A28,6A2A,6A2F,6A31,6A35,6A3D,6A3E,6A44,6A47,6A50,6A58,6A59,6A5B,6A61,6A65,6A71,6A79,6A7C,6A80,6A84,6A8E,6A90,6A91,6A97,6AA0,6AA9,6AAB,6AAC,6B20,6B21,6B22,6B23,6B24,6B27,6B32,6B37,6B39,6B3A,6B3E,6B43,6B46,6B47,6B49,6B4C,6B59,6B62,6B63,6B64,6B65,6B66,6B67,6B6A,6B79,6B7B,6B7C,6B81,6B82,6B83,6B84,6B86,6B87,6B89,6B8A,6B8B,6B8D,6B92,6B93,6B96,6B9A,6B9B,6BA1,6BAA,6BB3,6BB4,6BB5,6BB7,6BBF,6BC1,6BC2,6BC5,6BCB,6BCD,6BCF,6BD2,6BD3,6BD4,6BD5,6BD6,6BD7,6BD9,6BDB,6BE1,6BEA,6BEB,6BEF,6BF3,6BF5,6BF9,6BFD,6C05,6C06,6C07,6C0D,6C0F,6C10,6C11,6C13,6C14,6C15,6C16,6C18,6C19,6C1A,6C1B,6C1F,6C21,6C22,6C24,6C26,6C27,6C28,6C29,6C2A,6C2E,6C2F,6C30,6C32,6C34,6C35,6C38,6C3D,6C40,6C41,6C42,6C46,6C47,6C49,6C4A,6C50,6C54,6C55,6C57,6C5B,6C5C,6C5D,6C5E,6C5F,6C60,6C61,6C64,6C68,6C69,6C6A,6C70,6C72,6C74,6C76,6C79,6C7D,6C7E,6C81,6C82,6C83,6C85,6C86,6C88,6C89,6C8C,6C8F,6C90,6C93,6C94,6C99,6C9B,6C9F,6CA1,6CA3,6CA4,6CA5,6CA6,6CA7,6CA9,6CAA,6CAB,6CAD,6CAE,6CB1,6CB2,6CB3,6CB8,6CB9,6CBB,6CBC,6CBD,6CBE,6CBF,6CC4,6CC5,6CC9,6CCA,6CCC,6CD0,6CD3,6CD4,6CD5,6CD6,6CD7,6CDB,6CDE,6CE0,6CE1,6CE2,6CE3,6CE5,6CE8,6CEA,6CEB,6CEE,6CEF,6CF0,6CF1,6CF3,6CF5,6CF6,6CF7,6CF8,6CFA,6CFB,6CFC,6CFD,6CFE,6D01,6D04,6D07,6D0B,6D0C,6D0E,6D12,6D17,6D19,6D1A,6D1B,6D1E,6D25,6D27,6D2A,6D2B,6D2E,6D31,6D32,6D33,6D35,6D39,6D3B,6D3C,6D3D,6D3E,6D41,6D43,6D45,6D46,6D47,6D48,6D4A,6D4B,6D4D,6D4E,6D4F,6D51,6D52,6D53,6D54,6D59,6D5A,6D5C,6D5E,6D60,6D63,6D66,6D69,6D6A,6D6E,6D6F,6D74,6D77,6D78,6D7C,6D82,6D85,6D88,6D89,6D8C,6D8E,6D91,6D93,6D94,6D95,6D9B,6D9D,6D9E,6D9F,6DA0,6DA1,6DA3,6DA4,6DA6,6DA7,6DA8,6DA9,6DAA,6DAB,6DAE,6DAF,6DB2,6DB5,6DB8,6DBF,6DC0,6DC4,6DC5,6DC6,6DC7,6DCB,6DCC,6DD1,6DD6,6DD8,6DD9,6DDD,6DDE,6DE0,6DE1,6DE4,6DE6,6DEB,6DEC,6DEE,6DF1,6DF3,6DF7,6DF9,6DFB,6DFC,6E05,6E0A,6E0C,6E0D,6E0E,6E10,6E11,6E14,6E16,6E17,6E1A,6E1D,6E20,6E21,6E23,6E24,6E25,6E29,6E2B,6E2D,6E2F,6E32,6E34,6E38,6E3A,6E43,6E44,6E4D,6E4E,6E53,6E54,6E56,6E58,6E5B,6E5F,6E6B,6E6E,6E7E,6E7F,6E83,6E85,6E86,6E89,6E8F,6E90,6E98,6E9C,6E9F,6EA2,6EA5,6EA7,6EAA,6EAF,6EB1,6EB2,6EB4,6EB6,6EB7,6EBA,6EBB,6EBD,6EC1,6EC2,6EC7,6ECB,6ECF,6ED1,6ED3,6ED4,6ED5,6ED7,6EDA,6EDE,6EDF,6EE0,6EE1,6EE2,6EE4,6EE5,6EE6,6EE8,6EE9,6EF4,6EF9,6F02,6F06,6F09,6F0F,6F13,6F14,6F15,6F20,6F24,6F29,6F2A,6F2B,6F2D,6F2F,6F31,6F33,6F36,6F3E,6F46,6F47,6F4B,6F4D,6F58,6F5C,6F5E,6F62,6F66,6F6D,6F6E,6F72,6F74,6F78,6F7A,6F7C,6F84,6F88,6F89,6F8C,6F8D,6F8E,6F9C,6FA1,6FA7,6FB3,6FB6,6FB9,6FC0,6FC2,6FC9,6FD1,6FD2,6FDE,6FE0,6FE1,6FEE,6FEF,7011,701A,701B,7023,7035,7039,704C,704F,705E,706B,706C,706D,706F,7070,7075,7076,7078,707C,707E,707F,7080,7085,7089,708A,708E,7092,7094,7095,7096,7099,709C,709D,70AB,70AC,70AD,70AE,70AF,70B1,70B3,70B7,70B8,70B9,70BB,70BC,70BD,70C0,70C1,70C2,70C3,70C8,70CA,70D8,70D9,70DB,70DF,70E4,70E6,70E7,70E8,70E9,70EB,70EC,70ED,70EF,70F7,70F9,70FD,7109,710A,7110,7113,7115,7116,7118,7119,711A,7126,712F,7130,7131,7136,7145,714A,714C,714E,715C,715E,7164,7166,7167,7168,716E,7172,7173,7178,717A,717D,7184,718A,718F,7194,7198,7199,719F,71A0,71A8,71AC,71B3,71B5,71B9,71C3,71CE,71D4,71D5,71E0,71E5,71E7,71EE,71F9,7206,721D,7228,722A,722C,7230,7231,7235,7236,7237,7238,7239,723B,723D,723F,7247,7248,724C,724D,7252,7256,7259,725B,725D,725F,7261,7262,7266,7267,7269,726E,726F,7272,7275,7279,727A,727E,727F,7280,7281,7284,728A,728B,728D,728F,7292,729F,72AC,72AD,72AF,72B0,72B4,72B6,72B7,72B8,72B9,72C1,72C2,72C3,72C4,72C8,72CD,72CE,72D0,72D2,72D7,72D9,72DE,72E0,72E1,72E8,72E9,72EC,72ED,72EE,72EF,72F0,72F1,72F2,72F3,72F4,72F7,72F8,72FA,72FB,72FC,7301,7303,730A,730E,7313,7315,7316,7317,731B,731C,731D,731E,7321,7322,7325,7329,732A,732B,732C,732E,7331,7334,7337,7338,7339,733E,733F,734D,7350,7352,7357,7360,736C,736D,736F,737E,7384,7387,7389,738B,738E,7391,7396,739B,739F,73A2,73A9,73AB,73AE,73AF,73B0,73B2,73B3,73B7,73BA,73BB,73C0,73C2,73C8,73C9,73CA,73CD,73CF,73D0,73D1,73D9,73DE,73E0,73E5,73E7,73E9,73ED,73F2,7403,7405,7406,7409,740A,740F,7410,741A,741B,7422,7425,7426,7428,742A,742C,742E,7430,7433,7434,7435,7436,743C,7441,7455,7457,7459,745A,745B,745C,745E,745F,746D,7470,7476,7477,747E,7480,7481,7483,7487,748B,748E,7490,749C,749E,74A7,74A8,74A9,74BA,74D2,74DC,74DE,74E0,74E2,74E3,74E4,74E6,74EE,74EF,74F4,74F6,74F7,74FF,7504,750D,750F,7511,7513,7518,7519,751A,751C,751F,7525,7528,7529,752B,752C,752D,752F,7530,7531,7532,7533,7535,7537,7538,753A,753B,753E,7540,7545,7548,754B,754C,754E,754F,7554,7559,755A,755B,755C,7565,7566,756A,7572,7574,7578,7579,757F,7583,7586,758B,758F,7591,7592,7594,7596,7597,7599,759A,759D,759F,75A0,75A1,75A3,75A4,75A5,75AB,75AC,75AE,75AF,75B0,75B1,75B2,75B3,75B4,75B5,75B8,75B9,75BC,75BD,75BE,75C2,75C3,75C4,75C5,75C7,75C8,75C9,75CA,75CD,75D2,75D4,75D5,75D6,75D8,75DB,75DE,75E2,75E3,75E4,75E6,75E7,75E8,75EA,75EB,75F0,75F1,75F4,75F9,75FC,75FF,7600,7601,7603,7605,760A,760C,7610,7615,7617,7618,7619,761B,761F,7620,7622,7624,7625,7626,7629,762A,762B,762D,7630,7633,7634,7635,7638,763C,763E,763F,7640,7643,764C,764D,7654,7656,765C,765E,7663,766B,766F,7678,767B,767D,767E,7682,7684,7686,7687,7688,768B,768E,7691,7693,7696,7699,76A4,76AE,76B1,76B2,76B4,76BF,76C2,76C5,76C6,76C8,76CA,76CD,76CE,76CF,76D0,76D1,76D2,76D4,76D6,76D7,76D8,76DB,76DF,76E5,76EE,76EF,76F1,76F2,76F4,76F8,76F9,76FC,76FE,7701,7704,7707,7708,7709,770B,770D,7719,771A,771F,7720,7722,7726,7728,7729,772D,772F,7735,7736,7737,7738,773A,773C,7740,7741,7743,7747,7750,7751,775A,775B,7761,7762,7763,7765,7766,7768,776B,776C,7779,777D,777E,777F,7780,7784,7785,778C,778D,778E,7791,7792,779F,77A0,77A2,77A5,77A7,77A9,77AA,77AC,77B0,77B3,77B5,77BB,77BD,77BF,77CD,77D7,77DB,77DC,77E2,77E3,77E5,77E7,77E9,77EB,77EC,77ED,77EE,77F3,77F6,77F8,77FD,77FE,77FF,7800,7801,7802,7809,780C,780D,7811,7812,7814,7816,7817,7818,781A,781C,781D,781F,7823,7825,7826,7827,7829,782C,782D,7830,7834,7837,7838,7839,783A,783B,783C,783E,7840,7845,7847,784C,784E,7850,7852,7855,7856,7857,785D,786A,786B,786C,786D,786E,7877,787C,7887,7889,788C,788D,788E,7891,7893,7897,7898,789A,789B,789C,789F,78A1,78A3,78A5,78A7,78B0,78B1,78B2,78B3,78B4,78B9,78BE,78C1,78C5,78C9,78CA,78CB,78D0,78D4,78D5,78D9,78E8,78EC,78F2,78F4,78F7,78FA,7901,7905,7913,791E,7924,7934,793A,793B,793C,793E,7940,7941,7946,7948,7949,7953,7956,7957,795A,795B,795C,795D,795E,795F,7960,7962,7965,7967,7968,796D,796F,7977,7978,797A,7980,7981,7984,7985,798A,798F,799A,79A7,79B3,79B9,79BA,79BB,79BD,79BE,79C0,79C1,79C3,79C6,79C9,79CB,79CD,79D1,79D2,79D5,79D8,79DF,79E3,79E4,79E6,79E7,79E9,79EB,79ED,79EF,79F0,79F8,79FB,79FD,7A00,7A02,7A03,7A06,7A0B,7A0D,7A0E,7A14,7A17,7A1A,7A1E,7A20,7A23,7A33,7A37,7A39,7A3B,7A3C,7A3D,7A3F,7A46,7A51,7A57,7A70,7A74,7A76,7A77,7A78,7A79,7A7A,7A7F,7A80,7A81,7A83,7A84,7A86,7A88,7A8D,7A91,7A92,7A95,7A96,7A97,7A98,7A9C,7A9D,7A9F,7AA0,7AA5,7AA6,7AA8,7AAC,7AAD,7AB3,7ABF,7ACB,7AD6,7AD9,7ADE,7ADF,7AE0,7AE3,7AE5,7AE6,7AED,7AEF,7AF9,7AFA,7AFD,7AFF,7B03,7B04,7B06,7B08,7B0A,7B0B,7B0F,7B11,7B14,7B15,7B19,7B1B,7B1E,7B20,7B24,7B25,7B26,7B28,7B2A,7B2B,7B2C,7B2E,7B31,7B33,7B38,7B3A,7B3C,7B3E,7B45,7B47,7B49,7B4B,7B4C,7B4F,7B50,7B51,7B52,7B54,7B56,7B58,7B5A,7B5B,7B5D,7B60,7B62,7B6E,7B71,7B72,7B75,7B77,7B79,7B7B,7B7E,7B80,7B85,7B8D,7B90,7B94,7B95,7B97,7B9C,7B9D,7BA1,7BA2,7BA6,7BA7,7BA8,7BA9,7BAA,7BAB,7BAC,7BAD,7BB1,7BB4,7BB8,7BC1,7BC6,7BC7,7BCC,7BD1,7BD3,7BD9,7BDA,7BDD,7BE1,7BE5,7BE6,7BEA,7BEE,7BF1,7BF7,7BFC,7BFE,7C07,7C0B,7C0C,7C0F,7C16,7C1F,7C26,7C27,7C2A,7C38,7C3F,7C40,7C41,7C4D,7C73,7C74,7C7B,7C7C,7C7D,7C89,7C91,7C92,7C95,7C97,7C98,7C9C,7C9D,7C9E,7C9F,7CA2,7CA4,7CA5,7CAA,7CAE,7CB1,7CB2,7CB3,7CB9,7CBC,7CBD,7CBE,7CC1,7CC5,7CC7,7CC8,7CCA,7CCC,7CCD,7CD5,7CD6,7CD7,7CD9,7CDC,7CDF,7CE0,7CE8,7CEF,7CF8,7CFB,7D0A,7D20,7D22,7D27,7D2B,7D2F,7D6E,7D77,7DA6,7DAE,7E3B,7E41,7E47,7E82,7E9B,7E9F,7EA0,7EA1,7EA2,7EA3,7EA4,7EA5,7EA6,7EA7,7EA8,7EA9,7EAA,7EAB,7EAC,7EAD,7EAF,7EB0,7EB1,7EB2,7EB3,7EB5,7EB6,7EB7,7EB8,7EB9,7EBA,7EBD,7EBE,7EBF,7EC0,7EC1,7EC2,7EC3,7EC4,7EC5,7EC6,7EC7,7EC8,7EC9,7ECA,7ECB,7ECC,7ECD,7ECE,7ECF,7ED0,7ED1,7ED2,7ED3,7ED4,7ED5,7ED7,7ED8,7ED9,7EDA,7EDB,7EDC,7EDD,7EDE,7EDF,7EE0,7EE1,7EE2,7EE3,7EE5,7EE6,7EE7,7EE8,7EE9,7EEA,7EEB,7EED,7EEE,7EEF,7EF0,7EF1,7EF2,7EF3,7EF4,7EF5,7EF6,7EF7,7EF8,7EFA,7EFB,7EFC,7EFD,7EFE,7EFF,7F00,7F01,7F02,7F03,7F04,7F05,7F06,7F07,7F08,7F09,7F0B,7F0C,7F0D,7F0E,7F0F,7F11,7F12,7F13,7F14,7F15,7F16,7F17,7F18,7F19,7F1A,7F1B,7F1C,7F1D,7F1F,7F20,7F21,7F22,7F23,7F24,7F25,7F26,7F27,7F28,7F29,7F2A,7F2B,7F2C,7F2D,7F2E,7F2F,7F30,7F31,7F32,7F33,7F34,7F35,7F36,7F38,7F3A,7F42,7F44,7F45,7F50,7F51,7F54,7F55,7F57,7F58,7F5A,7F5F,7F61,7F62,7F68,7F69,7F6A,7F6E,7F71,7F72,7F74,7F79,7F7E,7F81,7F8A,7F8C,7F8E,7F94,7F9A,7F9D,7F9E,7F9F,7FA1,7FA4,7FA7,7FAF,7FB0,7FB2,7FB8,7FB9,7FBC,7FBD,7FBF,7FC1,7FC5,7FCA,7FCC,7FCE,7FD4,7FD5,7FD8,7FDF,7FE0,7FE1,7FE5,7FE6,7FE9,7FEE,7FF0,7FF1,7FF3,7FFB,7FFC,8000,8001,8003,8004,8005,8006,800B,800C,800D,8010,8012,8014,8015,8016,8017,8018,8019,801C,8020,8022,8025,8026,8027,8028,8029,802A,8031,8033,8035,8036,8037,8038,803B,803D,803F,8042,8043,8046,804A,804B,804C,804D,8052,8054,8058,805A,8069,806A,8071,807F,8080,8083,8084,8086,8087,8089,808B,808C,8093,8096,8098,809A,809B,809C,809D,809F,80A0,80A1,80A2,80A4,80A5,80A9,80AA,80AB,80AD,80AE,80AF,80B1,80B2,80B4,80B7,80BA,80BC,80BD,80BE,80BF,80C0,80C1,80C2,80C3,80C4,80C6,80CC,80CD,80CE,80D6,80D7,80D9,80DA,80DB,80DC,80DD,80DE,80E1,80E4,80E5,80E7,80E8,80E9,80EA,80EB,80EC,80ED,80EF,80F0,80F1,80F2,80F3,80F4,80F6,80F8,80FA,80FC,80FD,8102,8106,8109,810A,810D,810E,810F,8110,8111,8112,8113,8114,8116,8118,811A,811E,812C,812F,8131,8132,8136,8138,813E,8146,8148,814A,814B,814C,8150,8151,8153,8154,8155,8159,815A,8160,8165,8167,8169,816D,816E,8170,8171,8174,8179,817A,817B,817C,817D,817E,817F,8180,8182,8188,818A,818F,8191,8198,819B,819C,819D,81A3,81A6,81A8,81AA,81B3,81BA,81BB,81C0,81C1,81C2,81C3,81C6,81CA,81CC,81E3,81E7,81EA,81EC,81ED,81F3,81F4,81FB,81FC,81FE,8200,8201,8202,8204,8205,8206,820C,820D,8210,8212,8214,821B,821C,821E,821F,8221,8222,8223,8228,822A,822B,822C,822D,822F,8230,8231,8233,8234,8235,8236,8237,8238,8239,823B,823E,8244,8247,8249,824B,824F,8258,825A,825F,8268,826E,826F,8270,8272,8273,8274,8279,827A,827D,827E,827F,8282,8284,8288,828A,828B,828D,828E,828F,8291,8292,8297,8298,8299,829C,829D,829F,82A1,82A4,82A5,82A6,82A8,82A9,82AA,82AB,82AC,82AD,82AE,82AF,82B0,82B1,82B3,82B4,82B7,82B8,82B9,82BD,82BE,82C1,82C4,82C7,82C8,82CA,82CB,82CC,82CD,82CE,82CF,82D1,82D2,82D3,82D4,82D5,82D7,82D8,82DB,82DC,82DE,82DF,82E0,82E1,82E3,82E4,82E5,82E6,82EB,82EF,82F1,82F4,82F7,82F9,82FB,8301,8302,8303,8304,8305,8306,8307,8308,8309,830C,830E,830F,8311,8314,8315,8317,831A,831B,831C,8327,8328,832B,832C,832D,832F,8331,8333,8334,8335,8336,8338,8339,833A,833C,8340,8343,8346,8347,8349,834F,8350,8351,8352,8354,835A,835B,835C,835E,835F,8360,8361,8363,8364,8365,8366,8367,8368,8369,836A,836B,836C,836D,836E,836F,8377,8378,837B,837C,837D,8385,8386,8389,838E,8392,8393,8398,839B,839C,839E,83A0,83A8,83A9,83AA,83AB,83B0,83B1,83B2,83B3,83B4,83B6,83B7,83B8,83B9,83BA,83BC,83BD,83C0,83C1,83C5,83C7,83CA,83CC,83CF,83D4,83D6,83D8,83DC,83DD,83DF,83E0,83E1,83E5,83E9,83EA,83F0,83F1,83F2,83F8,83F9,83FD,8401,8403,8404,8406,840B,840C,840D,840E,840F,8411,8418,841C,841D,8424,8425,8426,8427,8428,8431,8438,843C,843D,8446,8451,8457,8459,845A,845B,845C,8461,8463,8469,846B,846C,846D,8471,8473,8475,8476,8478,847A,8482,8487,8488,8489,848B,848C,848E,8497,8499,849C,84A1,84AF,84B2,84B4,84B8,84B9,84BA,84BD,84BF,84C1,84C4,84C9,84CA,84CD,84D0,84D1,84D3,84D6,84DD,84DF,84E0,84E3,84E5,84E6,84EC,84F0,84FC,84FF,850C,8511,8513,8517,851A,851F,8521,852B,852C,8537,8538,8539,853A,853B,853C,853D,8543,8548,8549,854A,8556,8559,855E,8564,8568,8572,8574,8579,857A,857B,857E,8584,8585,8587,858F,859B,859C,85A4,85A8,85AA,85AE,85AF,85B0,85B7,85B9,85C1,85C9,85CF,85D0,85D3,85D5,85DC,85E4,85E9,85FB,85FF,8605,8611,8616,8627,8629,8638,863C,864D,864E,864F,8650,8651,8654,865A,865E,8662,866B,866C,866E,8671,8679,867A,867B,867C,867D,867E,867F,8680,8681,8682,868A,868B,868C,868D,8693,8695,869C,869D,86A3,86A4,86A7,86A8,86A9,86AA,86AC,86AF,86B0,86B1,86B4,86B5,86B6,86BA,86C0,86C4,86C6,86C7,86C9,86CA,86CB,86CE,86CF,86D0,86D1,86D4,86D8,86D9,86DB,86DE,86DF,86E4,86E9,86ED,86EE,86F0,86F1,86F2,86F3,86F4,86F8,86F9,86FE,8700,8702,8703,8707,8708,8709,870A,870D,8712,8713,8715,8717,8718,871A,871C,871E,8721,8722,8723,8725,8729,872E,8731,8734,8737,873B,873E,873F,8747,8748,8749,874C,874E,8753,8757,8759,8760,8763,8764,8765,876E,8770,8774,8776,877B,877C,877D,877E,8782,8783,8785,8788,878B,878D,8793,8797,879F,87A8,87AB,87AC,87AD,87AF,87B3,87B5,87BA,87BD,87C0,87C6,87CA,87CB,87D1,87D2,87D3,87DB,87E0,87E5,87EA,87EE,87F9,87FE,8803,880A,8813,8815,8816,881B,8821,8822,8832,8839,883C,8840,8844,8845,884C,884D,8854,8857,8859,8861,8862,8863,8864,8865,8868,8869,886B,886C,886E,8870,8872,8877,887D,887E,887F,8881,8882,8884,8885,8888,888B,888D,8892,8896,889C,88A2,88A4,88AB,88AD,88B1,88B7,88BC,88C1,88C2,88C5,88C6,88C9,88CE,88D2,88D4,88D5,88D8,88D9,88DF,88E2,88E3,88E4,88E5,88E8,88F0,88F1,88F3,88F4,88F8,88F9,88FC,88FE,8902,890A,8910,8912,8913,8919,891A,891B,8921,8925,892A,892B,8930,8934,8936,8941,8944,895E,895F,8966,897B,897F,8981,8983,8986,89C1,89C2,89C4,89C5,89C6,89C7,89C8,89C9,89CA,89CB,89CC,89CE,89CF,89D0,89D1,89D2,89D6,89DA,89DC,89DE,89E3,89E5,89E6,89EB,89EF,89F3,8A00,8A07,8A3E,8A48,8A79,8A89,8A8A,8A93,8B07,8B26,8B66,8B6C,8BA0,8BA1,8BA2,8BA3,8BA4,8BA5,8BA6,8BA7,8BA8,8BA9,8BAA,8BAB,8BAD,8BAE,8BAF,8BB0,8BB2,8BB3,8BB4,8BB5,8BB6,8BB7,8BB8,8BB9,8BBA,8BBC,8BBD,8BBE,8BBF,8BC0,8BC1,8BC2,8BC3,8BC4,8BC5,8BC6,8BC8,8BC9,8BCA,8BCB,8BCC,8BCD,8BCE,8BCF,8BD1,8BD2,8BD3,8BD4,8BD5,8BD6,8BD7,8BD8,8BD9,8BDA,8BDB,8BDC,8BDD,8BDE,8BDF,8BE0,8BE1,8BE2,8BE3,8BE4,8BE5,8BE6,8BE7,8BE8,8BE9,8BEB,8BEC,8BED,8BEE,8BEF,8BF0,8BF1,8BF2,8BF3,8BF4,8BF5,8BF6,8BF7,8BF8,8BF9,8BFA,8BFB,8BFC,8BFD,8BFE,8BFF,8C00,8C01,8C02,8C03,8C04,8C05,8C06,8C07,8C08,8C0A,8C0B,8C0C,8C0D,8C0E,8C0F,8C10,8C11,8C12,8C13,8C14,8C15,8C16,8C17,8C18,8C19,8C1A,8C1B,8C1C,8C1D,8C1F,8C20,8C21,8C22,8C23,8C24,8C25,8C26,8C27,8C28,8C29,8C2A,8C2B,8C2C,8C2D,8C2E,8C2F,8C30,8C31,8C32,8C33,8C34,8C35,8C36,8C37,8C41,8C46,8C47,8C49,8C4C,8C55,8C5A,8C61,8C62,8C6A,8C6B,8C73,8C78,8C79,8C7A,8C82,8C85,8C89,8C8A,8C8C,8C94,8C98,8D1D,8D1E,8D1F,8D21,8D22,8D23,8D24,8D25,8D26,8D27,8D28,8D29,8D2A,8D2B,8D2C,8D2D,8D2E,8D2F,8D30,8D31,8D32,8D33,8D34,8D35,8D36,8D37,8D38,8D39,8D3A,8D3B,8D3C,8D3D,8D3E,8D3F,8D40,8D41,8D42,8D43,8D44,8D45,8D46,8D47,8D48,8D49,8D4A,8D4B,8D4C,8D4D,8D4E,8D4F,8D50,8D53,8D54,8D55,8D56,8D58,8D59,8D5A,8D5B,8D5C,8D5D,8D5E,8D60,8D61,8D62,8D63,8D64,8D66,8D67,8D6B,8D6D,8D70,8D73,8D74,8D75,8D76,8D77,8D81,8D84,8D85,8D8A,8D8B,8D91,8D94,8D9F,8DA3,8DB1,8DB3,8DB4,8DB5,8DB8,8DBA,8DBC,8DBE,8DBF,8DC3,8DC4,8DC6,8DCB,8DCC,8DCE,8DCF,8DD1,8DD6,8DD7,8DDA,8DDB,8DDD,8DDE,8DDF,8DE3,8DE4,8DE8,8DEA,8DEB,8DEC,8DEF,8DF3,8DF5,8DF7,8DF8,8DF9,8DFA,8DFB,8DFD,8E05,8E09,8E0A,8E0C,8E0F,8E14,8E1D,8E1E,8E1F,8E22,8E23,8E29,8E2A,8E2C,8E2E,8E2F,8E31,8E35,8E39,8E3A,8E3D,8E40,8E41,8E42,8E44,8E47,8E48,8E49,8E4A,8E4B,8E51,8E52,8E59,8E66,8E69,8E6C,8E6D,8E6F,8E70,8E72,8E74,8E76,8E7C,8E7F,8E81,8E85,8E87,8E8F,8E90,8E94,8E9C,8E9E,8EAB,8EAC,8EAF,8EB2,8EBA,8ECE,8F66,8F67,8F68,8F69,8F6B,8F6C,8F6D,8F6E,8F6F,8F70,8F71,8F72,8F73,8F74,8F75,8F76,8F77,8F78,8F79,8F7A,8F7B,8F7C,8F7D,8F7E,8F7F,8F81,8F82,8F83,8F84,8F85,8F86,8F87,8F88,8F89,8F8A,8F8B,8F8D,8F8E,8F8F,8F90,8F91,8F93,8F94,8F95,8F96,8F97,8F98,8F99,8F9A,8F9B,8F9C,8F9E,8F9F,8FA3,8FA8,8FA9,8FAB,8FB0,8FB1,8FB6,8FB9,8FBD,8FBE,8FC1,8FC2,8FC4,8FC5,8FC7,8FC8,8FCE,8FD0,8FD1,8FD3,8FD4,8FD5,8FD8,8FD9,8FDB,8FDC,8FDD,8FDE,8FDF,8FE2,8FE4,8FE5,8FE6,8FE8,8FE9,8FEA,8FEB,8FED,8FEE,8FF0,8FF3,8FF7,8FF8,8FF9,8FFD,9000,9001,9002,9003,9004,9005,9006,9009,900A,900B,900D,900F,9010,9011,9012,9014,9016,9017,901A,901B,901D,901E,901F,9020,9021,9022,9026,902D,902E,902F,9035,9036,9038,903B,903C,903E,9041,9042,9044,9047,904D,904F,9050,9051,9052,9053,9057,9058,905B,9062,9063,9065,9068,906D,906E,9074,9075,907D,907F,9080,9082,9083,9088,908B,9091,9093,9095,9097,9099,909B,909D,90A1,90A2,90A3,90A6,90AA,90AC,90AE,90AF,90B0,90B1,90B3,90B4,90B5,90B6,90B8,90B9,90BA,90BB,90BE,90C1,90C4,90C5,90C7,90CA,90CE,90CF,90D0,90D1,90D3,90D7,90DB,90DC,90DD,90E1,90E2,90E6,90E7,90E8,90EB,90ED,90EF,90F4,90F8,90FD,90FE,9102,9104,9119,911E,9122,9123,912F,9131,9139,9143,9146,9149,914A,914B,914C,914D,914E,914F,9150,9152,9157,915A,915D,915E,9161,9162,9163,9164,9165,9169,916A,916C,916E,916F,9170,9171,9172,9174,9175,9176,9177,9178,9179,917D,917E,917F,9185,9187,9189,918B,918C,918D,9190,9191,9192,919A,919B,91A2,91A3,91AA,91AD,91AE,91AF,91B4,91B5,91BA,91C7,91C9,91CA,91CC,91CD,91CE,91CF,91D1,91DC,9274,928E,92AE,92C8,933E,936A,938F,93CA,93D6,943E,946B,9485,9486,9487,9488,9489,948A,948B,948C,948D,948E,948F,9490,9492,9493,9494,9495,9497,9499,949A,949B,949C,949D,949E,949F,94A0,94A1,94A2,94A3,94A4,94A5,94A6,94A7,94A8,94A9,94AA,94AB,94AC,94AD,94AE,94AF,94B0,94B1,94B2,94B3,94B4,94B5,94B6,94B7,94B8,94B9,94BA,94BB,94BC,94BD,94BE,94BF,94C0,94C1,94C2,94C3,94C4,94C5,94C6,94C8,94C9,94CA,94CB,94CC,94CD,94CE,94D0,94D1,94D2,94D5,94D6,94D7,94D8,94D9,94DB,94DC,94DD,94DE,94DF,94E0,94E1,94E2,94E3,94E4,94E5,94E7,94E8,94E9,94EA,94EB,94EC,94ED,94EE,94EF,94F0,94F1,94F2,94F3,94F4,94F5,94F6,94F7,94F8,94F9,94FA,94FC,94FD,94FE,94FF,9500,9501,9502,9503,9504,9505,9506,9507,9508,9509,950A,950B,950C,950D,950E,950F,9510,9511,9512,9513,9514,9515,9516,9517,9518,9519,951A,951B,951D,951E,951F,9521,9522,9523,9524,9525,9526,9528,9529,952A,952B,952C,952D,952E,952F,9530,9531,9532,9534,9535,9536,9537,9538,9539,953A,953B,953C,953E,953F,9540,9541,9542,9544,9545,9546,9547,9549,954A,954C,954D,954E,954F,9550,9551,9552,9553,9554,9556,9557,9558,9559,955B,955C,955D,955E,955F,9561,9562,9563,9564,9565,9566,9567,9568,9569,956A,956B,956C,956D,956F,9570,9571,9572,9573,9576,957F,95E8,95E9,95EA,95EB,95ED,95EE,95EF,95F0,95F1,95F2,95F3,95F4,95F5,95F6,95F7,95F8,95F9,95FA,95FB,95FC,95FD,95FE,9600,9601,9602,9603,9604,9605,9606,9608,9609,960A,960B,960C,960D,960E,960F,9610,9611,9612,9614,9615,9616,9617,9619,961A,961C,961D,961F,9621,9622,962A,962E,9631,9632,9633,9634,9635,9636,963B,963C,963D,963F,9640,9642,9644,9645,9646,9647,9648,9649,964B,964C,964D,9650,9654,9655,965B,965F,9661,9662,9664,9667,9668,9669,966A,966C,9672,9674,9675,9676,9677,9685,9686,9688,968B,968D,968F,9690,9694,9697,9698,9699,969C,96A7,96B0,96B3,96B6,96B9,96BC,96BD,96BE,96C0,96C1,96C4,96C5,96C6,96C7,96C9,96CC,96CD,96CE,96CF,96D2,96D5,96E0,96E8,96E9,96EA,96EF,96F3,96F6,96F7,96F9,96FE,9700,9701,9704,9706,9707,9708,9709,970D,970E,970F,9713,9716,971C,971E,972A,972D,9730,9732,9738,9739,973E,9752,9753,9756,9759,975B,975E,9760,9761,9762,9765,9769,9773,9774,9776,977C,9785,978B,978D,9791,9792,9794,9798,97A0,97A3,97AB,97AD,97AF,97B2,97B4,97E6,97E7,97E9,97EA,97EB,97EC,97ED,97F3,97F5,97F6,9875,9876,9877,9878,9879,987A,987B,987C,987D,987E,987F,9880,9881,9882,9883,9884,9885,9886,9887,9888,9889,988A,988C,988D,988F,9890,9891,9893,9894,9896,9897,9898,989A,989B,989C,989D,989E,989F,98A0,98A1,98A2,98A4,98A5,98A6,98A7,98CE,98D1,98D2,98D3,98D5,98D8,98D9,98DA,98DE,98DF,98E7,98E8,990D,9910,992E,9954,9955,9963,9965,9967,9968,9969,996A,996B,996C,996D,996E,996F,9970,9971,9972,9974,9975,9976,9977,997A,997C,997D,997F,9980,9981,9984,9985,9986,9987,9988,998A,998B,998D,998F,9990,9991,9992,9993,9994,9995,9996,9997,9998,9999,99A5,99A8,9A6C,9A6D,9A6E,9A6F,9A70,9A71,9A73,9A74,9A75,9A76,9A77,9A78,9A79,9A7A,9A7B,9A7C,9A7D,9A7E,9A7F,9A80,9A81,9A82,9A84,9A85,9A86,9A87,9A88,9A8A,9A8B,9A8C,9A8F,9A90,9A91,9A92,9A93,9A96,9A97,9A98,9A9A,9A9B,9A9C,9A9D,9A9E,9A9F,9AA0,9AA1,9AA2,9AA3,9AA4,9AA5,9AA7,9AA8,9AB0,9AB1,9AB6,9AB7,9AB8,9ABA,9ABC,9AC0,9AC1,9AC2,9AC5,9ACB,9ACC,9AD1,9AD3,9AD8,9ADF,9AE1,9AE6,9AEB,9AED,9AEF,9AF9,9AFB,9B03,9B08,9B0F,9B13,9B1F,9B23,9B2F,9B32,9B3B,9B3C,9B41,9B42,9B43,9B44,9B45,9B47,9B48,9B49,9B4D,9B4F,9B51,9B54,9C7C,9C7F,9C81,9C82,9C85,9C86,9C87,9C88,9C8B,9C8D,9C8E,9C90,9C91,9C92,9C94,9C95,9C9A,9C9B,9C9C,9C9E,9C9F,9CA0,9CA1,9CA2,9CA3,9CA4,9CA5,9CA6,9CA7,9CA8,9CA9,9CAB,9CAD,9CAE,9CB0,9CB1,9CB2,9CB3,9CB4,9CB5,9CB6,9CB7,9CB8,9CBA,9CBB,9CBC,9CBD,9CC3,9CC4,9CC5,9CC6,9CC7,9CCA,9CCB,9CCC,9CCD,9CCE,9CCF,9CD0,9CD3,9CD4,9CD5,9CD6,9CD7,9CD8,9CD9,9CDC,9CDD,9CDE,9CDF,9CE2,9E1F,9E20,9E21,9E22,9E23,9E25,9E26,9E28,9E29,9E2A,9E2B,9E2C,9E2D,9E2F,9E31,9E32,9E33,9E35,9E36,9E37,9E38,9E39,9E3A,9E3D,9E3E,9E3F,9E41,9E42,9E43,9E44,9E45,9E46,9E47,9E48,9E49,9E4A,9E4B,9E4C,9E4E,9E4F,9E51,9E55,9E57,9E58,9E5A,9E5B,9E5C,9E5E,9E63,9E64,9E66,9E67,9E68,9E69,9E6A,9E6B,9E6C,9E6D,9E70,9E71,9E73,9E7E,9E7F,9E82,9E87,9E88,9E8B,9E92,9E93,9E9D,9E9F,9EA6,9EB4,9EB8,9EBB,9EBD,9EBE,9EC4,9EC9,9ECD,9ECE,9ECF,9ED1,9ED4,9ED8,9EDB,9EDC,9EDD,9EDF,9EE0,9EE2,9EE5,9EE7,9EE9,9EEA,9EEF,9EF9,9EFB,9EFC,9EFE,9F0B,9F0D,9F0E,9F10,9F13,9F17,9F19,9F20,9F22,9F2C,9F2F,9F37,9F39,9F3B,9F3D,9F3E,9F44,9F50,9F51,9F7F,9F80,9F83,9F84,9F85,9F86,9F87,9F88,9F89,9F8A,9F8B,9F8C,9F99,9F9A,9F9B,9F9F,9FA0,FF01,FF02,FF03,FF04,FF05,FF06,FF07,FF08,FF09,FF0A,FF0B,FF0C,FF0D,FF0E,FF0F,FF10,FF11,FF12,FF13,FF14,FF15,FF16,FF17,FF18,FF19,FF1A,FF1B,FF1C,FF1D,FF1E,FF1F,FF20,FF21,FF22,FF23,FF24,FF25,FF26,FF27,FF28,FF29,FF2A,FF2B,FF2C,FF2D,FF2E,FF2F,FF30,FF31,FF32,FF33,FF34,FF35,FF36,FF37,FF38,FF39,FF3A,FF3B,FF3C,FF3D,FF3E,FF3F,FF40,FF41,FF42,FF43,FF44,FF45,FF46,FF47,FF48,FF49,FF4A,FF4B,FF4C,FF4D,FF4E,FF4F,FF50,FF51,FF52,FF53,FF54,FF55,FF56,FF57,FF58,FF59,FF5A,FF5B,FF5C,FF5D,FF5E,FFE0,FFE1,FFE3,FFE5';
        }
        AnsicodeChr = function () {
            return 'A1E8,A1EC,A1A7,A1E3,A1C0,A1A4,A1C1,A8A4,A8A2,A8A8,A8A6,A8BA,A8AC,A8AA,A8B0,A8AE,A1C2,A8B4,A8B2,A8B9,A8A1,A8A5,A8A7,A8A9,A8AD,A8B1,A8A3,A8AB,A8AF,A8B3,A8B5,A8B6,A8B7,A8B8,A1A6,A1A5,A6A1,A6A2,A6A3,A6A4,A6A5,A6A6,A6A7,A6A8,A6A9,A6AA,A6AB,A6AC,A6AD,A6AE,A6AF,A6B0,A6B1,A6B2,A6B3,A6B4,A6B5,A6B6,A6B7,A6B8,A6C1,A6C2,A6C3,A6C4,A6C5,A6C6,A6C7,A6C8,A6C9,A6CA,A6CB,A6CC,A6CD,A6CE,A6CF,A6D0,A6D1,A6D2,A6D3,A6D4,A6D5,A6D6,A6D7,A6D8,A7A7,A7A1,A7A2,A7A3,A7A4,A7A5,A7A6,A7A8,A7A9,A7AA,A7AB,A7AC,A7AD,A7AE,A7AF,A7B0,A7B1,A7B2,A7B3,A7B4,A7B5,A7B6,A7B7,A7B8,A7B9,A7BA,A7BB,A7BC,A7BD,A7BE,A7BF,A7C0,A7C1,A7D1,A7D2,A7D3,A7D4,A7D5,A7D6,A7D8,A7D9,A7DA,A7DB,A7DC,A7DD,A7DE,A7DF,A7E0,A7E1,A7E2,A7E3,A7E4,A7E5,A7E6,A7E7,A7E8,A7E9,A7EA,A7EB,A7EC,A7ED,A7EE,A7EF,A7F0,A7F1,A7D7,A1AA,A1AC,A1AE,A1AF,A1B0,A1B1,A1AD,A1EB,A1E4,A1E5,A1F9,A1E6,A1ED,A2F1,A2F2,A2F3,A2F4,A2F5,A2F6,A2F7,A2F8,A2F9,A2FA,A2FB,A2FC,A1FB,A1FC,A1FA,A1FD,A1CA,A1C7,A1C6,A1CC,A1D8,A1DE,A1CF,A1CE,A1C4,A1C5,A1C9,A1C8,A1D2,A1D3,A1E0,A1DF,A1C3,A1CB,A1D7,A1D6,A1D5,A1D9,A1D4,A1DC,A1DD,A1DA,A1DB,A1D1,A1CD,A1D0,A2D9,A2DA,A2DB,A2DC,A2DD,A2DE,A2DF,A2E0,A2E1,A2E2,A2C5,A2C6,A2C7,A2C8,A2C9,A2CA,A2CB,A2CC,A2CD,A2CE,A2CF,A2D0,A2D1,A2D2,A2D3,A2D4,A2D5,A2D6,A2D7,A2D8,A2B1,A2B2,A2B3,A2B4,A2B5,A2B6,A2B7,A2B8,A2B9,A2BA,A2BB,A2BC,A2BD,A2BE,A2BF,A2C0,A2C1,A2C2,A2C3,A2C4,A9A4,A9A5,A9A6,A9A7,A9A8,A9A9,A9AA,A9AB,A9AC,A9AD,A9AE,A9AF,A9B0,A9B1,A9B2,A9B3,A9B4,A9B5,A9B6,A9B7,A9B8,A9B9,A9BA,A9BB,A9BC,A9BD,A9BE,A9BF,A9C0,A9C1,A9C2,A9C3,A9C4,A9C5,A9C6,A9C7,A9C8,A9C9,A9CA,A9CB,A9CC,A9CD,A9CE,A9CF,A9D0,A9D1,A9D2,A9D3,A9D4,A9D5,A9D6,A9D7,A9D8,A9D9,A9DA,A9DB,A9DC,A9DD,A9DE,A9DF,A9E0,A9E1,A9E2,A9E3,A9E4,A9E5,A9E6,A9E7,A9E8,A9E9,A9EA,A9EB,A9EC,A9ED,A9EE,A9EF,A1F6,A1F5,A1F8,A1F7,A1F4,A1F3,A1F0,A1F2,A1F1,A1EF,A1EE,A1E2,A1E1,A1A1,A1A2,A1A3,A1A8,A1A9,A1B4,A1B5,A1B6,A1B7,A1B8,A1B9,A1BA,A1BB,A1BE,A1BF,A1FE,A1B2,A1B3,A1BC,A1BD,A4A1,A4A2,A4A3,A4A4,A4A5,A4A6,A4A7,A4A8,A4A9,A4AA,A4AB,A4AC,A4AD,A4AE,A4AF,A4B0,A4B1,A4B2,A4B3,A4B4,A4B5,A4B6,A4B7,A4B8,A4B9,A4BA,A4BB,A4BC,A4BD,A4BE,A4BF,A4C0,A4C1,A4C2,A4C3,A4C4,A4C5,A4C6,A4C7,A4C8,A4C9,A4CA,A4CB,A4CC,A4CD,A4CE,A4CF,A4D0,A4D1,A4D2,A4D3,A4D4,A4D5,A4D6,A4D7,A4D8,A4D9,A4DA,A4DB,A4DC,A4DD,A4DE,A4DF,A4E0,A4E1,A4E2,A4E3,A4E4,A4E5,A4E6,A4E7,A4E8,A4E9,A4EA,A4EB,A4EC,A4ED,A4EE,A4EF,A4F0,A4F1,A4F2,A4F3,A5A1,A5A2,A5A3,A5A4,A5A5,A5A6,A5A7,A5A8,A5A9,A5AA,A5AB,A5AC,A5AD,A5AE,A5AF,A5B0,A5B1,A5B2,A5B3,A5B4,A5B5,A5B6,A5B7,A5B8,A5B9,A5BA,A5BB,A5BC,A5BD,A5BE,A5BF,A5C0,A5C1,A5C2,A5C3,A5C4,A5C5,A5C6,A5C7,A5C8,A5C9,A5CA,A5CB,A5CC,A5CD,A5CE,A5CF,A5D0,A5D1,A5D2,A5D3,A5D4,A5D5,A5D6,A5D7,A5D8,A5D9,A5DA,A5DB,A5DC,A5DD,A5DE,A5DF,A5E0,A5E1,A5E2,A5E3,A5E4,A5E5,A5E6,A5E7,A5E8,A5E9,A5EA,A5EB,A5EC,A5ED,A5EE,A5EF,A5F0,A5F1,A5F2,A5F3,A5F4,A5F5,A5F6,A8C5,A8C6,A8C7,A8C8,A8C9,A8CA,A8CB,A8CC,A8CD,A8CE,A8CF,A8D0,A8D1,A8D2,A8D3,A8D4,A8D5,A8D6,A8D7,A8D8,A8D9,A8DA,A8DB,A8DC,A8DD,A8DE,A8DF,A8E0,A8E1,A8E2,A8E3,A8E4,A8E5,A8E6,A8E7,A8E8,A8E9,A2E5,A2E6,A2E7,A2E8,A2E9,A2EA,A2EB,A2EC,A2ED,A2EE,D2BB,B6A1,C6DF,CDF2,D5C9,C8FD,C9CF,CFC2,D8A2,B2BB,D3EB,D8A4,B3F3,D7A8,C7D2,D8A7,CAC0,C7F0,B1FB,D2B5,B4D4,B6AB,CBBF,D8A9,B6AA,C1BD,D1CF,C9A5,D8AD,B8F6,D1BE,E3DC,D6D0,B7E1,B4AE,C1D9,D8BC,CDE8,B5A4,CEAA,D6F7,C0F6,BED9,D8AF,C4CB,BEC3,D8B1,C3B4,D2E5,D6AE,CEDA,D5A7,BAF5,B7A6,C0D6,C6B9,C5D2,C7C7,B9D4,B3CB,D2D2,D8BF,BEC5,C6F2,D2B2,CFB0,CFE7,CAE9,D8C0,C2F2,C2D2,C8E9,C7AC,C1CB,D3E8,D5F9,CAC2,B6FE,D8A1,D3DA,BFF7,D4C6,BBA5,D8C1,CEE5,BEAE,D8A8,D1C7,D0A9,D8BD,D9EF,CDF6,BFBA,BDBB,BAA5,D2E0,B2FA,BAE0,C4B6,CFED,BEA9,CDA4,C1C1,C7D7,D9F1,D9F4,C8CB,D8E9,D2DA,CAB2,C8CA,D8EC,D8EA,D8C6,BDF6,C6CD,B3F0,D8EB,BDF1,BDE9,C8D4,B4D3,C2D8,B2D6,D7D0,CACB,CBFB,D5CC,B8B6,CFC9,D9DA,D8F0,C7AA,D8EE,B4FA,C1EE,D2D4,D8ED,D2C7,D8EF,C3C7,D1F6,D6D9,D8F2,D8F5,BCFE,BCDB,C8CE,B7DD,B7C2,C6F3,D8F8,D2C1,CEE9,BCBF,B7FC,B7A5,D0DD,D6DA,D3C5,BBEF,BBE1,D8F1,C9A1,CEB0,B4AB,D8F3,C9CB,D8F6,C2D7,D8F7,CEB1,D8F9,B2AE,B9C0,D9A3,B0E9,C1E6,C9EC,CBC5,CBC6,D9A4,B5E8,B5AB,CEBB,B5CD,D7A1,D7F4,D3D3,CCE5,BACE,D9A2,D9DC,D3E0,D8FD,B7F0,D7F7,D8FE,D8FA,D9A1,C4E3,D3B6,D8F4,D9DD,D8FB,C5E5,C0D0,D1F0,B0DB,BCD1,D9A6,D9A5,D9AC,D9AE,D9AB,CAB9,D9A9,D6B6,B3DE,D9A8,C0FD,CACC,D9AA,D9A7,D9B0,B6B1,B9A9,D2C0,CFC0,C2C2,BDC4,D5EC,B2E0,C7C8,BFEB,D9AD,D9AF,CEEA,BAEE,C7D6,B1E3,B4D9,B6ED,D9B4,BFA1,D9DE,C7CE,C0FE,D9B8,CBD7,B7FD,D9B5,D9B7,B1A3,D3E1,D9B9,D0C5,D9B6,D9B1,D9B2,C1A9,D9B3,BCF3,D0DE,B8A9,BEE3,D9BD,D9BA,B0B3,D9C2,D9C4,B1B6,D9BF,B5B9,BEF3,CCC8,BAF2,D2D0,D9C3,BDE8,B3AB,D9C5,BEEB,D9C6,D9BB,C4DF,D9BE,D9C1,D9C0,D5AE,D6B5,C7E3,D9C8,BCD9,D9CA,D9BC,D9CB,C6AB,D9C9,D7F6,CDA3,BDA1,D9CC,C5BC,CDB5,D9CD,D9C7,B3A5,BFFE,B8B5,C0FC,B0F8,B4F6,D9CE,D9CF,B4A2,D9D0,B4DF,B0C1,D9D1,C9B5,CFF1,D9D2,C1C5,D9D6,C9AE,D9D5,D9D4,D9D7,CBDB,BDA9,C6A7,D9D3,D9D8,D9D9,C8E5,C0DC,B6F9,D8A3,D4CA,D4AA,D0D6,B3E4,D5D7,CFC8,B9E2,BFCB,C3E2,B6D2,CDC3,D9EE,D9F0,B5B3,B6B5,BEA4,C8EB,C8AB,B0CB,B9AB,C1F9,D9E2,C0BC,B9B2,B9D8,D0CB,B1F8,C6E4,BEDF,B5E4,D7C8,D1F8,BCE6,CADE,BCBD,D9E6,D8E7,C4DA,B8D4,C8BD,B2E1,D4D9,C3B0,C3E1,DAA2,C8DF,D0B4,BEFC,C5A9,B9DA,DAA3,D4A9,DAA4,D9FB,B6AC,B7EB,B1F9,D9FC,B3E5,BEF6,BFF6,D2B1,C0E4,B6B3,D9FE,D9FD,BEBB,C6E0,D7BC,DAA1,C1B9,B5F2,C1E8,BCF5,B4D5,C1DD,C4FD,BCB8,B7B2,B7EF,D9EC,C6BE,BFAD,BBCB,B5CA,DBC9,D0D7,CDB9,B0BC,B3F6,BBF7,DBCA,BAAF,D4E4,B5B6,B5F3,D8D6,C8D0,B7D6,C7D0,D8D7,BFAF,DBBB,D8D8,D0CC,BBAE,EBBE,C1D0,C1F5,D4F2,B8D5,B4B4,B3F5,C9BE,C5D0,C5D9,C0FB,B1F0,D8D9,B9CE,B5BD,D8DA,D6C6,CBA2,C8AF,C9B2,B4CC,BFCC,B9F4,D8DB,D8DC,B6E7,BCC1,CCEA,CFF7,D8DD,C7B0,B9D0,BDA3,CCDE,C6CA,D8E0,D8DE,D8DF,B0FE,BEE7,CAA3,BCF4,B8B1,B8EE,D8E2,BDCB,D8E4,D8E3,C5FC,D8E5,D8E6,C1A6,C8B0,B0EC,B9A6,BCD3,CEF1,DBBD,C1D3,B6AF,D6FA,C5AC,BDD9,DBBE,DBBF,C0F8,BEA2,C0CD,DBC0,CAC6,B2AA,D3C2,C3E3,D1AB,DBC2,C0D5,DBC3,BFB1,C4BC,C7DA,DBC4,D9E8,C9D7,B9B4,CEF0,D4C8,B0FC,B4D2,D0D9,D9E9,DECB,D9EB,D8B0,BBAF,B1B1,B3D7,D8CE,D4D1,BDB3,BFEF,CFBB,D8D0,B7CB,D8D1,C6A5,C7F8,D2BD,D8D2,C4E4,CAAE,C7A7,D8A6,C9FD,CEE7,BBDC,B0EB,BBAA,D0AD,B1B0,D7E4,D7BF,B5A5,C2F4,C4CF,B2A9,B2B7,B1E5,DFB2,D5BC,BFA8,C2AC,D8D5,C2B1,D8D4,CED4,DAE0,CEC0,D8B4,C3AE,D3A1,CEA3,BCB4,C8B4,C2D1,BEED,D0B6,DAE1,C7E4,B3A7,B6F2,CCFC,C0FA,C0F7,D1B9,D1E1,D8C7,B2DE,C0E5,BAF1,D8C8,D4AD,CFE1,D8C9,D8CA,CFC3,B3F8,BEC7,D8CB,DBCC,C8A5,CFD8,C8FE,B2CE,D3D6,B2E6,BCB0,D3D1,CBAB,B7B4,B7A2,CAE5,C8A1,CADC,B1E4,D0F0,C5D1,DBC5,B5FE,BFDA,B9C5,BEE4,C1ED,DFB6,DFB5,D6BB,BDD0,D5D9,B0C8,B6A3,BFC9,CCA8,DFB3,CAB7,D3D2,D8CF,D2B6,BAC5,CBBE,CCBE,DFB7,B5F0,DFB4,D3F5,B3D4,B8F7,DFBA,BACF,BCAA,B5F5,CDAC,C3FB,BAF3,C0F4,CDC2,CFF2,DFB8,CFC5,C2C0,DFB9,C2F0,BEFD,C1DF,CDCC,D2F7,B7CD,DFC1,DFC4,B7F1,B0C9,B6D6,B7D4,BAAC,CCFD,BFD4,CBB1,C6F4,D6A8,DFC5,CEE2,B3B3,CEFC,B4B5,CEC7,BAF0,CEE1,D1BD,DFC0,B4F4,B3CA,B8E6,DFBB,C4C5,DFBC,DFBD,DFBE,C5BB,DFBF,DFC2,D4B1,DFC3,C7BA,CED8,C4D8,DFCA,DFCF,D6DC,DFC9,DFDA,CEB6,BAC7,DFCE,DFC8,C5DE,C9EB,BAF4,C3FC,BED7,DFC6,DFCD,C5D8,D5A6,BACD,BECC,D3BD,B8C0,D6E4,DFC7,B9BE,BFA7,C1FC,DFCB,DFCC,DFD0,DFDB,DFE5,DFD7,DFD6,D7C9,DFE3,DFE4,E5EB,D2A7,DFD2,BFA9,D4DB,BFC8,DFD4,CFCC,DFDD,D1CA,DFDE,B0A7,C6B7,DFD3,BAE5,B6DF,CDDB,B9FE,D4D5,DFDF,CFEC,B0A5,DFE7,DFD1,D1C6,DFD5,DFD8,DFD9,DFDC,BBA9,DFE0,DFE1,DFE2,DFE6,DFE8,D3B4,B8E7,C5B6,DFEA,C9DA,C1A8,C4C4,BFDE,CFF8,D5DC,DFEE,B2B8,BADF,DFEC,DBC1,D1E4,CBF4,B4BD,B0A6,DFF1,CCC6,DFF2,DFED,DFE9,DFEB,DFEF,DFF0,BBBD,DFF3,DFF4,BBA3,CADB,CEA8,E0A7,B3AA,E0A6,E0A1,DFFE,CDD9,DFFC,DFFA,BFD0,D7C4,C9CC,DFF8,B0A1,DFFD,DFFB,E0A2,E0A8,B7C8,C6A1,C9B6,C0B2,DFF5,C5BE,D8C4,DFF9,C4F6,E0A3,E0A4,E0A5,D0A5,E0B4,CCE4,E0B1,BFA6,E0AF,CEB9,E0AB,C9C6,C0AE,E0AE,BAED,BAB0,E0A9,DFF6,E0B3,E0B8,B4AD,E0B9,CFB2,BAC8,E0B0,D0FA,E0AC,D4FB,DFF7,C5E7,E0AD,D3F7,E0B6,E0B7,E0C4,D0E1,E0BC,E0C9,E0CA,E0BE,E0AA,C9A4,E0C1,E0B2,CAC8,E0C3,E0B5,CECB,CBC3,E0CD,E0C6,E0C2,E0CB,E0BA,E0BF,E0C0,E0C5,E0C7,E0C8,E0CC,E0BB,CBD4,E0D5,E0D6,E0D2,E0D0,BCCE,E0D1,B8C2,D8C5,D0EA,C2EF,E0CF,E0BD,E0D4,E0D3,E0D7,E0DC,E0D8,D6F6,B3B0,D7EC,CBBB,E0DA,CEFB,BAD9,E0E1,E0DD,D2AD,E0E2,E0DB,E0D9,E0DF,E0E0,E0DE,E0E4,C6F7,D8AC,D4EB,E0E6,CAC9,E0E5,B8C1,E0E7,E0E8,E0E9,E0E3,BABF,CCE7,E0EA,CFF9,E0EB,C8C2,BDC0,C4D2,E0EC,E0ED,C7F4,CBC4,E0EE,BBD8,D8B6,D2F2,E0EF,CDC5,B6DA,E0F1,D4B0,C0A7,B4D1,CEA7,E0F0,E0F2,B9CC,B9FA,CDBC,E0F3,C6D4,E0F4,D4B2,C8A6,E0F6,E0F5,E0F7,CDC1,CAA5,D4DA,DBD7,DBD9,DBD8,B9E7,DBDC,DBDD,B5D8,DBDA,DBDB,B3A1,DBDF,BBF8,D6B7,DBE0,BEF9,B7BB,DBD0,CCAE,BFB2,BBB5,D7F8,BFD3,BFE9,BCE1,CCB3,DBDE,B0D3,CEEB,B7D8,D7B9,C6C2,C0A4,CCB9,DBE7,DBE1,C6BA,DBE3,DBE8,C5F7,DBEA,DBE9,BFC0,DBE6,DBE5,B4B9,C0AC,C2A2,DBE2,DBE4,D0CD,DBED,C0DD,DBF2,B6E2,DBF3,DBD2,B9B8,D4AB,DBEC,BFD1,DBF0,DBD1,B5E6,DBEB,BFE5,DBEE,DBF1,DBF9,B9A1,B0A3,C2F1,B3C7,DBEF,DBF8,C6D2,DBF4,DBF5,DBF7,DBF6,DBFE,D3F2,B2BA,DBFD,DCA4,DBFB,DBFA,DBFC,C5E0,BBF9,DCA3,DCA5,CCC3,B6D1,DDC0,DCA1,DCA2,C7B5,B6E9,DCA7,DCA6,DCA9,B1A4,B5CC,BFB0,D1DF,B6C2,DCA8,CBFA,EBF3,CBDC,CBFE,CCC1,C8FB,DCAA,CCEE,DCAB,DBD3,DCAF,DCAC,BEB3,CAFB,DCAD,C9CA,C4B9,C7BD,DCAE,D4F6,D0E6,C4AB,B6D5,DBD4,B1DA,DBD5,DBD6,BABE,C8C0,CABF,C8C9,D7B3,C9F9,BFC7,BAF8,D2BC,E2BA,B4A6,B1B8,B8B4,CFC4,D9E7,CFA6,CDE2,D9ED,B6E0,D2B9,B9BB,E2B9,E2B7,B4F3,CCEC,CCAB,B7F2,D8B2,D1EB,BABB,CAA7,CDB7,D2C4,BFE4,BCD0,B6E1,DEC5,DEC6,DBBC,D1D9,C6E6,C4CE,B7EE,B7DC,BFFC,D7E0,C6F5,B1BC,DEC8,BDB1,CCD7,DECA,DEC9,B5EC,C9DD,B0C2,C5AE,C5AB,C4CC,BCE9,CBFD,BAC3,E5F9,C8E7,E5FA,CDFD,D7B1,B8BE,C2E8,C8D1,E5FB,B6CA,BCCB,D1FD,E6A1,C3EE,E6A4,E5FE,E6A5,CDD7,B7C1,E5FC,E5FD,E6A3,C4DD,E6A8,E6A7,C3C3,C6DE,E6AA,C4B7,E6A2,CABC,BDE3,B9C3,E6A6,D0D5,CEAF,E6A9,E6B0,D2A6,BDAA,E6AD,E6AF,C0D1,D2CC,BCA7,E6B1,D2F6,D7CB,CDFE,CDDE,C2A6,E6AB,E6AC,BDBF,E6AE,E6B3,E6B2,E6B6,E6B8,C4EF,C4C8,BEEA,C9EF,E6B7,B6F0,C3E4,D3E9,E6B4,E6B5,C8A2,E6BD,E6B9,C6C5,CDF1,E6BB,E6BC,BBE9,E6BE,E6BA,C0B7,D3A4,E6BF,C9F4,E6C3,E6C4,D0F6,C3BD,C3C4,E6C2,E6C1,E6C7,CFB1,EBF4,E6CA,E6C5,BCDE,C9A9,BCB5,CFD3,E6C8,E6C9,E6CE,E6D0,E6D1,E6CB,B5D5,E6CC,E6CF,C4DB,E6C6,E6CD,E6D2,E6D4,E6D3,E6D5,D9F8,E6D6,E6D7,D7D3,E6DD,E6DE,BFD7,D4D0,D7D6,B4E6,CBEF,E6DA,D8C3,D7CE,D0A2,C3CF,E6DF,BCBE,B9C2,E6DB,D1A7,BAA2,C2CF,D8AB,CAEB,E5EE,E6DC,B7F5,C8E6,C4F5,E5B2,C4FE,CBFC,E5B3,D5AC,D3EE,CAD8,B0B2,CBCE,CDEA,BAEA,E5B5,E5B4,D7DA,B9D9,D6E6,B6A8,CDF0,D2CB,B1A6,CAB5,B3E8,C9F3,BFCD,D0FB,CAD2,E5B6,BBC2,CFDC,B9AC,D4D7,BAA6,D1E7,CFFC,BCD2,E5B7,C8DD,BFED,B1F6,CBDE,BCC5,BCC4,D2FA,C3DC,BFDC,B8BB,C3C2,BAAE,D4A2,C7DE,C4AF,B2EC,B9D1,E5BB,C1C8,D5AF,E5BC,E5BE,B4E7,B6D4,CBC2,D1B0,B5BC,CAD9,B7E2,C9E4,BDAB,CEBE,D7F0,D0A1,C9D9,B6FB,E6D8,BCE2,B3BE,C9D0,E6D9,B3A2,DECC,D3C8,DECD,D2A2,DECE,BECD,DECF,CAAC,D2FC,B3DF,E5EA,C4E1,BEA1,CEB2,C4F2,BED6,C6A8,B2E3,BED3,C7FC,CCEB,BDEC,CEDD,CABA,C6C1,E5EC,D0BC,D5B9,E5ED,CAF4,CDC0,C2C5,E5EF,C2C4,E5F0,E5F8,CDCD,C9BD,D2D9,E1A8,D3EC,CBEA,C6F1,E1AC,E1A7,E1A9,E1AA,E1AF,B2ED,E1AB,B8DA,E1AD,E1AE,E1B0,B5BA,E1B1,E1B3,E1B8,D1D2,E1B6,E1B5,C1EB,E1B7,D4C0,E1B2,E1BA,B0B6,E1B4,BFF9,E1B9,E1BB,E1BE,E1BC,D6C5,CFBF,E1BD,E1BF,C2CD,B6EB,D3F8,C7CD,B7E5,BEFE,E1C0,E1C1,E1C7,B3E7,C6E9,B4DE,D1C2,E1C8,E1C6,E1C5,E1C3,E1C2,B1C0,D5B8,E1C4,E1CB,E1CC,E1CA,EFFA,E1D3,E1D2,C7B6,E1C9,E1CE,E1D0,E1D4,E1D1,E1CD,E1CF,E1D5,E1D6,E1D7,E1D8,E1DA,E1DB,CEA1,E7DD,B4A8,D6DD,D1B2,B3B2,B9A4,D7F3,C7C9,BEDE,B9AE,CED7,B2EE,DBCF,BCBA,D2D1,CBC8,B0CD,CFEF,D9E3,BDED,B1D2,CAD0,B2BC,CBA7,B7AB,CAA6,CFA3,E0F8,D5CA,E0FB,E0FA,C5C1,CCFB,C1B1,E0F9,D6E3,B2AF,D6C4,B5DB,B4F8,D6A1,CFAF,B0EF,E0FC,E1A1,B3A3,E0FD,E0FE,C3B1,C3DD,E1A2,B7F9,BBCF,E1A3,C4BB,E1A4,E1A5,E1A6,B4B1,B8C9,C6BD,C4EA,B2A2,D0D2,E7DB,BBC3,D3D7,D3C4,B9E3,E2CF,D7AF,C7EC,B1D3,B4B2,E2D1,D0F2,C2AE,E2D0,BFE2,D3A6,B5D7,E2D2,B5EA,C3ED,B8FD,B8AE,C5D3,B7CF,E2D4,E2D3,B6C8,D7F9,CDA5,E2D8,E2D6,CAFC,BFB5,D3B9,E2D5,E2D7,C1AE,C0C8,E2DB,E2DA,C0AA,C1CE,E2DC,E2DD,E2DE,DBC8,D1D3,CDA2,BDA8,DEC3,D8A5,BFAA,DBCD,D2EC,C6FA,C5AA,DEC4,B1D7,DFAE,CABD,DFB1,B9AD,D2FD,B8A5,BAEB,B3DA,B5DC,D5C5,C3D6,CFD2,BBA1,E5F3,E5F2,E5F4,CDE4,C8F5,B5AF,C7BF,E5F6,ECB0,E5E6,B9E9,B5B1,C2BC,E5E8,E5E7,E5E9,D2CD,E1EA,D0CE,CDAE,D1E5,B2CA,B1EB,B1F2,C5ED,D5C3,D3B0,E1DC,E1DD,D2DB,B3B9,B1CB,CDF9,D5F7,E1DE,BEB6,B4FD,E1DF,BADC,E1E0,BBB2,C2C9,E1E1,D0EC,CDBD,E1E2,B5C3,C5C7,E1E3,E1E4,D3F9,E1E5,D1AD,E1E6,CEA2,E1E7,B5C2,E1E8,BBD5,D0C4,E2E0,B1D8,D2E4,E2E1,BCC9,C8CC,E2E3,ECFE,ECFD,DFAF,E2E2,D6BE,CDFC,C3A6,E3C3,D6D2,E2E7,E2E8,D3C7,E2EC,BFEC,E2ED,E2E5,B3C0,C4EE,E2EE,D0C3,BAF6,E2E9,B7DE,BBB3,CCAC,CBCB,E2E4,E2E6,E2EA,E2EB,E2F7,E2F4,D4F5,E2F3,C5AD,D5FA,C5C2,B2C0,E2EF,E2F2,C1AF,CBBC,B5A1,E2F9,BCB1,E2F1,D0D4,D4B9,E2F5,B9D6,E2F6,C7D3,E2F0,D7DC,EDA1,E2F8,EDA5,E2FE,CAD1,C1B5,BBD0,BFD6,BAE3,CBA1,EDA6,EDA3,EDA2,BBD6,EDA7,D0F4,EDA4,BADE,B6F7,E3A1,B6B2,CCF1,B9A7,CFA2,C7A1,BFD2,B6F1,E2FA,E2FB,E2FD,E2FC,C4D5,E3A2,D3C1,E3A7,C7C4,CFA4,E3A9,BAB7,E3A8,BBDA,E3A3,E3A4,E3AA,E3A6,CEF2,D3C6,BBBC,D4C3,C4FA,EDA8,D0FC,E3A5,C3F5,E3AD,B1AF,E3B2,BCC2,E3AC,B5BF,C7E9,E3B0,BEAA,CDEF,BBF3,CCE8,E3AF,E3B1,CFA7,E3AE,CEA9,BBDD,B5EB,BEE5,B2D2,B3CD,B1B9,E3AB,B2D1,B5AC,B9DF,B6E8,CFEB,E3B7,BBCC,C8C7,D0CA,E3B8,B3EE,EDA9,D3FA,D3E4,EDAA,E3B9,D2E2,E3B5,D3DE,B8D0,E3B3,E3B6,B7DF,E3B4,C0A2,E3BA,D4B8,B4C8,E3BB,BBC5,C9F7,C9E5,C4BD,EDAB,C2FD,BBDB,BFAE,CEBF,E3BC,BFB6,B1EF,D4F7,E3BE,EDAD,E3BF,BAA9,EDAC,E3BD,E3C0,BAB6,B6AE,D0B8,B0C3,EDAE,EDAF,C0C1,E3C1,C5B3,E3C2,DCB2,EDB0,B8EA,CEEC,EAA7,D0E7,CAF9,C8D6,CFB7,B3C9,CED2,BDE4,E3DE,BBF2,EAA8,D5BD,C6DD,EAA9,EAAA,EAAC,EAAB,EAAE,EAAD,BDD8,EAAF,C2BE,B4C1,B4F7,BBA7,ECE6,ECE5,B7BF,CBF9,B1E2,ECE7,C9C8,ECE8,ECE9,CAD6,DED0,B2C5,D4FA,C6CB,B0C7,B4F2,C8D3,CDD0,BFB8,BFDB,C7A4,D6B4,C0A9,DED1,C9A8,D1EF,C5A4,B0E7,B3B6,C8C5,B0E2,B7F6,C5FA,B6F3,D5D2,B3D0,BCBC,B3AD,BEF1,B0D1,D2D6,CAE3,D7A5,CDB6,B6B6,BFB9,D5DB,B8A7,C5D7,DED2,BFD9,C2D5,C7C0,BBA4,B1A8,C5EA,C5FB,CCA7,B1A7,B5D6,C4A8,DED3,D1BA,B3E9,C3F2,B7F7,D6F4,B5A3,B2F0,C4B4,C4E9,C0AD,DED4,B0E8,C5C4,C1E0,B9D5,BEDC,CDD8,B0CE,CDCF,DED6,BED0,D7BE,DED5,D5D0,B0DD,C4E2,C2A3,BCF0,D3B5,C0B9,C5A1,B2A6,D4F1,C0A8,CAC3,DED7,D5FC,B9B0,C8AD,CBA9,DED9,BFBD,C6B4,D7A7,CAB0,C4C3,B3D6,B9D2,D6B8,EAFC,B0B4,BFE6,CCF4,CDDA,D6BF,C2CE,CECE,CCA2,D0AE,C4D3,B5B2,DED8,D5F5,BCB7,BBD3,B0A4,C5B2,B4EC,D5F1,EAFD,DEDA,CDA6,CDEC,CEE6,DEDC,CDB1,C0A6,D7BD,DEDB,B0C6,BAB4,C9D3,C4F3,BEE8,B2B6,C0CC,CBF0,BCF1,BBBB,B5B7,C5F5,DEE6,DEE3,BEDD,DEDF,B4B7,BDDD,DEE0,C4ED,CFC6,B5E0,B6DE,CADA,B5F4,DEE5,D5C6,DEE1,CCCD,C6FE,C5C5,D2B4,BEF2,C2D3,CCBD,B3B8,BDD3,BFD8,CDC6,D1DA,B4EB,DEE4,DEDD,DEE7,EAFE,C2B0,DEE2,D6C0,B5A7,B2F4,DEE8,DEF2,DEED,DEF1,C8E0,D7E1,DEEF,C3E8,CCE1,B2E5,D2BE,DEEE,DEEB,CED5,B4A7,BFAB,BEBE,BDD2,DEE9,D4AE,DEDE,DEEA,C0BF,DEEC,B2F3,B8E9,C2A7,BDC1,DEF5,DEF8,B2AB,B4A4,B4EA,C9A6,DEF6,CBD1,B8E3,DEF7,DEFA,DEF9,CCC2,B0E1,B4EE,E5BA,D0AF,B2EB,EBA1,DEF4,C9E3,DEF3,B0DA,D2A1,B1F7,CCAF,DEF0,CBA4,D5AA,DEFB,B4DD,C4A6,DEFD,C3FE,C4A1,DFA1,C1CC,DEFC,BEEF,C6B2,B3C5,C8F6,CBBA,DEFE,DFA4,D7B2,B3B7,C1C3,C7CB,B2A5,B4E9,D7AB,C4EC,DFA2,DFA3,DFA5,BAB3,DFA6,C0DE,C9C3,B2D9,C7E6,DFA7,C7DC,DFA8,EBA2,CBD3,DFAA,DFA9,B2C1,C5CA,DFAB,D4DC,C8C1,DFAC,BEF0,DFAD,D6A7,EAB7,EBB6,CAD5,D8FC,B8C4,B9A5,B7C5,D5FE,B9CA,D0A7,F4CD,B5D0,C3F4,BEC8,EBB7,B0BD,BDCC,C1B2,B1D6,B3A8,B8D2,C9A2,B6D8,EBB8,BEB4,CAFD,C7C3,D5FB,B7F3,CEC4,D5AB,B1F3,ECB3,B0DF,ECB5,B6B7,C1CF,F5FA,D0B1,D5E5,CED3,BDEF,B3E2,B8AB,D5B6,EDBD,B6CF,CBB9,D0C2,B7BD,ECB6,CAA9,C5D4,ECB9,ECB8,C2C3,ECB7,D0FD,ECBA,ECBB,D7E5,ECBC,ECBD,C6EC,CEDE,BCC8,C8D5,B5A9,BEC9,D6BC,D4E7,D1AE,D0F1,EAB8,EAB9,EABA,BAB5,CAB1,BFF5,CDFA,EAC0,B0BA,EABE,C0A5,EABB,B2FD,C3F7,BBE8,D2D7,CEF4,EABF,EABC,EAC3,D0C7,D3B3,B4BA,C3C1,D7F2,D5D1,CAC7,EAC5,EAC4,EAC7,EAC6,D6E7,CFD4,EACB,BBCE,BDFA,C9CE,EACC,C9B9,CFFE,EACA,D4CE,EACD,EACF,CDED,EAC9,EACE,CEEE,BBDE,B3BF,C6D5,BEB0,CEFA,C7E7,BEA7,EAD0,D6C7,C1C0,D4DD,EAD1,CFBE,EAD2,CAEE,C5AF,B0B5,EAD4,EAD3,F4DF,C4BA,B1A9,E5DF,EAD5,CAEF,EAD6,EAD7,C6D8,EAD8,EAD9,D4BB,C7FA,D2B7,B8FC,EAC2,B2DC,C2FC,D4F8,CCE6,D7EE,D4C2,D3D0,EBC3,C5F3,B7FE,EBD4,CBB7,EBDE,C0CA,CDFB,B3AF,C6DA,EBFC,C4BE,CEB4,C4A9,B1BE,D4FD,CAF5,D6EC,C6D3,B6E4,BBFA,D0E0,C9B1,D4D3,C8A8,B8CB,E8BE,C9BC,E8BB,C0EE,D0D3,B2C4,B4E5,E8BC,D5C8,B6C5,E8BD,CAF8,B8DC,CCF5,C0B4,D1EE,E8BF,E8C2,BABC,B1AD,BDDC,EABD,E8C3,E8C6,E8CB,E8CC,CBC9,B0E5,BCAB,B9B9,E8C1,CDF7,E8CA,CEF6,D5ED,C1D6,E8C4,C3B6,B9FB,D6A6,E8C8,CAE0,D4E6,E8C0,E8C5,E8C7,C7B9,B7E3,E8C9,BFDD,E8D2,E8D7,E8D5,BCDC,BCCF,E8DB,E8DE,E8DA,B1FA,B0D8,C4B3,B8CC,C6E2,C8BE,C8E1,E8CF,E8D4,E8D6,B9F1,E8D8,D7F5,C4FB,E8DC,B2E9,E8D1,BCED,BFC2,E8CD,D6F9,C1F8,B2F1,E8DF,CAC1,E8D9,D5A4,B1EA,D5BB,E8CE,E8D0,B6B0,E8D3,E8DD,C0B8,CAF7,CBA8,C6DC,C0F5,E8E9,D0A3,E8F2,D6EA,E8E0,E8E1,D1F9,BACB,B8F9,B8F1,D4D4,E8EF,E8EE,E8EC,B9F0,CCD2,E8E6,CEA6,BFF2,B0B8,E8F1,E8F0,D7C0,E8E4,CDA9,C9A3,BBB8,BDDB,E8EA,E8E2,E8E3,E8E5,B5B5,E8E7,C7C5,E8EB,E8ED,BDB0,D7AE,E8F8,E8F5,CDB0,E8F6,C1BA,E8E8,C3B7,B0F0,E8F4,E8F7,B9A3,C9D2,C3CE,CEE0,C0E6,CBF3,CCDD,D0B5,CAE1,E8F3,BCEC,E8F9,C3DE,C6E5,B9F7,B0F4,D7D8,BCAC,C5EF,CCC4,E9A6,C9AD,E9A2,C0E2,BFC3,E8FE,B9D7,E8FB,E9A4,D2CE,E9A3,D6B2,D7B5,E9A7,BDB7,E8FC,E8FD,E9A1,CDD6,D2AC,E9B2,E9A9,B4AA,B4BB,E9AB,D0A8,E9A5,B3FE,E9AC,C0E3,E9AA,E9B9,E9B8,E9AE,E8FA,E9A8,BFAC,E9B1,E9BA,C2A5,E9AF,B8C5,E9AD,D3DC,E9B4,E9B5,E9B7,E9C7,C0C6,E9C5,E9B0,E9BB,B0F1,E9BC,D5A5,E9BE,E9BF,E9C1,C1F1,C8B6,E9BD,E9C2,E9C3,E9B3,E9B6,BBB1,E9C0,BCF7,E9C4,E9C6,E9CA,E9CE,B2DB,E9C8,B7AE,E9CB,E9CC,D5C1,C4A3,E9D8,BAE1,E9C9,D3A3,E9D4,E9D7,E9D0,E9CF,C7C1,E9D2,E9D9,B3C8,E9D3,CFF0,E9CD,B3F7,E9D6,E9DA,CCB4,CFAD,E9D5,E9DC,E9DB,E9DE,E9D1,E9DD,E9DF,C3CA,C7B7,B4CE,BBB6,D0C0,ECA3,C5B7,D3FB,ECA4,ECA5,C6DB,BFEE,ECA6,ECA7,D0AA,C7B8,B8E8,ECA8,D6B9,D5FD,B4CB,B2BD,CEE4,C6E7,CDE1,B4F5,CBC0,BCDF,E9E2,E9E3,D1EA,E9E5,B4F9,E9E4,D1B3,CAE2,B2D0,E9E8,E9E6,E9E7,D6B3,E9E9,E9EA,E9EB,E9EC,ECAF,C5B9,B6CE,D2F3,B5EE,BBD9,ECB1,D2E3,CEE3,C4B8,C3BF,B6BE,D8B9,B1C8,B1CF,B1D1,C5FE,B1D0,C3AB,D5B1,EBA4,BAC1,CCBA,EBA5,EBA7,EBA8,EBA6,EBA9,EBAB,EBAA,EBAC,CACF,D8B5,C3F1,C3A5,C6F8,EBAD,C4CA,EBAE,EBAF,EBB0,B7D5,B7FA,EBB1,C7E2,EBB3,BAA4,D1F5,B0B1,EBB2,EBB4,B5AA,C2C8,C7E8,EBB5,CBAE,E3DF,D3C0,D9DB,CDA1,D6AD,C7F3,D9E0,BBE3,BABA,E3E2,CFAB,E3E0,C9C7,BAB9,D1B4,E3E1,C8EA,B9AF,BDAD,B3D8,CEDB,CCC0,E3E8,E3E9,CDF4,CCAD,BCB3,E3EA,E3EB,D0DA,C6FB,B7DA,C7DF,D2CA,CED6,E3E4,E3EC,C9F2,B3C1,E3E7,C6E3,E3E5,EDB3,E3E6,C9B3,C5E6,B9B5,C3BB,E3E3,C5BD,C1A4,C2D9,B2D7,E3ED,BBA6,C4AD,E3F0,BEDA,E3FB,E3F5,BAD3,B7D0,D3CD,D6CE,D5D3,B9C1,D5B4,D1D8,D0B9,C7F6,C8AA,B2B4,C3DA,E3EE,E3FC,E3EF,B7A8,E3F7,E3F4,B7BA,C5A2,E3F6,C5DD,B2A8,C6FC,C4E0,D7A2,C0E1,E3F9,E3FA,E3FD,CCA9,E3F3,D3BE,B1C3,EDB4,E3F1,E3F2,E3F8,D0BA,C6C3,D4F3,E3FE,BDE0,E4A7,E4A6,D1F3,E4A3,E4A9,C8F7,CFB4,E4A8,E4AE,C2E5,B6B4,BDF2,E4A2,BAE9,E4AA,E4AC,B6FD,D6DE,E4B2,E4AD,E4A1,BBEE,CDDD,C7A2,C5C9,C1F7,E4A4,C7B3,BDAC,BDBD,E4A5,D7C7,B2E2,E4AB,BCC3,E4AF,BBEB,E4B0,C5A8,E4B1,D5E3,BFA3,E4BA,E4B7,E4BB,E4BD,C6D6,BAC6,C0CB,B8A1,E4B4,D4A1,BAA3,BDFE,E4BC,CDBF,C4F9,CFFB,C9E6,D3BF,CFD1,E4B3,E4B8,E4B9,CCE9,CCCE,C0D4,E4B5,C1B0,E4B6,CED0,BBC1,B5D3,C8F3,BDA7,D5C7,C9AC,B8A2,E4CA,E4CC,D1C4,D2BA,BAAD,BAD4,E4C3,B5ED,D7CD,E4C0,CFFD,E4BF,C1DC,CCCA,CAE7,C4D7,CCD4,E4C8,E4C7,E4C1,E4C4,B5AD,D3D9,E4C6,D2F9,B4E3,BBB4,C9EE,B4BE,BBEC,D1CD,CCED,EDB5,C7E5,D4A8,E4CB,D7D5,E4C2,BDA5,E4C5,D3E6,E4C9,C9F8,E4BE,D3E5,C7FE,B6C9,D4FC,B2B3,E4D7,CEC2,E4CD,CEBC,B8DB,E4D6,BFCA,D3CE,C3EC,C5C8,E4D8,CDC4,E4CF,E4D4,E4D5,BAFE,CFE6,D5BF,E4D2,E4D0,E4CE,CDE5,CAAA,C0A3,BDA6,E4D3,B8C8,E4E7,D4B4,E4DB,C1EF,E4E9,D2E7,E4DF,E4E0,CFAA,CBDD,E4DA,E4D1,E4E5,C8DC,E4E3,C4E7,E4E2,E4E1,B3FC,E4E8,B5E1,D7CC,E4E6,BBAC,D7D2,CCCF,EBF8,E4E4,B9F6,D6CD,E4D9,E4DC,C2FA,E4DE,C2CB,C0C4,C2D0,B1F5,CCB2,B5CE,E4EF,C6AF,C6E1,E4F5,C2A9,C0EC,D1DD,E4EE,C4AE,E4ED,E4F6,E4F4,C2FE,E4DD,E4F0,CAFE,D5C4,E4F1,D1FA,E4EB,E4EC,E4F2,CEAB,C5CB,C7B1,C2BA,E4EA,C1CA,CCB6,B3B1,E4FB,E4F3,E4FA,E4FD,E4FC,B3CE,B3BA,E4F7,E4F9,E4F8,C5EC,C0BD,D4E8,E5A2,B0C4,E5A4,E5A3,BCA4,E5A5,E5A1,E4FE,B1F4,E5A8,E5A9,E5A6,E5A7,E5AA,C6D9,E5AB,E5AD,E5AC,E5AF,E5AE,B9E0,E5B0,E5B1,BBF0,ECE1,C3F0,B5C6,BBD2,C1E9,D4EE,BEC4,D7C6,D4D6,B2D3,ECBE,EAC1,C2AF,B4B6,D1D7,B3B4,C8B2,BFBB,ECC0,D6CB,ECBF,ECC1,ECC5,BEE6,CCBF,C5DA,BEBC,ECC6,B1FE,ECC4,D5A8,B5E3,ECC2,C1B6,B3E3,ECC3,CBB8,C0C3,CCFE,C1D2,ECC8,BAE6,C0D3,D6F2,D1CC,BFBE,B7B3,C9D5,ECC7,BBE2,CCCC,BDFD,C8C8,CFA9,CDE9,C5EB,B7E9,D1C9,BAB8,ECC9,ECCA,BBC0,ECCB,ECE2,B1BA,B7D9,BDB9,ECCC,D1E6,ECCD,C8BB,ECD1,ECD3,BBCD,BCE5,ECCF,C9B7,C3BA,ECE3,D5D5,ECD0,D6F3,ECD2,ECCE,ECD4,ECD5,C9BF,CFA8,D0DC,D1AC,C8DB,ECD6,CEF5,CAEC,ECDA,ECD9,B0BE,ECD7,ECD8,ECE4,C8BC,C1C7,ECDC,D1E0,ECDB,D4EF,ECDD,DBC6,ECDE,B1AC,ECDF,ECE0,D7A6,C5C0,EBBC,B0AE,BEF4,B8B8,D2AF,B0D6,B5F9,D8B3,CBAC,E3DD,C6AC,B0E6,C5C6,EBB9,EBBA,EBBB,D1C0,C5A3,EAF2,C4B2,C4B5,C0CE,EAF3,C4C1,CEEF,EAF0,EAF4,C9FC,C7A3,CCD8,CEFE,EAF5,EAF6,CFAC,C0E7,EAF7,B6BF,EAF8,EAF9,EAFA,EAFB,EAF1,C8AE,E1EB,B7B8,E1EC,E1ED,D7B4,E1EE,E1EF,D3CC,E1F1,BFF1,E1F0,B5D2,B1B7,E1F3,E1F2,BAFC,E1F4,B9B7,BED1,C4FC,BADD,BDC6,E1F5,E1F7,B6C0,CFC1,CAA8,E1F6,D5F8,D3FC,E1F8,E1FC,E1F9,E1FA,C0EA,E1FE,E2A1,C0C7,E1FB,E1FD,E2A5,C1D4,E2A3,E2A8,B2FE,E2A2,C3CD,B2C2,E2A7,E2A6,E2A4,E2A9,E2AB,D0C9,D6ED,C3A8,E2AC,CFD7,E2AE,BAEF,E9E0,E2AD,E2AA,BBAB,D4B3,E2B0,E2AF,E9E1,E2B1,E2B2,E2B3,CCA1,E2B4,E2B5,D0FE,C2CA,D3F1,CDF5,E7E0,E7E1,BEC1,C2EA,E7E4,E7E3,CDE6,C3B5,E7E2,BBB7,CFD6,C1E1,E7E9,E7E8,E7F4,B2A3,E7EA,E7E6,E7EC,E7EB,C9BA,D5E4,E7E5,B7A9,E7E7,E7EE,E7F3,D6E9,E7ED,E7F2,E7F1,B0E0,E7F5,C7F2,C0C5,C0ED,C1F0,E7F0,E7F6,CBF6,E8A2,E8A1,D7C1,E7FA,E7F9,E7FB,E7F7,E7FE,E7FD,E7FC,C1D5,C7D9,C5FD,C5C3,C7ED,E8A3,E8A6,E8A5,E8A7,BAF7,E7F8,E8A4,C8F0,C9AA,E8A9,B9E5,D1FE,E8A8,E8AA,E8AD,E8AE,C1A7,E8AF,E8B0,E8AC,E8B4,E8AB,E8B1,E8B5,E8B2,E8B3,E8B7,E8B6,B9CF,F0AC,F0AD,C6B0,B0EA,C8BF,CDDF,CECD,EAB1,EAB2,C6BF,B4C9,EAB3,D5E7,DDF9,EAB4,EAB5,EAB6,B8CA,DFB0,C9F5,CCF0,C9FA,C9FB,D3C3,CBA6,B8A6,F0AE,B1C2,E5B8,CCEF,D3C9,BCD7,C9EA,B5E7,C4D0,B5E9,EEAE,BBAD,E7DE,EEAF,B3A9,EEB2,EEB1,BDE7,EEB0,CEB7,C5CF,C1F4,DBCE,EEB3,D0F3,C2D4,C6E8,B7AC,EEB4,B3EB,BBFB,EEB5,E7DC,EEB6,BDAE,F1E2,CAE8,D2C9,F0DA,F0DB,F0DC,C1C6,B8ED,BECE,F0DE,C5B1,F0DD,D1F1,F0E0,B0CC,BDEA,D2DF,F0DF,B4AF,B7E8,F0E6,F0E5,C6A3,F0E1,F0E2,B4C3,F0E3,D5EE,CCDB,BED2,BCB2,F0E8,F0E7,F0E4,B2A1,D6A2,D3B8,BEB7,C8AC,F0EA,D1F7,D6CC,BADB,F0E9,B6BB,CDB4,C6A6,C1A1,F0EB,F0EE,F0ED,F0F0,F0EC,BBBE,F0EF,CCB5,F0F2,B3D5,B1D4,F0F3,F0F4,F0F6,B4E1,F0F1,F0F7,F0FA,F0F8,F0F5,F0FD,F0F9,F0FC,F0FE,F1A1,CEC1,F1A4,F1A3,C1F6,F0FB,CADD,B4F1,B1F1,CCB1,F1A6,F1A7,F1AC,D5CE,F1A9,C8B3,F1A2,F1AB,F1A8,F1A5,F1AA,B0A9,F1AD,F1AF,F1B1,F1B0,F1AE,D1A2,F1B2,F1B3,B9EF,B5C7,B0D7,B0D9,D4ED,B5C4,BDD4,BBCA,F0A7,B8DE,F0A8,B0A8,F0A9,CDEE,F0AA,F0AB,C6A4,D6E5,F1E4,F1E5,C3F3,D3DB,D6D1,C5E8,D3AF,D2E6,EEC1,B0BB,D5B5,D1CE,BCE0,BAD0,BFF8,B8C7,B5C1,C5CC,CAA2,C3CB,EEC2,C4BF,B6A2,EDEC,C3A4,D6B1,CFE0,EDEF,C5CE,B6DC,CAA1,EDED,EDF0,EDF1,C3BC,BFB4,EDEE,EDF4,EDF2,D5E6,C3DF,EDF3,EDF6,D5A3,D1A3,EDF5,C3D0,EDF7,BFF4,BEEC,EDF8,CCF7,D1DB,D7C5,D5F6,EDFC,EDFB,EDF9,EDFA,EDFD,BEA6,CBAF,EEA1,B6BD,EEA2,C4C0,EDFE,BDDE,B2C7,B6C3,EEA5,D8BA,EEA3,EEA6,C3E9,B3F2,EEA7,EEA4,CFB9,EEA8,C2F7,EEA9,EEAA,DEAB,C6B3,C7C6,D6F5,B5C9,CBB2,EEAB,CDAB,EEAC,D5B0,EEAD,F6C4,DBC7,B4A3,C3AC,F1E6,CAB8,D2D3,D6AA,EFF2,BED8,BDC3,EFF3,B6CC,B0AB,CAAF,EDB6,EDB7,CEF9,B7AF,BFF3,EDB8,C2EB,C9B0,EDB9,C6F6,BFB3,EDBC,C5F8,D1D0,D7A9,EDBA,EDBB,D1E2,EDBF,EDC0,EDC4,EDC8,EDC6,EDCE,D5E8,EDC9,EDC7,EDBE,C5E9,C6C6,C9E9,D4D2,EDC1,EDC2,EDC3,EDC5,C0F9,B4A1,B9E8,EDD0,EDD1,EDCA,EDCF,CEF8,CBB6,EDCC,EDCD,CFF5,EDD2,C1F2,D3B2,EDCB,C8B7,BCEF,C5F0,EDD6,B5EF,C2B5,B0AD,CBE9,B1AE,EDD4,CDEB,B5E2,EDD5,EDD3,EDD7,B5FA,EDD8,EDD9,EDDC,B1CC,C5F6,BCEE,EDDA,CCBC,B2EA,EDDB,C4EB,B4C5,B0F5,EDDF,C0DA,B4E8,C5CD,EDDD,BFC4,EDDE,C4A5,EDE0,EDE1,EDE3,C1D7,BBC7,BDB8,EDE2,EDE4,EDE6,EDE5,EDE7,CABE,ECEA,C0F1,C9E7,ECEB,C6EE,ECEC,C6ED,ECED,ECF0,D7E6,ECF3,ECF1,ECEE,ECEF,D7A3,C9F1,CBEE,ECF4,ECF2,CFE9,ECF6,C6B1,BCC0,ECF5,B5BB,BBF6,ECF7,D9F7,BDFB,C2BB,ECF8,ECF9,B8A3,ECFA,ECFB,ECFC,D3ED,D8AE,C0EB,C7DD,BACC,D0E3,CBBD,CDBA,B8D1,B1FC,C7EF,D6D6,BFC6,C3EB,EFF5,C3D8,D7E2,EFF7,B3D3,C7D8,D1ED,D6C8,EFF8,EFF6,BBFD,B3C6,BDD5,D2C6,BBE0,CFA1,EFFC,EFFB,EFF9,B3CC,C9D4,CBB0,EFFE,B0DE,D6C9,EFFD,B3ED,F6D5,CEC8,F0A2,F0A1,B5BE,BCDA,BBFC,B8E5,C4C2,F0A3,CBEB,F0A6,D1A8,BEBF,C7EE,F1B6,F1B7,BFD5,B4A9,F1B8,CDBB,C7D4,D5AD,F1B9,F1BA,C7CF,D2A4,D6CF,F1BB,BDD1,B4B0,BEBD,B4DC,CED1,BFDF,F1BD,BFFA,F1BC,F1BF,F1BE,F1C0,F1C1,C1FE,C1A2,CAFA,D5BE,BEBA,BEB9,D5C2,BFA2,CDAF,F1B5,BDDF,B6CB,D6F1,F3C3,F3C4,B8CD,F3C6,F3C7,B0CA,F3C5,F3C9,CBF1,F3CB,D0A6,B1CA,F3C8,F3CF,B5D1,F3D7,F3D2,F3D4,F3D3,B7FB,B1BF,F3CE,F3CA,B5DA,F3D0,F3D1,F3D5,F3CD,BCE3,C1FD,F3D6,F3DA,F3CC,B5C8,BDEE,F3DC,B7A4,BFF0,D6FE,CDB2,B4F0,B2DF,F3D8,F3D9,C9B8,F3DD,F3DE,F3E1,F3DF,F3E3,F3E2,F3DB,BFEA,B3EF,F3E0,C7A9,BCF2,F3EB,B9BF,F3E4,B2AD,BBFE,CBE3,F3ED,F3E9,B9DC,F3EE,F3E5,F3E6,F3EA,C2E1,F3EC,F3EF,F3E8,BCFD,CFE4,F3F0,F3E7,F3F2,D7AD,C6AA,F3F3,F3F1,C2A8,B8DD,F3F5,F3F4,B4DB,F3F6,F3F7,F3F8,C0BA,C0E9,C5F1,F3FB,F3FA,B4D8,F3FE,F3F9,F3FC,F3FD,F4A1,F4A3,BBC9,F4A2,F4A4,B2BE,F4A6,F4A5,BCAE,C3D7,D9E1,C0E0,F4CC,D7D1,B7DB,F4CE,C1A3,C6C9,B4D6,D5B3,F4D0,F4CF,F4D1,CBDA,F4D2,D4C1,D6E0,B7E0,C1B8,C1BB,F4D3,BEAC,B4E2,F4D4,F4D5,BEAB,F4D6,F4DB,F4D7,F4DA,BAFD,F4D8,F4D9,B8E2,CCC7,F4DC,B2DA,C3D3,D4E3,BFB7,F4DD,C5B4,F4E9,CFB5,CEC9,CBD8,CBF7,BDF4,D7CF,C0DB,D0F5,F4EA,F4EB,F4EC,F7E3,B7B1,F4ED,D7EB,F4EE,E6F9,BEC0,E6FA,BAEC,E6FB,CFCB,E6FC,D4BC,BCB6,E6FD,E6FE,BCCD,C8D2,CEB3,E7A1,B4BF,E7A2,C9B4,B8D9,C4C9,D7DD,C2DA,B7D7,D6BD,CEC6,B7C4,C5A6,E7A3,CFDF,E7A4,E7A5,E7A6,C1B7,D7E9,C9F0,CFB8,D6AF,D6D5,E7A7,B0ED,E7A8,E7A9,C9DC,D2EF,BEAD,E7AA,B0F3,C8DE,BDE1,E7AB,C8C6,E7AC,BBE6,B8F8,D1A4,E7AD,C2E7,BEF8,BDCA,CDB3,E7AE,E7AF,BEEE,D0E5,CBE7,CCD0,BCCC,E7B0,BCA8,D0F7,E7B1,D0F8,E7B2,E7B3,B4C2,E7B4,E7B5,C9FE,CEAC,C3E0,E7B7,B1C1,B3F1,E7B8,E7B9,D7DB,D5C0,E7BA,C2CC,D7BA,E7BB,E7BC,E7BD,BCEA,C3E5,C0C2,E7BE,E7BF,BCA9,E7C0,E7C1,E7B6,B6D0,E7C2,E7C3,E7C4,BBBA,B5DE,C2C6,B1E0,E7C5,D4B5,E7C6,B8BF,E7C8,E7C7,B7EC,E7C9,B2F8,E7CA,E7CB,E7CC,E7CD,E7CE,E7CF,E7D0,D3A7,CBF5,E7D1,E7D2,E7D3,E7D4,C9C9,E7D5,E7D6,E7D7,E7D8,E7D9,BDC9,E7DA,F3BE,B8D7,C8B1,F3BF,F3C0,F3C1,B9DE,CDF8,D8E8,BAB1,C2DE,EEB7,B7A3,EEB9,EEB8,B0D5,EEBB,D5D6,D7EF,D6C3,EEBD,CAF0,EEBC,EEBE,EEC0,EEBF,D1F2,C7BC,C3C0,B8E1,C1E7,F4C6,D0DF,F4C7,CFDB,C8BA,F4C8,F4C9,F4CA,F4CB,D9FA,B8FE,E5F1,D3F0,F4E0,CECC,B3E1,F1B4,D2EE,F4E1,CFE8,F4E2,C7CC,B5D4,B4E4,F4E4,F4E3,F4E5,F4E6,F4E7,BAB2,B0BF,F4E8,B7AD,D2ED,D2AB,C0CF,BFBC,EBA3,D5DF,EAC8,F1F3,B6F8,CBA3,C4CD,F1E7,F1E8,B8FB,F1E9,BAC4,D4C5,B0D2,F1EA,F1EB,F1EC,F1ED,F1EE,F1EF,F1F1,F1F0,C5D5,F1F2,B6FA,F1F4,D2AE,DEC7,CBCA,B3DC,B5A2,B9A2,C4F4,F1F5,F1F6,C1C4,C1FB,D6B0,F1F7,F1F8,C1AA,C6B8,BEDB,F1F9,B4CF,F1FA,EDB2,EDB1,CBE0,D2DE,CBC1,D5D8,C8E2,C0DF,BCA1,EBC1,D0A4,D6E2,B6C7,B8D8,EBC0,B8CE,EBBF,B3A6,B9C9,D6AB,B7F4,B7CA,BCE7,B7BE,EBC6,EBC7,B0B9,BFCF,EBC5,D3FD,EBC8,EBC9,B7CE,EBC2,EBC4,C9F6,D6D7,D5CD,D0B2,EBCF,CEB8,EBD0,B5A8,B1B3,EBD2,CCA5,C5D6,EBD3,EBD1,C5DF,EBCE,CAA4,EBD5,B0FB,BAFA,D8B7,F1E3,EBCA,EBCB,EBCC,EBCD,EBD6,E6C0,EBD9,BFE8,D2C8,EBD7,EBDC,B8EC,EBD8,BDBA,D0D8,B0B7,EBDD,C4DC,D6AC,B4E0,C2F6,BCB9,EBDA,EBDB,D4E0,C6EA,C4D4,EBDF,C5A7,D9F5,B2B1,EBE4,BDC5,EBE2,EBE3,B8AC,CDD1,EBE5,EBE1,C1B3,C6A2,CCF3,EBE6,C0B0,D2B8,EBE7,B8AF,B8AD,EBE8,C7BB,CDF3,EBEA,EBEB,EBED,D0C8,EBF2,EBEE,EBF1,C8F9,D1FC,EBEC,EBE9,B8B9,CFD9,C4E5,EBEF,EBF0,CCDA,CDC8,B0F2,EBF6,EBF5,B2B2,B8E0,EBF7,B1EC,CCC5,C4A4,CFA5,EBF9,ECA2,C5F2,EBFA,C9C5,E2DF,EBFE,CDCE,ECA1,B1DB,D3B7,D2DC,EBFD,EBFB,B3BC,EAB0,D7D4,F4AB,B3F4,D6C1,D6C2,D5E9,BECA,F4A7,D2A8,F4A8,F4A9,F4AA,BECB,D3DF,C9E0,C9E1,F3C2,CAE6,CCF2,E2B6,CBB4,CEE8,D6DB,F4AD,F4AE,F4AF,F4B2,BABD,F4B3,B0E3,F4B0,F4B1,BDA2,B2D5,F4B6,F4B7,B6E6,B2B0,CFCF,F4B4,B4AC,F4B5,F4B8,F4B9,CDA7,F4BA,F4BB,F4BC,CBD2,F4BD,F4BE,F4BF,F4DE,C1BC,BCE8,C9AB,D1DE,E5F5,DCB3,D2D5,DCB4,B0AC,DCB5,BDDA,DCB9,D8C2,DCB7,D3F3,C9D6,DCBA,DCB6,DCBB,C3A2,DCBC,DCC5,DCBD,CEDF,D6A5,DCCF,DCCD,DCD2,BDE6,C2AB,DCB8,DCCB,DCCE,DCBE,B7D2,B0C5,DCC7,D0BE,DCC1,BBA8,B7BC,DCCC,DCC6,DCBF,C7DB,D1BF,DCC0,DCCA,DCD0,CEAD,DCC2,DCC3,DCC8,DCC9,B2D4,DCD1,CBD5,D4B7,DCDB,DCDF,CCA6,DCE6,C3E7,DCDC,BFC1,DCD9,B0FA,B9B6,DCE5,DCD3,DCC4,DCD6,C8F4,BFE0,C9BB,B1BD,D3A2,DCDA,DCD5,C6BB,DCDE,D7C2,C3AF,B7B6,C7D1,C3A9,DCE2,DCD8,DCEB,DCD4,DCDD,BEA5,DCD7,DCE0,DCE3,DCE4,DCF8,DCE1,DDA2,DCE7,BCEB,B4C4,C3A3,B2E7,DCFA,DCF2,DCEF,DCFC,DCEE,D2F0,B2E8,C8D7,C8E3,DCFB,DCED,DCF7,DCF5,BEA3,DCF4,B2DD,DCF3,BCF6,DCE8,BBC4,C0F3,BCD4,DCE9,DCEA,DCF1,DCF6,DCF9,B5B4,C8D9,BBE7,DCFE,DCFD,D3AB,DDA1,DDA3,DDA5,D2F1,DDA4,DDA6,DDA7,D2A9,BAC9,DDA9,DDB6,DDB1,DDB4,DDB0,C6CE,C0F2,C9AF,DCEC,DDAE,DDB7,DCF0,DDAF,DDB8,DDAC,DDB9,DDB3,DDAD,C4AA,DDA8,C0B3,C1AB,DDAA,DDAB,DDB2,BBF1,DDB5,D3A8,DDBA,DDBB,C3A7,DDD2,DDBC,DDD1,B9BD,BED5,BEFA,BACA,DDCA,DDC5,DDBF,B2CB,DDC3,DDCB,B2A4,DDD5,DDBE,C6D0,DDD0,DDD4,C1E2,B7C6,DDCE,DDCF,DDC4,DDBD,DDCD,CCD1,DDC9,DDC2,C3C8,C6BC,CEAE,DDCC,DDC8,DDC1,DDC6,C2DC,D3A9,D3AA,DDD3,CFF4,C8F8,DDE6,DDC7,DDE0,C2E4,DDE1,DDD7,D6F8,DDD9,DDD8,B8F0,DDD6,C6CF,B6AD,DDE2,BAF9,D4E1,DDE7,B4D0,DDDA,BFFB,DDE3,DDDF,DDDD,B5D9,DDDB,DDDC,DDDE,BDAF,DDE4,DDE5,DDF5,C3C9,CBE2,DDF2,D8E1,C6D1,DDF4,D5F4,DDF3,DDF0,DDEC,DDEF,DDE8,D0EE,C8D8,DDEE,DDE9,DDEA,CBF2,DDED,B1CD,C0B6,BCBB,DDF1,DDF7,DDF6,DDEB,C5EE,DDFB,DEA4,DEA3,DDF8,C3EF,C2FB,D5E1,CEB5,DDFD,B2CC,C4E8,CADF,C7BE,DDFA,DDFC,DDFE,DEA2,B0AA,B1CE,DEAC,DEA6,BDB6,C8EF,DEA1,DEA5,DEA9,DEA8,DEA7,DEAD,D4CC,DEB3,DEAA,DEAE,C0D9,B1A1,DEB6,DEB1,DEB2,D1A6,DEB5,DEAF,DEB0,D0BD,DEB4,CAED,DEB9,DEB8,DEB7,DEBB,BDE5,B2D8,C3EA,DEBA,C5BA,DEBC,CCD9,B7AA,D4E5,DEBD,DEBF,C4A2,DEC1,DEBE,DEC0,D5BA,DEC2,F2AE,BBA2,C2B2,C5B0,C2C7,F2AF,D0E9,D3DD,EBBD,B3E6,F2B0,F2B1,CAAD,BAE7,F2B3,F2B5,F2B4,CBE4,CFBA,F2B2,CAB4,D2CF,C2EC,CEC3,F2B8,B0F6,F2B7,F2BE,B2CF,D1C1,F2BA,F2BC,D4E9,F2BB,F2B6,F2BF,F2BD,F2B9,F2C7,F2C4,F2C6,F2CA,F2C2,F2C0,F2C5,D6FB,F2C1,C7F9,C9DF,F2C8,B9C6,B5B0,F2C3,F2C9,F2D0,F2D6,BBD7,F2D5,CDDC,D6EB,F2D2,F2D4,B8F2,F2CB,F2CE,C2F9,D5DD,F2CC,F2CD,F2CF,F2D3,F2D9,D3BC,B6EA,CAF1,B7E4,F2D7,F2D8,F2DA,F2DD,F2DB,F2DC,D1D1,F2D1,CDC9,CECF,D6A9,F2E3,C3DB,F2E0,C0AF,F2EC,F2DE,F2E1,F2E8,F2E2,F2E7,F2E6,F2E9,F2DF,F2E4,F2EA,D3AC,F2E5,B2F5,F2F2,D0AB,F2F5,BBC8,F2F9,F2F0,F2F6,F2F8,F2FA,F2F3,F2F1,BAFB,B5FB,F2EF,F2F7,F2ED,F2EE,F2EB,F3A6,F3A3,F3A2,F2F4,C8DA,F2FB,F3A5,C3F8,F2FD,F3A7,F3A9,F3A4,F2FC,F3AB,F3AA,C2DD,F3AE,F3B0,F3A1,F3B1,F3AC,F3AF,F2FE,F3AD,F3B2,F3B4,F3A8,F3B3,F3B5,D0B7,F3B8,D9F9,F3B9,F3B7,C8E4,F3B6,F3BA,F3BB,B4C0,EEC3,F3BC,F3BD,D1AA,F4AC,D0C6,D0D0,D1DC,CFCE,BDD6,D1C3,BAE2,E1E9,D2C2,F1C2,B2B9,B1ED,F1C3,C9C0,B3C4,D9F2,CBA5,F1C4,D6D4,F1C5,F4C0,F1C6,D4AC,F1C7,B0C0,F4C1,F4C2,B4FC,C5DB,CCBB,D0E4,CDE0,F1C8,D9F3,B1BB,CFAE,B8A4,F1CA,F1CB,B2C3,C1D1,D7B0,F1C9,F1CC,F1CE,D9F6,D2E1,D4A3,F4C3,C8B9,F4C4,F1CD,F1CF,BFE3,F1D0,F1D4,F1D6,F1D1,C9D1,C5E1,C2E3,B9FC,F1D3,F1D5,B9D3,F1DB,BAD6,B0FD,F1D9,F1D8,F1D2,F1DA,F1D7,C8EC,CDCA,F1DD,E5BD,F1DC,F1DE,F1DF,CFE5,F4C5,BDF3,F1E0,F1E1,CEF7,D2AA,F1FB,B8B2,BCFB,B9DB,B9E6,C3D9,CAD3,EAE8,C0C0,BEF5,EAE9,EAEA,EAEB,EAEC,EAED,EAEE,EAEF,BDC7,F5FB,F5FD,F5FE,F5FC,BDE2,F6A1,B4A5,F6A2,F6A3,ECB2,D1D4,D9EA,F6A4,EEBA,D5B2,D3FE,CCDC,CAC4,E5C0,F6A5,BEAF,C6A9,DAA5,BCC6,B6A9,B8BC,C8CF,BCA5,DAA6,DAA7,CCD6,C8C3,DAA8,C6FD,D1B5,D2E9,D1B6,BCC7,BDB2,BBE4,DAA9,DAAA,D1C8,DAAB,D0ED,B6EF,C2DB,CBCF,B7ED,C9E8,B7C3,BEF7,D6A4,DAAC,DAAD,C6C0,D7E7,CAB6,D5A9,CBDF,D5EF,DAAE,D6DF,B4CA,DAB0,DAAF,D2EB,DAB1,DAB2,DAB3,CAD4,DAB4,CAAB,DAB5,DAB6,B3CF,D6EF,DAB7,BBB0,B5AE,DAB8,DAB9,B9EE,D1AF,D2E8,DABA,B8C3,CFEA,B2EF,DABB,DABC,BDEB,CEDC,D3EF,DABD,CEF3,DABE,D3D5,BBE5,DABF,CBB5,CBD0,DAC0,C7EB,D6EE,DAC1,C5B5,B6C1,DAC2,B7CC,BFCE,DAC3,DAC4,CBAD,DAC5,B5F7,DAC6,C1C2,D7BB,DAC7,CCB8,D2EA,C4B1,DAC8,B5FD,BBD1,DAC9,D0B3,DACA,DACB,CEBD,DACC,DACD,DACE,B2F7,DAD1,DACF,D1E8,DAD0,C3D5,DAD2,DAD3,DAD4,DAD5,D0BB,D2A5,B0F9,DAD6,C7AB,DAD7,BDF7,C3A1,DAD8,DAD9,C3FD,CCB7,DADA,DADB,C0BE,C6D7,DADC,DADD,C7B4,DADE,DADF,B9C8,BBED,B6B9,F4F8,F4F9,CDE3,F5B9,EBE0,CFF3,BBBF,BAC0,D4A5,E1D9,F5F4,B1AA,B2F2,F5F5,F5F7,BAD1,F5F6,C3B2,F5F9,F5F8,B1B4,D5EA,B8BA,B9B1,B2C6,D4F0,CFCD,B0DC,D5CB,BBF5,D6CA,B7B7,CCB0,C6B6,B1E1,B9BA,D6FC,B9E1,B7A1,BCFA,EADA,EADB,CCF9,B9F3,EADC,B4FB,C3B3,B7D1,BAD8,EADD,D4F4,EADE,BCD6,BBDF,EADF,C1DE,C2B8,D4DF,D7CA,EAE0,EAE1,EAE4,EAE2,EAE3,C9DE,B8B3,B6C4,EAE5,CAEA,C9CD,B4CD,E2D9,C5E2,EAE6,C0B5,D7B8,EAE7,D7AC,C8FC,D8D3,D8CD,D4DE,D4F9,C9C4,D3AE,B8D3,B3E0,C9E2,F4F6,BAD5,F4F7,D7DF,F4F1,B8B0,D5D4,B8CF,C6F0,B3C3,F4F2,B3AC,D4BD,C7F7,F4F4,F4F3,CCCB,C8A4,F4F5,D7E3,C5BF,F5C0,F5BB,F5C3,F5C2,D6BA,F5C1,D4BE,F5C4,F5CC,B0CF,B5F8,F5C9,F5CA,C5DC,F5C5,F5C6,F5C7,F5CB,BEE0,F5C8,B8FA,F5D0,F5D3,BFE7,B9F2,F5BC,F5CD,C2B7,CCF8,BCF9,F5CE,F5CF,F5D1,B6E5,F5D2,F5D5,F5BD,F5D4,D3BB,B3EC,CCA4,F5D6,F5D7,BEE1,F5D8,CCDF,F5DB,B2C8,D7D9,F5D9,F5DA,F5DC,F5E2,F5E0,F5DF,F5DD,F5E1,F5DE,F5E4,F5E5,CCE3,E5BF,B5B8,F5E3,F5E8,CCA3,F5E6,F5E7,F5BE,B1C4,F5BF,B5C5,B2E4,F5EC,F5E9,B6D7,F5ED,F5EA,F5EB,B4DA,D4EA,F5EE,B3F9,F5EF,F5F1,F5F0,F5F2,F5F3,C9ED,B9AA,C7FB,B6E3,CCC9,EAA6,B3B5,D4FE,B9EC,D0F9,E9ED,D7AA,E9EE,C2D6,C8ED,BAE4,E9EF,E9F0,E9F1,D6E1,E9F2,E9F3,E9F5,E9F4,E9F6,E9F7,C7E1,E9F8,D4D8,E9F9,BDCE,E9FA,E9FB,BDCF,E9FC,B8A8,C1BE,E9FD,B1B2,BBD4,B9F5,E9FE,EAA1,EAA2,EAA3,B7F8,BCAD,CAE4,E0CE,D4AF,CFBD,D5B7,EAA4,D5DE,EAA5,D0C1,B9BC,B4C7,B1D9,C0B1,B1E6,B1E7,B1E8,B3BD,C8E8,E5C1,B1DF,C1C9,B4EF,C7A8,D3D8,C6F9,D1B8,B9FD,C2F5,D3AD,D4CB,BDFC,E5C2,B7B5,E5C3,BBB9,D5E2,BDF8,D4B6,CEA5,C1AC,B3D9,CCF6,E5C6,E5C4,E5C8,E5CA,E5C7,B5CF,C6C8,B5FC,E5C5,CAF6,E5C9,C3D4,B1C5,BCA3,D7B7,CDCB,CBCD,CACA,CCD3,E5CC,E5CB,C4E6,D1A1,D1B7,E5CD,E5D0,CDB8,D6F0,E5CF,B5DD,CDBE,E5D1,B6BA,CDA8,B9E4,CAC5,B3D1,CBD9,D4EC,E5D2,B7EA,E5CE,E5D5,B4FE,E5D6,E5D3,E5D4,D2DD,C2DF,B1C6,D3E2,B6DD,CBEC,E5D7,D3F6,B1E9,B6F4,E5DA,E5D8,E5D9,B5C0,D2C5,E5DC,E5DE,E5DD,C7B2,D2A3,E5DB,D4E2,D5DA,E5E0,D7F1,E5E1,B1DC,D1FB,E5E2,E5E4,E5E3,E5E5,D2D8,B5CB,E7DF,DAF5,DAF8,DAF6,DAF7,DAFA,D0CF,C4C7,B0EE,D0B0,DAF9,D3CA,BAAA,DBA2,C7F1,DAFC,DAFB,C9DB,DAFD,DBA1,D7DE,DAFE,C1DA,DBA5,D3F4,DBA7,DBA4,DBA8,BDBC,C0C9,DBA3,DBA6,D6A3,DBA9,DBAD,DBAE,DBAC,BAC2,BFA4,DBAB,DBAA,D4C7,B2BF,DBAF,B9F9,DBB0,B3BB,B5A6,B6BC,DBB1,B6F5,DBB2,B1C9,DBB4,DBB3,DBB5,DBB7,DBB6,DBB8,DBB9,DBBA,D3CF,F4FA,C7F5,D7C3,C5E4,F4FC,F4FD,F4FB,BEC6,D0EF,B7D3,D4CD,CCAA,F5A2,F5A1,BAA8,F4FE,CBD6,F5A4,C0D2,B3EA,CDAA,F5A5,F5A3,BDB4,F5A8,F5A9,BDCD,C3B8,BFE1,CBE1,F5AA,F5A6,F5A7,C4F0,F5AC,B4BC,D7ED,B4D7,F5AB,F5AE,F5AD,F5AF,D0D1,C3D1,C8A9,F5B0,F5B1,F5B2,F5B3,F5B4,F5B5,F5B7,F5B6,F5B8,B2C9,D3D4,CACD,C0EF,D6D8,D2B0,C1BF,BDF0,B8AA,BCF8,F6C6,F6C7,F6C8,F6C9,F6CA,F6CC,F6CB,F7E9,F6CD,F6CE,EEC4,EEC5,EEC6,D5EB,B6A4,EEC8,EEC7,EEC9,EECA,C7A5,EECB,EECC,B7B0,B5F6,EECD,EECF,EECE,B8C6,EED0,EED1,EED2,B6DB,B3AE,D6D3,C4C6,B1B5,B8D6,EED3,EED4,D4BF,C7D5,BEFB,CED9,B9B3,EED6,EED5,EED8,EED7,C5A5,EED9,EEDA,C7AE,EEDB,C7AF,EEDC,B2A7,EEDD,EEDE,EEDF,EEE0,EEE1,D7EA,EEE2,EEE3,BCD8,EEE4,D3CB,CCFA,B2AC,C1E5,EEE5,C7A6,C3AD,EEE6,EEE7,EEE8,EEE9,EEEA,EEEB,EEEC,EEED,EEEE,EEEF,EEF0,EEF1,EEF2,EEF4,EEF3,EEF5,CDAD,C2C1,EEF6,EEF7,EEF8,D5A1,EEF9,CFB3,EEFA,EEFB,EEFC,EEFD,EFA1,EEFE,EFA2,B8F5,C3FA,EFA3,EFA4,BDC2,D2BF,B2F9,EFA5,EFA6,EFA7,D2F8,EFA8,D6FD,EFA9,C6CC,EFAA,EFAB,C1B4,EFAC,CFFA,CBF8,EFAE,EFAD,B3FA,B9F8,EFAF,EFB0,D0E2,EFB1,EFB2,B7E6,D0BF,EFB3,EFB4,EFB5,C8F1,CCE0,EFB6,EFB7,EFB8,EFB9,EFBA,D5E0,EFBB,B4ED,C3AA,EFBC,EFBD,EFBE,EFBF,CEFD,EFC0,C2E0,B4B8,D7B6,BDF5,CFC7,EFC3,EFC1,EFC2,EFC4,B6A7,BCFC,BEE2,C3CC,EFC5,EFC6,EFC7,EFCF,EFC8,EFC9,EFCA,C7C2,EFF1,B6CD,EFCB,EFCC,EFCD,B6C6,C3BE,EFCE,EFD0,EFD1,EFD2,D5F2,EFD3,C4F7,EFD4,C4F8,EFD5,EFD6,B8E4,B0F7,EFD7,EFD8,EFD9,EFDA,EFDB,EFDC,EFDD,EFDE,BEB5,EFE1,EFDF,EFE0,EFE2,EFE3,C1CD,EFE4,EFE5,EFE6,EFE7,EFE8,EFE9,EFEA,EFEB,EFEC,C0D8,EFED,C1AD,EFEE,EFEF,EFF0,CFE2,B3A4,C3C5,E3C5,C9C1,E3C6,B1D5,CECA,B4B3,C8F2,E3C7,CFD0,E3C8,BCE4,E3C9,E3CA,C3C6,D5A2,C4D6,B9EB,CEC5,E3CB,C3F6,E3CC,B7A7,B8F3,BAD2,E3CD,E3CE,D4C4,E3CF,E3D0,D1CB,E3D1,E3D2,E3D3,E3D4,D1D6,E3D5,B2FB,C0BB,E3D6,C0AB,E3D7,E3D8,E3D9,E3DA,E3DB,B8B7,DAE2,B6D3,DAE4,DAE3,DAE6,C8EE,DAE5,B7C0,D1F4,D2F5,D5F3,BDD7,D7E8,DAE8,DAE7,B0A2,CDD3,DAE9,B8BD,BCCA,C2BD,C2A4,B3C2,DAEA,C2AA,C4B0,BDB5,CFDE,DAEB,C9C2,B1DD,DAEC,B6B8,D4BA,B3FD,DAED,D4C9,CFD5,C5E3,DAEE,DAEF,DAF0,C1EA,CCD5,CFDD,D3E7,C2A1,DAF1,CBE5,DAF2,CBE6,D2FE,B8F4,DAF3,B0AF,CFB6,D5CF,CBED,DAF4,E3C4,C1A5,F6BF,F6C0,F6C1,C4D1,C8B8,D1E3,D0DB,D1C5,BCAF,B9CD,EFF4,B4C6,D3BA,F6C2,B3FB,F6C3,B5F1,F6C5,D3EA,F6A7,D1A9,F6A9,F6A8,C1E3,C0D7,B1A2,CEED,D0E8,F6AB,CFF6,F6AA,D5F0,F6AC,C3B9,BBF4,F6AE,F6AD,C4DE,C1D8,CBAA,CFBC,F6AF,F6B0,F6B1,C2B6,B0D4,C5F9,F6B2,C7E0,F6A6,BEB8,BEB2,B5E5,B7C7,BFBF,C3D2,C3E6,D8CC,B8EF,BDF9,D1A5,B0D0,F7B0,F7B1,D0AC,B0B0,F7B2,F7B3,F7B4,C7CA,BECF,F7B7,F7B6,B1DE,F7B5,F7B8,F7B9,CEA4,C8CD,BAAB,E8B8,E8B9,E8BA,BEC2,D2F4,D4CF,C9D8,D2B3,B6A5,C7EA,F1FC,CFEE,CBB3,D0EB,E7EF,CDE7,B9CB,B6D9,F1FD,B0E4,CBCC,F1FE,D4A4,C2AD,C1EC,C6C4,BEB1,F2A1,BCD5,F2A2,F2A3,F2A4,D2C3,C6B5,CDC7,F2A5,D3B1,BFC5,CCE2,F2A6,F2A7,D1D5,B6EE,F2A8,F2A9,B5DF,F2AA,F2AB,B2FC,F2AC,F2AD,C8A7,B7E7,ECA9,ECAA,ECAB,ECAC,C6AE,ECAD,ECAE,B7C9,CAB3,E2B8,F7CF,F7D0,B2CD,F7D1,F7D3,F7D2,E2BB,BCA2,E2BC,E2BD,E2BE,E2BF,E2C0,E2C1,B7B9,D2FB,BDA4,CACE,B1A5,CBC7,E2C2,B6FC,C8C4,E2C3,BDC8,B1FD,E2C4,B6F6,E2C5,C4D9,E2C6,CFDA,B9DD,E2C7,C0A1,E2C8,B2F6,E2C9,C1F3,E2CA,E2CB,C2F8,E2CC,E2CD,E2CE,CAD7,D8B8,D9E5,CFE3,F0A5,DCB0,C2ED,D4A6,CDD4,D1B1,B3DB,C7FD,B2B5,C2BF,E6E0,CABB,E6E1,E6E2,BED4,E6E3,D7A4,CDD5,E6E5,BCDD,E6E4,E6E6,E6E7,C2EE,BDBE,E6E8,C2E6,BAA7,E6E9,E6EA,B3D2,D1E9,BFA5,E6EB,C6EF,E6EC,E6ED,E6EE,C6AD,E6EF,C9A7,E6F0,E6F1,E6F2,E5B9,E6F3,E6F4,C2E2,E6F5,E6F6,D6E8,E6F7,E6F8,B9C7,F7BB,F7BA,F7BE,F7BC,BAA1,F7BF,F7C0,F7C2,F7C1,F7C4,F7C3,F7C5,F7C6,F7C7,CBE8,B8DF,F7D4,F7D5,F7D6,F7D8,F7DA,F7D7,F7DB,F7D9,D7D7,F7DC,F7DD,F7DE,F7DF,F7E0,DBCB,D8AA,E5F7,B9ED,BFFD,BBEA,F7C9,C6C7,F7C8,F7CA,F7CC,F7CB,F7CD,CEBA,F7CE,C4A7,D3E3,F6CF,C2B3,F6D0,F6D1,F6D2,F6D3,F6D4,F6D6,B1AB,F6D7,F6D8,F6D9,F6DA,F6DB,F6DC,F6DD,F6DE,CFCA,F6DF,F6E0,F6E1,F6E2,F6E3,F6E4,C0F0,F6E5,F6E6,F6E7,F6E8,F6E9,F6EA,F6EB,F6EC,F6ED,F6EE,F6EF,F6F0,F6F1,F6F2,F6F3,F6F4,BEA8,F6F5,F6F6,F6F7,F6F8,C8FA,F6F9,F6FA,F6FB,F6FC,F6FD,F6FE,F7A1,F7A2,F7A3,F7A4,F7A5,F7A6,F7A7,F7A8,B1EE,F7A9,F7AA,F7AB,F7AC,F7AD,C1DB,F7AE,F7AF,C4F1,F0AF,BCA6,F0B0,C3F9,C5B8,D1BB,F0B1,F0B2,F0B3,F0B4,F0B5,D1BC,D1EC,F0B7,F0B6,D4A7,CDD2,F0B8,F0BA,F0B9,F0BB,F0BC,B8EB,F0BD,BAE8,F0BE,F0BF,BEE9,F0C0,B6EC,F0C1,F0C2,F0C3,F0C4,C8B5,F0C5,F0C6,F0C7,C5F4,F0C8,F0C9,F0CA,F7BD,F0CB,F0CC,F0CD,F0CE,F0CF,BAD7,F0D0,F0D1,F0D2,F0D3,F0D4,F0D5,F0D6,F0D8,D3A5,F0D7,F0D9,F5BA,C2B9,F7E4,F7E5,F7E6,F7E7,F7E8,C2B4,F7EA,F7EB,C2F3,F4F0,F4EF,C2E9,F7E1,F7E2,BBC6,D9E4,CAF2,C0E8,F0A4,BADA,C7AD,C4AC,F7EC,F7ED,F7EE,F7F0,F7EF,F7F1,F7F4,F7F3,F7F2,F7F5,F7F6,EDE9,EDEA,EDEB,F6BC,F6BD,F6BE,B6A6,D8BE,B9C4,D8BB,DCB1,CAF3,F7F7,F7F8,F7F9,F7FB,F7FA,B1C7,F7FC,F7FD,F7FE,C6EB,ECB4,B3DD,F6B3,F6B4,C1E4,F6B5,F6B6,F6B7,F6B8,F6B9,F6BA,C8A3,F6BB,C1FA,B9A8,EDE8,B9EA,D9DF,A3A1,A3A2,A3A3,A1E7,A3A5,A3A6,A3A7,A3A8,A3A9,A3AA,A3AB,A3AC,A3AD,A3AE,A3AF,A3B0,A3B1,A3B2,A3B3,A3B4,A3B5,A3B6,A3B7,A3B8,A3B9,A3BA,A3BB,A3BC,A3BD,A3BE,A3BF,A3C0,A3C1,A3C2,A3C3,A3C4,A3C5,A3C6,A3C7,A3C8,A3C9,A3CA,A3CB,A3CC,A3CD,A3CE,A3CF,A3D0,A3D1,A3D2,A3D3,A3D4,A3D5,A3D6,A3D7,A3D8,A3D9,A3DA,A3DB,A3DC,A3DD,A3DE,A3DF,A3E0,A3E1,A3E2,A3E3,A3E4,A3E5,A3E6,A3E7,A3E8,A3E9,A3EA,A3EB,A3EC,A3ED,A3EE,A3EF,A3F0,A3F1,A3F2,A3F3,A3F4,A3F5,A3F6,A3F7,A3F8,A3F9,A3FA,A3FB,A3FC,A3FD,A1AB,A1E9,A1EA,A3FE,A3A4';
        }
        UnicodeToAnsi = function (chrCode) {
            var chrHex = chrCode.toString(16);
            chrHex = "000" + chrHex.toUpperCase();
            chrHex = chrHex.substr(chrHex.length - 4);
            var i = UnicodeChr().indexOf(chrHex);

            if (i != -1) {
                chrHex = AnsicodeChr().substr(i, 4);
            }
            return parseInt(chrHex, 16)
        }
        AnsiToUnicode = function (chrCode) {
            var chrHex = chrCode.toString(16);
            chrHex = "000" + chrHex.toUpperCase();
            chrHex = chrHex.substr(chrHex.length - 4);
            var i = AnsicodeChr().indexOf(chrHex);

            if (i != -1) {
                chrHex = UnicodeChr().substr(i, 4);
            }
            return parseInt(chrHex, 16)
        }
        strUnicode2Ansi = function (asContents) {
            var len1 = asContents.length;
            var temp = "";
            for (var i = 0; i < len1; i++) {
                var varasc = asContents.charCodeAt(i);
                if (varasc < 0)
                    varasc += 65536;

                if (varasc > 127)
                    varasc = UnicodeToAnsi(varasc);

                if (varasc > 255) {
                    var varlow = varasc & 65280;
                    varlow = varlow >> 8;
                    var varhigh = varasc & 255;
                    temp += String.fromCharCode(varlow) + String.fromCharCode(varhigh);
                }
                else {
                    temp += String.fromCharCode(varasc);
                }
            }
            return temp;
        }
        strAnsi2Unicode = function (asContents) {
            var len1 = asContents.length;
            var temp = "";
            var chrcode;
            for (var i = 0; i < len1; i++) {
                var varasc = asContents.charCodeAt(i);

                if (varasc > 127) {
                    chrcode = AnsiToUnicode((varasc << 8) + asContents.charCodeAt(++i));
                }
                else {
                    chrcode = varasc;
                }

                temp += String.fromCharCode(chrcode);
            }
            return temp;
        }
        utf16to8 = function (str) {
            var out, i, len, c;
            out = "";
            len = str.length;
            for (i = 0; i < len; i++) {
                c = str.charCodeAt(i);
                if ((c >= 0x0001) && (c <= 0x007F)) {
                    out += str.charAt(i);
                } else if (c > 0x07FF) {
                    out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
                    out += String.fromCharCode(0x80 | ((c >> 6) & 0x3F));
                    out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
                } else {
                    out += String.fromCharCode(0xC0 | ((c >> 6) & 0x1F));
                    out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
                }
            }
            return out;
        }
        utf8to16 = function (str) {
            var out, i, len, c;
            var char2, char3;
            out = "";
            len = str.length;
            i = 0;
            while (i < len) {
                c = str.charCodeAt(i++);
                switch (c >> 4) {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
// 0xxxxxxx
                        out += str.charAt(i - 1);
                        break;
                    case 12:
                    case 13:
// 110x xxxx 10xx xxxx
                        char2 = str.charCodeAt(i++);
                        out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
                        break;
                    case 14:
// 1110 xxxx 10xx xxxx 10xx xxxx
                        char2 = str.charCodeAt(i++);
                        char3 = str.charCodeAt(i++);
                        out += String.fromCharCode(((c & 0x0F) << 12) |
                            ((char2 & 0x3F) << 6) |
                            ((char3 & 0x3F) << 0));
                        break;
                }
            }
            return out;
        }
        encode64 = function (input) {
            var output = "";
            var chr1, chr2, chr3 = "";
            var enc1, enc2, enc3, enc4 = "";
            var i = 0;
            do {
                chr1 = input.charCodeAt(i++);
                chr2 = input.charCodeAt(i++);
                chr3 = input.charCodeAt(i++);
                enc1 = chr1 >> 2;
                enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                enc4 = chr3 & 63;
                if (isNaN(chr2)) {
                    enc3 = enc4 = 64;
                } else if (isNaN(chr3)) {
                    enc4 = 64;
                }
                output = output +
                    keyStr.charAt(enc1) +
                    keyStr.charAt(enc2) +
                    keyStr.charAt(enc3) +
                    keyStr.charAt(enc4);
                chr1 = chr2 = chr3 = "";
                enc1 = enc2 = enc3 = enc4 = "";
            } while (i < input.length);
            return output;
        }
        decode64 = function (input) {
            var output = "";
            var chr1, chr2, chr3 = "";
            var enc1, enc2, enc3, enc4 = "";
            var i = 0;

            if (input.length % 4 != 0) {
                return "";
            }
            var base64test = /[^A-Za-z0-9/+///=]/g;
            if (base64test.exec(input)) {
                return "";
            }
            do {
                enc1 = keyStr.indexOf(input.charAt(i++));
                enc2 = keyStr.indexOf(input.charAt(i++));
                enc3 = keyStr.indexOf(input.charAt(i++));
                enc4 = keyStr.indexOf(input.charAt(i++));
                chr1 = (enc1 << 2) | (enc2 >> 4);
                chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                chr3 = ((enc3 & 3) << 6) | enc4;

                output = output + String.fromCharCode(chr1);
                if (enc3 != 64) {
                    output += String.fromCharCode(chr2);
                }
                if (enc4 != 64) {
                    output += String.fromCharCode(chr3);
                }
                chr1 = chr2 = chr3 = "";
                enc1 = enc2 = enc3 = enc4 = "";
            } while (i < input.length);
            return output;
        }

        if (opts.data == "") {
            return false;
        } else {
            if (opts.type == 0) {
                if (opts.unicode == true) {
                    return encode64(strUnicode2Ansi(opts.data));
                } else {
                    return encode64(opts.data);
                }
            } else {
                if (opts.unicode == true) {
                    return strAnsi2Unicode(decode64(opts.data)).replace(/(\\u)(\w{4}|\w{2})/gi, function ($0, $1, $2) {
                        return String.fromCharCode(parseInt($2, 16));
                    });
                } else {
                    return utf8to16(decode64(opts.data));
                }
            }
        }
    }
})(jQuery);
;
///<jscompress sourcefile="calendar.js" />

/**
 * Calendar
 * @param   beginYear           1990
 * @param   endYear             2010
 * @param   language            0(zh_cn)|1(en_us)|2(en_en)|3(zh_tw)
 * @param   patternDelimiter    "-"
 * @param   date2StringPattern  "yyyy-MM-dd"
 * @param   string2DatePattern  "ymd"
 * @version 1.0 build 2006-04-01
 * @version 1.1 build 2006-12-17
 * @author  KimSoft (jinqinghua [at] gmail.com)
 * NOTE!    you can use it free, but keep the copyright please
 * IMPORTANT:you must include this script file inner html body elment 
 */
function Calendar(beginYear, endYear, language, patternDelimiter, date2StringPattern, string2DatePattern) {
	this.initDom = false;
  this.beginYear = beginYear || 1960;
	this.endYear   = endYear   || 2020;
	this.language  = language  || 0;
	this.patternDelimiter = patternDelimiter     || "-";
	this.date2StringPattern = date2StringPattern || Calendar.language["date2StringPattern"][this.language].replace(/\-/g, this.patternDelimiter);
	this.string2DatePattern = string2DatePattern || Calendar.language["string2DatePattern"][this.language];
	
	this.dateControl = null;
	//this.panel  = this.getElementById("__calendarPanel");
	//this.iframe = window.frames["__calendarIframe"];
	this.form   = null;
	
	this.date = new Date();
	this.year = this.date.getFullYear();
	this.month = this.date.getMonth();
	
	this.colors = {"bg_cur_day":"#00CC33","bg_over_cur_day":"#ccc","bg_over":"#ffffff","bg_out":"#FFCC00"}
};

Calendar.language = {
	"year"   : ["\u5e74", "", "", "\u5e74"],
	"months" : [
				["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"],
				["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
				["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
				["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"]
				],
	"weeks"  : [["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"],
				["Sun","Mon","Tur","Wed","Thu","Fri","Sat"],
				["Sun","Mon","Tur","Wed","Thu","Fri","Sat"],
				["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"]
		],
	"clear"  : ["\u6e05\u7a7a", "Clear", "Clear", "\u6e05\u7a7a"],
	"today"  : ["\u4eca\u5929", "Today", "Today", "\u4eca\u5929"],
	"close"  : ["\u786E\u5B9A", "Close", "Close", "\u95dc\u9589"],
	"date2StringPattern" : ["yyyy-MM-dd hh:mm:ss", "yyyy-MM-dd", "yyyy-MM-dd", "yyyy-MM-dd"],
	"string2DatePattern" : ["ymd","ymd", "ymd", "ymd"],
  "tipText" : ["\u4FEE\u6539\u65F6\u95F4"]
};

Calendar.prototype.draw = function() {
	calendar = this;
	
	var _cs = [];
	_cs[_cs.length] = '<form id="__calendarForm" name="__calendarForm" method="post">';
	_cs[_cs.length] = '<table id="__calendarTable" width="100%" border="0" cellpadding="0" cellspacing="0" align="center">';
  //_cs[_cs.length] = ' <tr class="toptit" style="height:10px; width:244px; padding:0;"><th style="height:10px; padding:0;" colspan="7"><\/th><\/tr>';
  _cs[_cs.length] = ' <tr class="toptit">';
	_cs[_cs.length] = '  <th class="toplBtn"><input class="l" name="goPrevMonthButton" type="button" id="goPrevMonthButton" value="&lt;" \/><\/th>';
	_cs[_cs.length] = '  <th class="topSelectWrap" colspan="5"><select class="year" name="yearSelect" id="yearSelect"><\/select><select class="month" name="monthSelect" id="monthSelect"><\/select><\/th>';
	_cs[_cs.length] = '  <th class="toprBtn"><input class="r" name="goNextMonthButton" type="button" id="goNextMonthButton" value="&gt;" \/><\/th>';
	_cs[_cs.length] = ' <\/tr>';
	_cs[_cs.length] = ' <tr class="toptit line">';

	for(var i = 0,thcls = "theader"; i < 7; i++) {
    if (i == 0){
      thcls = "theader first";
    }else if(i==6){
      thcls = "theader last";
    }else {
      thcls = "theader";
    }
		_cs[_cs.length] = '<th class="'+ thcls+ '">';
		_cs[_cs.length] = Calendar.language["weeks"][this.language][i];
		_cs[_cs.length] = '<\/th>';	
	}
	_cs[_cs.length] = '<\/tr>';
	_cs[_cs.length] = ' <tr class="noBg" style="height:1px; width:244px; padding:0;"><th style="height:10px;width:244px; background-color:#fffff; padding:0;" colspan="7"><\/th><\/tr>';
	for(var i = 0; i < 6; i++){
		_cs[_cs.length] = '<tr align="center">';
		for(var j = 0; j < 7; j++) {
			switch (j) {
				case 0: _cs[_cs.length] = '<td class="sun">&nbsp;<\/td>'; break;
				case 6: _cs[_cs.length] = '<td class="sat">&nbsp;<\/td>'; break;
				default:_cs[_cs.length] = '<td class="normal">&nbsp;<\/td>'; break;
			}
		}
		_cs[_cs.length] = '<\/tr>';
	}

  if (this.mmbtn) {
	_cs[_cs.length] = ' <tr class="trchange">';
  this.panel.style.height = '271px';
  } else {
    _cs[_cs.length] = ' <tr class="trchange" style="display:none;">';
    this.panel.style.height = '231px';
  }
  _cs[_cs.length] = '<th class="thCl" colspan="2" style="width:70px; padding-left:10px;"> <span id="tipText" ><\/span><\/th>';
	_cs[_cs.length] = '<th class="thCl" colspan="3" style="width:100px; "> ';
	_cs[_cs.length] = '<div class="inputWrap"> <input type="text" size="2" name="hourVal" value="" id="hourVal"\/>:<input type="text" name="minuteVal" value="" size="2" id="minuteVal"\/><\/div><\/th>';
	_cs[_cs.length] = '<th class="thCl" colspan="2" style="width:70px; padding-left:0;  padding-right:28px;"><div class="btnWrap"> <a href="javascript:" class="buttons" id = "addsBtn">+</a> <a href="javascript:" class="buttons" id="subtractBtn">-</a><\/div><\/th>';
	_cs[_cs.length] = ' <\/tr>';
 
	_cs[_cs.length] = ' <tr class="trbtns" style="display:none;">';
	_cs[_cs.length] = '  <th colspan="2" style="width:65px; padding-left:17px;"><input type="button" class="b" name="clearButton" id="clearButton" \/><\/th>';
	_cs[_cs.length] = '  <th class="thbtn3" colspan="3" style="width:102px;"><input type="button" class="b" name="selectTodayButton" id="selectTodayButton" \/><\/th>';
	_cs[_cs.length] = '  <th colspan="2" style="width:67px; padding-right:17px;"><input type="button" class="b" name="closeButton" id="closeButton" \/><\/th>';
	_cs[_cs.length] = ' <\/tr>';

	//_cs[_cs.length] = '<\/th> <\/tr>';
	_cs[_cs.length] = '<\/table>';
	_cs[_cs.length] = '<\/form>';
	
	this.iframe.document.body.innerHTML = _cs.join("");
	this.form = this.iframe.document.forms["__calendarForm"];

	this.form.clearButton.value = Calendar.language["clear"][this.language];
	this.form.selectTodayButton.value = Calendar.language["today"][this.language];
	this.form.closeButton.value = Calendar.language["close"][this.language];

  calendar.getElementById('tipText',this.iframe.document).innerHTML = Calendar.language["tipText"][this.language]+":";
  calendar.getElementById('addsBtn',this.iframe.document).onclick = function () {calendar.addHours(); return false;};
  calendar.getElementById('subtractBtn',this.iframe.document).onclick = function () {calendar.subtractHours(); return false;};
  
  this.form.hourVal.onchange = function () {calendar.changeHours(this.form); return false;};
  this.form.minuteVal.onchange = function () {calendar.changeHours(this.form); return false;};
	
	this.form.goPrevMonthButton.onclick = function () {calendar.goPrevMonth(this);}
	this.form.goNextMonthButton.onclick = function () {calendar.goNextMonth(this);}
	this.form.yearSelect.onchange = function () {calendar.update(this);}
	this.form.monthSelect.onchange = function () {calendar.update(this);}
	
	this.form.clearButton.onclick = function () {calendar.dateControl.value = "";calendar.hide();}
	this.form.closeButton.onclick = function () {calendar.hide();}
	this.form.selectTodayButton.onclick = function () {
		var today = new Date();
		calendar.date = today;
		calendar.year = today.getFullYear();
		calendar.month = today.getMonth();
		calendar.dateControl.value = today.format(calendar.date2StringPattern);
		calendar.hide();
	}
};

Calendar.prototype.addHours = function(d) {
  var d = this.form;
  var h = d.hourVal.value,
      m = d.minuteVal.value - 0;
  h = isNaN(h) ? 0 : h;
  m = isNaN(m) ? 0 : m;
  var now_h = (h - 0) + 1;
  if (now_h > 24){return;}
  now_h = now_h < 10 ? "0" + now_h : now_h;
  m = m < 10 ? "0" + m : m;
  d.hourVal.value = now_h;
  d.minuteVal.value = m;
  var oldymd = this.dateControl.value.substr(0,10);
  this.dateControl.value = oldymd + " " + d.hourVal.value +":"+ d.minuteVal.value + ":00";

};


Calendar.prototype.subtractHours = function(d) {
  var d = this.form;
  var h = d.hourVal.value,
      m = d.minuteVal.value - 0;
  h = isNaN(h) ? 0 : h;
  m = isNaN(m) ? 0 : m;
  var now_h = (h - 0) - 1;
  if (now_h < 1){return;}
  now_h = now_h < 10 ? "0" + now_h : now_h;
  m = m < 10 ? "0" + m : m;
  d.hourVal.value = now_h;
  d.minuteVal.value = m;
  var oldymd = this.dateControl.value.substr(0,10);
  this.dateControl.value = oldymd + " " + d.hourVal.value +":"+ d.minuteVal.value + ":00";

};

Calendar.prototype.changeHours = function(d) {
  var h = d.hourVal.value,
      m = d.minuteVal.value;
  h = isNaN(h) ? 0 : h;
  m = isNaN(m) ? 0 : m;
  var now_h = (h - 0);
  if (now_h > 24){now_h = 01;}
  var now_m = (m - 0);
  if (now_m > 60){now_m = 01;}
  now_h = now_h < 10 ? "0" + now_h : now_h;
  now_m = now_m < 10 ? "0" + now_m : now_m;
  d.hourVal.value = now_h;
  d.minuteVal.value = now_m;
  var oldymd = this.dateControl.value.substr(0,10);
  this.dateControl.value = oldymd + " " + d.hourVal.value +":"+ d.minuteVal.value + ":00";

};



Calendar.prototype.bindYear = function() {
	var ys = this.form.yearSelect;
	ys.length = 0;
	for (var i = this.beginYear; i <= this.endYear; i++){
		ys.options[ys.length] = new Option(i + Calendar.language["year"][this.language], i);
	}
};

Calendar.prototype.bindMonth = function() {
	var ms = this.form.monthSelect;
	ms.length = 0;
	for (var i = 0; i < 12; i++){
		ms.options[ms.length] = new Option(Calendar.language["months"][this.language][i], i);
	}
};

Calendar.prototype.goPrevMonth = function(e){
	if (this.year == this.beginYear && this.month == 0){return;}
	this.month--;
	if (this.month == -1) {
		this.year--;
		this.month = 11;
	}
	this.date = new Date(this.year, this.month, 1);
	this.changeSelect();
	this.bindData();
};

Calendar.prototype.goNextMonth = function(e){
	if (this.year == this.endYear && this.month == 11){return;}
  if (this.month >= new Date().getMonth() ) return;
	this.month++;
	if (this.month == 12) {
		this.year++;
		this.month = 0;
	}
	this.date = new Date(this.year, this.month, 1);
	this.changeSelect();
	this.bindData();
};

Calendar.prototype.changeSelect = function() {
	var ys = this.form.yearSelect;
	var ms = this.form.monthSelect;
	for (var i= 0; i < ys.length; i++){
		if (ys.options[i].value == this.date.getFullYear()){
			ys[i].selected = true;
			break;
		}
	}
	for (var i= 0; i < ms.length; i++){
		if (ms.options[i].value == this.date.getMonth()){
			ms[i].selected = true;
			break;
		}
	}
};

Calendar.prototype.update = function (e){
	this.year  = e.form.yearSelect.options[e.form.yearSelect.selectedIndex].value;
	this.month = e.form.monthSelect.options[e.form.monthSelect.selectedIndex].value;
	this.date = new Date(this.year, this.month, 1);
	this.changeSelect();
	this.bindData();
};

Calendar.prototype.bindData = function () {
	var calendar = this;

  if (calendar.dateControl && calendar.dateControl.value){
    var val = calendar.dateControl.value,
    y = val.substr(0,4),
    m = val.substr(5,2),
    d = val.substr(8,2),
    h = val.substr(11,2),
    mm = val.substr(14,2),
    s = val.substr(17,2),

    dd = new Date(y,m,d,h,mm,s),
    th = dd.getHours(),
    tm = dd.getMinutes();
    th = th < 10 ? "0" + th : th;
    tm = tm < 10 ? "0" + tm : tm;
    calendar.form.hourVal.value = th;
    calendar.form.minuteVal.value = tm;
  }else {
    var tdata = new Date().format(calendar.date2StringPattern),
    h = tdata.substr(11,2),
    mm = tdata.substr(14,2);
    calendar.dateControl.value = tdata;

    calendar.form.hourVal.value = h;
    calendar.form.minuteVal.value = mm;
  }

	var dateArray = this.getMonthViewDateArray(this.date.getFullYear(), this.date.getMonth());
	var tds = this.getElementsByTagName("td", this.getElementById("__calendarTable", this.iframe.document));
	for(var i = 0; i < tds.length; i++) {
    tds[i].style.backgroundColor = calendar.colors["bg_over"];
		tds[i].onclick = null;
		tds[i].onmouseover = null;
		tds[i].onmouseout = null;
		tds[i].innerHTML = dateArray[i] || "&nbsp;";
		if (i > dateArray.length - 1) continue;
		if (dateArray[i]){

      function clickfun(thtml) {
      	if (calendar.dateControl){
            var ymd = new Date(calendar.date.getFullYear(),
														calendar.date.getMonth(),
														thtml).format(calendar.date2StringPattern);
            var oldhms = calendar.dateControl.value.substr(10);
            if (calendar.mmbtn){
              calendar.dateControl.value = ymd.substr(0,10) + oldhms;
            } else {
              calendar.dateControl.value = ymd.substr(0,10);
            }
            
				}
				//calendar.hide();
      
      }

			tds[i].onclick = function () {
        //document.getElementByName('td').
        //this.style.backgroundColor= "#1A56A4";
        //this.setAttribute('class','cur');
        if (this.getAttribute('class') == 'disabled') return false;
        clickfun(this.innerHTML);
        calendar.panel.style.visibility = "hidden";
        calendar.panel.style.display = "none";
			}
			//tds[i].ondblclick = function () {
       // clickfun(this.innerHTML);
        //calendar.panel.style.visibility = "hidden";
        //calendar.panel.style.display = "none";
			//}

			//tds[i].onmouseover = function () {
        //this.style.backgroundColor = calendar.colors["bg_out"];
        //this.setAttribute('class','over');
      //}
			//tds[i].onmouseout  = function () {
        //this.style.backgroundColor = calendar.colors["bg_over"];
        //this.setAttribute('class','normal');
        //}
      var cls = tds[i].getAttribute('class') || ' ';
      if (cls && cls.indexOf('disabled')>-1) {
          cls = cls.replace('disabled', ' ');
          tds[i].setAttribute('class', cls);
      }

			var today = new Date();
			if (today.getFullYear() == calendar.date.getFullYear() ) {
				if (today.getMonth() == calendar.date.getMonth() ) {
					if (today.getDate() == dateArray[i] ) {
						tds[i].style.backgroundColor = calendar.colors["bg_cur_day"];
						tds[i].onmouseover = function () {this.style.backgroundColor = calendar.colors["bg_out"];}
						tds[i].onmouseout  = function () {this.style.backgroundColor = calendar.colors["bg_cur_day"];}
					} else if (today.getDate() < dateArray[i]) {
            tds[i].removeAttribute('class');
            tds[i].style.backgroundColor = calendar.colors["bg_over_cur_day"];
            tds[i].setAttribute('class','disabled');
          }
				}
			}
      /*if (today.getFullYear() <= calendar.date.getFullYear()) {
        console.log('1:'+today.getMonth());
        console.log('2:'+calendar.date.getMonth());
        if (today.getMonth() <= calendar.date.getMonth() ) {//&& today.getDate() < dateArray[i] 
          console.log('3:'+today.getDate());
          console.log('4:'+dateArray[i]);
          if ( today.getMonth() < calendar.date.getMonth() ) {
            //tds[i].removeAttribute('class');
            tds[i].style.backgroundColor = ''//calendar.colors["bg_over_cur_day"];
            tds[i].setAttribute('class','disabled');
          }
        }
      }*/
		}//end if
	}//end for
};

Calendar.prototype.getMonthViewDateArray = function (y, m) {
	var dateArray = new Array(42);
	var dayOfFirstDate = new Date(y, m, 1).getDay();
	var dateCountOfMonth = new Date(y, m + 1, 0).getDate();
	for (var i = 0; i < dateCountOfMonth; i++) {
		dateArray[i + dayOfFirstDate] = i + 1;
	}
	return dateArray;
};

Calendar.prototype.show = function (dateControl,mmbtn, popuControl) {
  this.mmbtn = mmbtn || false;
  if (!this.initDom) {this.initDoms();}
	if (this.panel.style.visibility == "visible") {
		this.panel.style.visibility = "hidden";
    this.panel.style.display = "none";
	}
	if (!dateControl){
		throw new Error("arguments[0] is necessary!")
	}
	this.dateControl = dateControl;
	popuControl = popuControl || dateControl;

	this.draw();
	this.bindYear();
	this.bindMonth();
	if (dateControl.value.length > 0){
		this.date  = new Date(dateControl.value.toDate(this.patternDelimiter, this.string2DatePattern));
		this.year  = this.date.getFullYear();
		this.month = this.date.getMonth();
	}
	this.changeSelect();
	this.bindData();

	/*var xy = this.getAbsPoint(popuControl);
	this.panel.style.left = xy.x + "px";
	this.panel.style.top = (xy.y + dateControl.offsetHeight) + "px";*/
	this.panel.style.visibility = "visible";
  this.panel.style.display = "block";
};

Calendar.prototype.hide = function() {
	this.panel.style.visibility = "hidden";
  this.panel.style.display = "none";
};

Calendar.prototype.getElementById = function(id, object){
	object = object || document;
	return document.getElementById ? object.getElementById(id) : document.all(id);
};

Calendar.prototype.getElementsByTagName = function(tagName, object){
	object = object || document;
	return document.getElementsByTagName ? object.getElementsByTagName(tagName) : document.all.tags(tagName);
};

Calendar.prototype.getAbsPoint = function (e){
	var x = e.offsetLeft;
	var y = e.offsetTop;
	while(e = e.offsetParent){
		x += e.offsetLeft;
		y += e.offsetTop;
	}
	return {"x": x, "y": y};
};

Calendar.prototype.initDoms = function () {
  var arr = [];
  var titArr = [];
  arr.push('<div id="__calendarPanel" style=" overflow: hidden; left:50%;top:50%;margin: -117px 0px auto -122px;border-radius:5px;  -moz-border-radius:5px;-webkit-border-radius:5px;position:absolute;visibility:hidden;display:none;z-index:9999;background-color:#FFFFFF;padding-top:2px;border:1px solid #cccccc;width:244px;height:271px;">');
  arr.push('<iframe name="__calendarIframe" id="__calendarIframe" width="100%" height="100%" scrolling="no" frameborder="0" style="margin:0px;opacity:1;">');
//var __ci = window.frames['__calendarIframe'];
  arr.push("<!DOCTYPE html>");
  arr.push('<html>');
  arr.push('<head>');
  titArr.push('<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />');
  titArr.push('<title>Web Calendar(UTF-8) Written By KimSoft</title>');

  titArr.push('<style type="text/css">');
  //titArr.push('<!--');
  titArr.push('body {font-size:12px;margin:0px;text-align:center;}');
  titArr.push('form {margin:0px;}');
  titArr.push('select {outline: none;font-size:12px; margin: 0 5px; color: #000000;}');
  titArr.push('table {background-color:#FFFFFF }');
  titArr.push('th {padding:0px;font-size:12px;font-weight:normal;background-color:#FAFAFA;}');
  titArr.push('th.theader {font-weight:normal;background-color:#fafafa;color:#000000;}');
  titArr.push('th.theader.first {color: #B8B8B8;padding-left:18px;width:40px;}');
  titArr.push('th.theader.last {color: #B8B8B8;padding-right:18px;width:40px;}');
  titArr.push('select.year {width:72px; padding:2px 0;}');
  titArr.push('select.month {width:65px; padding:2px 0;}');
  titArr.push('tr {text-align:center;padding: 0px;display:block;margin:0 auto; width:210px;}');
  titArr.push('td { background-color:#FAFAFA; border-radius:15px;  -moz-border-radius:15px;-webkit-border-radius:15px;font-size:12px;text-align:center; height:30px; width:30px;line-height:30px;margin:0 1px;display:inline-block;padding:0px;}');
  titArr.push('td.sat { width:30px; border-radius:15px;  -moz-border-radius:15px;-webkit-border-radius:15px;color:#b8b8b8;background-color:#ffffff;}');
  titArr.push('td.sun { border-radius:15px;  -moz-border-radius:15px;-webkit-border-radius:15px;color:#b8b8b8;background-color:#ffffff;}');
  titArr.push('td.normal {background-color:#ffffff;}');
  titArr.push('td.disabled {background-color:#CCCCCC; opacity:0.5}');

  titArr.push('input.l {outline: none;border: 1px solid #78A4DD; -moz-border-radius: 15px; -webkit-border-radius: 15px; border-radius: 15px; font-weight: 900; color: #78A4DD;background-color:#FFFFFF;width:23px;height:23px;}');

  titArr.push('input.r {outline: none;border: 1px solid #78A4DD;-moz-border-radius: 15px; -webkit-border-radius: 15px; border-radius: 15px; font-weight: 900; color: #78A4DD;background-color:#FFFFFF;width:23px;height:23px;}');
  titArr.push('input.b {outline: none;border: 1px solid #bcbcbc;-moz-border-radius: 3px; -webkit-border-radius: 3px; border-radius: 3px;  color: #000000;background-color:#FFFFFF;width:100%;height:26px;}');

  titArr.push('.thCl{text-align:left; font-weight: bold; padding-left: 5px;}');
  titArr.push('.thCl .cth{text-align:center;}');

  titArr.push('.thCl span{ width:60px; font-size: 12px;display:block;float:left;margin:0px 0px 0 0;}');
  titArr.push('.thCl input {background-color: #FFFFFF;color: #000000; padding: 2px 3px; font-size: 13px;width: 30px;height: 17px;border: 0px solid black;font-weight:bold;font-family: "宋体";text-align: center;}');
  titArr.push('.thCl .inputWrap{ margin: 0 0px 2px 5px; float:left;border: solid 1px #d4d4d4;width: 85px;line-height:30px;height: 30px;background-color: #FFFFFF;overflow: hidden;text-align: center;}');
  titArr.push('.thCl .buttons{outline:none;display:block; text-align: center; text-decoration: none;font-weight: bold;margin:0 0 3px 10px;background-color: #f0f0f0;color:#000000; border: solid 1px #78A4DD; width: 50px;line-height:12px;height: 12px;font-size: 17px;}');
  titArr.push('.thCl .btnWrap{ display:inline-block;}');

  titArr.push('.toptit{width: 244px; background-color:#fafafa;height:24px;padding:0px 0 0;}');
  titArr.push('.toptit .toplBtn{width:40px;}');
  titArr.push('.toptit .toprBtn{width:40px;}');
  titArr.push('.toptit .topSelectWrap{width:184px;}');
  titArr.push('.toptit.line {padding:0 0 0;border-bottom: 1px solid #E4E4E4;margin-bottom:0px;}');
  titArr.push('.toptit.line th{}');
  titArr.push('.toptit th{background-color:#fafafa;padding:0 1px;height:31px;width:31px;}');

  titArr.push('.trchange  { width:244px; height:40px; background-color: #FAFAFA; padding: 0px 0px 0px;border-top: 1px solid #E4E4E4;}');
  titArr.push('.trchange th{height:30px; padding:5px 0 0px 5px; background-color: #FAFAFA; }');

  titArr.push('.trbtns {width:244px; padding:0;background-color: #FAFAFA; height:35px; }');
  titArr.push('.trbtns .thbtn3 {width:90px; }');

  titArr.push('.trbtns th{ padding:0px 5px 0px 0px; height:30px; width: 67px;}');
  titArr.push('td.cur{ background-color:#1a56a4; color:#ffffff;}');
  titArr.push('td:hover{ background-color:#ffcc00; }');
  titArr.push('td.out{ background-color:#ffffff; }');

  titArr.push('.noBg th{ background-color:#ffffff; }');


  //titArr.push('-->');
  titArr.push('</style>');
  titArr.push('</head>');
  arr.push('<body>');
  arr.push('</body>');
  arr.push('</html>');
  arr.push('</iframe>');
//__ci.document.close();
 arr.push('</div>');
  //var bodys = document.getElementsByTagName('body');
  //this.iframe.document.body.innerHTML = arr.join("");
  $('body').append(arr.join(''));
  this.initDom = true;
  this.panel  = this.getElementById("__calendarPanel");
	this.iframe = window.frames["__calendarIframe"];
  this.iframe.document.head.innerHTML = titArr.join("");
};
/**
 * @param   d the delimiter
 * @param   p the pattern of your date
 * @author  meizz
 * @author  kimsoft add w+ pattern
 */
Date.prototype.format = function(style) {
	var o = {
		"M+" : this.getMonth() + 1, //month
		"d+" : this.getDate(),      //day
		"h+" : this.getHours(),     //hour
		"m+" : this.getMinutes(),   //minute
		"s+" : this.getSeconds(),   //second
		"w+" : "\u65e5\u4e00\u4e8c\u4e09\u56db\u4e94\u516d".charAt(this.getDay()),   //week
		"q+" : Math.floor((this.getMonth() + 3) / 3),  //quarter
		"S"  : this.getMilliseconds() //millisecond
	}
	if (/(y+)/.test(style)) {
		style = style.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	for(var k in o){
		if (new RegExp("("+ k +")").test(style)){
			style = style.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return style;
};

/**
 * @param d the delimiter
 * @param p the pattern of your date
 * @rebuilder kimsoft
 * @version build 2006.12.15
 */
String.prototype.toDate = function(delimiter, pattern) {
	delimiter = delimiter || "-";
	pattern = pattern || "ymd";
	var a = this.split(delimiter);
	var y = parseInt(a[pattern.indexOf("y")], 10);
	//remember to change this next century ;)
	if(y.toString().length <= 2) y += 2000;
	if(isNaN(y)) y = new Date().getFullYear();
	var m = parseInt(a[pattern.indexOf("m")], 10) - 1;
	var d = parseInt(a[pattern.indexOf("d")], 10);
	if(isNaN(d)) d = 1;
	return new Date(y, m, d);
};

//var calendar = new Calendar();
//-->;
///<jscompress sourcefile="init.js" />
window.amGloble = {
    page: {},
    slideBar: {},
    popup: {},
    // cardServer: "https://tlogin.kfc.com.cn/kfcgiftcard/",
    cardServer: "https://card.kfc.com.cn/",
    resFileServer: "https://login.kfc.com.cn/wap/",
    msg: function (msg, duration) {
        smartmobile.nativeUIWidget.showInstantMessage({
            content: msg,
            duration: duration || 3000
        });
    },
    hash: {
        get: function (isSearch) {
            var str = isSearch ? location.search : location.hash;
            var kvs = str.substring(1).split("&");
            var ret = {};
            for (var i = 0; i < kvs.length; i++) {
                var item = kvs[i].split("=");
                if (item[1] == null) {
                    continue;
                }
                ret[item[0]] = item[1];
            }
            ;
            return ret;
        },
        set: function (data, isSearch) {
            location.href = "#" + $.param(data);
        },

        add: function (data) {
            this.set($.extend(this.get(), data));
        },
        remove: function (keys) {
            var data = this.get();
            for (var i = 0; i < keys.length; i++) {
                delete data[keys[i]];
            }
            ;
            this.set(data);
        }
    },
    getPicture: function (size, success, failed) {
        try {
            navigator.camera.getPicture(function (imageURI) {
                $.am.debug.log(imageURI);
                if (imageURI) {
                    try {
                        $.am.debug.log(JSON.stringify({
                            "path": imageURI.split("?")[0],
                            "height": size.height,
                            "width": size.width
                        }));
                        smartmobile.media.resizeImage({
                            "path": imageURI.split("?")[0],
                            "height": size.height,
                            "width": size.width
                        }, function (ret) {
                            $.am.debug.log(JSON.stringify(ret));
                            if (ret.result == 0) {
                                success(ret);
                            } else {
                                amGloble.msg("照片裁剪失败!");
                                failed(ret);
                            }
                        }, function (ret) {
                            failed(ret);
                        });
                    } catch (e) {
                        $.am.debug.log("error:" + e);
                        success(imageURI);
                    }
                } else {
                    failed();
                }
            }, failed, {
                quality: 100,
                destinationType: Camera.DestinationType.FILE_URI,
                allowEdit: true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 300,
                targetHeight: 300,
                sourceType: size.type == 1 ? Camera.PictureSourceType.PHOTOLIBRARY : Camera.PictureSourceType.CAMERA
            });
        } catch (e) {
            success({
                result: 0,
                content: {
                    sourceRoot: "",
                    relativePath: "res/photo.png"
                }
            });
        }
        /*
         { quality : 75,
         destinationType : Camera.DestinationType.DATA_URL,
         sourceType : Camera.PictureSourceType.CAMERA,
         allowEdit : true,
         encodingType: Camera.EncodingType.JPEG,
         targetWidth: 100,
         targetHeight: 100,
         popoverOptions: CameraPopoverOptions,
         saveToPhotoAlbum: false
         };
         */
    },
    //服务器错误码 提示处理
    showErrMsg: function (code, opt) {
        var msg = opt && opt.msg || '访问服务器失败!';
        var errData = opt && opt.errData || '';
        var show = true;
        if (code == 400001) {
            msg = '';
            show = false;
            amGloble.userInfo.token = null;
            amGloble.userInfo.pwd = null;
            amGloble.util.storage.set("BRANDKFC_/login", amGloble.userInfo);
            navigator.notification.confirm("登录失效,是否立即登录?", function (button) {
                $.am.debug.log(JSON.stringify(button));
                if (button == 1) {
                    if (opt && opt.cb && typeof(opt.cb) == 'function') {
                        opt.cb();
                    } else {
                        amGloble.page.login.changeToMe("slideleft");
                    }
                } else {
                }
            }, "请先登录", ["确定", "取消"]);
        } else if (code == 400003) {
            show = false;
            msg = '登录失败多次请输入验证码';
        } else if (code == 400004) {
            show = false;
            var types = opt.types && opt.types.toLowerCase() || '';
            if (types == 'share') {
                msg = '分享太频繁';
            } else if (types == 'like') {
                msg = '点赞太频繁';
            } else if (types == 'sign') {
                msg = '您已签到了';
            }
        } else if (code == 400005) {
            show = false;
            msg = '刚签到过哦，休息一下再来吧!';
        } else if (code == 400006) {
            msg = '该手机号码已使用';
        } else if (code == 400007) {
            msg = '用户名或密码错误';
        } else if (code == 400008) {
            show = false;
            msg = '更换登录设备请输入验证码';
        } else if (code == 400009) {
            show = false;
            msg = '手机号未注册';
        } else if (code == 400010) {
            msg = '手机号已经注册过';
        } else if (code == 400011) {
            show = false;
            msg = 'email格式不对';
        } else if (code == 400012) {
            show = false;
            msg = 'sns token 无效';
        } else if (code == 400013) {
            show = false;
            msg = 'sns token 与登录账号不匹配';
        } else if (code == 400014) {
            show = false;
            msg = '你离该餐厅太远啦!';
        } else if (code == 400015) {
            show = false;
            msg = '昵称已被注册';
        } else if (code == 400016) {
            show = false;
            msg = '未验证手机号,昵称不能用于登录!';
        } else if (code == 400017) {
            show = false;
            msg = '请输入图片验证码,辅助登录!';
        } else if (code == 400018) {
            show = false;
            msg = '更换登录设备请输入图片验证码';
        } else if (code == 400019) {
            show = false;
            msg = '用户名未注册';
        } else if (code == 400020) {
            show = false;
            msg = '验证码输入次数太多请重新获取验证码';
        } else if (code == 400021) {
            show = false;
            msg = '验证码输入错误';
        } else if (code == 400028) {
            show = false;
            msg = '验证码失效';
        } else if (code == 500340) {
            msg = '您扫描的二维码已过期';
        } else if (code == 400030) {
            msg = '不能重复扫描同一个二维码';
        } else if (code == 500470) {
            msg = '本券已使用过';
        } else if (code == 500362) {
            msg = '根据肯德基会员规则，单天单账户扫码积分次数已达到上限，请保留小票次日再进行操作';
        } else if (code == 500351) {
            msg = '您的账号已被冻结。如有疑问，请拨打电话4009200715询问';
        }

        if (code >= 500000) {
            if (code >= 530000 && (msg == null || msg.trim() == "")) msg = "支付宝系统出错";
            else if (code >= 520000 && (msg == null || msg.trim() == "")) msg = "SSO系统出错";
            else if (code >= 510000 && (msg == null || msg.trim() == "")) msg = "积分系统出错";
            else msg = msg == null ? "" : msg.trim();
            msg = msg + "(" + code + " " + errData.substr(0, 20) + ")";
            if (amGloble.page.oops)
                $.am.changePage(amGloble.page.oops, "slideleft", msg);
            else
                msg && amGloble.msg(msg);
        } else {
            msg = msg + "(" + code + " " + errData.substr(0, 20) + ")";
            msg && amGloble.msg(msg);
        }

    },
    loading: {
        show: function (e) {
            //smartMobile.nativeUIWidget.startBusy(e ? {
            //    caption: e
            //} : undefined);
            $("#anim_part").addClass("anim")
            $("#loading_new").show();

        },
        hide: function () {
            $("#anim_part").removeClass("anim");
            $("#loading_new").hide();
        },
        startSplash: function () {
            smartMobile.nativeUIWidget.startSplash();
        },
        stopSplash: function () {
            smartMobile.nativeUIWidget.stopSplash();
        }
    },


    //amGloble.popupMenu("请选择客户级别", [{name:"普通用户"}, {name:"高级用户"}], function (ret) {_this.$level.find("p.text").text(ret.name);})
    popupMenu: function (title, items, cb, keyName) {
        var temps = [];
        this.popupMenuCbs = [];
        for (var i = 0; i < items.length; i++) {
            temps.push({
                "caption": items[i][keyName || "name"],
                "action": "amGloble.popupMenuCbs[" + i + "].cb()"
            });
            this.popupMenuCbs.push({
                item: items[i],
                cb: function () {
                    cb(this.item);
                }
            });
        }
        smartMobile.nativeUIWidget.showPopupMenu({
            title: title,
            items: temps
        });
    },
    reMail: /^(?:[a-z\d]+[_\-\+\.]?)*[a-z\d]+@(?:([a-z\d]+\-?)*[a-z\d]+\.)+([a-z]{2,})+$/i,
    //手机，座机
    rePhone: /((\d{11})|^((\d{7,8})|(\d{4}|\d{3})-(\d{7,8})|(\d{4}|\d{3})-(\d{7,8})-(\d{4}|\d{3}|\d{2}|\d{1})|(\d{7,8})-(\d{4}|\d{3}|\d{2}|\d{1}))$)/,
    reCellphone: /^0?(13[0-9]|15[012356789]|17[0-9]|18[0-9]|14[57]|19[0-9])[0-9]{8}$/,
    //密码,由大小写字母加数字组成
    rePassword: /^[A-Za-z0-9]+$/,
    ms2str: function (time) {
        var r = {};

        var ms = time % 1000;
        time = Math.floor(time / 1000);
        var s = time % 60;
        s = s < 10 ? "0" + s : "" + s;
        time = Math.floor(time / 60);
        var m = time % 60;
        m = m < 10 ? "0" + m : "" + m;
        var h = Math.floor(time / 60);
        h = h < 10 ? "0" + h : "" + h;

        return h + ":" + m;
    },

    userInfo: null,
    strWidth: function (str) {
        var text = str.replace(/[^\x00-\xff]/g, "**");
        return text.length;
    },

    getQueryParameter: function (name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        var r = window.location.search.substr(1).match(reg);
        if (r != null)
            return unescape(r[2]);
        return null;
    },
    validationString: function (str) {
        var valid = true;
        $.each(amGloble.specialChar, function (index, word) {
            if (str.toLowerCase().indexOf(word.toLowerCase()) != -1) {
                valid = false;
                return false;
            }
        });
        if (!valid) {
            amGloble.msg('请勿输入特殊字符');
            return false;
        }
        return true;
    },
    wxRedirect: function () {
        var pv = "superapp_wechat";
        var url = location.href.split("?")[0];
        // if (url.indexOf("tlogin") != -1) {
        //     pv = "";
        // } else {
        //     pv = "superapp_wechat";
        // }
        var opt = {
            redirectUrl: window.baseUrl + "/wx/fr/newWx_redirectWithSU.do?pv=" + pv,
            "{type}": "POST"
        };
        amGloble.api.getWXState.exec(opt, function (ret) {
            console.log(ret);
            if (typeof ret === "string")
                ret = JSON.parse(ret);
            if (ret.errCode != 0 || ret.data == null) {
                alert(JSON.stringify(ret));
            } else {
                var data = ret.data.data;
                data = JSON.parse(data);
                var url = data.redirect;
                //console.log(url);
                location.replace(url);

            }
        }, function () {
        });

    },
    specialChar: ["|", '<', '>', '%', '+', 'script', 'src', 'select', 'update', 'delete', 'insert'],
    city: {},
    preOrderUrl: null,//自助点餐url
    orderUrl: null,  //外送url
    addrManageUrl: null,
    isWeChat: function () {
        var ua = window.navigator.userAgent.toLowerCase();
        if (ua.match(/MicroMessenger/i) == 'micromessenger') {
            return true;
        } else {
            return false;
        }
    },
    isAliPay: function () {
        if (navigator.userAgent.indexOf("AlipayClient") === -1)
            return false;
        else
            return true;
    },
    isWeibo: function () {
        var ua = window.navigator.userAgent.toLowerCase();
        if (ua.match(/WeiBo/i) == "weibo") {
            return true;
        } else {
            return false;
        }
    },
    isDP: function () {
        var dpid = amGloble.getQueryParameter("dpid");
        if (dpid == null || dpid == "") {
            return false;
        }
        else {
            return true;
        }
    },
    is360: function () {
        var id360 = amGloble.getQueryParameter("id360");
        if (id360 == null || id360 == "") {
            return false;
        }
        else {
            return true;
        }
    },
    tokenValid: function (token, uid, scb, fcb) {
        var tokenValidInfo = localStorage.getItem("tokenValidInfo");
        var forceCheck = false;
        var campUrl = amGloble.getQueryParameter("campainUri");
        if (campUrl && campUrl.indexOf("forceCheck") != -1)
            forceCheck = true;
        if (!tokenValidInfo || tokenValidInfo == "" || tokenValidInfo == "null" || tokenValidInfo == "undefined" || forceCheck) {
            amGloble.tokenValidFromRemote(token, scb, fcb);
        } else {
            tokenValidInfo = JSON.parse(tokenValidInfo);
            if (tokenValidInfo.token != token) {
                amGloble.tokenValidFromRemote(token, scb, fcb);
            } else {
                if ((uid + "").indexOf("T") == 0)//temp user
                {
                    if ((new Date().getTime() - tokenValidInfo.ts) > 3600000) {
                        localStorage.removeItem("tokenValidInfo");
                        amGloble.tokenValidFromRemote(token, scb, fcb);
                    } else {
                        scb && scb();
                    }
                } else {
                    if ((new Date().getTime() - tokenValidInfo.ts) > 1728000000) {
                        localStorage.removeItem("tokenValidInfo");
                        amGloble.tokenValidFromRemote(token, scb, fcb);
                    } else {
                        scb && scb();
                    }
                }
            }
        }

    },
    tokenValidFromRemote: function (token, scb, fcb) {
        amGloble.api.tokenValid.exec({
            '{type}': 'POST',
            token: token
        }, function (ret) {
            if (ret && ret.errCode == 0) {
                var tokenValidInfo = localStorage.getItem("tokenValidInfo");
                //if (!tokenValidInfo || tokenValidInfo == "" || tokenValidInfo == "null" || tokenValidInfo == "undefined") {
                //    var obj = {token: token, ts: new Date().getTime()};
                //    localStorage.setItem("tokenValidInfo", JSON.stringify(obj));
                //} else {
                //    tokenValidInfo = JSON.parse(tokenValidInfo);
                //    if (tokenValidInfo.token != token) {
                //        var obj = {token: token, ts: new Date().getTime()};
                //        localStorage.setItem("tokenValidInfo", JSON.stringify(obj));
                //    }
                //}
                var obj = {token: token, ts: new Date().getTime()};
                localStorage.setItem("tokenValidInfo", JSON.stringify(obj));
                scb && scb();
            } else {
                fcb && fcb();
            }
        });
    },
    isTempUser: function () {
        if ((amGloble.userInfo.id + "").indexOf("T") == 0 || (amGloble.userInfo.su && (amGloble.userInfo.su.userType + "").indexOf("3") == 0)) {
            return true;
        } else
            return false;
    },
    afterLoginSuccess: function (isFromLogin) {
        localStorage.removeItem("SUPERAPP_memberCard_uniqueCode");
        localStorage.removeItem("KEY_COUPONS_FAVOURITE");
        localStorage.removeItem("KEY_CARDBAGS_COUNT");
        var campUrl = amGloble.getQueryParameter("campainUri");
        if (campUrl) {//如果是跳转过来需要登录的,则登录完成后直接跳回去，第三方把token带回去
            if (campUrl.indexOf("login.kfc") == -1) {
                if (campUrl.indexOf("?") != -1 || campUrl.indexOf("%3F") != -1)
                    campUrl = campUrl + "&token=" + amGloble.userInfo.token;
                else
                    campUrl = campUrl + "?token=" + amGloble.userInfo.token;

            }
            window.location.replace(campUrl);
            return;
        } else {//否则直接跳9宫格首页
            if (amGloble.isAliPay())
                location.replace("home.html?showCard=1");
            else
                location.replace("home.html");
        }
    },
    guid: function () {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0,
                v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });

    },
    getDeviceType: function () {
        var ua = navigator.userAgent;
        if (ua.indexOf("iPhone") != -1 || ua.indexOf("iPad") != -1 || ua.indexOf("iPod") != -1) {
            return "ios";
        } else if (ua.indexOf("Android") != -1)
            return "android";
        else
            return "ios";
    },
    getDeviceId: function () {
        var deviceId;
        if (amGloble.isWeChat()) {
            deviceId = localStorage.getItem("SUPERAPP_WECHAT_openid");
        } else if (amGloble.isAliPay()) {
            deviceId = localStorage.getItem("SUPERAPP_ALIPAY_openid");
        } else {
            deviceId = localStorage.getItem("SUPERAPP_OTHER_openid");
            if (!deviceId || deviceId == "" || deviceId == "null" || deviceId == "undefined") {
                deviceId = amGloble.guid();
                localStorage.setItem("SUPERAPP_OTHER_openid", deviceId);
            }
        }
        return deviceId;
    },
    checkLogin: function () {
        if (amGloble.userInfo && amGloble.userInfo.token && !amGloble.isTempUser()) {
            return true;
        } else {
            return false
        }
    },

    getSVC: function () {
        amGloble.svc = false;
        var opt = {
            "{type}": "GET"
        };
        amGloble.api.home.exec(opt, function (ret) {
            console.log(ret);
            if (ret && ret.errCode == 0) {
                var svc = ret.data.svc;
                amGloble.svc = svc;
            } else {
                amGloble.svc = false;
            }
        }, function () {
            amGloble.svc = false;
        });

    },

    aliRedirect: function (fromUrl) {
        localStorage.setItem("SUPERAPP_ALIPAY_FROM_URL", fromUrl);
        //location.replace("https://openauth.alipay.com/oauth2/publicAppAuthorize.htm?app_id=2015040100041323&auth_skip=false&scope=auth_userinfo,auth_ecard&redirect_uri=" + window.htmlHostUrl + "ali_transfer.html")
        location.replace("https://openauth.alipay.com/oauth2/publicAppAuthorize.htm?app_id=2015040100041323&auth_skip=false&scope=auth_user,auth_ecard&redirect_uri=" + window.htmlHostUrl + "ali_transfer.html")

    }


};

$(function () {

});

$.am.init = function () {
    if (amGloble.isWeibo()) {
        alert("请用微信打开");
        return;
    }
    var url = location.href.split("?")[0];

    if (url.indexOf("tlogin") != -1) {
        $.am.imgSvr = "http://t.res.kfc.com.cn/";
        window.htmlHostUrl = "https://tlogin.kfc.com.cn/CRM/superapp_wechat/";  //uat
    } else {
        $.am.imgSvr = "http://res.kfc.com.cn/";
        window.htmlHostUrl = "https://login.kfc.com.cn/CRM/superapp_wechat/";  //prod
    }
    var page;
    if (url.indexOf("lawprivacy") != -1) {
        page = amGloble.page.lawPrivacy;
    }else if (url.indexOf("protocol") != -1) {
        page = amGloble.page.protocol;
    }else{
        page = amGloble.page.lawPrivacy;
	}
    $.am.changePage(page, "slideleft");
};
;
///<jscompress sourcefile="api.js" />
/**
 * Created by cuanzh on 2016/7/25.
 */
(function () {
    window.baseUrl = "https://login.kfc.com.cn/KBS/api";
    //"http://121.40.136.246:8080/KBS/api"; //
    // window.baseUrl = "https://tlogin.kfc.com.cn/KBS/api";
    // window.clientKey = "kbaptkJGtByWrQaP";
    //for uat
    window.clientKey = "kbappkwle8K1Mhlc";//for prod
    //for prod
    //for uat
    //serviceName
    window.htmlHostUrl = "https://login.kfc.com.cn/CRM/superapp_wechat/";
    window.Api = function (opt) {
        if (!opt)
            return;
        if (opt.serviceName || opt.url) {
            this.serviceName = opt.serviceName || opt.url;
        } else {
            throw ('Api error: 必须输入serviceName');
        }
    }
    window.Api.prototype = {
        init: function () {
//            console.log("api init");
            //-1 != window.location.href.indexOf("https://login") ? (window.baseUrl = "https://login.kfc.com.cn/KBS/api", this.isWeChat() ? (window.clientKey = "kbwxpnJ9wYqnUJV1", window.sign = "emwyVnRSdlltUkRLVXJ3MA==") : this.is360() ? (window.clientKey = "k360pbJGZG8eEXk6", window.sign = "MUdyN2duaUZiUHhWUURIaQ==") : this.isDP() ? (window.clientKey = "kbdppMaFFZJNsb6d", window.sign = "ZG5GOEpJMG9MUW8wZ01FQQ==") : this.isAliPay() ? (window.clientKey = "kzfbp3tkKUsXCiJ6", window.sign = "Y0lEWkcyZzVYc0pwSXhkSg==") : (window.clientKey = "kbwapzJAAUs1g2od", window.sign = "ZmVnRkxWTUpKODhJZjJocA==")) : (window.baseUrl = "https://tlogin.kfc.com.cn/KBS/api", this.isWeChat() ? (window.clientKey = "kbwxtWeMjrviqTtg", window.sign = "aHRBMEJvbGt2QUhPNWpySA==") : this.is360() ? (window.clientKey = "k360tzCOHLuMJhj6", window.sign = "TXdUcHprR0NvSExvcm9PaQ==") : this.isDP() ? (window.clientKey = "kbdptKdq3A4rumrC", window.sign = "cmtiblpCMEVOd0d0QjNVQg==") : this.isAliPay() ? (window.clientKey = "kzfbtlv5DjaD6uBS", window.sign = "S2NRTFg1UVlQWUdFNmNUVQ==") : (window.clientKey = "kbwat2EkGjjJuRg3", window.sign = "MkhTcklubnpTYXdFVTB6MQ=="))

            if (-1 != window.location.href.indexOf("https://plogin")) {
                window.baseUrl = "https://plogin.kfc.com.cn/KBS/api",
                    this.isWeChat() ? (window.clientKey = "kbwxpnJ9wYqnUJV1", window.sign = "emwyVnRSdlltUkRLVXJ3MA==") :
                        this.is360() ? (window.clientKey = "k360pbJGZG8eEXk6", window.sign = "MUdyN2duaUZiUHhWUURIaQ==") :
                            this.isDP() ? (window.clientKey = "kbdppMaFFZJNsb6d", window.sign = "ZG5GOEpJMG9MUW8wZ01FQQ==") :
                                this.isAliPay() ? (window.clientKey = "kzfbp3tkKUsXCiJ6", window.sign = "Y0lEWkcyZzVYc0pwSXhkSg==") :
                                    this.isWeibo() ? (window.clientKey = "kbwbphpZ5cxLagy8", window.sign = "UHZ3ckdoekM2eTBWcmlLYQ==") :
                                        this.isIQiyi() ? (window.clientKey = "kbiqa7hRMyWOmSAc", window.sign = "ZUhibEhva2ZWdGlNdU1oVg==") :
                                            (window.clientKey = "kbwapzJAAUs1g2od", window.sign = "ZmVnRkxWTUpKODhJZjJocA==")
            } else if (-1 != window.location.href.indexOf("https://tlogin") || -1 != window.location.href.indexOf("localhost")) {
                window.baseUrl = "https://tlogin.kfc.com.cn/KBS/api",
                    this.isWeChat() ? (window.clientKey = "kbwxtWeMjrviqTtg", window.sign = "aHRBMEJvbGt2QUhPNWpySA==") :
                        this.is360() ? (window.clientKey = "k360tzCOHLuMJhj6", window.sign = "TXdUcHprR0NvSExvcm9PaQ==") :
                            this.isDP() ? (window.clientKey = "kbdptKdq3A4rumrC", window.sign = "cmtiblpCMEVOd0d0QjNVQg==") :
                                this.isAliPay() ? (window.clientKey = "kzfbtlv5DjaD6uBS", window.sign = "S2NRTFg1UVlQWUdFNmNUVQ==") :
                                    this.isWeibo() ? (window.clientKey = "kbwbtL50GN715CYS", window.sign = "RHZWQzh4dXd6QXpYYXN4ZA==") :
                                        this.isIQiyi() ? (window.clientKey = "kbiqoeJynmSHoXEH", window.sign = "TjVGN0o5aUxtc05DSWliTw==") :
                                            (window.clientKey = "kbwat2EkGjjJuRg3", window.sign = "MkhTcklubnpTYXdFVTB6MQ==")
            } else {
                window.baseUrl = "https://login.kfc.com.cn/KBS/api",
                    this.isWeChat() ? (window.clientKey = "kbwxpnJ9wYqnUJV1", window.sign = "emwyVnRSdlltUkRLVXJ3MA==") :
                        this.is360() ? (window.clientKey = "k360pbJGZG8eEXk6", window.sign = "MUdyN2duaUZiUHhWUURIaQ==") :
                            this.isDP() ? (window.clientKey = "kbdppMaFFZJNsb6d", window.sign = "ZG5GOEpJMG9MUW8wZ01FQQ==") :
                                this.isAliPay() ? (window.clientKey = "kzfbp3tkKUsXCiJ6", window.sign = "Y0lEWkcyZzVYc0pwSXhkSg==") :
                                    this.isWeibo() ? (window.clientKey = "kbwbphpZ5cxLagy8", window.sign = "UHZ3ckdoekM2eTBWcmlLYQ==") :
                                        this.isIQiyi() ? (window.clientKey = "kbiqa7hRMyWOmSAc", window.sign = "ZUhibEhva2ZWdGlNdU1oVg==") :
                                            (window.clientKey = "kbwapzJAAUs1g2od", window.sign = "ZmVnRkxWTUpKODhJZjJocA==")
            }
        },
        getQueryParameter: function (name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
            var r = window.location.search.substr(1).match(reg);
            // if (r!=null) return unescape(r[2]); return null;
            if (r != null) return decodeURIComponent(r[2]);
            return null;
        },
        isIQiyi: function () {
            var ua = window.navigator.userAgent.toLowerCase();
            if (ua.match(/iqiyiapp/i) == "iqiyiapp") {
                return true;
            } else {
                return false;
            }
        },
        isWeibo: function () {
            var ua = window.navigator.userAgent.toLowerCase();
            if (ua.match(/WeiBo/i) == "weibo") {
                return true;
            } else {
                return false;
            }
        },
        isDP: function () {
            var dpid = this.getQueryParameter("dpid");
            if (dpid == null || dpid == "") {
                return false;
            }
            else {
                return true;
            }
        },
        is360: function () {
            var id360 = this.getQueryParameter("id360");
            if (id360 == null || id360 == "")
                return false;
            else
                return true;
        },
        isWeChat: function () {
            return "micromessenger" == window.navigator.userAgent.toLowerCase().match(/MicroMessenger/i) ? !0 : !1
        },
        isAliPay: function () {
            return -1 === navigator.userAgent.indexOf("AlipayClient") ? !1 : !0
        },
        exec: function (opt, cb) {
            this.getdata(opt, cb);
        },
        getdata: function (option, sc, shortTimeWaiting) {
            var self = this;
            var ajaxOption = {};
            var url = this.serviceName;
            var optionName = [];
            var headers = null;
            for (var i in option) {
                if (i == '{headers}') {
                    headers = option[i];
                    delete option[i];
                } else if (i.indexOf("{") != -1 && i != "{type}") {
                    url = url.replace(i, option[i]);
                    delete option[i];
                } else {
                    if (i != "{type}") {
                        optionName[optionName.length] = i;
                    }

                }
            }
            optionName = optionName.sort();
            var kbcts = new Date().getTime();
            ajaxOption.url = baseUrl + url;

            if (option["{type}"] == "POST") {
                ajaxOption.type = "POST";
                delete option["{type}"];
                ajaxOption.data = JSON.stringify(option);
            } else if (option["{type}"] == "DELETE") {
                ajaxOption.type = "DELETE";
                delete option["{type}"];
                ajaxOption.data = JSON.stringify(option);
            } else {
                ajaxOption.type = "GET";
                ajaxOption.traditional = true;
                delete option["{type}"];
                ajaxOption.data = option;
            }
            var signStr = clientKey + "\t" + $.b64({
                data: sign,
                type: 1,
                unicode: !1
            }) + "\t" + kbcts + "\t" + url;

            if (ajaxOption.type == "GET") {
                var queryStr = "";
                for (var i = 0; i < optionName.length; i++) {
                    var value = option[optionName[i]];
                    if (typeof (value) == "undefined" || $.trim(value) == "") {
                        continue;
                    } else if (value instanceof Array) {
                        for (var j = 0; j < value.length; j++)
                            queryStr = queryStr + optionName[i] + "=" + value[j] + "&";
                    } else
                        queryStr = queryStr + optionName[i] + "=" + value + "&";

                }
                signStr = signStr + "\t" + queryStr.substr(0, queryStr.length - 1);
            } else
                signStr = signStr + "\t\t" + JSON.stringify(option);
            //console.log(signStr);

            ajaxOption["beforeSend"] = function (xhr) {
                xhr.setRequestHeader("kbck", clientKey);
                xhr.setRequestHeader("kbcts", kbcts);
                xhr.setRequestHeader("kbsv", $.md5(signStr));
                xhr.setRequestHeader("requestTo", "Pilot");
                for (var key in headers) {
                    xhr.setRequestHeader(key, headers[key]);
                }
            };

            ajaxOption["success"] = function (ret, textStatus, jqXHR) {
                var res = ret;
                if (typeof (ret) == "string") {
                    try {
                        res = JSON.parse(ret);
                    } catch (e) {
                        //console.log(e);
                    }
                }
                if (res && (res.errCode == -1 || res.errCode == 400001)) {
                    localStorage.removeItem("KEY_USER");
                    localStorage.removeItem("tokenValidInfo");
                    var campUrl = self.getQueryParameter("campainUri");
                    if (campUrl)
                        location.replace(window.htmlHostUrl + "login.html?campainUri=" + campUrl);
                    else
                        location.replace(window.htmlHostUrl + "login.html?campainUri=" + location.href);
                    return;
                } else {
                    var resource = jqXHR.getResponseHeader('resouceVersion');
                    if (resource) {
                        res['resouceVersion'] = resource;
                        res['iphoneVersion'] = jqXHR.getResponseHeader('iphoneVersion');
                        res['androidVersion'] = jqXHR.getResponseHeader('androidVersion');
                        //console.log('res'+JSON.stringify(res));
                    }
                    sc(res);
                }
            };
            ajaxOption["error"] = function (ret) {
                sc({
                    errCode: -1,
                    errMsg: "无可用网络连接，离线状态下无法使用此功能"
                });
            };
            ajaxOption.timeout = 2000 * 10;
            ajaxOption.contentType = 'application/json; charset=UTF-8';
            //console.log(ajaxOption);
            $.ajax(ajaxOption);
        }
    }

    /*
     * ApiCacheable类,实例化一个service对象,通过调用这个对象的exec方法执行一个service
     * @Class
     * @public
     *
     * @param opt.serviceName   [string]    必需      undefined   service名称
     * @param opt.keys          [array]     必需      undefined   参数名
     * @param opt.memoryCache   [boolean]   可选      false       是否启用内存缓存
     * @param opt.isSuccess     [function]  必需      返回是否成功调用业务数据,参数为结果
     *
     * @return                  [ApiCacheable]
     */
    ApiCacheable = function (opt) {
        if (!opt)
            return;
        Api.call(this, opt);
        if (opt.keys && opt.isSuccess) {
            this.keys = opt.keys;
            this.isSuccess = opt.isSuccess;
            this.ignoreTS = opt.ignoreTS;
        } else {
            throw ('ApiCacheable error: 参数有误,必须输入keys[array],isSuccess[function]');
        }
        this.memoryCache = opt.memoryCache;
        this.storeData = {};
    }
    ApiCacheable.prototype = new Api();
    /*
     * 获取作为cache使用的key,此key由servicename和参数组成(过滤掉keyFilter);
     * @function
     * @private
     * @param    opt    [object]     必需      调用service的时的option
     *
     * @return   key    [string]
     */
    ApiCacheable.prototype._key = function (opt) {
        var key = "BRANDKFC_" + this.serviceName;
        if (this.keys) {
            for (var i = 0; i < this.keys.length; i++) {
                if (typeof (opt[this.keys[i]]) == "undefined")
                    continue;
                if (typeof (opt[this.keys[i]]) == "object") {
                    key = key + "_" + JSON.stringify(opt[this.keys[i]]);
                } else {
                    key = key + "_" + opt[this.keys[i]];
                }
            }
        }
        return key;
    },
        /*
         * 读取本地存储中的数据
         * @function
         * @private
         * @param    opt    [string]     必需      接口参数
         *
         * @return   result [object]     service的本地数据
         */
        ApiCacheable.prototype._get = function (opt) {
            var key = typeof (opt) == "string" ? opt : this._key(opt);
            var temp = localStorage.getItem(key);
            if (!temp) {
                return;
            }
            try {
                temp = JSON.parse(temp);
            } catch (e) {
                $.am.debug.log("api.get JSON.parse error:" + key);
                temp = null;
            }
            return temp;
        },
        /*
         * 保存service数据到本地存储中
         * @function
         * @private
         * @param    opt    [object]     必需      接口参数
         * @param    data   [object]     必需      调用数据成功后得到的数据
         *
         * @return   result [object]     service的本地数据
         */
        ApiCacheable.prototype._save = function (opt, data) {
            localStorage.setItem(typeof (opt) == "string" ? opt : this._key(opt), JSON.stringify(data));
        },
        /*
         * 添加一个数据对象到缓存中
         * @function
         * @public
         * @param    option  [object]     必需     缓存数据的参数,需要以此参数生成key
         * @param    item    [function]   必需     要插入的数据对象
         * @param    noCache [boolean]    可选     目标路径,如:"responseData.data.storelist"
         *
         * @return
         * @description
         */
        ApiCacheable.prototype.addItemToCache = function (option, item, targetPath) {

        },
        /*
         * 执行service
         * @function
         * @public
         * @param    option  [object]     必需     调用service的时的option
         * @param    sc      [function]   必需     回调函数
         * @param    noCache [boolean]    可选     是否忽略缓存数据
         *
         * @return
         */
        ApiCacheable.prototype.exec = function (opt, cb, noCache) {
            var key = this._key(opt),
                _this = this;

            if (!noCache && this.memoryCache && this.storeData[key]) {
                //如果内存中有数据
                cb(_this.storeData[key], 2);
                return;
            }
            if (!this.ignoreTS) {
                opt.ts = (opt.ts || localStorage.getItem(key + "ts") || 946656000000);
            }
            _this.getdata(opt, function (ret) {
                if (_this.isSuccess(ret)) {
                    //调用成功
                    if (!_this.ignoreTS && ret.data.ts == opt.ts) {
                        //调用成功,但无更新,返回local数据
                        cb(_this._get(key), 1);
                    } else {
                        //调用成功,有更新
                        //保存新数据
                        _this._save(key, ret);
                        //更新ts
                        !_this.ignoreTS && localStorage.setItem(key + "ts", ret.data.ts);
                        //写入内存
                        _this.memoryCache && (_this.storeData[key] = ret);
                        //
                        cb(ret);
                    }
                } else {//两种情况：1、离线；2、4XX或者5XXX错误
                    //返回失败信息
                    console.log('error');
                    console.log(ret);
                    if (ret.errCode == -1) {  //离线，则使用cache，无cache则向上抛
                        var localdata = _this._get(key);
                        if (localdata) {
                            $.am.debug.log("API_local:" + key);
                            cb(localdata);
                        } else {
                            cb(ret);
                        }
                    } else {  //服务端错误，则统一处理，不再向上抛
                        if (ret.errCode != 0) {
                            amGloble.showErrMsg(ret.errCode, {
                                msg: ret.errMsg,
                                errData: ret.errData
                            });
                        } else {  //isSuccess判断不准确时，处理
                            cb(ret);
                        }
                    }
                }
            });
        }
    window.Api.prototype.init()
})();

/*
 $(function () {
 var baseUrlCount = 0;
 window.baseUrl = localStorage.getItem("BRANDKFC_baseUrl");
 if (!window.baseUrl) {
 //window.baseUrl = "http://121.40.136.246:8080/KBS/api";
 window.baseUrl = "http://t.a.kfc.com.cn/KBS/api";
 }
 //window.baseUrl = "http://error_test";
 $("#switchBaseUrl").vclick(function () {
 baseUrlCount++;
 if (baseUrlCount%5==0) {
 if (window.baseUrl == "http://121.40.136.246:8080/KBS/api") {
 window.baseUrl = "http://t.a.kfc.com.cn/KBS/api";
 } else {
 window.baseUrl = "http://121.40.136.246:8080/KBS/api"
 }
 amGloble.msg("BASEURL已改变:" + window.baseUrl);
 localStorage.setItem("BRANDKFC_baseUrl", window.baseUrl);
 }
 });

 var clearCache = 0;
 $("#clearCache").vclick(function () {
 baseUrlCount++;
 if (baseUrlCount % 5 == 0) {
 navigator.notification.confirm("此操作会清除所有缓存,确定清除吗?", function (button) {
 if (button == 1) {
 localStorage.clear();
 //清除以后 要保持内存中 个人中心中信息
 amGloble.util.storage.set("BRANDKFC_/login", amGloble.userInfo);
 }
 }, "清除缓存", ["确定", "取消"]);
 }
 });

 })*/
;
///<jscompress sourcefile="apiConfig.js" />
(function () {
    var _uploadthreadId = 0;
    /*
     统一数据格式
     {errCode:0,errMsg:"",data:{},errData:{}}
     */
    
    var self = amGloble.api = {
        /*
        amGloble.api.upload({
            "filePath": "/user/xxxx.png",
            "fileName": "photo",
            "url": "/user/register",
            "params": {
                phone:"",
                smsCode:"",
                pwd:"",
                nickname:"",
                gender="M"
                bYear:""
            }
        }, function (ret) {
            
        }, function (ret) {
            
        });
        */
        upload: function (opt, cb) {
            _uploadthreadId++;
            opt.threadId = _uploadthreadId;
            opt.serviceName=opt.url;
            opt.url = baseUrl + opt.url;
            $.am.debug.log("smartmobile.fileTransfer.upload");
            $.am.debug.log(JSON.stringify(opt));
            smartmobile.fileTransfer.upload(opt, function (ret) {
                $.am.debug.log("success:" + JSON.stringify(ret));
                if (ret && ret.result == 0 && ret.content) {
                    cb(ret.content);
                } else {
                    cb({
                        errCode: -2
                    });
                }
            }, function (ret) {
                $.am.debug.log("failed:"+JSON.stringify(ret));
                cb({
                    errCode: -1
                });
            });
        },
        // 获取公共参数
        getCommon: new ApiCacheable({
            url: "/common",
            keys: [],
            memoryCache: true,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),
        
        /*
         home 参数列表
         ts          时间戳
         token       token
         cityId      城市ID

         调用示例:
         amGloble.api.home.exec({
         ts: 1407146604702,
         token:"3234hjkhy343khsf0",
         cityId:12
         },function(ret){
         if(ret && ret.errCode == 0 && ret.data){
         do some thing
         }else{
         amGloble.msg("数据读取失败!");
         }
         });
         */
        home: new ApiCacheable({
            //接口相对地址
            url: "/home",
            //作为缓存使用的KEY
            keys: ["cityId"],
            //是否启动内存缓存,内存缓存为true时，参数相同的话每次启动APP只会调用一次服务器接口，下次调用使用内存中的数据
            memoryCache: true,
            //isSuccess用来判断接口是否调用成功，只有调用成功才会记录将本次调用得到的数据记入缓存
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        cities: new ApiCacheable({
            //接口相对地址
            url: "/common/cities",
            //作为缓存使用的KEY
            keys: [],
            memoryCache: true,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),
        citiesNoCache: new Api({
            url: "/common/cities"
        }),
        /*stores:new ApiCacheable({
            //接口相对地址
            url: "/stores",
            //作为缓存使用的KEY
            keys: [],
            ignoreTS:1,
            memoryCache: false,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            },
        }),*/
        stores: new Api({
            url: "/stores"
        }),
        //
        storesSigncount: new ApiCacheable({
            //接口相对地址
            url: "/stores/signcount",
            //作为缓存使用的KEY
            keys: ["scs"],
            memoryCache: true,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),
        nicknameLimits: new ApiCacheable({
            url: "/common/nickname/limits",
            keys:[],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),
        audiocode: new Api({
          url: "/smscode/audio"
        }),
        smscode: new Api({
            url: "/smscode"
        }),

        imgSmscode: new Api({
            url: "/captcha"
        }),

        register: new Api({
            url: "/user/register"
        }),

        //验证昵称是否注册过
        nicknameRegistered:new Api({
            url: "/user/nickname/registered"
        }),

        //验证手机号是否注册过
        registered:new Api({
            url: "/user/phone/registered"
        }),

        verify:new Api({
            url: "/user/phone/verify"
        }),

        resetpwd: new Api({
            url: "/user/resetpwd"
        }),

        login: new Api({
            url: "/user/login"
        }),
        smsLogin: new Api({
          url: "/user/smsLogin"
        }),
        mePush: new Api({
            url: "/user/push"
        }),

        meCity: new Api({
            url: "/user/city"
        }),

        meLogout: new Api({
            url: "/user/logout"
        }),

        me: new Api({
            url: "/user"
        }),

        mePwd: new Api({
            url: "/user/pwd"
        }),

        mePhone: new Api({
            url: "/user/phone"
        }),

        smsPwd: new Api({
            url: "/user/smsPwd"
        }),

        mePhoto: new Api({
            url: "/user/photo"
        }),

        meComments: new Api({
            url: "/user/comments"
        }),

        meSigns: new ApiCacheable({
            url: "/user/signs",
            keys: ['pageSize','pageNum'],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        meSignsDelete: new Api({
            url: "/user/signs/{id}"
        }),

        meBag: new ApiCacheable({
            url: "/user/bag",
            keys: ['userId'],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        meBagDelete: new Api({
            url: "/user/bag/{id}"
        }),

        meMsg: new Api({
            url: "/user/msg"
        }),

        meMsgRead: new Api({
            url: "/user/msg/{id}/read"
        }),

        meMsgDel: new Api({
            url: "/user/msg/{id}"
        }),

        msgCount: new Api({
            url: "/user/msg/count"
        }),

        law: new ApiCacheable({
            url: "/common/law",
            keys:[],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        localPromotions: new ApiCacheable({
            url: "/promotions",
            keys: ["storeId", "cityId"],
            memoryCache: true,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //增加点赞数
        praises: new Api({
            url: "/praises/inc"
        }),

        //增加 分享数
        shares: new Api({
            url: "/shares/inc"
        }),

        //读取点赞数
        getPraises: new ApiCacheable({
            //接口相对地址
            url: "/praises",
            //作为缓存使用的KEY
            keys: ["objType","objId"],
            memoryCache: false,
            ignoreTS: 1,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //读取分享数
        getShares: new ApiCacheable({
            //接口相对地址
            url: "/shares",
            //作为缓存使用的KEY
            keys: ["objType","objId"],
            memoryCache: false,
            ignoreTS: 1,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //优惠券分类列表
        couponsCat: new ApiCacheable({
            url: "/coupons/cat",
            keys:[],
            memoryCache: true,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //优惠券列表--根据类别获取列表
        coupons: new Api({
            url: "/coupons",
            keys:["cityId","catId"],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //收藏|取消收藏 优惠券
        couponsFav: new ApiCacheable({
            url: "/coupons/fav/{id}",
            keys:[],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //获取收藏优惠券列表
        getMeCoupons: new ApiCacheable({
            url: "/user/coupons",
            keys:['userId'],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //美食 时段分类
        getFoodDaypart: new ApiCacheable({
            url: "/food/daypart",
            keys:[],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //美食品类列表
        getFoodClasses: new ApiCacheable({
            url: "/food/classes",
            keys:[],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //美食品类分类
        /**
            调用：
            amGloble.api.getFoodClassesById({
                "{classId}": 1,
                "ts": 1407999794936,
                "cs": "1,2,3"
            }, function (ret) {
                //do something on callback
            });
        */
        getFoodClassesById: new ApiCacheable({
            url: "/food/classes/{classId}",
            keys:["{classId}"],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        signs: new Api({
            url: "/stores/{storeCode}/signs"
        }),
        sign: new Api({
            url: "/stores/{storeCode}/sign"
        }),

        //发现列表
        getFound: new ApiCacheable({
            url: "/discoverys",
            keys:['cityId'],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        signLimits: new ApiCacheable({
            url: "/sign/limits",
            keys:[],
            memoryCache: true,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //检查版本
        versionCheck: new Api({
            url: "/mas/mobile/mobiletMetaByServer"
        }),

        adddWinAddr: new Api({
            url: "/draws/{drawId}/win/{winId}/addr"
        }),

        //打开首页统计用户信息
        saveOpenInfo: new Api({
            url: "/log/open"
        }),

        getEgiftToken: new Api({
            url: "/egc/token?token={BrandAppToken}"
        }),

        //用户投诉建议
        userComplin: new Api({
            url: "/user/complain"
        }),

        //城市 省份列表
        citiesByProvince: new Api({
            url: "/common/citiesByProvince"
        }),

        //加入会员
        member : new Api({
          url : "/user/member"
        }),

        //获取卡包列表
        getCardList: new ApiCacheable({
            url: "/crm/pri",
            keys:['ts',"type","pageSize","pageNum"],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //getCardList: new Api({
        //    url: "/crm/pri"
        //}),
        
        //K-Gold
        gold:new Api({
        	url:"/crm/gold"
        }),

        //获取卡包详情
        getCardDetails: new ApiCacheable({
            url: "/crm/pri/{cardId}",
            keys:['ts'],
            memoryCache: false,
            isSuccess: function(ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),

        //使用优惠券
        useCardTicket: new Api({
            url: "/crm/pri"
        }),
        estoreProd: new ApiCacheable({
            //接口相对地址
            url: "/crm/store/prod",
            //作为缓存使用的KEY
            keys: ["pageNum","pageSize","cityId"],
            memoryCache: false,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),
        estoreProdDetail: new ApiCacheable({
            //接口相对地址
            url: "/crm/store/prod/{prodId}",
            //作为缓存使用的KEY
            keys: ["{prodId}"],
            memoryCache: false,
            isSuccess: function (ret) {
                if (ret && ret.errCode == 0 && ret.data) {
                    return true;
                }
            }
        }),
        estoreProdExchange:new Api({
        	url:"/crm/store/prod"
        }),
        kGoldDetail:new Api({
        	url:"/crm/gold/{goldType}"
        }),
        scanQRCodeForKGold:new Api({
        	url:"/barcode/scpoint"
        }),
        getUserPriCount:new Api({
            url:"/crm/priOwnCount"
        }),
        getWXState:new Api({
            url:"/wx/fr/getNewWechatState"
        }),
        tokenValid:new Api({
            url:"/user/token/valid"
        })
    }
})();


;
///<jscompress sourcefile="page.lawPrivacy.js" />
(function () {
    amGloble.page.lawPrivacy = new $.am.Page({
        id: 'page-lawPrivacy',
        init: function () {
            var self = this;
            self.dom = {
                title: self.$.find('.am-header p'),
                lawDetail: self.$.find('.lawDetail .con'),
                backBtn: self.$.find('.back-btn')
            };
            self.dom.backBtn.vclick(function () {
                self.backButtonOnclick();
            });

        },
        beforeShow: function () {
            var self = this;
            var htmlTitle = '';
            self.type = amGloble.getQueryParameter('type');
            self.dom.backBtn.html('').hide();
            // 默认显示隐私条款
            if (!self.type) { self.type = 'lawPrivacy'; }
            switch (self.type) {
                case 'agreement':
                    htmlTitle = '用户协议'
                    self.type = 'lawUserAgreement';
                    break;
                case 'wowAgreement':
                    htmlTitle = 'WOW会员服务协议'
                    break;
                case 'law':
                    htmlTitle = '法律条款'
                    break;
                case 'deliveryAgreement':
                    htmlTitle = '外送';
                    break;
                case 'preorderAgreement':
                    htmlTitle = '自助点餐';
                    break;
                case 'purchasingNotice':
                    htmlTitle = '购物须知';
                    self.dom.backBtn.html('我已阅读并同意《购物须知》').show();
                    break;
                case 'frequentQA':
                    htmlTitle = '常用问题';
                    break;
                case 'coupon':
                    htmlTitle = '优惠券协议';
                    break;
                case 'eGiftCard':
                    htmlTitle = '百胜卡协议';
                    break;
                case 'primeNotes':
                    htmlTitle = '肯德基会员权益购买须知';
                    break;
                case 'sharingNote':
                    htmlTitle = '活动规则';
                    break;
                case 'rechargeRules':
                    htmlTitle = '百胜预付卡章程及购卡协议';
                    break;
                case 'tacobell_member_agreement':
                    htmlTitle = 'TacoBell会员协议';
                    break;
                case 'tacobell_privacy':
                    htmlTitle = 'TacoBell隐私条款';
                    break;
                case 'tacobell_app_agreement':
                    htmlTitle = 'TacoBell APP会员条款';
                    break;
                case 'tacobell_vmall_agreement':
                    htmlTitle = 'TacoBell积分商城协议';
                    break;
                default:
                    htmlTitle = '隐私条款'
                    break;
            }
            self.dom.title.html(htmlTitle);
            self.getLawData();

        },
        afterShow: function () {
            this.refresh();
            this.scrollview.refresh();
        },
        beforeHide: function () {

        },
        afterHide: function () {
        },
        getLawData: function () {
            var self = this;
            // var orderApi = new Api({
            //     // 默认显示隐私条款
            //     url: '/common/key/' + self.type
            // }),
            //     opt = {
            //         '{type}': 'GET'
            //     };
            // amGloble.loading.show();
            // orderApi.exec(opt, function (ret) {
            //     amGloble.loading.hide();
            //     if (ret && ret.errCode == 0 && ret.data && ret.data.law) {
            //         localStorage.setItem('SUPERAPP_lawPrivacyType_' + self.type, ret.data.law);
            //     }
            //     var lawPrivacyCache = localStorage.getItem('SUPERAPP_lawPrivacyType_' + self.type) || '';
            //     self.dom.lawDetail.html(lawPrivacyCache);
            //     self.scrollview.refresh();
            //     self.scrollview.scrollTo('top');
            // });
            self.scrollview.scrollTo('top');
        },
        backButtonOnclick: function () {
            var fromType = amGloble.getQueryParameter('from');
            switch (fromType) {
                // app进入则关闭
                case 'app':
                    try {
                        smartmobile.appmanager.stopTopApp();
                    } catch (e) {
                        history.back();
                    }
                    break;
                //小程序进入则关闭
                case 'wxapp':
                    try {
                        wx.miniProgram.navigateBack(1);
                    } catch (e) {
                        history.back();
                    }
                    break;
                case 'aliapp':
                    try {
                        my.navigateBack(1);
                    } catch (e) {
                        history.back();
                    }
                    break;
                // 其他渠道进入则后退
                default:
                    history.back();
                    break;
            }
        }
    });
})();;
